moDraw.infoBar = {};

function moDraw.infoBar:setMasterPda(overlay, disableClickArea, app)
	if overlay == nil or app == nil or app[6][1] == nil or not app[6][1] then return;end;
	g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.masterPda.appInfoBar, overlay.x, nil, overlay.width);
	moSetGetOverlaysLight.default.masterPda.appInfoBar:render();
	if app[3] == "mapMissionsSlot_" then		
		if g_currentMission.hl.timers["infoBarMapMissionsSlot_"] == nil then
			g_currentMission.hl.addTimer( {delay=app[6][4], name="infoBarMapMissionsSlot_", repeatable=false} ); 
			app[6][3], app[6][2] = moMissions:getInfoBar();													
			if app[6][2] == nil then app[6][2] = 0;end;
			if app[6][3] == nil then app[6][3] = false;end;
			if app[6][2] < 5 then app[6][2] = 5;end; --min view
		end;
	end;
	if app[6][2] ~= nil and app[6][2] > 0 then
		local prozentColor = g_currentMission.hl.getColorProzent(g_currentMission.hl.getProzentColor(app[6][2], true), true);		
		local oneProzent = overlay.width/100;
		local width = oneProzent*app[6][2];
		g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.masterPda.appInfoBarProzent, overlay.x, nil, width);
		g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.appInfoBarProzent, prozentColor);
		moSetGetOverlaysLight.default.masterPda.appInfoBarProzent:render();	
	end;
	if app[6][3] ~= nil and app[6][3] then
		g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.masterPda.appNotice, overlay.x+overlay.width-(moSetGetOverlaysLight.default.masterPda.appNotice.width));
		moSetGetOverlaysLight.default.masterPda.appNotice:render()
	end;
end;