moDrawAppIconSetting = {}; --for hlGuiMenue

function moDrawAppIconSetting:setOpen(args)
	if args ~= nil and type(args) == "table" then		
		if moSetGetOverlays.previewIcons ~= nil and moSetGetOverlays.previewIcons["MultiOverlayV4"] == nil then
			moSetGetOverlays:loadPreviewIcons();
		end;		
		moGeneralSettings.clickAreas.menue["appIconSettingMenue"] = {};
		moGeneralSettings.clickAreas.masterMenue["appIconSettingMenue"] = {};	
		if moSetGetOverlays.previewIcons["MultiOverlayV4"] == nil then return;end; --Error, problem with Icons
		local warningDrapDropWidth = false;
		local posX = args.x;
		local posY = args.y;
		local width = args.width;
		local height = args.height;		
		local minHeight = args.minHeight;
		local distanceEdge = 0.001;
		local iconWidth = moSetGetOverlays.buttonGfxWidth1*g_currentMission.hlGui.menue.zoomOutIn;
		local iconHeight = moSetGetOverlays.buttonGfxHeight1*g_currentMission.hlGui.menue.zoomOutIn;
		local distanceIconWidth = iconWidth/4; --moSetGetOverlays.buttonGfxWidth1*4;
		local distanceIconHeight = iconHeight/3; --moSetGetOverlays.buttonGfxHeight1*6;
		local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor; 
		local optiSize = args.optiSize;
		local txt = "Edit: ";
		local moreTxt = "";
		local txtHeight = 0;
		local color = nil;
		local editTable = nil;
		local editIconTable = nil;		
		if moHlGuiAppIconSetting:isOn() then
			editTable, editIconTable, txtTitle = moHlGuiAppIconSetting:getEditTables();
			if editTable ~= nil and editIconTable ~= nil then				
				moreTxt = txtTitle;				
			else
				moreTxt = "! Start App Icon Menue over Pda !";
			end;			
		else
			moreTxt = "! Start App Icon Menue over Pda !";
		end;		
		local dummyTable = moSetGetOverlays.pda["dummyPda_"];		
		if dummyTable == nil then dummyTable = moSetGetOverlays.slot["dummySlot_"];end;
		local dummyGroundName = dummyTable.design.byName.ground;
		local dummyIconName = dummyTable.design.byName.icon;
		local dummyLineName = dummyTable.design.byName.line;
		local dummyIcon = dummyTable.design.icon;
		local dummyGround = dummyTable.design.ground;
		local dummyLine = dummyTable.design.line;		
		local overlay = dummyIcon[dummyIconName["buttonIcon"]];
		local tempOverlay = dummyIcon[dummyIconName["buttonEditIcon"]];
		local iconRightPosX = posX+width-iconWidth;
		local iconLeftPosX = posX;
		local iconPosY = posY+height-iconHeight;		
		local oldTxt = txt.. moreTxt;
		g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if editTable == nil or editIconTable == nil then
			color = g_currentMission.hl.getColor(dummyTable.color.settingOff, true);
		else
			color = g_currentMission.hl.getColor(dummyTable.color.settingOn, true);
		end;
		g_currentMission.hl.setBackgroundColor(overlay, color);
		overlay:render();
		iconLeftPosX = iconLeftPosX+iconWidth+distanceEdge;
		txt = g_currentMission.hl.getTxtToWidthFix(txt.. moreTxt, optiSize, iconRightPosX-iconLeftPosX, "..", 0);
		if txt ~= oldTxt then warningDrapDropWidth = true;end;
		setTextBold(false);
		setTextColor(unpack(g_currentMission.hl.getColor("yellow", true)));
		renderText(iconLeftPosX, iconPosY, optiSize, txt);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		if warningDrapDropWidth then g_currentMission.hlGui.setGet:blinkingDragDropWidth(true);else g_currentMission.hlGui.setGet:blinkingDragDropWidth(false);end;
		--if editTable.cmdSettings.height == 0 or editTable.cmdSettings.height ~= height or editTable.cmdSettings.bounds[4] ~= iconHeight then 
		--	editTable.cmdSettings.height = height;editTable.cmdSettings.bounds[1]=0;
		--end;
		iconPosY = iconPosY-iconHeight-distanceIconHeight;
		iconLeftPosX = posX;
		if iconPosY < posY then 
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(true);
			return;
		else
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(false);
		end;
		if editTable == nil or editIconTable == nil or not editTable.setting.on then 
			return;
		end;		
		
		local maxWidth = width/3-(distanceIconWidth*2);
		---add icon---
		overlay = g_currentMission.hlGui.menue.icon["groundButton"];
		g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,maxWidth,iconHeight);
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.buttonGround, true);
		g_currentMission.hl.setBackgroundColor(overlay, color);			
		overlay:render();
		tempOverlay = dummyIcon[dummyIconName["buttonIcon"]];
		g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-iconWidth,iconPosY,iconWidth,iconHeight);
		color = g_currentMission.hl.getColor(dummyTable.color.settingOn, true);		
		txt = tostring(moSetGetOverlays.previewIcons[editTable.appIconSettings.openMod][editTable.appIconSettings.openGroup][editTable.appIconSettings.selectIcon].iconName);		
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);			
		tempOverlay:render();
		if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueAddIcon_", isHlGui=true, infoTxt="Add Icon at App"});end;
		txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, maxWidth-iconWidth-(distanceEdge*2), "..", 0);
		setTextBold(true);
		setTextColor(unpack(color));
		renderText(overlay.x+distanceEdge, iconPosY+distanceEdge, optiSize, txt);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		---add icon---
		---del icon---
		tempOverlay = g_currentMission.hlGui.menue.icon["groundButton"];
		g_currentMission.hl.setOverlay(tempOverlay, iconLeftPosX+maxWidth+(distanceIconWidth*2),iconPosY,maxWidth,iconHeight);
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.buttonGround, true);
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);			
		tempOverlay:render();
		overlay = g_currentMission.hlGui.menue.icon["buttonDelete"];
		g_currentMission.hl.setOverlay(overlay, tempOverlay.x+tempOverlay.width-iconWidth,iconPosY,iconWidth,iconHeight);
		txt = "";
		if editIconTable == nil or editIconTable[1] == nil then
			color = g_currentMission.hl.getColor(dummyTable.color.settingOff, true);
			txt = "NOT Found App Icon";
			if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="appIconSettingMenue", isHlGui=true, infoTxt="Delete App Icon (if available App Icon)"});end;
		else
			color = g_currentMission.hl.getColor(dummyTable.color.settingReady, true);
			txt = editIconTable[1].iconName;
			if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueDeleteIcon_", isHlGui=true, infoTxt="Delete App Icon (if available App Icon)"});end;
		end;
		g_currentMission.hl.setBackgroundColor(overlay, color);			
		overlay:render();
		txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, maxWidth-iconWidth-(distanceEdge*2), "..", 0);
		setTextBold(true);
		setTextColor(unpack(color));
		renderText(tempOverlay.x+distanceEdge, iconPosY+distanceEdge, optiSize, txt);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		---del icon---
		---edit icon---
		overlay = g_currentMission.hlGui.menue.icon["groundButton"];
		g_currentMission.hl.setOverlay(overlay, iconLeftPosX+(maxWidth*2)+(distanceIconWidth*4),iconPosY,maxWidth,iconHeight);
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.buttonGround, true);
		g_currentMission.hl.setBackgroundColor(overlay, color);			
		overlay:render();
		tempOverlay = dummyIcon[dummyIconName["buttonEditIcon"]];
		g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-iconWidth,iconPosY,iconWidth,iconHeight);
		txt = "Edit Icon";
		if editIconTable == nil or editIconTable[1] == nil or editIconTable[1].iconType == nil or editIconTable[1].iconType ~= 0 or not editIconTable[1].editTxt then
			color = g_currentMission.hl.getColor(dummyTable.color.settingOff, true);
			txt = "NOT Edit Icon";
		else
			color = g_currentMission.hl.getColor(dummyTable.color.settingOn, true);
			if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueEditIcon_", isHlGui=true, infoTxt="Edit App Icon (if available App Icon and if edit icon)"});end;
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);			
		tempOverlay:render();
		txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, maxWidth-iconWidth-(distanceEdge*2), "..", 0);
		setTextBold(true);
		setTextColor(unpack(color));
		renderText(overlay.x+distanceEdge, iconPosY+distanceEdge, optiSize, txt);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		---edit icon---
		
		iconPosY = iconPosY-(iconHeight*2)-(distanceIconHeight*2);
		if iconPosY < posY then 
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(true);
			return;
		else
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(false);
		end;
		
		---icons mods---
		overlay = g_currentMission.hlGui.menue.icon["groundButton"];
		g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,width/2-distanceIconWidth,iconHeight);
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.buttonGround, true);
		g_currentMission.hl.setBackgroundColor(overlay, color);			
		overlay:render();		
		tempOverlay = dummyIcon[dummyIconName["buttonLeft"]];
		g_currentMission.hl.setOverlay(tempOverlay, overlay.x,iconPosY,iconWidth,iconHeight);
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.button, true);
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);			
		tempOverlay:render();		
		if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueBoundsOpenModLeft_"});end;
		txt = g_currentMission.hl.getTxtToWidthFix(editTable.appIconSettings.openMod, optiSize, overlay.width-(iconWidth*2)-(distanceEdge*2), "..", 0);
		local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txt, true);
		setTextBold(true);
		setTextColor(unpack(color));
		renderText(overlay.x+(overlay.width/2)-(txtWidth/2), iconPosY+distanceEdge, optiSize, txt);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);		
		tempOverlay = dummyIcon[dummyIconName["buttonRight"]];
		g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-iconWidth,iconPosY,iconWidth,iconHeight);
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.button, true);
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);			
		tempOverlay:render();
		if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueBoundsOpenModRight_"});end;
		---icons mods---		
		
		--icon mods group--
		tempOverlay = g_currentMission.hlGui.menue.icon["groundButton"];
		g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width+distanceIconWidth,iconPosY,width/2-distanceIconWidth,iconHeight);
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.buttonGround, true);
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);			
		tempOverlay:render();		
		overlay = dummyIcon[dummyIconName["buttonLeft"]];
		g_currentMission.hl.setOverlay(overlay, tempOverlay.x,iconPosY,iconWidth,iconHeight);
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.button, true);
		g_currentMission.hl.setBackgroundColor(overlay, color);			
		overlay:render();
		if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueBoundsOpenGroupLeft_"});end;
		txt = g_currentMission.hl.getTxtToWidthFix(editTable.appIconSettings.openGroup, optiSize, tempOverlay.width-(iconWidth*2)-(distanceEdge*2), "..", 0);
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.txt, true);
		setTextBold(true);
		setTextColor(unpack(color));
		renderText(tempOverlay.x+(tempOverlay.width/2)-(txtWidth/2), iconPosY+distanceEdge, optiSize, txt);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);		
		overlay = dummyIcon[dummyIconName["buttonRight"]];
		g_currentMission.hl.setOverlay(overlay, tempOverlay.x+tempOverlay.width-iconWidth,iconPosY,iconWidth,iconHeight);
		color = g_currentMission.hl.getColor(g_currentMission.hlGui.menue.color.button, true);
		g_currentMission.hl.setBackgroundColor(overlay, color);			
		overlay:render();
		if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueBoundsOpenGroupRight_"});end;
		--icon mods group--		
		
		iconLeftPosX = posX;
		iconPosY = iconPosY-iconHeight-distanceIconHeight;
		if iconPosY < posY then 
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(true);
			return;
		else
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(false);
		end;
				
					
			local iconTable = moSetGetOverlays.previewIcons[editTable.appIconSettings.openMod][editTable.appIconSettings.openGroup];
			if iconTable ~= nil and #iconTable > 0 then
				local previewIconHeight = iconHeight*2;
				local previewIconWidth = iconWidth*2;
				local iconOptiSize = g_currentMission.hl.optiHeightSize(previewIconHeight, "Äg", 0.015);
				local iconOptiSizeHalf = g_currentMission.hl.optiHeightSize(previewIconHeight, "Äg", 0.015);
				tempOverlay = dummyGround[dummyGroundName["groundWhiteSettingT"]];
				g_currentMission.hl.setOverlay(tempOverlay, posX, posY, width, iconPosY-posY+distanceEdge);
				tempOverlay:render();
				iconPosY = iconPosY-previewIconHeight;
				for icon=1, #iconTable do
					if iconTable[icon] ~= nil then
						if iconPosY > posY then
							if iconLeftPosX+previewIconWidth+(distanceIconWidth) < iconRightPosX then
								overlay = iconTable[icon];
								g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,previewIconWidth,previewIconHeight);
								overlay:render();
								iconLeftPosX = iconLeftPosX+previewIconWidth+(distanceIconWidth);
							else
								iconLeftPosX = posX;
								iconPosY = iconPosY-previewIconHeight-distanceIconHeight;
								overlay = iconTable[icon];
								g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,previewIconWidth,previewIconHeight);
								overlay:render();
								iconLeftPosX = iconLeftPosX+previewIconWidth+(distanceIconWidth);
							end;
							if editTable.appIconSettings.selectIcon == icon then
								moSetGetDraw:setLineBorder(dummyLine[dummyLineName["lineBlack"]], overlay, 1, 0.0008, true, true, true, true);
							end;
							if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueSelectIcon_", isHlGui=true, infoTxt=iconTable[icon].infoTxt, ownTable={icon=icon}});end;
							
							if not disableClickArea and overlay.isFormatTxt ~= nil and overlay.txt ~= nil and #overlay.txt > 0 then	
								local tempWhatTable = {
									color = {txt="green"};
									appOptiSizeTxtHeight = iconOptiSize;
									appOptiSizeHalfTxtHeight = iconOptiSizeHalf;
									txtWidthFix = 0;
								};							
								moSetGetDraw:setFormatIconTxt(tempWhatTable, iconTable[icon]);								
								if overlay.iconFormatTxt ~= nil and #overlay.iconFormatTxt > 0 then
									for iconTxt=1, #overlay.iconFormatTxt do
										if overlay.iconFormatTxt[iconTxt].run then
											setTextBold(overlay.iconFormatTxt[iconTxt].bold);	
											setTextColor(unpack(overlay.iconFormatTxt[iconTxt].color));		
											renderText(overlay.iconFormatTxt[iconTxt].x, overlay.iconFormatTxt[iconTxt].y, overlay.iconFormatTxt[iconTxt].size, overlay.iconFormatTxt[iconTxt].txt);
											setTextBold(false);		
											setTextColor(1, 1, 1, 1);
										end;
									end;
								end;
							end;
						
						
						else
							if icon < #iconTable then
								g_currentMission.hlGui.setGet:blinkingDragDropHeight(true);
								break;
							else
								g_currentMission.hlGui.setGet:blinkingDragDropHeight(false);
							end;
						end;
					end;
				end;
			end;
			local isLineView = 0; --disabled
			if isLineView < editTable.appIconSettings.bounds[3] then 
				--moSetGetDraw:setLineHorizontal(slotLine[slotLineName["lineBlackBorderUp"]], slotGround[groundIcon].x, endTxtPosY, slotGround[groundIcon].width, 0.0008)
				--moSetGetDraw:setLineBorder(slotLine[slotLineName["lineBlackBorderUp"]], {x=slotGround[groundIcon].x,y=endTxtPosY,width=slotGround[groundIcon].width,height=0}, 1, 0.0008, false, true, false, false);
				---output line up---
				overlay = dummyIcon[dummyIconName["buttonUp"]];
				g_currentMission.hl.setOverlay(overlay,posX+(width/4)-(iconWidth/2),posY-minHeight+distanceEdge,iconWidth,iconHeight);
				if editTable.appIconSettings.bounds[1] <= 1 then
					color = g_currentMission.hl.getColor(editTable.color.settingOff, true);
				else
					color = g_currentMission.hl.getColor(editTable.color.settingOn, true);
				end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
				overlay:render();
				local tempOverlay = {
					[1]=posX;
					[2]=posX+(width/2);
					[3]=posY-minHeight;
					[4]=posY;
				};			
				if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueUp_"});end;
				---output line up---
				---output line down---
				overlay = dummyIcon[dummyIconName["buttonDown"]];
				g_currentMission.hl.setOverlay(overlay,posX+((width/4)*3)-(iconWidth/2),posY-minHeight+distanceEdge,iconWidth,iconHeight);
				if editTable.appIconSettings.bounds[2] >= editTable.appIconSettings.bounds[3] then
					color = g_currentMission.hl.getColor(editTable.color.settingOff, true);
				else
					color = g_currentMission.hl.getColor(editTable.color.settingOn, true);
				end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
				overlay:render();
				tempOverlay = {
					[1]=posX+(width/2); 
					[2]=posX+width-iconWidth;
					[3]=posY-minHeight;
					[4]=posY;
				};			
				if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueDown_"});end;
				---output line down---
				---output scroll line up/down---
				tempOverlay = {
					[1]=posX; 
					[2]=posX+width;
					[3]=posY-minHeight;
					[4]=posY+height;
				};
				---output scroll line up/down---
				---output scroll line up---
				if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueScrollUp_"});end;
				---output scroll line up---				
				---output scroll line down---
				if not disableClickArea then moDrawAppIconSetting:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="appIconSettingMenue", editTable=editTable, whereClick="appIconSettingMenueScrollDown_"});end;
				---output scroll line down---				
				overlay = g_currentMission.hlGui.menue.icon["buttonMouseMiddle"];
				g_currentMission.hl.setOverlay(overlay,posX+(width/2)-(iconWidth/2),posY-minHeight+distanceEdge,iconWidth,iconHeight);				
				color = g_currentMission.hl.getColor("gold", true);				
				g_currentMission.hl.setBackgroundColor(overlay, color);
				overlay:render();				
			end;
		
		---output total area---
		tempOverlay = {
			[1]=posX; 
			[2]=posX+width;
			[3]=posY-minHeight;
			[4]=posY+height;
		};
		if not disableClickArea then moDrawAppIconSetting:clickAreas(true, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="appIconSettingMenue"});end;
		---output total area---
	end;
end;

function moDrawAppIconSetting:clickAreas(masterArea, args)	
	if masterArea ~= nil and masterArea then
		moGeneralSettings.clickAreas.masterMenue[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;
		};
	else	
		moGeneralSettings.clickAreas.menue[args.whatClick][#moGeneralSettings.clickAreas.menue[args.whatClick]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whatClick = args.whatClick;			
			whereClick = args.whereClick;			
			isHlGui = args.isHlGui or false;
			mouseClick = "";
			helpTxt = args.helpTxt;
			infoTxt = args.infoTxt;			
			callback = args.callback;
			editTable = args.editTable;
			editIconTable = args.editIconTable;
			cmdPos = args.cmdPos;
			ownTable = args.ownTable;			
			cmdTable = args.cmdTable;
		};
	end;	
end;

function moDrawAppIconSetting:getFormatOutputLines(editTable, editCmdTable)	
	local outputTable = moHlGuiCmdSetting:giveOutputTable( {editTable=editTable, editCmdTable=editCmdTable} );
	if outputTable ~= nil and #outputTable.line > 0 then
		editTable.cmdSettings.bounds[3] = #outputTable.line;
		if editTable.cmdSettings.bounds[1] == 0 then			
			editTable.cmdSettings.bounds[1] = 1;
			local iconHeight = moSetGetOverlays.buttonGfxHeight1*g_currentMission.hlGui.menue.zoomOutIn;
			local maxLines = moSetGetDraw:getMaxHeight(editTable.cmdSettings.height, iconHeight);
			if maxLines > 1 then
				editTable.cmdSettings.bounds[2] = maxLines;
			else
				editTable.cmdSettings.bounds[2] = 1;
			end;
			editTable.cmdSettings.bounds[4] = iconHeight;
		end;	
		for line=1, #outputTable.line do
			if outputTable.line[line] ~= nil then									
				if line >= editTable.cmdSettings.bounds[1] and line <= editTable.cmdSettings.bounds[2] then
					outputTable.line[line].view = true;						
				else
					outputTable.line[line].view = false;
				end;
			end;
		end;
	end;
	return outputTable.line;
end;