moDrawCmdSetting = {}; --for hlGuiMenue

function moDrawCmdSetting:setOpen(args)
	if args ~= nil and type(args) == "table" then		
		moGeneralSettings.clickAreas.menue["cmdSettingMenue"] = {};
		moGeneralSettings.clickAreas.masterMenue["cmdSettingMenue"] = {};	
		local warningDrapDropWidth = false;
		local posX = args.x;
		local posY = args.y;
		local width = args.width;
		local height = args.height;		
		local minHeight = args.minHeight;
		local distanceEdge = 0.001;
		local iconWidth = moSetGetOverlays.buttonGfxWidth1*g_currentMission.hlGui.menue.zoomOutIn;
		local iconHeight = moSetGetOverlays.buttonGfxHeight1*g_currentMission.hlGui.menue.zoomOutIn;
		local distanceIconWidth = iconWidth/4; --moSetGetOverlays.buttonGfxWidth1*4;
		local distanceIconHeight = iconHeight/3; --moSetGetOverlays.buttonGfxHeight1*6;
		local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor; 
		local optiSize = args.optiSize;
		local txt = "Edit: ";
		local moreTxt = "";
		local txtHeight = 0;
		local color = nil;
		local editTable = nil;
		local editCmdTable = nil;		
		if moHlGuiCmdSetting:isOn() then
			editTable, editCmdTable, txtTitle = moHlGuiCmdSetting:getEditTables();
			if editTable ~= nil and editCmdTable ~= nil then				
				moreTxt = txtTitle;				
			else
				moreTxt = "! Start Cmd Menue over Slot/Pda !";
			end;			
		else
			moreTxt = "! Start Cmd Menue over Slot/Pda !";
		end;		
		local dummyTable = moSetGetOverlays.slot["dummySlot_"];		
		if dummyTable == nil then dummyTable = moSetGetOverlays.pda["dummyPda_"];end;
		local dummyGroundName = dummyTable.design.byName.ground;
		local dummyIconName = dummyTable.design.byName.icon;
		local dummyLineName = dummyTable.design.byName.line;
		local dummyIcon = dummyTable.design.icon;
		local dummyGround = dummyTable.design.ground;
		local dummyLine = dummyTable.design.line;		
		local overlay = dummyIcon[dummyIconName["buttonCmd"]];
		local tempOverlay = dummyIcon[dummyIconName["buttonCmd"]];
		local iconRightPosX = posX+width-iconWidth;
		local iconLeftPosX = posX;
		local iconPosY = posY+height-iconHeight;		
		local oldTxt = txt.. moreTxt;
		g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if editTable == nil or editCmdTable == nil then
			color = g_currentMission.hl.getColor(dummyTable.color.settingOff, true);
		else
			color = g_currentMission.hl.getColor(dummyTable.color.settingOn, true);
		end;
		g_currentMission.hl.setBackgroundColor(overlay, color);
		overlay:render();
		iconLeftPosX = iconLeftPosX+iconWidth+distanceEdge;
		txt = g_currentMission.hl.getTxtToWidthFix(txt.. moreTxt, optiSize, iconRightPosX-iconLeftPosX, "..", 0);
		if txt ~= oldTxt then warningDrapDropWidth = true;end;
		setTextBold(false);
		setTextColor(unpack(g_currentMission.hl.getColor("yellow", true)));
		renderText(iconLeftPosX, iconPosY, optiSize, txt);
		setTextColor(1, 1, 1, 1);
		setTextBold(false);
		if warningDrapDropWidth then g_currentMission.hlGui.setGet:blinkingDragDropWidth(true);else g_currentMission.hlGui.setGet:blinkingDragDropWidth(false);end;
		if editTable == nil or editCmdTable == nil then 
			return;
		end;
		if editTable.cmdSettings.height == 0 or editTable.cmdSettings.height ~= height-minHeight-(iconHeight*2) or editTable.cmdSettings.bounds[4] ~= iconHeight+distanceIconHeight then 
			editTable.cmdSettings.height = height-minHeight-(iconHeight*2);editTable.cmdSettings.bounds[1]=0;
		end;
		iconPosY = iconPosY-iconHeight-distanceIconHeight;
		iconLeftPosX = posX;
		if iconPosY < posY then 
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(true);
			return;
		else
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(false);
		end;
		tempOverlay = dummyIcon[dummyIconName["buttonCmdView"]];
		g_currentMission.hl.setOverlay(tempOverlay, iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if editTable.cmdSettings.viewActiveCmd then
			color = g_currentMission.hl.getColor(editTable.color.settingActiveCmd, true);
		else
			color = g_currentMission.hl.getColor(editTable.color.settingDefault, true);
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);
		tempOverlay:render();
		if not disableClickArea then moDrawCmdSetting:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingViewActiveCmd_", isHlGui=true, infoTxt="View On/Off Active Cmds", editTable=editTable});end;
		iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
		g_currentMission.hl.setOverlay(tempOverlay, iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if editTable.cmdSettings.viewAlreadyExistsCmd then
			color = g_currentMission.hl.getColor(editTable.color.settingAlreadyExistsCmd, true);
		else
			color = g_currentMission.hl.getColor(editTable.color.settingDefault, true);
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);
		tempOverlay:render();
		if not disableClickArea then moDrawCmdSetting:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingViewAlreadyExistsCmd_", isHlGui=true, infoTxt="View On/Off Already Exists Cmd", editTable=editTable});end;
		iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
		if not editTable.cmdSettings.moveUp then 
			tempOverlay = dummyIcon[dummyIconName["buttonMoveUp"]];
		else
			tempOverlay = dummyIcon[dummyIconName["buttonMoveDown"]];
		end;
		g_currentMission.hl.setOverlay(tempOverlay, iconLeftPosX,iconPosY,iconWidth,iconHeight);
		color = g_currentMission.hl.getColor(editTable.color.settingReady, true);
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);
		tempOverlay:render();
		if not disableClickArea then moDrawCmdSetting:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingActiveCmdMoveUpOrDown_", isHlGui=true, infoTxt="Set Edit Cmd Pos Up or Down", editTable=editTable});end;
		iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
		tempOverlay = dummyIcon[dummyIconName["buttonDistanceObject"]];
		g_currentMission.hl.setOverlay(tempOverlay, iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if editTable.cmdSettings.viewDistanceObjectCmd then
			color = g_currentMission.hl.getColor(editTable.color.txtExtra, true);
		else
			color = g_currentMission.hl.getColor(editTable.color.settingDefault, true);
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, color);
		tempOverlay:render();
		if not disableClickArea then moDrawCmdSetting:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+iconWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingViewDistanceObjectCmd_", isHlGui=true, infoTxt="View On/Off Player near Cmd Object (".. tostring(editTable.cmdSettings.distanceObject).. "m) !search only at Open Groups!", editTable=editTable});end;
		local tempOptiSize = g_currentMission.hl.optiWidthSize(iconWidth, tostring(editTable.cmdSettings.distanceObject), optiSize);		
		if editTable.cmdSettings.viewDistanceObjectCmd and (editTable.cmdSettings.distanceObject >= 50 or editTable.cmdSettings.distanceObject <= 1) then color = g_currentMission.hl.getColor(editTable.color.settingOff, true);end;
		txtHeight = getTextHeight(tempOptiSize, utf8Substr(tostring(editTable.cmdSettings.distanceObject), 0))
		setTextBold(true);	
		setTextColor(unpack(color));		
		renderText(iconLeftPosX+iconWidth, iconPosY+(iconHeight/2)-(txtHeight/2), tempOptiSize, tostring(editTable.cmdSettings.distanceObject));
		setTextBold(false);		
		setTextColor(1, 1, 1, 1);
		iconLeftPosX = iconLeftPosX+(iconWidth*2)+distanceIconWidth;		
		if editTable.cmdSettings.viewDistanceObjectCmd then
			overlay = dummyIcon[dummyIconName["buttonUpDown"]];
			g_currentMission.hl.setOverlay(overlay, iconLeftPosX,iconPosY,iconWidth,iconHeight);												
			color = g_currentMission.hl.getColor(editTable.color.txtExtra, true);
			g_currentMission.hl.setBackgroundColor(overlay, color);			
			overlay:render();
			if not disableClickArea then moDrawCmdSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y+(overlay.height/2), overlay.y+overlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingDistanceObjectCmdUp_", isHlGui=true, infoTxt="Player near Cmd Object Distance Up (max 50)", editTable=editTable});end;
			if not disableClickArea then moDrawCmdSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+(overlay.height/2), whatClick="cmdSettingMenue", whereClick="cmdSettingDistanceObjectCmdDown_", isHlGui=true, infoTxt="Player near Cmd Object Distance Down (min 1)", editTable=editTable});end;
			iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;						
		end;
		iconLeftPosX = posX;
		iconPosY = iconPosY-iconHeight-distanceIconHeight;
		if iconPosY < posY then 
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(true);
			return;
		else
			g_currentMission.hlGui.setGet:blinkingDragDropHeight(false);
		end;
		local outputTable = moDrawCmdSetting:getFormatOutputLines(editTable, editCmdTable);
		if outputTable ~= nil and #outputTable > 0 then			
			optiSize = MultiOverlayV4:get_hl("optiHeightSize", {iconHeight, "Äg", 0.015}, "moDrawCmdSetting:setOpen");
			txtHeight = getTextHeight(optiSize, utf8Substr("Äg", 0));
			local outputIconHeight = iconHeight; 
			local outputIconWidth = iconWidth;		
			iconRightPosX = posX+width-iconWidth; 
			iconLeftPosX = posX; 
			iconPosY = iconPosY;			
			local firstTxtPosY = iconPosY+iconHeight+distanceIconHeight;
			local nextTxtPosY = iconHeight+distanceIconHeight;
			local endTxtPosY = posY;		
			local isLineView = 0;								
			for line=1, #outputTable do				
				if outputTable[line] ~= nil and outputTable[line].view then
					if outputTable[line].txt ~= nil and #outputTable[line].txt > 0 then
						for lineTxt=1, #outputTable[line].txt do
							if outputTable[line].txt[lineTxt].txt ~= nil then								
								if outputTable[line].txt[lineTxt].groupName then
									overlay = dummyIcon[dummyIconName["buttonDown"]];
									g_currentMission.hl.setOverlay(overlay,iconLeftPosX,firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
									if overlay.iconType == 2 then			
										if editTable.cmdSettings.openGroup[outputTable[line].txt[lineTxt].ownTable.groupName] ~= nil then
											color = g_currentMission.hl.getColor(editTable.color.settingOn, true);
										else	
											color = g_currentMission.hl.getColor(editTable.color.settingDefault, true);							
										end;
										g_currentMission.hl.setBackgroundColor(overlay, color);
									end;
									overlay:render();
								end;									
								local isSelectCmd = false;
								local isActiveCmd = outputTable[line].txt[lineTxt].activeCmd ~= nil and outputTable[line].txt[lineTxt].activeCmd;
								local notFoundCmd = outputTable[line].txt[lineTxt].notFoundCmd ~= nil and outputTable[line].txt[lineTxt].notFoundCmd;
								local maxTxtWidth = iconRightPosX-iconLeftPosX-(outputIconWidth*2)-(distanceEdge*2)-(outputIconWidth*5);
								txt = outputTable[line].txt[lineTxt].txt;										
								txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, maxTxtWidth, "..", 0);										
								if outputTable[line].txt[lineTxt].slotColor ~= nil and editTable.color[outputTable[line].txt[lineTxt].slotColor] ~= nil then
									color = g_currentMission.hl.getColor(editTable.color[outputTable[line].txt[lineTxt].slotColor], true);
								elseif outputTable[line].txt[lineTxt].color ~= nil then
									color = g_currentMission.hl.getColor(outputTable[line].txt[lineTxt].color, true);
								else
									color = g_currentMission.hl.getColor(editTable.color.txt, true);
								end;
								if outputTable[line].txt[lineTxt].bold ~= nil then setTextBold(outputTable[line].txt[lineTxt].bold);else setTextBold(false);end;
								setTextColor(unpack(color));		
								if outputTable[line].txt[lineTxt].groupName then
									renderText(iconLeftPosX+outputIconWidth+(distanceEdge), firstTxtPosY-nextTxtPosY, optiSize, txt);
								else
									if outputTable[line].txt[lineTxt].ownTable ~= nil and outputTable[line].txt[lineTxt].ownTable.cmdRegName ~= nil then
										if MultiOverlayV4.cmdSetting.selectCmd[1] ~= nil and MultiOverlayV4.cmdSetting.selectCmd[1].regName == outputTable[line].txt[lineTxt].ownTable.cmdRegName then
											isSelectCmd = true;
										end;
									end;
									if not isSelectCmd or (isSelectCmd and g_currentMission.hl.runsTimer("1sec", true)) then
										renderText(iconLeftPosX+(outputIconWidth*2)+(distanceEdge*2), firstTxtPosY-nextTxtPosY, optiSize, txt);
									end;
								end;
								if outputTable[line].txt[lineTxt].ownTable ~= nil and outputTable[line].txt[lineTxt].ownTable.cmdRegName ~= nil and MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName] ~= nil and (MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].typ[1] == "output_" ) then 
									moDrawCmdSetting:setCmdOverObject(MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName]);
								end;
								setTextBold(false);		
								setTextColor(1, 1, 1, 1);
								if notFoundCmd or isSelectCmd then
									---newPos cmd---
									overlay = dummyIcon[dummyIconName["buttonMoveUp"]];
									if isSelectCmd and not editTable.cmdSettings.moveUp then overlay = dummyIcon[dummyIconName["buttonMoveDown"]];end;
									g_currentMission.hl.setOverlay(overlay,iconLeftPosX+outputIconWidth,firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
									if overlay.iconType == 2 then									
										color = g_currentMission.hl.getColor(editTable.color.settingReady, true);								
										g_currentMission.hl.setBackgroundColor(overlay, color);
									end;
									if not notFoundCmd and isActiveCmd then 
										overlay:render();											
										if not disableClickArea then moDrawCmdSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingNewPosActiveCmd_", isHlGui=true, editTable=editTable, editCmdTable=editCmdTable, ownTable=outputTable[line].txt[lineTxt].ownTable, infoTxt="Set this cmd new position"});end;
									end;
									---newPos cmd---
									---insert/delete cmd---								
									overlay = dummyIcon[dummyIconName["buttonNotOkay"]];											
									if not isActiveCmd then overlay = dummyIcon[dummyIconName["buttonOkay"]];end;
									g_currentMission.hl.setOverlay(overlay,iconRightPosX,firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
									if overlay.iconType == 2 then									
										if not isActiveCmd then 
											color = g_currentMission.hl.getColor(editTable.color.settingOn, true);	
										else
											color = g_currentMission.hl.getColor(editTable.color.settingOff, true);									
										end;
										g_currentMission.hl.setBackgroundColor(overlay, color);
									end;
									if g_currentMission.hl.runsTimer("1sec", true) or notFoundCmd then overlay:render();end;											
									if isActiveCmd then
										if not disableClickArea then moDrawCmdSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingDeleteActiveCmd_", isHlGui=true, editTable=editTable, editCmdTable=editCmdTable, ownTable=outputTable[line].txt[lineTxt].ownTable, infoTxt="Delete this Active cmd"});end;
									else
										if not disableClickArea then moDrawCmdSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingInsertActiveCmd_", isHlGui=true, editTable=editTable, editCmdTable=editCmdTable, ownTable=outputTable[line].txt[lineTxt].ownTable, infoTxt="Insert this cmd"});end;
									end;
									---insert/delete cmd---
								end;
								---all mouseClicks---
								if outputTable[line].txt[lineTxt].ownTable ~= nil and outputTable[line].txt[lineTxt].ownTable.cmdRegName ~= nil and MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName] ~= nil and (MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].typ[1] == "outputAction_" or MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].typ[1] == "action_") then 
									local leftClick = false;
									local middleClick = false;
									local rightClick = false;
									if isActiveCmd then												
										leftClick = editCmdTable[outputTable[line].txt[lineTxt].ownTable.cmd].mouseClick[1];
										middleClick = editCmdTable[outputTable[line].txt[lineTxt].ownTable.cmd].mouseClick[2];
										rightClick = editCmdTable[outputTable[line].txt[lineTxt].ownTable.cmd].mouseClick[3];												
									else
										leftClick = MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[1];
										middleClick = MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[2];
										rightClick = MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[3];
									end;
									--button separator horizontal--
									if isSelectCmd and isActiveCmd then
										overlay = dummyIcon[dummyIconName["buttonSeparatorHorizontal"]];
										g_currentMission.hl.setOverlay(overlay,iconRightPosX-(outputIconWidth*4),firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
										if overlay.iconType == 2 then									
											color = g_currentMission.hl.getColor(editTable.color.settingOn, true);								
											g_currentMission.hl.setBackgroundColor(overlay, color);
										end;
										overlay:render();
									end;
									--button separator horizontal--
									---mouseClick Left---
									overlay = dummyIcon[dummyIconName["mouseClickLeft"]];
									g_currentMission.hl.setOverlay(overlay,iconRightPosX-(outputIconWidth*3),firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
									if overlay.iconType == 2 then --and MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[1] then			
										if leftClick then
											color = g_currentMission.hl.getColor(editTable.color.txtOutputTitle, true);
										elseif not MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[1] then
											color = g_currentMission.hl.getColor(editTable.color.settingOff, true);
										else
											color = g_currentMission.hl.getColor("darkGray", true);
										end;
										g_currentMission.hl.setBackgroundColor(overlay, color);
									end;
									if isActiveCmd or isSelectCmd then overlay:render();end;
									if MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[1] then
										if isSelectCmd and isActiveCmd then
											if not disableClickArea then moDrawCmdSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingSetMouseClickCmd_", isHlGui=true, editCmdTable=editCmdTable, ownTable={cmd=outputTable[line].txt[lineTxt].ownTable.cmd,mouseClick=1}, infoTxt="MouseClick to execute this cmd"});end;
										end;
									end;
									---mouseClick Left---
									---mouseClick Middle---
									overlay = dummyIcon[dummyIconName["mouseClickMiddle"]];
									g_currentMission.hl.setOverlay(overlay,iconRightPosX-(outputIconWidth*2),firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
									if overlay.iconType == 2 then --and MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[2] then			
										if middleClick then
											color = g_currentMission.hl.getColor(editTable.color.txtOutputTitle, true);
										elseif not MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[2] then
											color = g_currentMission.hl.getColor(editTable.color.settingOff, true);
										else
											color = g_currentMission.hl.getColor("darkGray", true);
										end;
										g_currentMission.hl.setBackgroundColor(overlay, color);
									end;
									if isActiveCmd or isSelectCmd then overlay:render();end;
									if MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[2] then
										if isSelectCmd and isActiveCmd then
											if not disableClickArea then moDrawCmdSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingSetMouseClickCmd_", isHlGui=true, editCmdTable=editCmdTable, ownTable={cmd=outputTable[line].txt[lineTxt].ownTable.cmd,mouseClick=2}, infoTxt="MouseClick to execute this cmd"});end;
										end;
									end;
									---mouseClick Middle---
									---mouseClick Right---
									overlay = dummyIcon[dummyIconName["mouseClickRight"]];
									g_currentMission.hl.setOverlay(overlay,iconRightPosX-(outputIconWidth*1),firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
									if overlay.iconType == 2 then --and MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[3] then			
										if rightClick then
											color = g_currentMission.hl.getColor(editTable.color.txtOutputTitle, true);
										elseif not MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[3] then
											color = g_currentMission.hl.getColor(editTable.color.settingOff, true);
										else
											color = g_currentMission.hl.getColor("darkGray", true);
										end;
										g_currentMission.hl.setBackgroundColor(overlay, color);
									end;
									if isActiveCmd or isSelectCmd then overlay:render();end;
									if MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName].mouseClickAccepts[3] then
										if isSelectCmd and isActiveCmd then
											if not disableClickArea then moDrawCmdSetting:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="cmdSettingMenue", whereClick="cmdSettingSetMouseClickCmd_", isHlGui=true, editCmdTable=editCmdTable, ownTable={cmd=outputTable[line].txt[lineTxt].ownTable.cmd,mouseClick=3}, infoTxt="MouseClick to execute this cmd"});end;
										end;
									end;
									---mouseClick Right---
								end;
								---all mouseClicks---
								if outputTable[line].txt[lineTxt].callback ~= nil then
									local tempArea = {
										[1]=iconLeftPosX+(outputIconWidth*2)+distanceEdge; 
										[2]=iconRightPosX-(outputIconWidth*5)-distanceIconWidth;
										[3]=firstTxtPosY-nextTxtPosY;
										[4]=firstTxtPosY-nextTxtPosY+(iconHeight+distanceIconHeight);
									};
									if outputTable[line].txt[lineTxt].groupName then tempArea[1] = posX;end;
									local isCmdTable = MultiOverlayV4.cmd[outputTable[line].txt[lineTxt].ownTable.cmdRegName];
									local infoTxt = nil;
									if isCmdTable then infoTxt = isCmdTable.infoTxt;end;
									if not disableClickArea then moDrawCmdSetting:clickAreas(false, {tempArea[1], tempArea[2], tempArea[3], tempArea[4], whatClick="cmdSettingMenue", whereClick="outputTableCallback_", editTable=editTable, callback=outputTable[line].txt[lineTxt].callback, isHlGui=true, cmdTable=isCmdTable, ownTable=outputTable[line].txt[lineTxt].ownTable, infoTxt=infoTxt});end;
								end;
							end;
						end;
					end;
					isLineView = isLineView+1;
					if isLineView >= editTable.cmdSettings.bounds[3] then break;end;
					nextTxtPosY = nextTxtPosY+(iconHeight+distanceIconHeight);
					if firstTxtPosY-nextTxtPosY < posY and line < #outputTable then break;end;
				end;
			end;
			if isLineView < editTable.cmdSettings.bounds[3] then 
				--moSetGetDraw:setLineHorizontal(slotLine[slotLineName["lineBlackBorderUp"]], slotGround[groundIcon].x, endTxtPosY, slotGround[groundIcon].width, 0.0008)
				--moSetGetDraw:setLineBorder(slotLine[slotLineName["lineBlackBorderUp"]], {x=slotGround[groundIcon].x,y=endTxtPosY,width=slotGround[groundIcon].width,height=0}, 1, 0.0008, false, true, false, false);
				---output line up---
				overlay = dummyIcon[dummyIconName["buttonUp"]];
				g_currentMission.hl.setOverlay(overlay,posX+(width/4)-(iconWidth/2),posY-minHeight+distanceEdge,iconWidth,iconHeight);
				if editTable.cmdSettings.bounds[1] <= 1 then
					color = g_currentMission.hl.getColor(editTable.color.settingOff, true);
				else
					color = g_currentMission.hl.getColor(editTable.color.settingOn, true);
				end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
				overlay:render();
				local tempOverlay = {
					[1]=posX;
					[2]=posX+(width/2);
					[3]=posY-minHeight;
					[4]=posY;
				};			
				if not disableClickArea then moDrawCmdSetting:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="cmdSettingMenue", editTable=editTable, whereClick="cmdSettingMenueUp_"});end;
				---output line up---
				---output line down---
				overlay = dummyIcon[dummyIconName["buttonDown"]];
				g_currentMission.hl.setOverlay(overlay,posX+((width/4)*3)-(iconWidth/2),posY-minHeight+distanceEdge,iconWidth,iconHeight);
				if editTable.cmdSettings.bounds[2] >= editTable.cmdSettings.bounds[3] then
					color = g_currentMission.hl.getColor(editTable.color.settingOff, true);
				else
					color = g_currentMission.hl.getColor(editTable.color.settingOn, true);
				end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
				overlay:render();
				tempOverlay = {
					[1]=posX+(width/2); 
					[2]=posX+width-iconWidth;
					[3]=posY-minHeight;
					[4]=posY;
				};			
				if not disableClickArea then moDrawCmdSetting:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="cmdSettingMenue", editTable=editTable, whereClick="cmdSettingMenueDown_"});end;
				---output line down---
				---output scroll line up/down---
				tempOverlay = {
					[1]=posX; 
					[2]=posX+width;
					[3]=posY-minHeight;
					[4]=posY+height;
				};
				---output scroll line up/down---
				---output scroll line up---
				if not disableClickArea then moDrawCmdSetting:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="cmdSettingMenue", editTable=editTable, whereClick="cmdSettingMenueScrollUp_"});end;
				---output scroll line up---				
				---output scroll line down---
				if not disableClickArea then moDrawCmdSetting:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="cmdSettingMenue", editTable=editTable, whereClick="cmdSettingMenueScrollDown_"});end;
				---output scroll line down---				
				overlay = g_currentMission.hlGui.menue.icon["buttonMouseMiddle"];
				g_currentMission.hl.setOverlay(overlay,posX+(width/2)-(iconWidth/2),posY-minHeight+distanceEdge,iconWidth,iconHeight);				
				color = g_currentMission.hl.getColor("gold", true);				
				g_currentMission.hl.setBackgroundColor(overlay, color);
				overlay:render();				
			end;
		end;
		---output total area---
		tempOverlay = {
			[1]=posX; 
			[2]=posX+width;
			[3]=posY-minHeight;
			[4]=posY+height;
		};
		---testarea --moSetGetDraw:setLineBorder(dummyLine[dummyLineName["lineColorBorder"]], {x=tempOverlay[1],y=tempOverlay[3],width=tempOverlay[2]-tempOverlay[1],height=tempOverlay[4]-tempOverlay[3]}, 1, 0.0008, true, true, true, true, "yellow");
		if not disableClickArea then moDrawCmdSetting:clickAreas(true, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick="cmdSettingMenue"});end;
		---output total area---
	end;
end;

function moDrawCmdSetting:clickAreas(masterArea, args)	
	if masterArea ~= nil and masterArea then
		moGeneralSettings.clickAreas.masterMenue[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;
		};
	else	
		moGeneralSettings.clickAreas.menue[args.whatClick][#moGeneralSettings.clickAreas.menue[args.whatClick]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whatClick = args.whatClick;			
			whereClick = args.whereClick;			
			isHlGui = args.isHlGui or false;
			mouseClick = "";
			helpTxt = args.helpTxt;
			infoTxt = args.infoTxt;			
			callback = args.callback;
			editTable = args.editTable;
			editCmdTable = args.editCmdTable;
			cmdPos = args.cmdPos;
			ownTable = args.ownTable;			
			cmdTable = args.cmdTable;
		};
	end;	
end;

function moDrawCmdSetting:getFormatOutputLines(editTable, editCmdTable)	
	local outputTable = moHlGuiCmdSetting:giveOutputTable( {editTable=editTable, editCmdTable=editCmdTable} );
	if outputTable ~= nil and #outputTable.line > 0 then
		editTable.cmdSettings.bounds[3] = #outputTable.line;
		if editTable.cmdSettings.bounds[1] == 0 then			
			editTable.cmdSettings.bounds[1] = 1;
			local iconHeight = moSetGetOverlays.buttonGfxHeight1*g_currentMission.hlGui.menue.zoomOutIn;
			local distanceIconHeight = iconHeight/3;
			local maxLines = moSetGetDraw:getMaxHeight(editTable.cmdSettings.height, iconHeight+distanceIconHeight);
			if maxLines > 1 then
				editTable.cmdSettings.bounds[2] = maxLines;
			else
				editTable.cmdSettings.bounds[2] = 1;
			end;
			editTable.cmdSettings.bounds[4] = iconHeight+distanceIconHeight;
		end;	
		for line=1, #outputTable.line do
			if outputTable.line[line] ~= nil then									
				if line >= editTable.cmdSettings.bounds[1] and line <= editTable.cmdSettings.bounds[2] then
					outputTable.line[line].view = true;						
				else
					outputTable.line[line].view = false;
				end;
			end;
		end;
	end;
	return outputTable.line;
end;

function moDrawCmdSetting:setCmdOverObject(cmd)
	if cmd ~= nil and cmd.object ~= nil and cmd.typ[1] == "output_" then		
		for _, object in pairs (cmd.object) do			
			if object ~= nil and moModuleObjects:isObject(object) then				
				local objectId = object.nodeId or object.rootNode;
				local txt = tostring(cmd.displayName);
				local x, y, z = getWorldTranslation(objectId);
				local distance = calcDistanceFrom(objectId, getCamera());
				if x ~= nil and y ~= nil and z ~= nil and (x~=0 and y~=0 and z~=0) and distance < 40 then					
					Utils.renderTextAtWorldPosition(x, y+2, z, txt, getCorrectTextSize(0.02), 0.02, g_currentMission.hl.getColor("ls22", true));
				end;
			end;
		end;
		
	end;
end;