moDragDrop = {};

function moDragDrop:setOpen(refresh)	
	if refresh == nil or not refresh then
		if g_currentMission.hl.dragDrop.what == "_dragDropArea_" then
			local pdaTable = moSetGetOverlays.pda[g_currentMission.hl.dragDrop.where];			
			if pdaTable == nil then return;end;			
			local overlay = pdaTable.design.icon[pdaTable.design.byName.icon["buttonDragDropArea"]];
			if overlay == nil then return;end;			
			local appIconHeight = moSetGetOverlays.buttonGfxHeight1*pdaTable.appIconZoomOutIn;
			local appIconWidth = moSetGetOverlays.buttonGfxWidth1*pdaTable.appIconZoomOutIn;
			g_currentMission.hl.setOverlay(overlay,MultiOverlayV4.mouseCursor.posX-(appIconWidth/2),MultiOverlayV4.mouseCursor.posY-(appIconHeight/2),appIconWidth,appIconHeight);
			if overlay.iconType == 2 then
				local color = g_currentMission.hl.getColor("mangenta", true);				
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			overlay:render();
		end;
	end;
end;

function moDragDrop:addAreaApp(args)
	if args == nil or type(args) ~= "table" or args.appValue == nil or args.whatClick == nil then return nil;end;
	local isLine = g_currentMission.hl.dragDrop.app[1] == args.appValue[1];
	local isApp = g_currentMission.hl.dragDrop.app[2] == args.appValue[2];
	local isPda = g_currentMission.hl.dragDrop.where == args.whatClick;
	if not isLine or not isApp or not isPda then
		if isPda or (not isPda and moSetGetOverlays.pda[args.whatClick].setting.on) then 
			local copyApp = g_currentMission.hl.getTableCopyFunc(moSetGetOverlays.pda[g_currentMission.hl.dragDrop.where].apps[g_currentMission.hl.dragDrop.app[1]][g_currentMission.hl.dragDrop.app[2]]);
			local copyCmdApp = g_currentMission.hl.getTableCopyFunc(moSetGetOverlays.pda[g_currentMission.hl.dragDrop.where].apps[g_currentMission.hl.dragDrop.app[1]][g_currentMission.hl.dragDrop.app[2]].cmd);
			local _, insertApp = moSetGetPda:generateApp(args, true);
			moSetGetOverlays.pda[args.whatClick].apps[args.appValue[1]][args.appValue[2]].cmd = copyCmdApp;
			if copyApp.icon ~= nil and copyApp.icon[1] ~= nil then
				local saveArgs = copyApp.icon[1].saveArgs;
				local iconTxt = copyApp.icon[1].txt;
				saveArgs.loadIcons={copyApp.icon[1].iconPlace};saveArgs.previewIcons=nil;saveArgs.whichPda=tostring(args.whatClick);saveArgs.appIcon={args.appValue[1],args.appValue[2]};
				moSetGetOverlays:loadIcons(saveArgs);
				if iconTxt ~= nil then
					moSetGetOverlays.pda[args.whatClick].apps[args.appValue[1]][args.appValue[2]].icon[1].txt = iconTxt;
					moSetGetOverlays.pda[args.whatClick].apps[args.appValue[1]][args.appValue[2]].icon[1].isFormatTxt = false;
				end;				
			end;			
			args.whatClick=tostring(g_currentMission.hl.dragDrop.where);
			if insertApp and isLine then args.appValue = {g_currentMission.hl.dragDrop.app[1],g_currentMission.hl.dragDrop.app[2]+1};else
			args.appValue = {g_currentMission.hl.dragDrop.app[1],g_currentMission.hl.dragDrop.app[2]};end;
			moSetGetPda:deleteApp(args);
			copyApp = nil;
			copyCmdApp = nil;		
		end;
	end;
end;