moDraw.pda_typ1 = {};

function moDraw.pda_typ1:setOpen(whichPda, pdaTable)
	local whichSubPda = whichPda or "dummyPda_";
	moGeneralSettings.clickAreas.pda[whichSubPda] = {};
	moGeneralSettings.clickAreas.masterPda[whichSubPda] = {};	
	local pdaGroundName = pdaTable.design.byName.ground;
	local pdaIconName = pdaTable.design.byName.icon;
	local pdaLineName = pdaTable.design.byName.line;
	local pdaIcon = pdaTable.design.icon;
	local pdaGround = pdaTable.design.ground;
	local pdaLine = pdaTable.design.line;
	if pdaGround == nil or pdaIcon == nil or pdaLine == nil or pdaGroundName == nil or pdaIconName == nil or pdaLineName == nil then return;end;
	local groundIcon = pdaGroundName["groundWhiteT"]; 
	local groundIconS = pdaGroundName["groundBlackSettingT"];
	local lineIcon = pdaLineName["lineBlack"];
	local lineIconS = pdaLineName["lineBlackT"];	
	--if not moDraw.pda:setDesignColor(whichSubPda, {pdaGround[groundIcon], pdaGround[groundIconS]}) then return;end;
	local overlay = pdaIcon[pdaIconName["close"]];
	local tempOverlay = pdaIcon[pdaIconName["close"]];
	local frameIconHeight = moSetGetOverlays.buttonGfxHeight1*pdaTable.frameZoomOutIn;
	local frameIconWidth = moSetGetOverlays.buttonGfxWidth1*pdaTable.frameZoomOutIn;
	local distanceFrameIconWidth = moSetGetOverlays.buttonGfxWidth1*1;
	local distanceFrameIconHeight = moSetGetOverlays.buttonGfxHeight1*1;
	local frameIconRightUpPosX = 0;
	local frameIconLeftUpPosX = 0;
	local frameIconUpPosY = 0;
	local frameIconRightDownPosX = 0;
	local frameIconLeftDownPosX = 0;
	local frameIconDownPosY = 0;	
	
	local appIconHeight = moSetGetOverlays.buttonGfxHeight1*pdaTable.appIconZoomOutIn;
	local appIconWidth = moSetGetOverlays.buttonGfxWidth1*pdaTable.appIconZoomOutIn;
	local distanceAppIconWidth = moSetGetOverlays.buttonGfxWidth1*pdaTable.distanceAppIconWidth; 
	local distanceAppIconHeight = moSetGetOverlays.buttonGfxHeight1*pdaTable.distanceAppIconHeight;
	local appIconRightPosX = 0;
	local appIconLeftPosX = 0;
	local appIconPosY = 0;
	
	local settingIconHeight = moSetGetOverlays.buttonGfxHeight1*pdaTable.settingZoomOutIn;
	local settingIconWidth = moSetGetOverlays.buttonGfxWidth1*pdaTable.settingZoomOutIn;
	local settingIconRightPosX = 0;
	local settingIconLeftPosX = 0;
	local settingIconPosY = 0;	
	local distanceSettingIconWidth = moSetGetOverlays.buttonGfxWidth1*pdaTable.setting.distanceIconWidth;
	local distanceSettingIconHeight = moSetGetOverlays.buttonGfxHeight1*pdaTable.setting.distanceIconHeight;
	local distanceSettingEdgeWidth = moSetGetOverlays.buttonGfxWidth1*pdaTable.setting.distanceEdgeWidth;
		
	local optiSize = 0;
	local color = "";
	local txt = "";
	local txtWidth = 0;
	local txtHeight = 0;
	local txtLengthOld = 0;
	local txtLengthNew = 0;	
	local maxTxtWidth = 0;
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor; 
	local thisDragDrop = g_currentMission.hl.isMouseCursor and g_currentMission.hl.dragDrop.on and (g_currentMission.hl.dragDrop.what == "_pda_" or g_currentMission.hl.dragDrop.what == "_pdaWH_" or g_currentMission.hl.dragDrop.what == "_dragDropArea_") and (g_currentMission.hl.dragDrop.where == whichSubPda or g_currentMission.hl.dragDrop.addArea == whichSubPda);
		
	---pda setting Height---
	local settingHeight = distanceSettingIconHeight;
	if pdaTable.setting.defaultLine then
		settingHeight = settingHeight+((settingIconHeight+distanceSettingIconHeight)*pdaTable.setting.maxDefaultLine);
	end;
	if pdaTable.setting.on then
		settingHeight = settingHeight+((settingIconHeight+distanceSettingIconHeight)*pdaTable.setting.maxSettingLine);
	end;
	if pdaTable.setting.helpLine then
		settingHeight = settingHeight+((settingIconHeight+distanceSettingIconHeight)*pdaTable.setting.maxHelpLine);
	end;
	if pdaTable.setting.infoLine then
		settingHeight = settingHeight+((settingIconHeight+distanceSettingIconHeight)*pdaTable.setting.maxInfoLine);
	end;
	if pdaTable.setting.extraLine and not pdaTable.setting.on and pdaTable.setting.maxExtraLine > 0 then
		if pdaTable.setting.extraLineMultiple then
			settingHeight = settingHeight+((settingIconHeight+distanceSettingIconHeight)*pdaTable.setting.maxExtraLine);
		else
			settingHeight = settingHeight+(settingIconHeight+distanceSettingIconHeight);
		end;
	elseif pdaTable.setting.on and pdaTable.setting.extraLine then
		if pdaTable.setting.extraLineMultiple then
			settingHeight = settingHeight+((settingIconHeight+distanceSettingIconHeight)*#pdaTable.setting.extraIconLine);
		else
			settingHeight = settingHeight+(settingIconHeight+distanceSettingIconHeight);
		end;
	end;	
	---pda setting height---
	
	---set drapDrop---
	if thisDragDrop and (g_currentMission.hl.dragDrop.what == "_pda_" or g_currentMission.hl.dragDrop.what == "_pdaWH_") then
		if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][whichSubPda] ~= nil then
			MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", whichSubPda}, "moDraw.pda_typ1:setOpen");
		end;
		if g_currentMission.hl.dragDrop.what == "_pda_" then			
			pdaTable.posX[pdaTable.view.isModus] = MultiOverlayV4.mouseCursor.posX+(frameIconWidth/2)+distanceFrameIconWidth;
			pdaTable.posY[pdaTable.view.isModus] = MultiOverlayV4.mouseCursor.posY+pdaTable.height[pdaTable.view.isModus]+(frameIconHeight/2)+distanceFrameIconHeight;			
			moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);
			moGeneralSettings.isSave = false;
		elseif g_currentMission.hl.dragDrop.what == "_pdaWH_" then
			local tempWidth = MultiOverlayV4.mouseCursor.posX-pdaGround[groundIcon].x-(frameIconWidth/2);
			local tempHeight = (pdaGround[groundIcon].y+pdaTable.height[pdaTable.view.isModus])-MultiOverlayV4.mouseCursor.posY-frameIconHeight/2;			
			local setRefresh = false;
			if tempWidth > pdaTable.width.default then
				pdaTable.width[pdaTable.view.isModus] = tempWidth;
				setRefresh = true;
			end;
			if tempHeight > pdaTable.height.default then
				pdaTable.height[pdaTable.view.isModus] = tempHeight;
				setRefresh = true;
			end;
			if setRefresh then 
				--pdaTable.selectApp = {0,0};
				moSetGetPda:resetSettingLinesBounds(whichSubPda);
				moSetGetPda:resetLineAppBounds(whichSubPda);
				moGeneralSettings.isSave = false;
			end;
		end;	
	end;	
	---set dragDrop---	
		
	---ground app icons---	
	g_currentMission.hl.setOverlay(pdaGround[groundIcon], 
		pdaTable.posX[pdaTable.view.isModus], pdaTable.posY[pdaTable.view.isModus]-pdaTable.height[pdaTable.view.isModus], 
		pdaTable.width[pdaTable.view.isModus], pdaTable.height[pdaTable.view.isModus]
	);	
	pdaGround[groundIcon]:render();
	local firstAppIconLeftPosX = pdaGround[groundIcon].x+distanceAppIconWidth; 
	appIconLeftPosX = pdaGround[groundIcon].x+distanceAppIconWidth; 
	appIconRightPosX = pdaGround[groundIcon].x+pdaGround[groundIcon].width-distanceAppIconWidth;
	appIconPosY = pdaGround[groundIcon].y+pdaGround[groundIcon].height-appIconHeight-distanceAppIconHeight;
	---ground app icons---
	
	---app icons---
	local maxAppsWidth = moSetGetDraw:getMaxWidth(pdaGround[groundIcon].width-distanceAppIconWidth, appIconWidth+distanceAppIconWidth);
	local maxAppsHeight = moSetGetDraw:getMaxHeight(pdaGround[groundIcon].height-distanceAppIconHeight, appIconHeight+distanceAppIconHeight)
	if pdaTable.view[pdaTable.view.isModus].boundsHeight[1] == 0 or pdaTable.view[pdaTable.view.isModus].boundsHeight[3] == 0 then
		pdaTable.view[pdaTable.view.isModus].boundsHeight[1] = 1;pdaTable.view[pdaTable.view.isModus].boundsHeight[2] = maxAppsHeight;pdaTable.view[pdaTable.view.isModus].boundsHeight[3] = maxAppsHeight;
	end;
	if pdaTable.view[pdaTable.view.isModus].boundsWidth[1] == 0 or pdaTable.view[pdaTable.view.isModus].boundsWidth[3] == 0 then
		pdaTable.view[pdaTable.view.isModus].boundsWidth[1] = 1;pdaTable.view[pdaTable.view.isModus].boundsWidth[2] = maxAppsWidth;pdaTable.view[pdaTable.view.isModus].boundsWidth[3] = maxAppsWidth;
	end;
	if pdaTable.view[pdaTable.view.isModus].boundsWidth[4] == 0 or pdaTable.view[pdaTable.view.isModus].boundsHeight[4] == 0 then
		local highestLine, highestApp = moSetGetPda:getHighestTotal(whichSubPda);
		pdaTable.view[pdaTable.view.isModus].boundsWidth[4] = highestApp;
		pdaTable.view[pdaTable.view.isModus].boundsHeight[4] = highestLine;
	end;
	--moGeneralSettings.testString[2] = tostring(highestLine);
	--moGeneralSettings.testString[3] = tostring(highestApp);
	
	local boundsLine = pdaTable.view[pdaTable.view.isModus].boundsHeight[1];
	local boundsApp = pdaTable.view[pdaTable.view.isModus].boundsWidth[1];
	local isBoundsLine = 0;
	local isBoundsApp = 0;
	if maxAppsWidth > 0 and maxAppsHeight > 0 then				
			--for appsHeight=1, maxAppsHeight do
			for appsHeight=pdaTable.view[pdaTable.view.isModus].boundsHeight[1], pdaTable.view[pdaTable.view.isModus].boundsHeight[2] do
				if isBoundsLine >= pdaTable.view[pdaTable.view.isModus].boundsHeight[2] then break;end;
				isBoundsLine = isBoundsLine+1;				
				isBoundsApp = 0;
				--for appsWidth=1, maxAppsWidth do
				for appsWidth=pdaTable.view[pdaTable.view.isModus].boundsWidth[1], pdaTable.view[pdaTable.view.isModus].boundsWidth[2] do
					if isBoundsApp >= pdaTable.view[pdaTable.view.isModus].boundsWidth[2] then break;end;
					isBoundsApp = isBoundsApp+1;
					local foundApp = pdaTable.apps[appsHeight] ~= nil and pdaTable.apps[appsHeight][appsWidth] ~= nil;
					local foundAppIcon = false;
					local foundErrorAppIcon = false;
					local foundAppCmd = false;
					if foundApp then foundErrorAppIcon = pdaTable.apps[appsHeight][appsWidth].icon ~= nil and pdaTable.apps[appsHeight][appsWidth].icon.loadChange ~= nil;end;
					if foundApp then foundAppIcon = (pdaTable.apps[appsHeight][appsWidth].icon ~= nil and pdaTable.apps[appsHeight][appsWidth].icon[1] ~= nil and pdaTable.apps[appsHeight][appsWidth].icon[1].overlayId ~= nil) or foundErrorAppIcon;end;
					if foundApp then foundAppCmd = pdaTable.apps[appsHeight][appsWidth].cmd ~= nil and #pdaTable.apps[appsHeight][appsWidth].cmd > 0;end;
					local isSelectApp = pdaTable.selectApp[1] == appsHeight and pdaTable.selectApp[2] == appsWidth;
					local emptyOverlay = pdaIcon[pdaIconName["emptyApp"]];
					g_currentMission.hl.setOverlay(emptyOverlay,appIconLeftPosX,appIconPosY,appIconWidth,appIconHeight);
					local selectOverlay = pdaLine[pdaLineName["lineBorderSelect"]];
					g_currentMission.hl.setOverlay(selectOverlay,appIconLeftPosX,appIconPosY,appIconWidth,appIconHeight);
					if foundApp then							
						if (foundAppIcon and not pdaTable.setting.on) or (foundAppIcon and not isSelectApp) or (foundAppIcon and pdaTable.setting.on and g_currentMission.hl.runsTimer("1sec", true)) then
							overlay = pdaTable.apps[appsHeight][appsWidth].icon[1];
							if overlay == nil then overlay = pdaGround[pdaGroundName["iconFail"]];end;
							g_currentMission.hl.setOverlay(overlay,appIconLeftPosX,appIconPosY,appIconWidth,appIconHeight);
							if overlay.onOpen ~= nil and type(overlay.onOpen) == "function" then
								overlay.onOpen( {overlay=overlay, whichPda=whichSubPda, appLine=appsHeight, appPos=appsWidth} );														
							end;						
							if overlay.iconType == 2 or overlay.iconType == 3 then							
								g_currentMission.hl.setBackgroundColor(overlay, overlay.colorState);
							end;
							if overlay.onDrawBefore ~= nil and type(overlay.onDrawBefore) == "function" then
								overlay.onDrawBefore( {overlay=overlay, whichPda=whichSubPda, appLine=appsHeight, appPos=appsWidth, before=true, after=false} );
							end;
							if overlay.visible then
								overlay:render();
							end;
							if overlay.onDrawAfter ~= nil and type(overlay.onDrawAfter) == "function" then
								overlay.onDrawAfter( {overlay=overlay, whichPda=whichSubPda, appLine=appsHeight, appPos=appsWidth, before=false, after=true} );
							end;							
							if not thisDragDrop or (thisDragDrop and g_currentMission.hl.dragDrop.what == "_pdaWZ_") then
								if overlay.isFormatTxt ~= nil and not overlay.isFormatTxt and overlay.txt ~= nil and #overlay.txt > 0 then							
									moSetGetDraw:setFormatIconTxt(pdaTable, overlay);
								end;
								if overlay.isFormatTxt and overlay.iconFormatTxt ~= nil and #overlay.iconFormatTxt > 0 then
									for iconTxt=1, #overlay.iconFormatTxt do
										if overlay.iconFormatTxt[iconTxt].run then
											setTextBold(overlay.iconFormatTxt[iconTxt].bold);	
											setTextColor(unpack(overlay.iconFormatTxt[iconTxt].color));		
											renderText(overlay.iconFormatTxt[iconTxt].x, overlay.iconFormatTxt[iconTxt].y, overlay.iconFormatTxt[iconTxt].size, overlay.iconFormatTxt[iconTxt].txt);
											renderText(overlay.iconFormatTxt[iconTxt].x, overlay.iconFormatTxt[iconTxt].y, overlay.iconFormatTxt[iconTxt].size, overlay.iconFormatTxt[iconTxt].txt);
											setTextBold(false);		
											setTextColor(1, 1, 1, 1);
										end;
									end;
								end;
							end;
							if not disableClickArea and not pdaTable.setting.on then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="callbackCmdApp_", appValue={appsHeight, appsWidth}});end;
						end;												
						if pdaTable.setting.on and isSelectApp then
							---delete App---
							overlay = pdaIcon[pdaIconName["buttonMinus"]];
							g_currentMission.hl.setOverlay(overlay,appIconLeftPosX,appIconPosY,appIconWidth/2,appIconHeight/2);
							color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);															
							g_currentMission.hl.setBackgroundColor(overlay, color);								
							if not disableClickArea and not g_currentMission.hl.runsTimer("1sec", true) then overlay:render();end;
							if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingDeleteApp_", appValue={appsHeight, appsWidth}, infoTxt="Delete App"});end;
							---delete App---
							---add/EditIcon App---
							if foundAppIcon then
								overlay = pdaIcon[pdaIconName["buttonEditIcon"]];									
							else
								overlay = pdaIcon[pdaIconName["buttonIcon"]];									
							end;
							color = g_currentMission.hl.getColor(pdaTable.color.selectMarker, true);	
							g_currentMission.hl.setOverlay(overlay,appIconLeftPosX,appIconPosY+(appIconHeight/2),appIconWidth/2,appIconHeight/2);
							g_currentMission.hl.setBackgroundColor(overlay, color);								
							if not disableClickArea and not g_currentMission.hl.runsTimer("1sec", true) then overlay:render();end;
							if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingAddAppIcon_", appValue={appsHeight, appsWidth}});end;
							---add/EditIcon App---
							---setting Cmd App---
							overlay = pdaIcon[pdaIconName["buttonCmd"]];
							g_currentMission.hl.setOverlay(overlay,appIconLeftPosX+(appIconWidth/2),appIconPosY+(appIconHeight/2),appIconWidth/2,appIconHeight/2);								
							color = g_currentMission.hl.getColor(pdaTable.color.selectMarker, true);																							
							g_currentMission.hl.setBackgroundColor(overlay, color);								
							if not disableClickArea and not g_currentMission.hl.runsTimer("1sec", true) then overlay:render();end;
							if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingCmd_", appValue={appsHeight, appsWidth}, infoTxt="Open/Close Setting Cmd"});end;
							---setting Cmd App---
							---dragDrop App---
							--if foundAppIcon or foundAppCmd then --or #pdaTable.apps[appsHeight][appsWidth].cmd > 0 then
								overlay = pdaIcon[pdaIconName["buttonDragDropArea"]];
								g_currentMission.hl.setOverlay(overlay,appIconLeftPosX+(appIconWidth/2),appIconPosY,appIconWidth/2,appIconHeight/2);
								if not disableClickArea then 
									color = g_currentMission.hl.getColor(pdaTable.color.selectMarker, true);
								else
									color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);
								end;															
								g_currentMission.hl.setBackgroundColor(overlay, color);								
								if not disableClickArea and not g_currentMission.hl.runsTimer("1sec", true) then overlay:render();end;
								if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="dragDropArea_", appValue={appsHeight, appsWidth}, infoTxt="Move App or Pos"});end;
							--end;
							---dragDrop App---								
						end;												
					else
						if pdaTable.setting.on then
							overlay = pdaIcon[pdaIconName["buttonPlus"]];
							g_currentMission.hl.setOverlay(overlay,appIconLeftPosX,appIconPosY,appIconWidth/2,appIconHeight/2);
							if isSelectApp then
								color = g_currentMission.hl.getColor(pdaTable.color.selectMarker, true);								
							else
								color = g_currentMission.hl.getColor(pdaTable.color.settingDefault, true);								
							end;
							g_currentMission.hl.setBackgroundColor(overlay, color);							
							overlay:render();
							if isSelectApp and not disableClickArea then
								moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingGenerateApp_", appValue={appsHeight, appsWidth}, infoTxt="Generate App"});
							end;
							if pdaTable.apps[appsHeight] ~= nil and #pdaTable.apps[appsHeight] > appsWidth then
								overlay = pdaIcon[pdaIconName["buttonMinus"]];
								g_currentMission.hl.setOverlay(overlay,appIconLeftPosX+(appIconWidth/2),appIconPosY+(appIconHeight/2),appIconWidth/2,appIconHeight/2);
								if isSelectApp then
									color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);								
								else
									color = g_currentMission.hl.getColor(pdaTable.color.settingDefault, true);								
								end;
								g_currentMission.hl.setBackgroundColor(overlay, color);							
								overlay:render();
								if isSelectApp and not disableClickArea then
									moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingDeleteApp_", appValue={appsHeight, appsWidth}, infoTxt="Delete App Pos"});
								end;
							end;
						end;						
					end;
					if pdaTable.setting.on then
						if not isSelectApp then
							moSetGetDraw:setLineBorder(pdaLine[lineIcon], emptyOverlay, 1, 0.0005, true, true, true, true);
							if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {emptyOverlay.x, emptyOverlay.x+emptyOverlay.width, emptyOverlay.y, emptyOverlay.y+emptyOverlay.height, whatClick=whichSubPda, whereClick="selectApp_", appValue={appsHeight, appsWidth}, infoTxt="Select App"});end;
						else
							color = g_currentMission.hl.getColor(pdaTable.color.selectMarker, true);
							g_currentMission.hl.setBackgroundColor(selectOverlay, color);
							selectOverlay:render();
						end;
					end;
					---slectDrapDrop App area---
					moDraw.pda_typ1:clickAreas(false, {emptyOverlay.x, emptyOverlay.x+emptyOverlay.width, emptyOverlay.y, emptyOverlay.y+emptyOverlay.height, whatClick=whichSubPda, whereClick="selectDragDropApp_", appValue={appsHeight, appsWidth}});
					---slectDrapDrop App area---
					if appsWidth >= pdaTable.view[pdaTable.view.isModus].boundsWidth[2] then break;end;
					appIconLeftPosX = appIconLeftPosX+appIconWidth+distanceAppIconWidth;
				end;
				if appsHeight >= pdaTable.view[pdaTable.view.isModus].boundsHeight[2] then break;end;
				appIconPosY = appIconPosY-appIconHeight-distanceAppIconHeight;
				appIconLeftPosX = firstAppIconLeftPosX;
			end;	
		
	end;	
	---app icons---
	---frame ground---
	overlay = pdaGround[pdaGroundName["frameUp"]];
	g_currentMission.hl.setOverlay(overlay,pdaGround[groundIcon].x-(frameIconWidth)-(distanceFrameIconWidth*2),pdaGround[groundIcon].y+pdaGround[groundIcon].height,pdaGround[groundIcon].width+(frameIconWidth*2)+(distanceFrameIconWidth*4),frameIconHeight+(distanceFrameIconHeight*2));		
	overlay:render();
	overlay = pdaGround[pdaGroundName["frameDown"]];
	g_currentMission.hl.setOverlay(overlay,pdaGround[groundIcon].x-(frameIconWidth)-(distanceFrameIconWidth*2),pdaGround[groundIcon].y-(frameIconHeight)-(distanceFrameIconHeight*2),pdaGround[groundIcon].width+(frameIconWidth*2)+(distanceFrameIconWidth*4),frameIconHeight+(distanceFrameIconHeight*2));		
	overlay:render();
	overlay = pdaGround[pdaGroundName["frameLeft"]];
	g_currentMission.hl.setOverlay(overlay,pdaGround[groundIcon].x-(frameIconWidth)-(distanceFrameIconWidth*2),pdaGround[groundIcon].y,frameIconWidth+(distanceFrameIconWidth*2),pdaGround[groundIcon].height);		
	overlay:render();
	overlay = pdaGround[pdaGroundName["frameRight"]];
	g_currentMission.hl.setOverlay(overlay,pdaGround[groundIcon].x+pdaGround[groundIcon].width,pdaGround[groundIcon].y,frameIconWidth+(distanceFrameIconWidth*2),pdaGround[groundIcon].height);		
	overlay:render();
	---frame ground---
	---masterArea ground---	
	if not pdaTable.setting.defaultLine and not pdaTable.setting.infoLine and not pdaTable.setting.extraLine and not pdaTable.setting.on then
		moDraw.pda_typ1:clickAreas(true, {pdaGround[pdaGroundName["frameUp"]].x,pdaGround[pdaGroundName["frameUp"]].x+pdaGround[pdaGroundName["frameUp"]].width,pdaGround[pdaGroundName["frameDown"]].y,pdaGround[pdaGroundName["frameDown"]].y+pdaGround[pdaGroundName["frameDown"]].height+pdaGround[pdaGroundName["frameUp"]].height+pdaGround[groundIcon].height,whatClick=whichSubPda}	);
	else	
		if pdaTable.setting.up then
			tempOverlay = {
				[1]=pdaGround[pdaGroundName["frameUp"]].x;
				[2]=pdaGround[pdaGroundName["frameUp"]].x+pdaGround[pdaGroundName["frameUp"]].width;
				[3]=pdaGround[pdaGroundName["frameDown"]].y;
				[4]=pdaGround[pdaGroundName["frameDown"]].y+pdaGround[pdaGroundName["frameDown"]].height+pdaGround[pdaGroundName["frameUp"]].height+pdaGround[groundIcon].height+pdaGround[groundIconS].height;
			};
		else
			tempOverlay = {
				[1]=pdaGround[pdaGroundName["frameDown"]].x;
				[2]=pdaGround[pdaGroundName["frameDown"]].x+pdaGround[pdaGroundName["frameDown"]].width;
				[3]=pdaGround[groundIconS].y;
				[4]=pdaGround[groundIconS].y+pdaGround[groundIconS].height+pdaGround[pdaGroundName["frameDown"]].y+pdaGround[pdaGroundName["frameDown"]].height+pdaGround[pdaGroundName["frameUp"]].height+pdaGround[groundIcon].height;
			};
		end;
		moDraw.pda_typ1:clickAreas(true, {tempOverlay[1],tempOverlay[2],tempOverlay[3],tempOverlay[4],whatClick=whichSubPda} );
	end;
	---masterArea ground---
	
	frameIconRightUpPosX = pdaGround[pdaGroundName["frameUp"]].x+pdaGround[pdaGroundName["frameUp"]].width-(frameIconWidth)-distanceFrameIconWidth; 
	frameIconLeftUpPosX = pdaGround[pdaGroundName["frameUp"]].x+distanceFrameIconWidth;
	frameIconUpPosY = pdaGround[pdaGroundName["frameUp"]].y+distanceFrameIconHeight;
	
	frameIconRightDownPosX = pdaGround[pdaGroundName["frameDown"]].x+pdaGround[pdaGroundName["frameDown"]].width-(frameIconWidth)-distanceFrameIconWidth; 
	frameIconLeftDownPosX = pdaGround[pdaGroundName["frameDown"]].x+distanceFrameIconWidth;
	frameIconDownPosY = pdaGround[pdaGroundName["frameDown"]].y+distanceFrameIconHeight;
	
	--------------frame default icons--------------
	if g_currentMission.hl.isMouseCursor then
		---close---
		overlay = pdaIcon[pdaIconName["buttonClose"]];
		g_currentMission.hl.setOverlay(overlay,frameIconRightUpPosX,frameIconUpPosY,frameIconWidth,frameIconHeight);		
		if overlay.iconType == 2 then
			color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		frameIconRightUpPosX = frameIconRightUpPosX-(frameIconWidth)-distanceFrameIconWidth;
		if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="buttonClose_", infoTxt="Close this Pda"});end;
		---close---
		---viewModus---
		overlay = pdaIcon[pdaIconName["buttonViewModus"]];
		g_currentMission.hl.setOverlay(overlay,frameIconRightUpPosX,frameIconUpPosY,frameIconWidth,frameIconHeight);		
		if overlay.iconType == 2 then
			if pdaTable.view.isModus == 1 then
				color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
			else	
				color = g_currentMission.hl.getColor(pdaTable.color.settingReady, true);
			end;			
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;		
		overlay:render();		
		frameIconRightUpPosX = frameIconRightUpPosX-frameIconWidth-distanceFrameIconWidth;
		if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="buttonViewModus_", infoTxt="Set other Pos/Widht/Height"});end;
		---viewModus---
		
		---buttonUp setting defaultLine over/under frame up/down---
		overlay = pdaIcon[pdaIconName["buttonDown"]];
		if pdaTable.setting.up then overlay = pdaIcon[pdaIconName["buttonUp"]];end;
		g_currentMission.hl.setOverlay(overlay,frameIconRightUpPosX,frameIconUpPosY,frameIconWidth,frameIconHeight);
		if overlay.iconType == 2 then
			if pdaTable.setting.defaultLine then color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);else color = g_currentMission.hl.getColor(pdaTable.color.settingDefault, true);end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		frameIconRightUpPosX = frameIconRightUpPosX-frameIconWidth-distanceFrameIconWidth;
		if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingDefaultLine_", infoTxt="Open/Close Menue Line"});end;
		---buttonUp setting defaultLine over/under frame up/down---
		
		---dragDrop frame down---
		overlay = pdaIcon[pdaIconName["buttonDragDrop"]];
		g_currentMission.hl.setOverlay(overlay,frameIconLeftDownPosX,frameIconDownPosY,frameIconWidth,frameIconHeight);
		if overlay.iconType == 2 then
			if g_currentMission.hl.dragDrop.on and (g_currentMission.hl.dragDrop.what ~= "_pda_" or g_currentMission.hl.dragDrop.where ~= whichSubPda) then 
				color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);			
			elseif g_currentMission.hl.dragDrop.on and g_currentMission.hl.dragDrop.what == "_pda_" and g_currentMission.hl.dragDrop.where == whichSubPda then
				color = g_currentMission.hl.getColor(pdaTable.color.settingReady, true);
			else 
				color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);			
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);		
		end;
		overlay:render();
		frameIconLeftDownPosX = frameIconLeftDownPosX+(frameIconWidth)+distanceFrameIconWidth;
		if not disableClickArea or (thisDragDrop and g_currentMission.hl.dragDrop.what == "_pda_") then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="dragDrop_", infoTxt="Set New Pos"});end;
		---dragDrop frame down---
		---dragDrop white/heigh frame down---				
		overlay = pdaIcon[pdaIconName["buttonSizeWidthHeight"]];
		g_currentMission.hl.setOverlay(overlay,frameIconRightDownPosX,frameIconDownPosY,frameIconWidth,frameIconHeight);
		if overlay.iconType == 2 then
			if g_currentMission.hl.dragDrop.on and (g_currentMission.hl.dragDrop.what ~= "_pdaWH_" or g_currentMission.hl.dragDrop.where ~= whichSubPda) then 
				color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);			
			elseif g_currentMission.hl.dragDrop.on and g_currentMission.hl.dragDrop.what == "_pdaWH_" and g_currentMission.hl.dragDrop.where == whichSubPda then
				color = g_currentMission.hl.getColor(pdaTable.color.settingReady, true);
			else 
				color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);			
			end;			
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();	
		if not disableClickArea or (thisDragDrop and g_currentMission.hl.dragDrop.what == "_pdaWH_") then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="dragDropWH_"});end;
		frameIconRightDownPosX = frameIconRightDownPosX-(frameIconWidth)-distanceFrameIconWidth;
		---dragDrop white/height frame down---
		
		---pda name frame up---	
		if not pdaTable.setting.editPdaName or not pdaTable.setting.on or (pdaTable.setting.editPdaName and pdaTable.setting.on and g_currentMission.hl.runsTimer("1sec", true)) or not g_currentMission.hl.isMouseCursor then		
			---pdaName---
			txt = utf8Substr(pdaTable.name, 0);		
			optiSize = MultiOverlayV4:get_hl("optiHeightSize", {frameIconHeight-distanceFrameIconHeight, txt, pdaTable.maxTxtSize}, "moDraw.pda_typ1:setOpen")-0.0005;	
			if g_currentMission.hl.isMouseCursor then			
				maxTxtWidth = frameIconRightUpPosX-frameIconLeftUpPosX;
			else
				maxTxtWidth = pdaGround[pdaGroundName["frameUp"]].width-(distanceFrameIconWidth*2);
			end;
			txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, maxTxtWidth, "..", 0);			
			color = g_currentMission.hl.getColor(pdaTable.color.txtOutputTitle, true);
			setTextBold(true);	
			setTextColor(unpack(color));		
			renderText(frameIconLeftUpPosX, frameIconUpPosY, optiSize, txt);
			setTextBold(false);		
			setTextColor(1, 1, 1, 1);
			---pdaName---
			overlay = pdaIcon[pdaIconName["buttonEdit"]];
			g_currentMission.hl.setOverlay(overlay,frameIconLeftUpPosX,frameIconUpPosY,frameIconWidth,frameIconHeight);
			if pdaTable.setting.editPdaName and pdaTable.setting.on then
				if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="editPdaName_", infoTxt="Edit this Pda Name"});end;
			end;
		elseif pdaTable.setting.on and not g_currentMission.hl.runsTimer("1sec", true) and pdaTable.setting.editPdaName and g_currentMission.hl.isMouseCursor then
			---pdaName edit---
			overlay = pdaIcon[pdaIconName["buttonEdit"]];
			g_currentMission.hl.setOverlay(overlay,frameIconLeftUpPosX,frameIconUpPosY,frameIconWidth,frameIconHeight);
			if overlay.iconType == 2 then
				color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="editPdaName_", infoTxt="Edit this Pda Name"});end;
			frameIconLeftDownPosX = frameIconLeftDownPosX+(frameIconWidth)+distanceFrameIconWidth;
			---pdatName edit---
		end;
		---pda name frame up---
	end;	
	--------------frame default icons--------------
	
	--------------frame default scrool up/down and left/right icons--------------
	if maxAppsWidth > 0 and maxAppsHeight > 0 and g_currentMission.hl.isMouseCursor then
		---left/right scroll frame left---
		local canScrollLeft = pdaTable.view[pdaTable.view.isModus].boundsWidth[1] > 1;
		local canScrollRight = pdaTable.view[pdaTable.view.isModus].boundsWidth[2] < pdaTable.view[pdaTable.view.isModus].boundsWidth[4];
		local canScrollUp = pdaTable.view[pdaTable.view.isModus].boundsHeight[1] > 1;
		local canScrollDown = pdaTable.view[pdaTable.view.isModus].boundsHeight[2] < pdaTable.view[pdaTable.view.isModus].boundsHeight[4];
		if maxAppsWidth < pdaTable.view[pdaTable.view.isModus].boundsWidth[4] then
			overlay = pdaIcon[pdaIconName["buttonLeft"]];
			g_currentMission.hl.setOverlay(overlay, 
				pdaGround[pdaGroundName["frameLeft"]].x, pdaGround[pdaGroundName["frameLeft"]].y+(pdaGround[pdaGroundName["frameLeft"]].height/2)+(distanceFrameIconHeight/2), 
				frameIconWidth, frameIconHeight
			);
			if overlay.iconType == 2 then
				if canScrollLeft then
					color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
				else
					color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);
				end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="boundsClickLeft_", infoTxt="Click or Scroll Pda Left"});end;
			tempOverlay = pdaIcon[pdaIconName["buttonRight"]];
			g_currentMission.hl.setOverlay(tempOverlay, 
				pdaGround[pdaGroundName["frameLeft"]].x, pdaGround[pdaGroundName["frameLeft"]].y+(pdaGround[pdaGroundName["frameLeft"]].height/2)-(frameIconHeight)-(distanceFrameIconHeight/2), 
				frameIconWidth, frameIconHeight
			);
			if overlay.iconType == 2 then
				if canScrollRight then
					color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
				else
					color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);
				end;
				g_currentMission.hl.setBackgroundColor(tempOverlay, color);
			end;
			tempOverlay:render();
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick=whichSubPda, whereClick="boundsClickRight_", infoTxt="Click or Scroll Pda Right"});end;
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {tempOverlay.x, overlay.x+overlay.width, tempOverlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="boundsScrollLeftRight_"});end;
			---left/right scroll frame left---
			---left/right scroll frame right---
			overlay = pdaIcon[pdaIconName["buttonLeft"]];
			g_currentMission.hl.setOverlay(overlay, 
				pdaGround[pdaGroundName["frameRight"]].x, pdaGround[pdaGroundName["frameRight"]].y+(pdaGround[pdaGroundName["frameRight"]].height/2)+(distanceFrameIconHeight/2), 
				frameIconWidth, frameIconHeight
			);
			if overlay.iconType == 2 then
				if canScrollLeft then
					color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
				else
					color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);
				end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="boundsClickLeft_", infoTxt="Click or Scroll Pda Left"});end;
			tempOverlay = pdaIcon[pdaIconName["buttonRight"]];
			g_currentMission.hl.setOverlay(tempOverlay, 
				pdaGround[pdaGroundName["frameRight"]].x, pdaGround[pdaGroundName["frameRight"]].y+(pdaGround[pdaGroundName["frameRight"]].height/2)-(frameIconHeight)-(distanceFrameIconHeight/2), 
				frameIconWidth, frameIconHeight
			);
			if overlay.iconType == 2 then
				if canScrollRight then
					color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
				else
					color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);
				end;
				g_currentMission.hl.setBackgroundColor(tempOverlay, color);
			end;
			tempOverlay:render();
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick=whichSubPda, whereClick="boundsClickRight_", infoTxt="Click or Scroll Pda Right"});end;
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {tempOverlay.x, overlay.x+overlay.width, tempOverlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="boundsScrollLeftRight_"});end;
		---left/right scroll frame right---
		end;
		if maxAppsHeight < pdaTable.view[pdaTable.view.isModus].boundsHeight[4] then
		---up/down scroll---
			overlay = pdaIcon[pdaIconName["buttonUp"]];
			g_currentMission.hl.setOverlay(overlay, 
				pdaGround[pdaGroundName["frameDown"]].x+(pdaGround[pdaGroundName["frameDown"]].width/2)-(frameIconWidth)-(distanceFrameIconWidth/2), pdaGround[pdaGroundName["frameDown"]].y, 
				frameIconWidth, frameIconHeight
			);
			if overlay.iconType == 2 then
				if canScrollUp then
					color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
				else
					color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);
				end;
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="boundsClickUp_", infoTxt="Click or Scroll Pda Up"});end;
			tempOverlay = pdaIcon[pdaIconName["buttonDown"]];
			g_currentMission.hl.setOverlay(tempOverlay, 
				pdaGround[pdaGroundName["frameDown"]].x+(pdaGround[pdaGroundName["frameDown"]].width/2)+(distanceFrameIconWidth/2), pdaGround[pdaGroundName["frameDown"]].y, 
				frameIconWidth, frameIconHeight
			);
			if overlay.iconType == 2 then
				if canScrollDown then
					color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
				else
					color = g_currentMission.hl.getColor(pdaTable.color.settingOff, true);
				end;
				g_currentMission.hl.setBackgroundColor(tempOverlay, color);
			end;
			tempOverlay:render();
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick=whichSubPda, whereClick="boundsClickDown_", infoTxt="Click or Scroll Pda Down"});end;
						
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {pdaGround[groundIcon].x, pdaGround[groundIcon].x+pdaGround[groundIcon].width, pdaGround[groundIcon].y, pdaGround[groundIcon].y+pdaGround[groundIcon].height, whatClick=whichSubPda, whereClick="boundsScrollUpDown_"});end;
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, tempOverlay.x+tempOverlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="boundsScrollUpDown_"});end;
		end;
		---up/down scroll---
	end;
	--------------frame default scrool up/down and left/right icons--------------
	
	--------------pda setting ground line 1--------------	
	if pdaTable.setting.defaultLine or pdaTable.setting.on or pdaTable.setting.infoLine or pdaTable.setting.extraLine then	
		---ground Settings---
		if not pdaTable.setting.up then
			g_currentMission.hl.setOverlay(pdaGround[groundIconS], 
				pdaGround[pdaGroundName["frameDown"]].x, pdaGround[pdaGroundName["frameDown"]].y-settingHeight, 
				pdaGround[pdaGroundName["frameDown"]].width, settingHeight
			);
		else
			g_currentMission.hl.setOverlay(pdaGround[groundIconS], 
				pdaGround[pdaGroundName["frameUp"]].x, pdaGround[pdaGroundName["frameUp"]].y+pdaGround[pdaGroundName["frameUp"]].height, 
				pdaGround[pdaGroundName["frameUp"]].width, settingHeight
			);
		end;
		pdaGround[groundIconS]:render();	
		---ground Settings---
		
		
		settingIconRightPosX = pdaGround[groundIconS].x+pdaGround[groundIconS].width-settingIconWidth-distanceSettingEdgeWidth; 
		settingIconLeftPosX = pdaGround[groundIconS].x+distanceSettingEdgeWidth;
		if not pdaTable.setting.up then
			settingIconPosY = pdaGround[groundIconS].y+pdaGround[groundIconS].height;
		else
			settingIconPosY = pdaGround[groundIconS].y-(settingIconHeight+distanceSettingIconHeight);
		end;		
	end;
	--------------pda setting ground line 1--------------	
	
	--------------pda setting ground line 2 and--------------
	if pdaTable.setting.defaultLine then		
		settingIconRightPosX = pdaGround[groundIconS].x+pdaGround[groundIconS].width-settingIconWidth-distanceSettingEdgeWidth; 
		settingIconLeftPosX = pdaGround[groundIconS].x+distanceSettingEdgeWidth; 
		if not pdaTable.setting.up then
			settingIconPosY = settingIconPosY-settingIconHeight-distanceSettingIconHeight;			
		else
			settingIconPosY = settingIconPosY+settingIconHeight+distanceSettingIconHeight;
		end;
		---setting menu up/down pos---
		overlay = pdaIcon[pdaIconName["buttonMoveUp"]];
		if pdaTable.setting.up then overlay = pdaIcon[pdaIconName["buttonMoveDown"]];end;
		g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);
		if overlay.iconType == 2 then			
			color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);							
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
		if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingMoveUpDown_", infoTxt="Set this Menue Up/Down"});end;
		---setting menu up/down pos---
		---setting---
		overlay = pdaIcon[pdaIconName["buttonSetting"]];
		g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);
		if overlay.iconType == 2 then
			if pdaTable.setting.on then
				color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
			else
				color = g_currentMission.hl.getColor(pdaTable.color.settingDefault, true);
			end;				
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
		if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="setting_", infoTxt="Open/Close this Pda Menue"});end;
		---setting---
		---setting extra---
		if (pdaTable.setting.on and #pdaTable.setting.extraIconLine > 0) or (not pdaTable.setting.on and #pdaTable.setting.extraIconLine > 0 and pdaTable.setting.maxExtraLine > 0) then			
			overlay = pdaIcon[pdaIconName["buttonSettingExtra"]];
			g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);
			if overlay.iconType == 2 then				
				if (pdaTable.setting.extraLine and pdaTable.setting.on) or (pdaTable.setting.extraLine and not pdaTable.setting.on) then
					color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
				elseif not pdaTable.setting.extraLine and pdaTable.setting.maxExtraLine > 0 then
					color = g_currentMission.hl.getColor(pdaTable.color.settingReady, true);
				else
					color = g_currentMission.hl.getColor(pdaTable.color.settingDefault, true);
				end;						
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingExtraLine_", infoTxt="Open/Close Extra Pda Menue"});end;
		end;		
		---setting extra---	
		if pdaTable.setting.on and not pdaTable.setting.infoLine then
			---setting info---
			overlay = pdaIcon[pdaIconName["buttonCompactInfo"]];
			g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);
			if overlay.iconType == 2 then
				if pdaTable.setting.infoLine then
					color = g_currentMission.hl.getColor(pdaTable.color.settingReady, true);
				else
					color = g_currentMission.hl.getColor(pdaTable.color.settingDefault, true);
				end;				
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingInfoLine_", infoTxt="View Permanent Info Line"});end;
			---setting info---
		end;			
			
		---save---
		overlay = pdaIcon[pdaIconName["buttonSave"]];
		g_currentMission.hl.setOverlay(overlay,settingIconRightPosX,settingIconPosY,settingIconWidth,settingIconHeight);
		if overlay.iconType == 2 then
			if moGeneralSettings.isSave then
				color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
			else
				color = g_currentMission.hl.getColor(pdaTable.color.settingReady, true);
			end;		
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		settingIconRightPosX = settingIconRightPosX-settingIconWidth-distanceSettingIconWidth;
		if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="save_", infoTxt="Save all MultiOverlay Data"});end;
		---save---
		---global help---
		--if settingIconRightPosX > settingIconLeftPosX then
			--overlay = pdaIcon[pdaIconName["buttonHelp"]];
			--g_currentMission.hl.setOverlay(overlay,settingIconRightPosX,settingIconPosY,settingIconWidth,settingIconHeight);
			--if overlay.iconType == 2 then
			--	if pdaTable.help.globalOn then
			--		color = g_currentMission.hl.getColor(pdaTable.color.settingReady, true);
			--	else
			--		color = g_currentMission.hl.getColor(pdaTable.color.settingDefault, true);
			--	end;			
			--	g_currentMission.hl.setBackgroundColor(overlay, color);
			--end;
			--overlay:render();
			--settingIconRightPosX = settingIconRightPosX-settingIconWidth-distanceSettingIconWidth;
			--if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="helpGlobal_"});end;
		--end;
		---global help---				
	end;
	--------------pda setting ground line 2 and--------------	
	
	--------------pda ground setting line--------------
	if pdaTable.setting.settingLine and pdaTable.setting.on then
		settingIconRightPosX = pdaGround[groundIconS].x+pdaGround[groundIconS].width-settingIconWidth-distanceSettingEdgeWidth; 
		settingIconLeftPosX = pdaGround[groundIconS].x+distanceSettingEdgeWidth; 
		if not pdaTable.setting.up then
			settingIconPosY = settingIconPosY-settingIconHeight-distanceSettingIconHeight;			
		else
			settingIconPosY = settingIconPosY+settingIconHeight+distanceSettingIconHeight;
		end;
		local maxIconLine = moSetGetDraw:getMaxWidth(settingIconRightPosX-settingIconLeftPosX, settingIconWidth+distanceSettingIconWidth);
		---setting button left/right---
		if maxIconLine < #pdaTable.setting.settingIcon+#pdaTable.setting.modIcon then
			maxIconLine = maxIconLine-1;
			overlay = pdaIcon[pdaIconName["buttonLeftRight"]];
			g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);		
			if overlay.iconType == 2 then
				color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+(overlay.width/2), overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingLineLeft_"});end;
			if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x+(overlay.width/2), overlay.x+(overlay.width), overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingLineRight_"});end;
		end;		
		---setting button left/right---
		---setting line defaultIcons/modIcons---		
		if pdaTable.setting.settingIconLineBounds[3] == 0 or pdaTable.setting.settingIconLineBounds[1] == 0 then
			pdaTable.setting.settingIconLineBounds[1]=1;pdaTable.setting.settingIconLineBounds[2]=maxIconLine;pdaTable.setting.settingIconLineBounds[3]=#pdaTable.setting.settingIcon+#pdaTable.setting.modIcon;
		end;
		local addIconTables = {};		
		table.foreach(pdaTable.setting.settingIcon, function(k, v) table.insert(addIconTables, v) end);
		table.foreach(pdaTable.setting.modIcon, function(k, v) table.insert(addIconTables, v) end);			
		for a=1, #addIconTables do
			if a >= pdaTable.setting.settingIconLineBounds[1] and a <= pdaTable.setting.settingIconLineBounds[2] then				
				local iconName = addIconTables[a].name;										
				local overlay = pdaIcon[pdaIconName[iconName]];
				if overlay == nil then overlay = pdaGround[pdaGroundName["iconFail"]];end;
				if overlay ~= nil then
					local areaName = iconName.. "_";
					if addIconTables[a].areaName then areaName = addIconTables[a].areaName.. "_";end;
					if addIconTables[a].onOpen then
						addIconTables[a].onOpen( {whichPda=whichSubPda, areaName=tostring(areaName), overlay=overlay, ownTable=addIconTables[a].ownTable} );
					end;						
					g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);		
					if overlay.iconType == 2 and overlay.colorState ~= nil then g_currentMission.hl.setBackgroundColor(overlay, overlay.colorState);end;
					if overlay.isBlinking == nil or (overlay.isBlinking and g_currentMission.hl.runsTimer("1sec", true)) or not overlay.isBlinking then
						overlay:render();
						if (iconName == "free" or iconName == "buttonTxtLoad") and addIconTables[a].txt ~= nil then
							txt = utf8Substr(tostring(addIconTables[a].txt), 0);
							local difSize = 0;
							if iconName == "buttonTxtLoad" then difSize = 0.003;end;
							optiSize = MultiOverlayV4:get_hl("optiHeightSize", {settingIconHeight, txt, pdaTable.maxTxtSize}, "moDraw.pda_typ1:setOpen")-difSize;
							optiSize = g_currentMission.hl.optiWidthSize(settingIconWidth, txt, optiSize);
							if addIconTables[a].txtColor ~= nil then
								color = g_currentMission.hl.getColor(addIconTables[a].txtColor, true);
							elseif addIconTables[a].txtPdaColor ~= nil then
								color = g_currentMission.hl.getColor(pdaTable.color[addIconTables[a].txtPdaColor], true);
							else
								color = g_currentMission.hl.getColor(pdaTable.color.txt, true);
							end;
							txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));							
							setTextBold(true);	
							setTextColor(unpack(color));
							if iconName == "free" then
								renderText(settingIconLeftPosX, settingIconPosY+(settingIconHeight/2)-(txtHeight/2), optiSize, txt);
							else
								txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
								renderText(settingIconLeftPosX+(settingIconWidth/2)-(txtWidth/2), settingIconPosY+(settingIconHeight/2)-(txtHeight/2), optiSize, txt);
							end;
							setTextBold(false);		
							setTextColor(1, 1, 1, 1);
						end;
					end;
					settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
					if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick=tostring(areaName), isMenu=true, pdaTable=pdaTable, overlay=overlay, ownTable=addIconTables[a].ownTable, callback=addIconTables[a].callback, infoTxt=addIconTables[a].infoTxt});end;
				end;							
			end;
		end;		
		---setting line defaultIcons/modIcons---		
	end;
	--------------pda ground setting line--------------
	
	--------------pda setting extra line--------------
	if (pdaTable.setting.on and #pdaTable.setting.extraIconLine > 0 and pdaTable.setting.extraLine) or (not pdaTable.setting.on and pdaTable.setting.extraLine and pdaTable.setting.maxExtraLine > 0) then
		local setFirstPosY = true;		
		for extraLine=1, #pdaTable.setting.extraIconLine do
			if pdaTable.setting.extraIconLine[extraLine] ~= nil and (pdaTable.setting.extraIconLine[extraLine].view or pdaTable.setting.on) then
				if pdaTable.setting.extraLineMultiple or (not pdaTable.setting.extraLineMultiple and setFirstPosY) then 
					settingIconRightPosX = pdaGround[groundIconS].x+pdaGround[groundIconS].width-settingIconWidth-distanceSettingEdgeWidth; 
					settingIconLeftPosX = pdaGround[groundIconS].x+distanceSettingEdgeWidth; 
					if not pdaTable.setting.up then
						settingIconPosY = settingIconPosY-settingIconHeight-distanceSettingIconHeight;			
					else
						settingIconPosY = settingIconPosY+settingIconHeight+distanceSettingIconHeight;
					end;
					setFirstPosY = false;
				end;				
				overlay = pdaIcon[pdaIconName["buttonSee"]];
				g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);
				if overlay.iconType == 2 then					
					if pdaTable.setting.extraIconLine[extraLine].view then
						color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
					else
						color = g_currentMission.hl.getColor(pdaTable.color.settingDefault, true);
					end;						
					g_currentMission.hl.setBackgroundColor(overlay, color);
				end;
				overlay:render();
				settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
				if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingMaxExtraLine_", ownTable={line=extraLine}});end;
				local maxIconLine = moSetGetDraw:getMaxWidth(settingIconRightPosX-settingIconLeftPosX, settingIconWidth+distanceSettingIconWidth);
				---setting extra button left/right---
				if maxIconLine < #pdaTable.setting.extraIconLine[extraLine].icon then
					maxIconLine = maxIconLine-1;
					overlay = pdaIcon[pdaIconName["buttonLeftRight"]];
					g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);		
					if overlay.iconType == 2 then
						color = g_currentMission.hl.getColor(pdaTable.color.settingOn, true);
						g_currentMission.hl.setBackgroundColor(overlay, color);
					end;
					overlay:render();
					settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
					if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+(overlay.width/2), overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingExtraLineLeft_", ownTable={line=extraLine}});end;
					if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x+(overlay.width/2), overlay.x+(overlay.width), overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingExtraLineRight_", ownTable={line=extraLine}});end;
				end;		
				---setting extra button left/right---
				---setting extra icon---
				if pdaTable.setting.extraIconLine[extraLine].bounds[3] == 0 or pdaTable.setting.extraIconLine[extraLine].bounds[1] == 0 then
					pdaTable.setting.extraIconLine[extraLine].bounds[1]=1;pdaTable.setting.extraIconLine[extraLine].bounds[2]=maxIconLine;pdaTable.setting.extraIconLine[extraLine].bounds[3]=#pdaTable.setting.extraIconLine[extraLine].icon;
				end;
				for a=1, #pdaTable.setting.extraIconLine[extraLine].icon do
					if a >= pdaTable.setting.extraIconLine[extraLine].bounds[1] and a <= pdaTable.setting.extraIconLine[extraLine].bounds[2] then				
						local iconName = pdaTable.setting.extraIconLine[extraLine].icon[a].name;												
						local overlay = pdaIcon[pdaIconName[iconName]];
						if overlay == nil then overlay = pdaGround[pdaGroundName["iconFail"]];end;
						if overlay ~= nil then
							local areaName = iconName.. "_";
							if pdaTable.setting.extraIconLine[extraLine].icon[a].areaName then areaName = pdaTable.setting.extraIconLine[extraLine].icon[a].areaName.. "_";end;
							if pdaTable.setting.extraIconLine[extraLine].icon[a].onOpen then
								pdaTable.setting.extraIconLine[extraLine].icon[a].onOpen( {whichPda=whichSubPda, areaName=tostring(areaName), overlay=overlay, ownTable=pdaTable.setting.extraIconLine[extraLine].icon[a].ownTable} );
							end;						
							g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);		
							if overlay.iconType == 2 and overlay.colorState ~= nil then g_currentMission.hl.setBackgroundColor(overlay, overlay.colorState);end;
							if overlay.isBlinking == nil or (overlay.isBlinking and g_currentMission.hl.runsTimer("1sec", true)) or not overlay.isBlinking then
								overlay:render();
								if (iconName == "free" or iconName == "buttonTxtLoad") and pdaTable.setting.extraIconLine[extraLine].icon[a].txt ~= nil then
									txt = utf8Substr(tostring(pdaTable.setting.extraIconLine[extraLine].icon[a].txt), 0);
									local difSize = 0;
									if iconName == "buttonTxtLoad" then difSize = 0.003;end;
									optiSize = MultiOverlayV4:get_hl("optiHeightSize", {settingIconHeight, txt, pdaTable.maxTxtSize}, "moDraw.pda_typ1:setOpen")-difSize;
									optiSize = g_currentMission.hl.optiWidthSize(settingIconWidth, txt, optiSize);
									if pdaTable.setting.extraIconLine[extraLine].icon[a].txtColor ~= nil then
										color = g_currentMission.hl.getColor(pdaTable.setting.extraIconLine[extraLine].icon[a].txtColor, true);
									elseif pdaTable.setting.extraIconLine[extraLine].icon[a].txtPdaColor ~= nil then
										color = g_currentMission.hl.getColor(pdaTable.color[pdaTable.setting.extraIconLine[extraLine].icon[a].txtPdaColor], true);
									else
										color = g_currentMission.hl.getColor(pdaTable.color.txt, true);
									end;
									txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));									
									setTextBold(true);	
									setTextColor(unpack(color));
									if iconName == "free" then
										renderText(settingIconLeftPosX, settingIconPosY+(settingIconHeight/2)-(txtHeight/2), optiSize, txt);
									else
										txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
										renderText(settingIconLeftPosX+(settingIconWidth/2)-(txtWidth/2), settingIconPosY+(settingIconHeight/2)-(txtHeight/2), optiSize, txt);
									end;
									setTextBold(false);		
									setTextColor(1, 1, 1, 1);
								end;
							end;
							settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
							if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick=tostring(areaName), isMenu=true, pdaTable=pdaTable, overlay=overlay, ownTable=pdaTable.setting.extraIconLine[extraLine].icon[a].ownTable, callback=pdaTable.setting.extraIconLine[extraLine].icon[a].callback, infoTxt=pdaTable.setting.extraIconLine[extraLine].icon[a].infoTxt});end;
						end;									
					end;
				end;	
				---setting extra icon---
			end;
		end;		
	end;	
	--------------pda setting extra line--------------
	
	--------------setting info line Txt and timer--------------
	if pdaTable.setting.infoLine then
		settingIconRightPosX = pdaGround[groundIconS].x+pdaGround[groundIconS].width-settingIconWidth-distanceSettingEdgeWidth; 
		settingIconLeftPosX = pdaGround[groundIconS].x+distanceSettingEdgeWidth; 
		if not pdaTable.setting.up then
			settingIconPosY = settingIconPosY-settingIconHeight-distanceSettingIconHeight;			
		else
			settingIconPosY = settingIconPosY+settingIconHeight+distanceSettingIconHeight;
		end;
		overlay = pdaIcon[pdaIconName["buttonCompactInfo"]];
		g_currentMission.hl.setOverlay(overlay,settingIconLeftPosX,settingIconPosY,settingIconWidth,settingIconHeight);
		if overlay.iconType == 2 then
			if pdaTable.setting.infoLine then
				color = g_currentMission.hl.getColor(pdaTable.color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(pdaTable.color.settingDefault, true);
			end;				
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		settingIconLeftPosX = settingIconLeftPosX+settingIconWidth+distanceSettingIconWidth;
		if not disableClickArea then moDraw.pda_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubPda, whereClick="settingInfoLine_"});end;
		
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."infoLine"] == nil then
			g_currentMission.hl.addTimer({name=whichSubPda.."infoLine", delay=3, repeatable=2, ownTable={infoTxt="",whichPda=whichSubPda}});
		else
			txt = utf8Substr(tostring(g_currentMission.hl.timers[whichSubPda.."infoLine"].ownTable.infoTxt), 0);
			if utf8Strlen(txt) > 0 then
				optiSize = MultiOverlayV4:get_hl("optiHeightSize", {settingIconHeight, txt, pdaTable.maxTxtSize}, "moDraw.pda_typ1:setOpen")-0.0005;
				optiSize = g_currentMission.hl.optiWidthSize(settingIconRightPosX-settingIconLeftPosX, txt, optiSize);
				--txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
				color = g_currentMission.hl.getColor(pdaTable.color.txtTitle, true);
				setTextBold(true);	
				setTextColor(unpack(color));
				renderText(settingIconLeftPosX, settingIconPosY+distanceSettingIconHeight, optiSize, txt);
				setTextBold(false);		
				setTextColor(1, 1, 1, 1);
			end;
		end;
	end;
	--------------setting info line Txt and timer--------------
	
	--------------setting is ready--------------
	if pdaTable.setting.on and not pdaTable.view[pdaTable.view.isModus].isSmallView and ((moHlGuiCmdSetting:isHlGuiOpen() and moHlGuiCmdSetting:isOpen("Pda", whichSubPda)) or (moHlGuiAppIconSetting:isHlGuiOpen() and moHlGuiAppIconSetting:isOpen(whichSubPda))) then
		if g_currentMission.hl.runsTimer("1sec", true) then
			moSetGetDraw:setLineBorder(pdaLine[lineIcon], pdaGround[pdaGroundName["frameUp"]], 1, 0.0008, true, false, true, true, "ls15");
			moSetGetDraw:setLineBorder(pdaLine[lineIcon], pdaGround[pdaGroundName["frameDown"]], 1, 0.0008, false, true, true, true, "ls15");
			moSetGetDraw:setLineBorder(pdaLine[lineIcon], pdaGround[pdaGroundName["frameLeft"]], 1, 0.0008, false, false, true, false, "ls15");
			moSetGetDraw:setLineBorder(pdaLine[lineIcon], pdaGround[pdaGroundName["frameRight"]], 1, 0.0008, false, false, false, true, "ls15");
		end;
	end;
	--------------setting is ready--------------	
end;

function moDraw.pda_typ1:clickAreas(masterArea, args)	
	if masterArea ~= nil and masterArea then
		moGeneralSettings.clickAreas.masterPda[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;
		};
	else	
		moGeneralSettings.clickAreas.pda[args.whatClick][#moGeneralSettings.clickAreas.pda[args.whatClick]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whatClick = args.whatClick;			
			whereClick = args.whereClick;
			isMenue = args.isMenue or false;
			mouseClick = "";
			appValue = args.appValue;			 
			infoTxt = args.infoTxt;
			helpTxt = args.helpTxt;
			overlay = args.overlay;
			callback = args.callback;						
			ownTable = args.ownTable;
			pdaTable = args.pdaTable;
		};
	end;	
end;










