moDraw.time = {};

function moDraw.time.onOpen(args)
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	if args.overlay.isFormatTxt ~= nil then 		
		if args.overlay.ownValue == "realDayTime" then						
			args.overlay.txt[1].txt = tostring(moDraw.time:getRealDay());
			args.overlay.txt[2].txt = tostring(moDraw.time:getRealTime());			
			args.overlay.isFormatTxt = false;			
		elseif args.overlay.ownValue == "ingameDayTime" then						
			args.overlay.txt[1].txt = tostring(moDraw.time:getIngameDay());
			args.overlay.txt[2].txt = tostring(moDraw.time:getIngameTime());			
			args.overlay.isFormatTxt = false;
		end;
	end;	
end;

function moDraw.time.onDrawAfter(args)		
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;			
end;

function moDraw.time:getRealDay(large)
	local realDay = math.fmod(g_currentMission.hl.getRealDay(false,true,false,false), 7);
	if realDay == 0 then realDay = 7;end;
	local day = g_i18n:getText("ui_dayShort".. tostring(realDay));	
	if large then day = g_i18n:getText("ui_financesDay".. tostring(realDay));end;
	return tostring(day);
end;

function moDraw.time:getRealTime()
	return g_currentMission.hl.getRealTime(true,true,false,moGeneralSettings.timeFormat == 12);
end;

function moDraw.time:getIngameDay(large)	
	local ingameDay = math.fmod(g_currentMission.environment.currentDay, 7);
	--if ingameDay == 0 then ingameDay = 7;end;
	local day = g_i18n:getText("ui_dayShort".. tostring(ingameDay));	
	if large then day = g_i18n:getText("ui_financesDay".. tostring(ingameDay));end;
	return tostring(day);
end;

function moDraw.time:getIngameTime()
	local currentTime = g_currentMission.environment.dayTime / 3600000;
	local timeHours = math.floor(currentTime);
	local timeMinutes = math.floor((currentTime - timeHours) * 60);
	return string.format("%02d:%02d", timeHours, timeMinutes);	
end;
