moDraw.timescale = {};

function moDraw.timescale.onOpen(args)
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	local timeScale = moDraw.timescale:getTimeScale(true);
	if timeScale > 1 or timeScale < 1 then args.overlay.colorState = g_currentMission.hl.getColor("red", true);else args.overlay.colorState = g_currentMission.hl.getColor("darkBlue", true);end;
	if args.overlay.isFormatTxt ~= nil then 		
		if timeScale > 1 or timeScale < 1 then
			args.overlay.txt[1].color = "red";
		else
			args.overlay.txt[1].color = "darkBlue";
		end;
		timeScale = moDraw.timescale:getTimeScale();
		args.overlay.txt[1].txt = tostring(timeScale);
		args.overlay.isFormatTxt = false;
	end;	
end;

function moDraw.timescale.onDrawAfter(args)		
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	local timeScale = moDraw.timescale:getTimeScale(true);
	local icon0 = moSetGetOverlays.icons.byName["MultiOverlayV4"]["intern"]["timeScale0"];
	local icon1 = moSetGetOverlays.icons.byName["MultiOverlayV4"]["intern"]["timeScale1"];
	local icon2 = moSetGetOverlays.icons.byName["MultiOverlayV4"]["intern"]["timeScale2"];
	local icon3 = moSetGetOverlays.icons.byName["MultiOverlayV4"]["intern"]["timeScale3"];
	local overlay = moSetGetOverlays.icons["MultiOverlayV4"]["intern"][icon1];
	g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);		
	if timeScale > 1 then				
		if timeScale > 360 then --by mod
			overlay = moSetGetOverlays.icons["MultiOverlayV4"]["intern"][icon3];
		else
			overlay = moSetGetOverlays.icons["MultiOverlayV4"]["intern"][icon2];
		end;
		g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);
	elseif timeScale < 1 then
		overlay = moSetGetOverlays.icons["MultiOverlayV4"]["intern"][icon0];
		g_currentMission.hl.setOverlay(overlay,args.overlay.x,args.overlay.y,args.overlay.width,args.overlay.height);
	end;	
	g_currentMission.hl.setBackgroundColor(overlay, args.overlay.colorState);
	overlay:render();		
end;

function moDraw.timescale:getTimeScale(int)
	if int then return g_currentMission.missionInfo.timeScale;end;
	if g_currentMission.missionInfo.timeScale < 1 then
		return string.format("%0.1f", g_currentMission.missionInfo.timeScale);
	else
		return string.format("%d", g_currentMission.missionInfo.timeScale);
	end
end;