moHlGui = {};
source(MultiOverlayV4.modDir.."scripte/hlGui/moGlobalSetting.lua");
source(MultiOverlayV4.modDir.."scripte/hlGui/moProfileSetting.lua");
source(MultiOverlayV4.modDir.."scripte/hlGui/moWtmSetting.lua");
source(MultiOverlayV4.modDir.."scripte/hlGui/moOtherSetting.lua");


function moHlGui:generate(change, debugPrint)
	if g_currentMission.hlGui == nil or g_currentMission.hlGui.setGet == nil then 
		if change then print("***Error	-can not generate MultiOverlayV4 Settings Menue (! is hlGui Menue loaded !)- Error***");end;
		MultiOverlayV4.hlGui.isLoad = false;
		return;
	end;	
	local errorTable = {};
	g_currentMission.hlGui.callbacks.moh = {};
	g_currentMission.hlGui.callbacks.moh["onOpenHlGui"] = moHlGui.onOpenHlGui;
	g_currentMission.hlGui.callbacks.moh["closeHlGui"] = moHlGui.setCloseHlGui;
	g_currentMission.hlGui.callbacks.moh["saveHlGui"] = moHlGui.setSaveHlGui;
	local isLoad = g_currentMission.hlGui.setGet:generateModMenue( {modName="MultiOverlayV4",displayName= tostring(MultiOverlayV4.metadata.title).. tostring(MultiOverlayV4.metadata.version), saveCallback=g_currentMission.hlGui.callbacks.moh["saveHlGui"], closeCallback=g_currentMission.hlGui.callbacks.moh["closeHlGui"]} );
	if not isLoad then errorTable[errorTable+1] = "***Error	-can not generate MultiOverlayV4 Settings Menue (! is hlGui Menue loaded !)- Error***";end;
	if isLoad then
		g_currentMission.hlGui.callbacks.moh["clickButton"] = moHlGui.clickButtonCallback;
		g_currentMission.hlGui.callbacks.moh["pullDownButton"] = moHlGui.pullDownButtonCallback;
		g_currentMission.hlGui.callbacks.moh["clickPullDownLine"] = moHlGui.clickPullDownLineCallback;
		g_currentMission.hlGui.callbacks.moh["txtButton"] = moHlGui.txtButtonCallback;
		g_currentMission.hlGui.callbacks.moh["openDraw"] = moHlGui.setOpenDraw;		
		
		-----GlobalSetting Page/Side-----
		MultiOverlayV4.hlGui.page["GlobalSetting"] = 1;MultiOverlayV4.hlGui.side["GlobalSetting"] = 1;
		isLoad = g_currentMission.hlGui.setGet:generateModPage( {modName="MultiOverlayV4", displayName="Global Setting"} );
		if not isLoad then errorTable[errorTable+1] = "***Error Global Setting";end;
		isLoad = g_currentMission.hlGui.setGet:generateModPageSide( {modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["GlobalSetting"]} );
		if not isLoad then errorTable[errorTable+1] = "***Error Global Setting Page Side";end;
		moGlobalSetting:generateSide(1);
		-----GlobalSetting Page/Side-----
		
		-----ProfileSetting Page/Side-----
		MultiOverlayV4.hlGui.page["ProfileSetting"] = 2;MultiOverlayV4.hlGui.side["ProfileSetting"] = 1;
		isLoad = g_currentMission.hlGui.setGet:generateModPage( {modName="MultiOverlayV4", displayName="Profile Setting"} );
		if not isLoad then errorTable[errorTable+1] = "***Error Profile Setting";end;
		isLoad = g_currentMission.hlGui.setGet:generateModPageSide( {modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["ProfileSetting"]} );
		if not isLoad then errorTable[errorTable+1] = "***Error Profile Setting Page Side";end;
		moProfileSetting:generateSide(1);
		-----ProfileSetting Page/Side-----
		
		
		-----WtmSetting Page/Side-----
		MultiOverlayV4.hlGui.page["WtmSetting"] = 3;MultiOverlayV4.hlGui.side["WtmSetting"] = 1;
		isLoad = g_currentMission.hlGui.setGet:generateModPage( {modName="MultiOverlayV4", displayName="Weather/Time/Money Setting"} );
		if not isLoad then errorTable[errorTable+1] = "***Error Wtm Setting";end;
		isLoad = g_currentMission.hlGui.setGet:generateModPageSide( {modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["WtmSetting"]} );
		if not isLoad then errorTable[errorTable+1] = "***Error Wtm Setting Page Side";end;
		moWtmSetting:generateSide(1);
		-----WtmSetting Page/Side-----

		
		-----CmdSetting Page/Side-----	
		MultiOverlayV4.hlGui.page["CmdSetting"] = 4;MultiOverlayV4.hlGui.side["CmdSetting"] = 1;
		isLoad = g_currentMission.hlGui.setGet:generateModPage( {modName="MultiOverlayV4", displayName="Cmd Setting"} );
		if not isLoad then errorTable[errorTable+1] = "***Error Cmd Setting";end;
		isLoad = g_currentMission.hlGui.setGet:generateModPageSide( {modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["CmdSetting"], otherDraw=g_currentMission.hlGui.callbacks.moh["openDraw"], ownTable={setOpen="cmdSettingMenue_"}} );
		if not isLoad then errorTable[errorTable+1] = "***Error Cmd Setting Page Side";end;
		-----CmdSetting Page/Side-----
		
		-----IconAppSetting Page/Side-----
		MultiOverlayV4.hlGui.page["AppIconSetting"] = 5;MultiOverlayV4.hlGui.side["AppIconSetting"] = 1;
		isLoad = g_currentMission.hlGui.setGet:generateModPage( {modName="MultiOverlayV4", displayName="App Icon Setting"} );
		if not isLoad then errorTable[errorTable+1] = "***Error App Icon Setting";end;
		isLoad = g_currentMission.hlGui.setGet:generateModPageSide( {modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["AppIconSetting"], otherDraw=g_currentMission.hlGui.callbacks.moh["openDraw"], ownTable={setOpen="appIconSettingMenue_"}} );
		if not isLoad then errorTable[errorTable+1] = "***Error App Icon Setting Page Side";end;
		-----IconAppSetting Page/Side-----
		
		-----OtherSetting Page/Side-----
		MultiOverlayV4.hlGui.page["OtherSetting"] = 6;MultiOverlayV4.hlGui.side["OtherSetting"] = 1;
		isLoad = g_currentMission.hlGui.setGet:generateModPage( {modName="MultiOverlayV4", displayName="Other Setting"} );
		if not isLoad then errorTable[errorTable+1] = "***Error Other Setting";end;
		isLoad = g_currentMission.hlGui.setGet:generateModPageSide( {modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["OtherSetting"]} );
		if not isLoad then errorTable[errorTable+1] = "***Error Other Setting Page Side";end;
		moOtherSetting:generateSide(1);
		-----OtherSetting Page/Side-----
		
		MultiOverlayV4.hlGui.isLoad = true;		
		--print(DebugUtil.printTableRecursively(g_currentMission.hlGui.mod["MultiOverlayV4"], "Moh Gui ", 0, 7))
	end;
	if #errorTable > 0 then
		if debugPrint then
			for a=1, #errorTable do
				print("---MOH DebugPrint= ".. tostring(errorTable[a]))
			end;
		end;
		MultiOverlayV4.hlGui.isLoad = false;
		return;
	end;
	MultiOverlayV4.hlGui.isLoad = true;
end;

function moHlGui.clickButtonCallback(args)	
	if args == nil or type(args) ~= "table" or args.lineButton == nil then return;end;	
	if args.lineButton.ownTable.pageName == "GlobalSetting" then
		if not moGeneralSettings.modOn then 
			if args.lineButton.ownTable.side ~= 1 then return;end;
			if args.lineButton.ownTable.whatClick ~= "mohOnOff_" then return;end;
		end;
		moGlobalSetting:clickButtonCallback(args);
	elseif args.lineButton.ownTable.pageName == "ProfileSetting" then
		if not moGeneralSettings.modOn then return;end;
		moProfileSetting:clickButtonCallback(args);
	elseif args.lineButton.ownTable.pageName == "WtmSetting" then
		if not moGeneralSettings.modOn then return;end;
		moWtmSetting:clickButtonCallback(args);
	elseif args.lineButton.ownTable.pageName == "OtherSetting" then
		if not moGeneralSettings.modOn then return;end;
		moOtherSetting:clickButtonCallback(args);
	end;
	return;
end;

function moHlGui.pullDownButtonCallback(args)
	local pullDownTable = {};
	if not moGeneralSettings.modOn then return pullDownTable;end;
	if args == nil or type(args) ~= "table" or args.lineButton == nil then return pullDownTable;end;
	if args.lineButton.ownTable.pageName == "GlobalSetting" then
		pullDownTable = moGlobalSetting:pullDownCallback(args.lineButton);
	elseif args.lineButton.ownTable.pageName == "ProfileSetting" then
		pullDownTable = moProfileSetting:pullDownCallback(args.lineButton);
	elseif args.lineButton.ownTable.pageName == "WtmSetting" then
		pullDownTable = moWtmSetting:pullDownCallback(args.lineButton);
	elseif args.lineButton.ownTable.pageName == "OtherSetting" then
		pullDownTable = moOtherSetting:pullDownCallback(args.lineButton);
	end;
	return pullDownTable;
end;

function moHlGui.clickPullDownLineCallback(args)
	if not moGeneralSettings.modOn then return;end;
	if args == nil or type(args) ~= "table" or args.selectLine == nil or args.ownTable == nil then return;end;	
	if args.ownTable.pageName == "GlobalSetting" then
		moGlobalSetting:clickPullDownLineCallback(args);
	elseif args.ownTable.pageName == "ProfileSetting" then
		moProfileSetting:clickPullDownLineCallback(args);
	elseif args.ownTable.pageName == "WtmSetting" then
		moWtmSetting:clickPullDownLineCallback(args);
	elseif args.ownTable.pageName == "OtherSetting" then
		moOtherSetting:clickPullDownLineCallback(args);
	end;
	return;
end;

function moHlGui.txtButtonCallback(args)
	if args == nil or type(args) ~= "table" or args.lineButton == nil or args.lineButton.ownTable == nil then return "";end;
	local txtButton = "";
	if args.lineButton.ownTable.pageName == "GlobalSetting" then
		if not moGeneralSettings.modOn then 
			if args.lineButton.ownTable.side ~= 1 then return "";end;
			if args.lineButton.ownTable.whatClick ~= "mohOnOff_" then return "";end;
		end;
		txtButton = moGlobalSetting:txtButtonCallback(args.lineButton);
	elseif args.lineButton.ownTable.pageName == "ProfileSetting" then
		if not moGeneralSettings.modOn then return "";end;
		txtButton = moProfileSetting:txtButtonCallback(args.lineButton);
	elseif args.lineButton.ownTable.pageName == "WtmSetting" then
		if not moGeneralSettings.modOn then return "";end;
		txtButton = moWtmSetting:txtButtonCallback(args.lineButton);
	elseif args.lineButton.ownTable.pageName == "OtherSetting" then
		if not moGeneralSettings.modOn then return "";end;
		txtButton = moOtherSetting:txtButtonCallback(args.lineButton);
	end;
	return tostring(txtButton);
end;

function moHlGui.onOpenHlGui(args)
	
end;

function moHlGui.setOpenDraw(args)
	if not moGeneralSettings.modOn then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.ownTable.setOpen == "cmdSettingMenue_" then
		moDrawCmdSetting:setOpen(args);
	elseif args.ownTable.setOpen == "appIconSettingMenue_" then
		moDrawAppIconSetting:setOpen(args);
	end;
end;

function moHlGui.setCloseHlGui()
	moSetGetDraw:closeAllMenues();
end;

function moHlGui.setSaveHlGui()
	moXmlSettings:saveXml();
end;































