moOtherSetting = {}

function moOtherSetting:clickButtonCallback(args)
	local color = "";
	local txt = "";
	if args.lineButton.ownTable.side == 1 then
		if args.lineButton.ownTable.whatClick == "miniMapAutoState_" then			
			moGeneralSettings.miniMapAutoState.on = not moGeneralSettings.miniMapAutoState.on;			
			g_currentMission.hlGui.setGet:setUnSave();			
			return;			
		elseif args.lineButton.ownTable.whatClick == "viewMiniMapAutoStateIcons_" then			
			if not moGeneralSettings.miniMapAutoState.on then return;end;
			moGeneralSettings.miniMapAutoState.viewIcons = not moGeneralSettings.miniMapAutoState.viewIcons;			
			g_currentMission.hlGui.setGet:setUnSave();			
			return;
		elseif args.lineButton.ownTable.whatClick == "viewPlayerPos_" then			
			moGeneralSettings.other.viewPlayerPos = not moGeneralSettings.other.viewPlayerPos;			
			g_currentMission.hlGui.setGet:setUnSave();			
			return;
		elseif args.lineButton.ownTable.whatClick == "viewRevampModeInfo_" then			
			moGeneralSettings.other.revamp.viewModeInfo = not moGeneralSettings.other.revamp.viewModeInfo;			
			g_currentMission.hlGui.setGet:setUnSave();			
			return;
		elseif args.lineButton.ownTable.whatClick == "viewOpeningTimeInfo_" then			
			moGeneralSettings.other.vot.viewOpeningTimeInfo = not moGeneralSettings.other.vot.viewOpeningTimeInfo;			
			g_currentMission.hlGui.setGet:setUnSave();			
			return;
		end;
	end;
end;

function moOtherSetting:txtButtonCallback(lineButton)
	local txtButton = "";
	if lineButton.ownTable.side == 1 then
		if lineButton.ownTable.whatClick == "miniMapAutoState_" then
			if moGeneralSettings.miniMapAutoState.on then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;				
		elseif lineButton.ownTable.whatClick == "viewMiniMapAutoStateIcons_" then
			if moGeneralSettings.miniMapAutoState.viewIcons then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;	
		elseif lineButton.ownTable.whatClick == "viewPlayerPos_" then
			if moGeneralSettings.other.viewPlayerPos then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;
		elseif lineButton.ownTable.whatClick == "viewRevampModeInfo_" then
			if moGeneralSettings.other.revamp.viewModeInfo then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;
		elseif lineButton.ownTable.whatClick == "viewOpeningTimeInfo_" then
			if moGeneralSettings.other.vot.viewOpeningTimeInfo then
				txtButton = "On";
				lineButton.clickButtonColor = "green";
			else
				txtButton = "Off"
				lineButton.clickButtonColor = "red";
			end;
		end;
	end;
	return txtButton;
end;

function moOtherSetting:pullDownCallback(lineButton)
	local pullDownTable = {}
	
	return pullDownTable;
end;

function moOtherSetting:clickPullDownLineCallback(args)
	
end;

function moOtherSetting:generateSide(side)
	local buttons = {};
	local color = ""
	local txtButton = "";
	if side == 1 then
		buttons = {
			[1] = {
				txtOverButton = "MiniMapAutoState";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="OtherSetting", whatClick="miniMapAutoState_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die MiniMap Auto State Funktion";
			};
			[2] = {
				txtOverButton = "View MiniMapAutoState Icons";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="OtherSetting", whatClick="viewMiniMapAutoStateIcons_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die MiniMap Auto State Icons";
			};
			[3] = {
				txtOverButton = "View Player Position";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="OtherSetting", whatClick="viewPlayerPos_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die Spieler Position (wird dann über der MiniMap angezeigt)";
			};
			[4] = {
				txtOverButton = "View Revamp Mode Info";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="OtherSetting", whatClick="viewRevampModeInfo_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die RevampMode Info (Hourly,Sun,Temp ....)";	
			};
		};		
		g_currentMission.hlGui.setGet:generateModSideLine({modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["OtherSetting"], side=side, lineButtons=buttons});
		--line--
		buttons = {		
			[1] = {
				txtOverButton = "View VOT OpeningTime Info";				
				txtButton = "On";
				txtBoldButton = true;
				txtButtonCallback = g_currentMission.hlGui.callbacks.moh["txtButton"];
				clickButton = "buttonOnOff";
				clickButtonColor = "green";
				clickButtonCallback = g_currentMission.hlGui.callbacks.moh["clickButton"];
				ownTable = {pageName="OtherSetting", whatClick="viewOpeningTimeInfo_",side=side};
				txtInfo = "Aktiviere oder Deaktiviere die Öffnungszeiten Info *needs VariableOpeningTime Mod*";
				width = 25;
			};
			[2] = {
				visible = false;			
			};
		};	
		g_currentMission.hlGui.setGet:generateModSideLine({modName="MultiOverlayV4", page=MultiOverlayV4.hlGui.page["OtherSetting"], side=side, lineButtons=buttons});
		--line--
	end;
end;
























