moChargingStationsOutput = {};

function moChargingStationsOutput:loadSimple(cmdTable, slotTable)
	local foundViewInput = false;
	local cmdRegName = cmdTable.regName;	
	local lineTable = {line={}};
	local foundChargingStations = 0;
	if moModule.chargingStations ~= nil and #moModule.chargingStations > 0 then
		for index=1, #moModule.chargingStations do
			if moModule.chargingStations[index] ~= nil then
				local cmdObject = moModule.chargingStations[index].object;
				if cmdObject ~= nil and moModuleObjects:isObject(cmdObject) and cmdObject.mohTable ~= nil and cmdObject.mohTable.general ~= nil and cmdObject.mohTable.general[1] ~= nil then				
					foundChargingStations = foundChargingStations+1;
					-----general-----
					---objectName---
					local viewChargingInfoSmall = cmdObject.mohTable.viewChargingInfoSmall;
					local chargingStationGeneral = cmdObject.mohTable.general[1];
					lineTable.line[#lineTable.line+1] = {};
					local isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};	
					if cmdObject.isGreatDemand ~= nil and cmdObject.isGreatDemand then
						isLineTable.txt[1].outputColor = "txtGreatDemandColor";
					else
						isLineTable.txt[1].slotColor = "txtOutputTitle";
					end;
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(chargingStationGeneral.objectName);		
					isLineTable.txt[1].callback = moChargingStationsOutput.clickChargingStation;
					isLineTable.txt[1].ownTable = {cmdObject.rootNode};
					isLineTable.txt[1].width = 75;
					if g_currentMission.hl.isMouseCursor then
						iconColor = "green";
						buttonName = "buttonUp";
						if viewChargingInfoSmall then iconColor = "gray";buttonName = "buttonDown";end;				
						isLineTable.txt[1].icon = {before={},after={}};
						isLineTable.txt[1].icon.before[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moChargingStationsOutput.clickViewChargingInfoSmall}, ownTable={cmdObject.rootNode}, infoTxt="BunkerSilo Info Small"};
					end;
					local objectId = cmdObject.nodeId or cmdObject.rootNode;		
					local oX,oY,oZ = getWorldTranslation(objectId);
					if oX ~= nil and oY ~= nil and oZ ~= nil then
						local x,y,z = g_currentMission.hl.getPlayerPos();
						if x ~= nil and y ~= nil and z ~= nil then
							local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, 10);
							if nearObject then isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";end;
						end;
					end;
					---objectName---
					if not viewChargingInfoSmall then
						---infoGeneral---					
						local color = chargingStationGeneral.statusColor;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_status"));
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].width = 50;
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].prozentColor = color;
						if chargingStationGeneral.status == 1 then
							isLineTable.txt[2].txt = tostring(g_i18n:getText("action_startCharging"));
						elseif chargingStationGeneral.status == 2 then
							isLineTable.txt[2].txt = tostring(g_i18n:getText("ui_production_status_running"));
						elseif chargingStationGeneral.status == 3 then
							isLineTable.txt[2].txt = tostring(g_i18n:getText("button_fieldJob_complete"));
						else
							isLineTable.txt[2].txt = "--";
						end;
						isLineTable.txt[2].width = 50;
						isLineTable.txt[2].alignment = 3;					
						if chargingStationGeneral.statusTxt ~= nil and string.len(chargingStationGeneral.statusTxt) > 0 then
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];
							isLineTable.txt = {};
							isLineTable.txt[1] = {};
							isLineTable.txt[1].bold = false;
							isLineTable.txt[1].txt = tostring(chargingStationGeneral.statusTxt);
							isLineTable.txt[1].slotColor = "txt";						
						end;
						if chargingStationGeneral.vehicleName ~= nil and string.len(chargingStationGeneral.vehicleName) > 0 then
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];
							isLineTable.txt = {};
							isLineTable.txt[1] = {};
							isLineTable.txt[1].bold = false;
							isLineTable.txt[1].txt = tostring(chargingStationGeneral.vehicleName);
							isLineTable.txt[1].slotColor = "txt";						
						end;
						---infoGeneral---
						---input view---
						local chargingStationOutput = cmdObject.mohTable.output;
						local viewOutput = cmdObject.mohTable.viewOutput;
						if #chargingStationOutput > 0 then
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];
							isLineTable.txt = {};
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].slotColor = "txt";
							isLineTable.txt[1].bold = true;			
							isLineTable.txt[1].txt = "Out ++ ".. "(".. tostring(#chargingStationOutput).. ")";			
							isLineTable.txt[1].callback = moChargingStationsOutput.clickViewOutputOnOff;
							isLineTable.txt[1].ownTable = {cmdObject.rootNode};
							color = "red";
							local buttonName = "buttonDown";
							if viewOutput then color = "green";buttonName = "buttonUp";end;
							isLineTable.txt[1].icon = {before={},after={}};
							isLineTable.txt[1].icon.before[1] = {name=buttonName, color=color, settingButton=true, callback={[1]=moChargingStationsOutput.clickViewOutputOnOff}, ownTable={cmdObject.rootNode}};					
						end;
						---input view---							
						-----general-----
						
						-----output-----					
						if viewOutput then			
							foundViewInput = true;
							---global on/off view filltypes later not view !?!
							for output=1, #chargingStationOutput do
								if chargingStationOutput[output] ~= nil then
									lineTable.line[#lineTable.line+1] = {};
									isLineTable = lineTable.line[#lineTable.line];
									isLineTable.txt = {};
									isLineTable.txt[1] = {};
									if moFillTypes.values.amount[chargingStationOutput[output].fillType] ~= nil and moFillTypes.values.amount[chargingStationOutput[output].fillType] > 0 then
										isLineTable.txt[1].outputColor = "txtFillTypesColor"; 
										isLineTable.txt[1].isAmount = true;
									else
										isLineTable.txt[1].outputColor = "txtPriceColor";
										isLineTable.txt[1].isAmount = false;
									end;
									isLineTable.txt[1].bold = false;
									isLineTable.txt[1].txt = tostring(chargingStationOutput[output].fillTypeName);								
									isLineTable.txt[1].width = 60;
									
									local priceTrend = "priceNormal";
									isLineTable.txt[2] = {};																
									isLineTable.txt[2].outputColor = "txtPriceColor";
									--if chargingStationOutput[output].priceTrend == "up" then									
									--	priceTrend = "priceUp";
									--elseif chargingStationOutput[output].priceTrend == "down" then									
									--	priceTrend = "priceDown";
									--elseif chargingStationOutput[output].priceTrend == "greatDemand" then
									--	isLineTable.txt[2].outputColor = "txtGreatDemandColor";								
									--end;
									--isLineTable.txt[2].icon = {before={},after={}};
									--isLineTable.txt[2].icon.after[1] = {name=priceTrend, modName="MultiOverlayV4", groupName="intern" };
									isLineTable.txt[2].bold = false;
									isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(chargingStationOutput[output].price, 0, true, false));
									isLineTable.txt[2].width = 40;
									isLineTable.txt[2].alignment = 3;						
								end;
							end;						
						end;
						-----output-----
					end;
				end;
			end;
		end;
		function comp(w1,w2)		
			if w1.txt[1].txt < w2.txt[1].txt then
				return true;
			end;				
		end;
		--table.sort(lineTable.line, comp);
		---objectLineDistance---
		lineTable.line[#lineTable.line+1] = {};
		local isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};		
		isLineTable.txt[1].txt = " ";
		---objectLineDistance---
	end;
	table.insert(lineTable.line, 1, {});
	isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = tostring(g_i18n:getText("shopItem_chargingStation")).. " (".. tostring(foundChargingStations).. ")";
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
		isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moChargingStationsOutput.clickChargingStationsHelpTxt}};
	end;
	moChargingStations[cmdRegName] = {output=lineTable};
end;

function moChargingStationsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="chargingStations" } );
	if args.cmdTable.ownTable ~= nil and args.cmdTable.ownTable[1] ~= nil and args.cmdTable.ownTable[1] == "simpleChargingStations" then		
		moChargingStationsOutput:loadSimple(args.cmdTable, args.slotTable);
	end;
	return moChargingStations[args.cmdTable.regName].output;
end;

function moChargingStationsOutput.clickChargingStationsHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "ChargingStations Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional ChargingStations or Out++ for more Info or MapHotSpot or ...";
	end;
end;

function moChargingStationsOutput.clickViewChargingInfoSmall(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "chargingStations");			
			if object ~= nil then
				object.mohTable.viewChargingInfoSmall = not object.mohTable.viewChargingInfoSmall;
			end;
		end;	
	end;
end;

function moChargingStationsOutput.clickChargingStation(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "chargingStations");			
			if object ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then
					moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
				end;
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[1] ~= nil and g_currentMission.controlledVehicle == nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "chargingStations");			
			if object ~= nil and object.spec_hotspots ~= nil and object.spec_hotspots.mapHotspots ~= nil then
				local hotspot = object.spec_hotspots.mapHotspots[1];
				if hotspot ~= nil and hotspot.teleportWorldX ~= nil and hotspot.teleportWorldY ~= nil and hotspot.teleportWorldZ ~= nil then
					g_currentMission.player:moveToAbsolute(hotspot.teleportWorldX, hotspot.teleportWorldY, hotspot.teleportWorldZ, false, false);
					MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moChargingStationsOutput.clickChargingStation"); --force mouseOff
				end;				
			end;
		end;		
	end;
end;

function moChargingStationsOutput.clickViewOutputOnOff(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then					
			local object = moModuleObjects:getObject(args.ownTable[1], "chargingStations");			
			if object ~= nil then				
				object.mohTable.viewOutput = not object.mohTable.viewOutput;
			end;			
		end;
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="chargingStations" } );