moFarmlandsConfig = {};

function moFarmlandsConfig:defaultValues()
	moFarmlands.values = {farmlandFields={}, farmlands={}, sortBy=1, maxSortBy=6, updateTimer=2, msec=false};
	--sortBy 1=farmlandId, 2=price, 3=farmlandHectar, 4=farmlandFieldsHectar, 5=fields, 6=farmId
end;

function moFarmlandsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moFarmlands.values == nil then moFarmlandsConfig:defaultValues();end;
	--local groupNameTag = (xmlNameTag.. ".module.farmlands(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		--moFarmlands.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		--moFarmlands.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;
end;

function moFarmlandsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;
	if moFarmlands.values == nil then moFarmlandsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	--local groupNameTag = (xmlNameTag.. ".module.farmlands(%d)"):format(0);
	--setXMLInt(Xml, groupNameTag.. "#updateTimer", moFarmlands.values.updateTimer);
	--setXMLBool(Xml, groupNameTag.. "#mSecTimer", moFarmlands.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moFarmlandsConfig:generateCmd()
	function generateCmd(ownTable)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = "output_mapFarmlands_";
				groupName = "OutputByMoh";			
				displayName = "Map Farmlands";
				infoTxt = "View Farmlands";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = ownTable;
				object = {};
				actionCallback = moFarmlandsOutput.giveOutputTable;			
			}
		)
	end;	
	generateCmd({});	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moFarmlandsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moFarmlandsConfig.saveXml } );
