moItemsConfig = {};

function moItemsConfig:defaultValues()
	moItemsConfig.values = {updateTimer=10, msec=false};
end;

function moItemsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moItemsConfig.values == nil then moItemsConfig:defaultValues();end;
	--local groupNameTag = (xmlNameTag.. ".module.items(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		--moItemsConfig.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		--moItemsConfig.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;	
end;

function moItemsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;
	if moItemsConfig.values == nil then moItemsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.items(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moItemsConfig.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moItemsConfig.values.msec);
	----------------------------------------------------------------------------------------------	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moItemsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moItemsConfig.saveXml } );
