moKeySettingsConfig = {};

function moKeySettingsConfig:defaultValues()
	moKeySettings.values = {mod={}, modBindings={}, disabledId={}, viewAll=false, updateTimer=1, msec=false};	
end;

function moKeySettingsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;
	if moKeySettings.values == nil then moKeySettingsConfig:defaultValues();end;	
	--local groupNameTag = (xmlNameTag.. ".module.keySettings(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		--moKeySettings.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") ~= nil then
		--moKeySettings.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;
	--if getXMLBool(Xml, groupNameTag.. "#viewAll") ~= nil then
		--moKeySettings.values.viewAll = getXMLBool(Xml, groupNameTag.. "#viewAll");
	--end;	
end;

function moKeySettingsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;	
	if moKeySettings.values == nil then moKeySettingsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	--local groupNameTag = (xmlNameTag.. ".module.keySettings(%d)"):format(0);
	--setXMLInt(Xml, groupNameTag.. "#updateTimer", moKeySettings.values.updateTimer);
	--setXMLBool(Xml, groupNameTag.. "#mSecTimer", moKeySettings.values.msec);
	--setXMLBool(Xml, groupNameTag.. "#viewAll", moKeySettings.values.viewAll);
	----------------------------------------------------------------------------------------------	
end;

function moKeySettingsConfig:generateCmd()
	function generateCmd(ownTable)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = "output_keySettings_";
				groupName = "OutputByMoh";			
				displayName = "Key Settings";
				infoTxt = "View Key Settings";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = ownTable;
				object = {};
				actionCallback = moKeySettingsOutput.giveOutputTable;			
			}
		)
	end;	
	generateCmd({});	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moKeySettingsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moKeySettingsConfig.saveXml } );
