moModuleObjects = {};

function moModuleObjects:isObject(object, item)
	if object ~= nil and item then --g_currentMission:getNodeObject(object) --for items,later
		local objectId = object.rootNode or object.nodeId;
		if objectId ~= nil and g_currentMission.nodeToObject[objectId] ~= nil then
			if object.isa ~= nil and object:isa(Vehicle) then return true;end;
		end;
		return false;
	end;
	if object ~= nil and item == nil then
		local objectId = object.rootNode or object.nodeId;
		if objectId ~= nil and objectId ~= 0 then			
			local id = getNumOfChildren(Utils.getNoNil(objectId, 0));
			if id == nil or id == 0 then return false;end;return true;
		end;		
	end;
	return false;
end;

function moModuleObjects:getObject(rootNode, searchModul)
	if rootNode == nil or searchModul == nil or moModule[searchModul] == nil or #moModule[searchModul] <= 0 then return nil;end;
	local object = nil;
	for a=1, #moModule[searchModul] do
		if moModule[searchModul][a].object ~= nil then
			object = moModule[searchModul][a].object
			if object.rootNode ~= nil and object.rootNode == rootNode then break;else object = nil;end;
		end;
	end;
	return object;
end;

local test = true;
function moModuleObjects:load()
	moModule.beehives = {};
	moModule.productionPoints = {};
	--moModule.productionPointWardrobe = {};
	moModule.bunkerSilos = {};
	moModule.windTurbines = {};
	moModule.weatherStations = {};
	moModule.solarPanels = {};	
	moModule.greenhouses = {};
	moModule.storages = {};
	moModule.storageExtensions = {};
	moModule.storageExtensionsFree = {};
	moModule.sellingStations = {};
	moModule.buyingStations = {}; 
	moModule.chargingStations = {};
	moModule.animals = {};	
	if g_currentMission.placeableSystem == nil or g_currentMission.placeableSystem.placeables == nil then return;end;
	local mohOtherScriptSupport = "revampgreenhouse,revampproductionpoint,spec_extendedProductionPoint,"
	function setMohData(object, name)		
		object.mohTable = {general={},production={},output={},input={}};
		object.mohTable.name = Utils.getNoNil(object:getName(), "Unknown");
		object.mohTable.cmdName = name; --needs for cmd		
		local xmlObject = Utils.getNoNil(object.configFileName, nil);			
		if xmlObject ~= nil then
			local stringTable = g_currentMission.hl.stringSplit(xmlObject, "/", true);					
			if stringTable ~= nil and #stringTable > 0 then
				local xmlName = stringTable[#stringTable];
				object.mohTable.xmlName = string.gsub(xmlName, ".xml", "");
			else
				object.mohTable.xmlName = "storageXmlUnknown";
			end;
			local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
			if storeItem ~= nil then						
				object.mohTable.storeData = storeItem;
			end;
		end;
		--print("mohName= ".. tostring(object.mohTable.name))
	end;
	for key, object in pairs(g_currentMission.placeableSystem.placeables) do
		if object.typeName ~= nil then
			--print("-------TypeName: ".. tostring(object.typeName))
			local support = object.spec_extendedProductionPoint == nil; --Hof Bergmann Map eigenes ExtendedProduktionsScript !! Warum !! keine Ahnung was das kann was LS Scripts nicht können oder was man nicht einfach in LS Scripts integrieren kann
			--if support then
				if (object.typeName:lower() == "silo" or string.find(object.typeName:lower(), "revampsilo") or object.spec_siloObjectFillLevel ~= nil or object.supportsExtension ~= nil) and not string.find(object.configFileName, "railroad") then --or object.typeName == "siloExtension" then and not string.find(object.configFileName, "railroad") 
					moModule.storages[#moModule.storages+1] = {};
					local storage = moModule.storages[#moModule.storages];
					setMohData(object, "silo");							
					object.mohTable.siloExtensions = {};				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "Storage ".. tostring(#moModule.storages);end;
					storage.object = object;				
				elseif object.typeName:lower() == "siloextension" then
					moModule.storageExtensions[#moModule.storageExtensions+1] = {object=object};				
				elseif (object.typeName:lower() == "greenhouse" or object.spec_greenhouse ~= nil or string.find(object.typeName:lower(), "revampgreenhouse")) then --and support then
					moModule.greenhouses[#moModule.greenhouses+1] = {};
					local greenhouse = moModule.greenhouses[#moModule.greenhouses];
					setMohData(object, "greenhouses");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "Greenhouse ".. tostring(#moModule.greenhouses);end;
					greenhouse.object = object;				
				elseif object.typeName:lower() == "beehive" then
					moModule.beehives[#moModule.beehives+1] = {};
					local beehive = moModule.beehives[#moModule.beehives];
					setMohData(object, "beehives");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "Beehive ".. tostring(#moModule.beehives);end;
					beehive.object = object;				
				elseif object.typeName:lower() == "productionpoint" or object.typeName:lower() == "productionpointwardrobe" or string.find(object.typeName:lower(), "revampproductionpoint") or object.spec_productionObjectFillLevel ~= nil or object.spec_extendedProductionPoint then
					moModule.productionPoints[#moModule.productionPoints+1] = {};
					local productionPoint = moModule.productionPoints[#moModule.productionPoints];
					setMohData(object, "productionPoints");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "Production ".. tostring(#moModule.productionPoints);end;
					productionPoint.object = object;				
				elseif object.typeName:lower() == "sellingstation" then
					moModule.sellingStations[#moModule.sellingStations+1] = {};
					local sellingStations = moModule.sellingStations[#moModule.sellingStations];
					setMohData(object, "sellingStations");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "SellingStation ".. tostring(#moModule.sellingStations);end;
					sellingStations.object = object;
				elseif object.typeName:lower() == "buyingstation" then
					moModule.buyingStations[#moModule.buyingStations+1] = {};
					local buyingStations = moModule.buyingStations[#moModule.buyingStations];
					setMohData(object, "buyingStations");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "BuyingStation ".. tostring(#moModule.buyingStations);end;
					buyingStations.object = object;	
				elseif string.find(object.typeName:lower(), "windturbine") then
					moModule.windTurbines[#moModule.windTurbines+1] = {};
					local windTurbines = moModule.windTurbines[#moModule.windTurbines];
					setMohData(object, "windTurbines");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "WindTurbine ".. tostring(#moModule.windTurbines);end;
					windTurbines.object = object;			
				elseif string.find(object.typeName:lower(), "bunkersilo") then
					moModule.bunkerSilos[#moModule.bunkerSilos+1] = {};
					local bunkerSilos = moModule.bunkerSilos[#moModule.bunkerSilos];
					setMohData(object, "bunkerSilos");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "BunkerSilo ".. tostring(#moModule.bunkerSilos);end;
					bunkerSilos.object = object;
				elseif string.find(object.typeName:lower(), "solarpanel") then
					moModule.solarPanels[#moModule.solarPanels+1] = {};
					local solarPanels = moModule.solarPanels[#moModule.solarPanels];
					setMohData(object, "solarPanels");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "SolarPanel ".. tostring(#moModule.solarPanels);end;
					solarPanels.object = object;
				elseif string.find(object.typeName:lower(), "chargingstation") then
					moModule.chargingStations[#moModule.chargingStations+1] = {};
					local chargingStations = moModule.chargingStations[#moModule.chargingStations];
					setMohData(object, "chargingStations");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "ChargingStation ".. tostring(#moModule.chargingStations);end;
					chargingStations.object = object;				
				elseif string.find(object.typeName:lower(), "husbandry") or object.spec_productionObjectFillLevel ~= nil or object.spec_husbandryAnimals ~= nil then
					moModule.animals[#moModule.animals+1] = {};
					local animals = moModule.animals[#moModule.animals];
					setMohData(object, "animals");				
					if object.mohTable.name == "Unknown" then object.mohTable.name = "Animal ".. tostring(#moModule.animals);end;
					animals.object = object;				
				end;
			--end;
		end;
	end;	
	function comp(w1,w2)			
		if w1.object.mohTable.name < w2.object.mohTable.name then
			return true;
		end;			
	end;
	local sortModule = {"sellingStations", "buyingStations", "greenhouses", "bunkerSilos", "beehives", "productionPoints", "animals", "solarPanels", "windTurbines", "storages", "chargingStations"};
	for _, modul in pairs (sortModule) do
		if moModule[modul] ~= nil and #moModule[modul] > 1 then
			table.sort(moModule[modul], comp);
		end;
	end;	
end;

function moModuleObjects:loadOld()--ls19
	moModule.sellingStations = {};
	moModule.buyingStations = {};
	moModule.storages = {};
	moModule.objectStorages = {};
	moModule.bgas = {};
	moModule.bunkerSilos = {};
	moModule.greenhouses = {};
	moModule.gc = {factorys={}}; --GlobalCompany
	moModule.animals = {};
	moModule.beehivehouses = {};
	moModule.windturbinen = {};
	moModule.solarcollectoren = {};
	moModule.heatingplants = {};
	moModule.feedMixers = {}; --FeedMixer Script
	moModule.heapPreview = {}; --heapPreview --MaizePlus
	moModule.fillTypeMovers = {}; --FillTypeMover Script
	moModule.others = {};
	if g_currentMission.objectsToClassName == nil then return;end;
	for object, class in pairs(g_currentMission.objectsToClassName) do
		--print("g_currentMission.objectsToClassName object und class ...".. tostring(object).. "-----".. tostring(class))
		if class == "SellingStationPlaceable" then
			moModule.sellingStations[#moModule.sellingStations+1] = {};
			local station = moModule.sellingStations[#moModule.sellingStations];
			station.object = object;
			station.name = "Unknown"
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					station.mohDisplayName = displayName;
				end;
			end;
			if object.sellingStation ~= nil then station.name = Utils.getNoNil(object.sellingStation.stationName, "Unknown");end;			
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module SellingStation configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					station.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					station.xmlName = "sellingStationXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if station.name == "Unknown" and storeItem.name ~= nil then	station.name = storeItem.name;end;
					station.storeData = storeItem;
				end;
			end;
			if station.name == "Unknown" then station.name = "SellingStation ".. tostring(#moModule.sellingStations);end;
			--print("objectName SellingStationPlaceable= ".. tostring(station.name));
		elseif class == "SiloExtensionPlaceable" or class == "SiloPlaceable" then	
			local fillTypeMoverTable = nil;
			function isFillTypeMover()
				--placeable
				local env = getfenv(0);
				if env[object.customEnvironment] ~= nil and env[object.customEnvironment]["FillTypeMover"] ~= nil then								
					for key, value in ipairs(env[object.customEnvironment]["FillTypeMover"].Herst) do						
						if value.nodeId == object.nodeId then
							fillTypeMoverTable = value;
							return true;						
						end;		
					end;
				end;
				--placeable
				--map
				if MultiOverlayV4.otherMods.fillTypeMover ~= nil and MultiOverlayV4.otherMods.fillTypeMoverFirstScan then
					for key, value in ipairs(MultiOverlayV4.otherMods.fillTypeMover.Herst) do						
						if value.nodeId == object.nodeId then
							fillTypeMoverTable = value;
							return true;						
						end;						
					end;	
				end;
				--map
				return false;
			end;
			local storage = nil;			
			if isFillTypeMover() then
				moModule.fillTypeMovers[#moModule.fillTypeMovers+1] = {};
				storage = moModule.fillTypeMovers[#moModule.fillTypeMovers];
				storage.fillTypeMoverTable = fillTypeMoverTable;
			else
				moModule.storages[#moModule.storages+1] = {};
				storage = moModule.storages[#moModule.storages];
			end;
			storage.object = object;
			storage.extension = class == "SiloExtensionPlaceable";
			storage.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					storage.mohDisplayName = displayName;
				end;
			end;
			if object.unloadingStation ~= nil then storage.name = Utils.getNoNil(object.unloadingStation.stationName, "Unknown");end;
			if storage.name == "Unknown" and object.loadingStation ~= nil then storage.name = Utils.getNoNil(object.loadingStation.stationName, "Unknown");end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module Silo configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					storage.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					storage.xmlName = "storageXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if storage.name == "Unknown" and storeItem.name ~= nil then storage.name = storeItem.name;end;
					storage.storeData = storeItem;
				end;
			end;
			if storage.name == "Unknown" then storage.name = "Silo ".. tostring(#moModule.storages);end;
			--print("objectName SiloPlaceable+SiloExtensionPlaceable= ".. tostring(storage.name));			
		elseif class == "GreenhousePlaceable" then 
			moModule.greenhouses[#moModule.greenhouses+1] = {};
			local greenhouse = moModule.greenhouses[#moModule.greenhouses];
			greenhouse.object = object;			
			greenhouse.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					greenhouse.mohDisplayName = displayName;
				end;
			end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);			
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module Greenhouse configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					greenhouse.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					greenhouse.xmlName = "greenhouseXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if greenhouse.name == "Unknown" and storeItem.name ~= nil then greenhouse.name = storeItem.name;end;
					greenhouse.storeData = storeItem;
				end;
			end;
			if greenhouse.name == "Unknown" then greenhouse.name = "Greenhouse ".. tostring(#moModule.greenhouses);end;
			--print("objectName GreenhousePlaceable= ".. tostring(greenhouse.name));			
		elseif class == "BgaPlaceable" then	
			moModule.bgas[#moModule.bgas+1] = {};
			local bga = moModule.bgas[#moModule.bgas];
			bga.object = object;			
			bga.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					bga.mohDisplayName = displayName;
				end;
			end;
			if object.bga ~= nil and object.bga.digestateSilo ~= nil and object.bga.digestateSilo.loadingStation ~= nil then bga.name = Utils.getNoNil(object.bga.digestateSilo.loadingStation.stationName, "Unknown");end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module Bga configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					bga.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					bga.xmlName = "bgaXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if bga.name == "Unknown" and storeItem.name ~= nil then bga.name = storeItem.name;end;
					bga.storeData = storeItem;
				end;
			end;
			if bga.name == "Unknown" then bga.name = "BGA ".. tostring(#moModule.bgas);end;
			--print("objectName BgaPlaceable= ".. tostring(bga.name));			
		elseif class == "BuyingStationPlaceable" then		
			moModule.buyingStations[#moModule.buyingStations+1] = {};
			local buyingStation = moModule.buyingStations[#moModule.buyingStations];
			buyingStation.object = object;			
			buyingStation.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					buyingStation.mohDisplayName = displayName;
				end;
			end;
			if object.buyingStation ~= nil then buyingStation.name = Utils.getNoNil(object.buyingStation.stationName, "Unknown");end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module BuyingStation configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					buyingStation.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					buyingStation.xmlName = "buyingStationXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if buyingStation.name == "Unknown" and storeItem.name ~= nil then buyingStation.name = storeItem.name;end;
					buyingStation.storeData = storeItem;
				end;
			end;
			if buyingStation.name == "waterFillTrigger" then buyingStation.name = moLanguageXml:getTxt("buyingwater", nil, "Waterhole");end;
			if buyingStation.name == "Unknown" then buyingStation.name = "BuyingStation ".. tostring(#moModule.buyingStation);end;
			--print("objectName BuyingStation= ".. tostring(buyingStation.name));
		elseif class == "BeehivePlaceable" then
			moModule.beehivehouses[#moModule.beehivehouses+1] = {};
			local beehivehouse = moModule.beehivehouses[#moModule.beehivehouses];
			beehivehouse.object = object;			
			beehivehouse.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					beehivehouse.mohDisplayName = displayName;
				end;
			end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module BeehiveHouse configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					beehivehouse.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					beehivehouse.xmlName = "beehivehouseXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if beehivehouse.name == "Unknown" and storeItem.name ~= nil then beehivehouse.name = storeItem.name;end;
					beehivehouse.storeData = storeItem;
				end;
			end;
			if beehivehouse.name == "Unknown" then beehivehouse.name = "Beehivehouse ".. tostring(#moModule.beehivehouses);end;
			--print("objectName BeehiveHouse= ".. tostring(beehivehouse.name));			
		elseif class == "WindTurbinePlaceable" then
			moModule.windturbinen[#moModule.windturbinen+1] = {};
			local windturbine = moModule.windturbinen[#moModule.windturbinen];
			windturbine.object = object;			
			windturbine.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					windturbine.mohDisplayName = displayName;
				end;
			end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module WindTurbine configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					windturbine.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					windturbine.xmlName = "windturbineXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if windturbine.name == "Unknown" and storeItem.name ~= nil then windturbine.name = storeItem.name;end;
					windturbine.storeData = storeItem;
				end;
			end;
			if windturbine.name == "Unknown" then windturbine.name = "WindTurbine ".. tostring(#moModule.windturbinen);end;
			--print("objectName WindTurbine= ".. tostring(windturbine.name));
		elseif class == "SolarCollectorPlaceable" then
			moModule.solarcollectoren[#moModule.solarcollectoren+1] = {};
			local solarcollector = moModule.solarcollectoren[#moModule.solarcollectoren];
			solarcollector.object = object;			
			solarcollector.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					solarcollector.mohDisplayName = displayName;
				end;
			end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module SolarCollector configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					solarcollector.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					solarcollector.xmlName = "solarcollectorXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if solarcollector.name == "Unknown" and storeItem.name ~= nil then solarcollector.name = storeItem.name;end;
					solarcollector.storeData = storeItem;
				end;
			end;
			if solarcollector.name == "Unknown" then solarcollector.name = "SolarCollector ".. tostring(#moModule.solarcollectoren);end;
			--print("objectName SolarCollector= ".. tostring(solarcollector.name));
		elseif class == "HeatingPlantPlaceable" then
			moModule.heatingplants[#moModule.heatingplants+1] = {};
			local heatingplant = moModule.heatingplants[#moModule.heatingplants];
			heatingplant.object = object;			
			heatingplant.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					heatingplant.mohDisplayName = displayName;
				end;
			end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module HeatingPlant configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					heatingplant.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					heatingplant.xmlName = "heatingplantXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if heatingplant.name == "Unknown" and storeItem.name ~= nil then heatingplant.name = storeItem.name;end;
					heatingplant.storeData = storeItem;
				end;
			end;
			if heatingplant.name == "Unknown" then heatingplant.name = "HeatingPlant ".. tostring(#moModule.heatingplants);end;
			--print("objectName HeatingPlant= ".. tostring(heatingplant.name));			
		elseif class == "AnimalHusbandry" then
			moModule.animals[#moModule.animals+1] = {};
			local animal = moModule.animals[#moModule.animals];
			animal.object = object;			
			animal.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					animal.mohDisplayName = displayName;
				end;
			end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module Animal configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					animal.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					animal.xmlName = "animalXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if animal.name == "Unknown" and storeItem.name ~= nil then animal.name = storeItem.name;end;
					animal.storeData = storeItem;
				end;
			end;
			if animal.name == "Unknown" then
				local animalModule = object:getModuleByName("animals");
				if animalModule ~= nil then		
					animal.name = tostring(animalModule:getAnimalType());					
				end;
			end;			
			if animal.name == "Unknown" then animal.name = "Animal ".. tostring(#moModule.animals);end;
			--print("objectName AnimalHusbandry= ".. tostring(animal.name));			
		elseif class == "BunkerSiloPlaceable" then	
			moModule.bunkerSilos[#moModule.bunkerSilos+1] = {};
			local bunkerSilo = moModule.bunkerSilos[#moModule.bunkerSilos];
			bunkerSilo.object = object;			
			bunkerSilo.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					bunkerSilo.mohDisplayName = displayName;
				end;
			end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module BunkerSilo configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					bunkerSilo.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					bunkerSilo.xmlName = "bunkerSiloXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if bunkerSilo.name == "Unknown" and storeItem.name ~= nil then bunkerSilo.name = storeItem.name;end;
					bunkerSilo.storeData = storeItem;
				end;
			end;
			if bunkerSilo.name == "Unknown" then bunkerSilo.name = "Bunker Silo ".. tostring(#moModule.bunkerSilos);end;
			--print("objectName BunkerSiloPlaceable= ".. tostring(bunkerSilo.name));					
		elseif object.numInputs ~= nil and object.numOutputs ~= nil then
			moModule.feedMixers[#moModule.feedMixers+1] = {};
			local feedMixer = moModule.feedMixers[#moModule.feedMixers];
			feedMixer.object = object;			
			feedMixer.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					feedMixer.mohDisplayName = displayName;
				end;
			end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module FeedMixer configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					feedMixer.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					feedMixer.xmlName = "feedMixerXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if feedMixer.name == "Unknown" and storeItem.name ~= nil then feedMixer.name = storeItem.name;end;
					feedMixer.storeData = storeItem;
				end;
			end;
			if feedMixer.name == "Unknown" then feedMixer.name = "FeedMixer ".. tostring(#moModule.feedMixers);end;		
			--print("objectName FeedMixers= ".. tostring(feedMixer.name));		
		elseif string.find(class, "ObjectStorage") and object.storageAreas ~= nil then
			moModule.objectStorages[#moModule.objectStorages+1] = {};
			local objectStorages = moModule.objectStorages[#moModule.objectStorages];
			objectStorages.object = object;			
			objectStorages.name = "Unknown";
			if getUserAttribute ~= nil and object.nodeId ~= nil then 
				local displayName = getUserAttribute(object.nodeId, "mohDisplayName");
				if displayName ~= nil and displayName ~= false then
					objectStorages.mohDisplayName = displayName;
				end;
			end;
			local xmlObject = Utils.getNoNil(object.configFileName, nil);
			if xmlObject ~= nil then
				local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module ObjectStorages configFile XML/String Split");
				if isOkay then
					local xmlName = stringTable[#stringTable];
					objectStorages.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
				else
					objectStorages.xmlName = "objectStoragesXmlUnknown"; --needs for cmd
				end;
				local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
				if storeItem ~= nil then
					if objectStorages.name == "Unknown" and storeItem.name ~= nil then objectStorages.name = storeItem.name;end;
					objectStorages.storeData = storeItem;
				end;
			end;
			if objectStorages.name == "Unknown" then objectStorages.name = "ObjectStorages ".. tostring(#moModule.objectStorages);end;
			--print("objectName ObjectStorages= ".. tostring(objectStorages.name));			
		end;	
	end;		
	if MultiOverlayV4.otherMods.gc ~= nil then		
		if MultiOverlayV4.otherMods.gc["GlobalCompany"].loadedFactories ~= nil and #MultiOverlayV4.otherMods.gc["GlobalCompany"].loadedFactories > 0 then
			for _, object in pairs(MultiOverlayV4.otherMods.gc["GlobalCompany"].loadedFactories) do
				moModule.gc.factorys[#moModule.gc.factorys+1] = {};
				local gcFactory = moModule.gc.factorys[#moModule.gc.factorys];
				gcFactory.object = object;			
				gcFactory.name = Utils.getNoNil(object.indexName, "Unknown");
				if getUserAttribute ~= nil and object.rootNode ~= nil then 
					local displayName = getUserAttribute(object.rootNode, "mohDisplayName");
					if displayName ~= nil and displayName ~= false then
						gcFactory.mohDisplayName = displayName;
					end;
				end;
				local xmlObject = Utils.getNoNil(object.xmlFilename, nil);
				if xmlObject ~= nil then
					local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {xmlObject, "/"}, "Module GC Factory configFile XML/String Split");
					if isOkay then
						local xmlName = stringTable[#stringTable];
						gcFactory.xmlName = string.gsub(xmlName, ".xml", ""); --needs for cmd
					else
						gcFactory.xmlName = "gcFactoryXmlUnknown"; --needs for cmd
					end;
					local storeItem = g_storeManager:getItemByXMLFilename(xmlObject);
					if storeItem ~= nil then
						if gcFactory.name == "Unknown" and storeItem.name ~= nil then gcFactory.name = storeItem.name;end;
						gcFactory.storeData = storeItem;
					end;
				end;
				if gcFactory.name == "Unknown" then gcFactory.name = "GCFactory ".. tostring(#moModule.gc);end;		
				--print("objectName GCFactory= ".. tostring(gcFactory.name));					
			end;			
		end;
	end;
	function comp(w1,w2)			
		if w1.name < w2.name then
			return true;
		end;			
	end;	
	if #moModule.sellingStations > 1 then table.sort(moModule.sellingStations, comp);end;
	if #moModule.storages > 1 then table.sort(moModule.storages, comp);end;
	if #moModule.greenhouses > 1 then table.sort(moModule.greenhouses, comp);end;
	if #moModule.bgas > 1 then table.sort(moModule.bgas, comp);end;
	if #moModule.bunkerSilos > 1 then table.sort(moModule.bunkerSilos, comp);end;
	if #moModule.buyingStations > 1 then table.sort(moModule.buyingStations, comp);end;
	if #moModule.animals > 1 then table.sort(moModule.animals, comp);end;
	if #moModule.gc.factorys > 1 then table.sort(moModule.gc.factorys, comp);end;
	if #moModule.feedMixers > 1 then table.sort(moModule.feedMixers, comp);end;
	if #moModule.others > 1 then table.sort(moModule.others, comp);end;	
end;