moFillTypeAmountPriceOutput = {};
source(MultiOverlayV4.modDir.."scripte/module/onlyOutputs/moFillTypeAmountPriceConfig.lua");
moFillTypeAmountPriceOutput.isViewBestPrice = false; --for running modul sellingStations

--needs module,moFillTypes,moAmounts,moSellingStations
function moFillTypeAmountPriceOutput:load(cmdTable, slotTable)
	local foundViewBestPrice = false;
	local cmdRegName = cmdTable.regName;	
	local lineTable = {line={}};
	local txtBold = moFillTypeAmountPriceConfig.values.txtBold;
	if moFillTypes ~= nil and moFillTypes.values ~= nil and moFillTypes.values.fillTypes ~= nil then 
		for a=1, #moFillTypes.values.fillTypes do
			if moFillTypes.values.fillTypes[a] ~= nil and (moFillTypes.values.fillTypes[a].view or moFillTypeAmountPriceConfig.values.viewAllFillTypes) then				
				local fillType = moFillTypes.values.fillTypes[a].index;
				--local isItemBale = string.find(moFillTypes.values.fillTypes[fillType].regName:lower(), "bale");
				local width = {40,30,30};
				if (moFillTypeAmountPriceConfig.values.viewPrices and not moFillTypeAmountPriceConfig.values.viewAmounts) or (not moFillTypeAmountPriceConfig.values.viewPrices and moFillTypeAmountPriceConfig.values.viewAmounts) then
					width = {60,40};
				end;				
				local isAmount = moFillTypes.values.amount[fillType] ~= nil and moFillTypes.values.amount[fillType] > 0;
				local isBalesAmount = (moFillTypes.values.items.rBales[fillType] ~= nil and moFillTypes.values.items.rBales[fillType].amount > 0) or (moFillTypes.values.items.sBales[fillType] ~= nil and moFillTypes.values.items.sBales[fillType].amount > 0);
				local isPalAmount = moFillTypes.values.items.pal[fillType] ~= nil and moFillTypes.values.items.pal[fillType].amount > 0;
				local isPrice = moFillTypes.values.bestPrice[fillType] ~= nil and moFillTypes.values.bestPrice[fillType][1] ~= nil and moFillTypes.values.bestPrice[fillType][1][1] > 0;
				--new update 4.11--				
				function setViewIcon(isLineTable, buttonName, color, fillType)
					isLineTable.txt[1].icon = {before={},after={}};
					isLineTable.txt[1].icon.before[1] = {name=buttonName, color=color, settingButton=true, callback={[1]=moFillTypeAmountPriceOutput.clickViewAmountStorages}, ownTable={fillType}};	
				end;
				function hashTableKey(t)				
					for i,v in pairs(t) do if i ~= nil and v.fillLevel > 0 then return true;end;end;return false;
					--for i,v in pairs(t) do if i ~= nil and v.fillLevel ~= nil then return true;end;end;return false;
				end;				
				--new update 4.11--
				if isAmount or (not isAmount and moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount) then
					local nextTxt = 1;					
					lineTable.line[#lineTable.line+1] = {};
					local isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[nextTxt] = {};
					--new update 4.11--
					if moFillTypes.values.storages[fillType] == nil or not hashTableKey(moFillTypes.values.storages[fillType].storage) then
						setViewIcon(isLineTable, "buttonNoView", "gray");							
					else
						local color = "gray";
						if moFillTypes.values.fillTypes[fillType].viewAmountStorages then color = "green";end;
						setViewIcon(isLineTable, "buttonDown", color, fillType);
					end;
					--new update 4.11--					
					isLineTable.txt[nextTxt].fillType = fillType; --new update 4.11--
					isLineTable.txt[nextTxt].isAmount = isAmount; --new update 4.11--
					local name = "";
					if moFillTypes.values.name then name = moFillTypes.values.fillTypes[a].name;end;
					if moFillTypes.values.regName then
						if string.len(name) == 0 then name = moFillTypes.values.fillTypes[a].regName;else name = name.. " (".. moFillTypes.values.fillTypes[a].regName.. ")";end;
					end;
					if moFillTypes.values.index then
						if string.len(name) == 0 then name = moFillTypes.values.fillTypes[a].index;else name = name.. " *".. moFillTypes.values.fillTypes[a].index.. "*";end;
					end;
					isLineTable.txt[nextTxt].sortByName = tostring(name);
					isLineTable.txt[nextTxt].sortByAmount = 0;
					isLineTable.txt[nextTxt].sortByPrice = 0;
					isLineTable.txt[nextTxt].txt = tostring(name);
					isLineTable.txt[nextTxt].bold = txtBold;					
					if isBalesAmount or isPalAmount then
						isLineTable.txt[nextTxt].txt = isLineTable.txt[nextTxt].txt.. " *";							
					end;
					if isAmount then
						isLineTable.txt[nextTxt].outputColor = "txtFillTypesColor"; 
						isLineTable.txt[nextTxt].isAmount = true;
					else
						isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
						isLineTable.txt[nextTxt].isAmount = false;
					end;
					if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
					isLineTable.txt[nextTxt].width = width[1];				
					nextTxt = nextTxt+1;					
					if moFillTypeAmountPriceConfig.values.viewAmounts then						
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].width = width[nextTxt];						
						isLineTable.txt[nextTxt].bold = txtBold;
						if isAmount then
							isLineTable.txt[nextTxt].outputColor = "txtAmountColor"; 							
							isLineTable.txt[nextTxt].txt = tostring(g_i18n:formatVolume(math.max(moFillTypes.values.amount[fillType], 0))); --string.format("%1.0f", "".. tostring(moFillTypes.values.amount[fillType]));
							--if isItemBale then isLineTable.txt[nextTxt].txt = tostring(moFillTypes.values.amount[fillType]);end;
							isLineTable.txt[1].sortByAmount = moFillTypes.values.amount[fillType];
						else
							isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
							isLineTable.txt[nextTxt].txt = "-";
							isLineTable.txt[1].sortByAmount = 0;
						end;
						if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
						isLineTable.txt[nextTxt].width = width[nextTxt];						
						isLineTable.txt[nextTxt].alignment = 3;						
						nextTxt = nextTxt+1;
					end;					
					if moFillTypeAmountPriceConfig.values.viewPrices then						
						local priceTrend = "priceNormal";
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].width = width[nextTxt];						
						isLineTable.txt[nextTxt].bold = txtBold;
						if isPrice then							
							foundViewBestPrice = true;
							isLineTable.txt[nextTxt].outputColor = "txtPriceColor";							
							isLineTable.txt[nextTxt].txt = tostring(g_i18n:formatMoney(moFillTypes.values.bestPrice[fillType][1][1], 0, true, false));
							isLineTable.txt[1].sortByPrice = moFillTypes.values.bestPrice[fillType][1][1];
							if moFillTypes.values.bestPrice[fillType][1][3] == "up" then priceTrend = "priceUp";elseif moFillTypes.values.bestPrice[fillType][1][3] == "down" then priceTrend = "priceDown";end;
							isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickOutputPrice;
							isLineTable.txt[nextTxt].ownTable = {fillType, tostring(name)};
						else
							isLineTable.txt[nextTxt].outputColor = "txtNoPriceColor";
							isLineTable.txt[nextTxt].txt = "-";
							isLineTable.txt[1].sortByPrice = 0;
							priceTrend = nil;
						end;						
						if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
						isLineTable.txt[nextTxt].width = width[nextTxt];						
						isLineTable.txt[nextTxt].alignment = 3;						
						if moFillTypeAmountPriceConfig.values.viewPriceTrend and priceTrend ~= nil then
							isLineTable.txt[nextTxt].icon = {before={},after={}};
							isLineTable.txt[nextTxt].icon.after[1] = {name=priceTrend, modName="MultiOverlayV4", groupName="intern" };
						end;
					end;					
				end;
			end;
		end;
		
		if moFillTypeAmountPriceConfig.values.sortBy ~= 4 then --4 no sort
			function sortByName(w1,w2)		
				if w1.txt[1].sortByName < w2.txt[1].sortByName then
					return true;
				end;				
			end;
			function sortByAmount(w1,w2)		
				if w1.txt[1].sortByAmount > w2.txt[1].sortByAmount then
					return true;
				end;				
			end;
			function sortByPrice(w1,w2)		
				if w1.txt[1].sortByPrice > w2.txt[1].sortByPrice then
					return true;
				end;				
			end;
			if moFillTypeAmountPriceConfig.values.sortBy == 1 then 
				table.sort(lineTable.line, sortByName);
			elseif moFillTypeAmountPriceConfig.values.sortBy == 2 then
				table.sort(lineTable.line, sortByPrice);
			elseif moFillTypeAmountPriceConfig.values.sortBy == 3 then
				table.sort(lineTable.line, sortByAmount);
			end;
		end;		
		
		--new update 4.11--
		if #lineTable.line > 0 then			
			for a=1, #lineTable.line do				
				if lineTable.line[a].txt[1].isAmount ~= nil and lineTable.line[a].txt[1].isAmount then
					local fillType = lineTable.line[a].txt[1].fillType;
					if moFillTypes.values.storages[fillType] ~= nil then						
						local isLineTable = lineTable.line[a];												
						if moFillTypes.values.fillTypes[fillType].viewAmountStorages then
							nextTxt = 1;
							local line = a+1;
							for k, v in pairs (moFillTypes.values.storages[fillType].storage) do
								if v.fillLevel > 0 then									
									table.insert(lineTable.line, line, {});									
									isLineTable = lineTable.line[line];
									isLineTable.txt = {};
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].bold = false;
									isLineTable.txt[nextTxt].slotColor = "txt";
									isLineTable.txt[nextTxt].txt = "*".. tostring(v.storageName);
									if v.objectId ~= nil then
										isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickStorageName;
										isLineTable.txt[nextTxt].ownTable = {v.objectId, v.mapHotspot};
									end;									
									isLineTable.txt[nextTxt].width = 70;
									nextTxt = nextTxt+1;
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].bold = false;
									isLineTable.txt[nextTxt].slotColor = "txt";
									isLineTable.txt[nextTxt].txt = tostring(g_i18n:formatVolume(math.max(v.fillLevel, 0)));
									isLineTable.txt[nextTxt].width = 30;
									isLineTable.txt[nextTxt].alignment = 3;	
									nextTxt = 1;
									line = line+1;
								end;
							end;						
						end;
					end;										
				end;
			end;
		end;
		--new update 4.11--
		
		
		--new update 4.11--
		local isSeparator = false;
		if moFillTypeAmountPriceConfig.values.viewPal then
			if moFillTypes.values.items.palTotal > 0 or (not moFillTypes.values.items.palTotal == 0 and moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount) then
				local width = {40,30,30};
				if (moFillTypeAmountPriceConfig.values.viewPrices and not moFillTypeAmountPriceConfig.values.viewAmounts) or (not moFillTypeAmountPriceConfig.values.viewPrices and moFillTypeAmountPriceConfig.values.viewAmounts) then
					width = {60,40};
				end;
				local nextTxt = 1;			
				if not isSeparator then
					---seperator---
					isSeparator = true;
					lineTable.line[#lineTable.line+1] = {};
					local isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
					isLineTable.txt[nextTxt].bold = true;
					isLineTable.txt[nextTxt].txt = "--";
					nextTxt = nextTxt+1;
					if #width == 2 then
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = true;
						isLineTable.txt[nextTxt].txt = "--";
						isLineTable.txt[nextTxt].alignment = 3;
					else
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = false;
						isLineTable.txt[nextTxt].txt = "";				
						nextTxt = nextTxt+1;
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = true;
						isLineTable.txt[nextTxt].txt = "--";
						isLineTable.txt[nextTxt].alignment = 3;
					end;					
					---seperator---	
				end;
				nextTxt = 1;
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[nextTxt] = {};			
				isLineTable.txt[nextTxt].txt = tostring(g_i18n:getText("category_pallets")); 
				if moFillTypes.values.items.palTotal > 0 then
					isLineTable.txt[nextTxt].outputColor = "txtFillTypesColor";
				else
					isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
				end;
				isLineTable.txt[nextTxt].bold = txtBold;
				isLineTable.txt[nextTxt].width = width[nextTxt];
				nextTxt = nextTxt+1;
				if moFillTypeAmountPriceConfig.values.viewAmounts then
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].txt = tostring(moFillTypes.values.items.palTotal);
					if moFillTypes.values.items.palTotal > 0 then
						isLineTable.txt[nextTxt].outputColor = "txtAmountColor"; 
					else
						isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
					end;
					isLineTable.txt[nextTxt].bold = txtBold;
					isLineTable.txt[nextTxt].width = width[nextTxt];
					isLineTable.txt[nextTxt].alignment = 3;						
					nextTxt = nextTxt+1;
				end;
				if moFillTypeAmountPriceConfig.values.viewPrices then
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].width = width[nextTxt];						
					isLineTable.txt[nextTxt].bold = txtBold;
					isLineTable.txt[nextTxt].outputColor = "txtNoPriceColor";
					isLineTable.txt[nextTxt].txt = "-";	
					isLineTable.txt[nextTxt].alignment = 3;
				end;
				if moFillTypes.values.items.palTotal > 0 then
					local color = "gray";
					if moFillTypeAmountPriceConfig.values.viewDetailsPal then color = "green";end;
					isLineTable.txt[1].icon = {before={},after={}};
					isLineTable.txt[1].icon.before[1] = {name="buttonDown", color=color, settingButton=true, callback={[1]=moFillTypeAmountPriceOutput.clickViewDetailsPalBales}, ownTable={"viewDetailsPal"}, infoTxt="View Pallets List"};	
					nextTxt = 1;
					if moFillTypeAmountPriceConfig.values.viewDetailsPal then
						for fillType, values in pairs (moFillTypes.values.items.pal) do
							if moFillTypes.values.fillTypes[fillType] ~= nil then
								local isPrice = moFillTypes.values.bestPrice[fillType] ~= nil and moFillTypes.values.bestPrice[fillType][1] ~= nil and moFillTypes.values.bestPrice[fillType][1][1] > 0;
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];
								isLineTable.txt = {};
								isLineTable.txt[nextTxt] = {};
								isLineTable.txt[nextTxt].txt = "*".. tostring(moFillTypes.values.fillTypes[fillType].name);
								isLineTable.txt[nextTxt].bold = txtBold;
								isLineTable.txt[nextTxt].outputColor = "txtPriceColor";
								if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
								isLineTable.txt[nextTxt].width = width[nextTxt];
								nextTxt = nextTxt+1;
								if moFillTypeAmountPriceConfig.values.viewAmounts then
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].txt = tostring(values.amount);									
									isLineTable.txt[nextTxt].outputColor = "txtPriceColor";						
									if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
									isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickViewPalBalesCapacity;
									isLineTable.txt[nextTxt].ownTable = {"capacityPal",fillType};
																		
									isLineTable.txt[nextTxt-1].callback = moFillTypeAmountPriceOutput.clickViewPalBalesMapHotSpot;
									isLineTable.txt[nextTxt-1].ownTable = {values.objects};
									
									isLineTable.txt[nextTxt].bold = txtBold;
									isLineTable.txt[nextTxt].width = width[nextTxt];
									isLineTable.txt[nextTxt].alignment = 3;						
									nextTxt = nextTxt+1;
								end;
								if moFillTypeAmountPriceConfig.values.viewPrices then
									local priceTrend = "priceNormal";
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].width = width[nextTxt];						
									isLineTable.txt[nextTxt].bold = txtBold;
									if isPrice then
										foundViewBestPrice = true;
										isLineTable.txt[nextTxt].outputColor = "txtPriceColor";							
										isLineTable.txt[nextTxt].txt = tostring(g_i18n:formatMoney(moFillTypes.values.bestPrice[fillType][1][1], 0, true, false));
										if moFillTypes.values.bestPrice[fillType][1][3] == "up" then priceTrend = "priceUp";elseif moFillTypes.values.bestPrice[fillType][1][3] == "down" then priceTrend = "priceDown";end;
										isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickOutputPrice;
										isLineTable.txt[nextTxt].ownTable = {fillType, tostring(moFillTypes.values.fillTypes[fillType].name)};
									else
										isLineTable.txt[nextTxt].outputColor = "txtNoPriceColor";
										isLineTable.txt[nextTxt].txt = "-";
										priceTrend = nil;
									end;
									if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
									isLineTable.txt[nextTxt].width = width[nextTxt];						
									isLineTable.txt[nextTxt].alignment = 3;						
									if moFillTypeAmountPriceConfig.values.viewPriceTrend and priceTrend ~= nil then
										isLineTable.txt[nextTxt].icon = {before={},after={}};
										isLineTable.txt[nextTxt].icon.after[1] = {name=priceTrend, modName="MultiOverlayV4", groupName="intern" };
									end;							
								end;
								nextTxt = 1;
							end;
						end;
					end;
				end;
			end;
		end;
		
		if moFillTypeAmountPriceConfig.values.viewBales then
			if moFillTypes.values.items.rBalesTotal > 0 or (not moFillTypes.values.items.rBalesTotal == 0 and moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount) then
				local width = {40,30,30};
				if (moFillTypeAmountPriceConfig.values.viewPrices and not moFillTypeAmountPriceConfig.values.viewAmounts) or (not moFillTypeAmountPriceConfig.values.viewPrices and moFillTypeAmountPriceConfig.values.viewAmounts) then
					width = {60,40};
				end;
				local nextTxt = 1;			
				if not isSeparator then
					---seperator---
					isSeparator = true;
					lineTable.line[#lineTable.line+1] = {};
					local isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
					isLineTable.txt[nextTxt].bold = true;
					isLineTable.txt[nextTxt].txt = "--";
					nextTxt = nextTxt+1;
					if #width == 2 then
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = true;
						isLineTable.txt[nextTxt].txt = "--";
						isLineTable.txt[nextTxt].alignment = 3;
					else
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = false;
						isLineTable.txt[nextTxt].txt = "";				
						nextTxt = nextTxt+1;
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = true;
						isLineTable.txt[nextTxt].txt = "--";
						isLineTable.txt[nextTxt].alignment = 3;
					end;			
					---seperator---	
				end;
				nextTxt = 1;
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[nextTxt] = {};			
				isLineTable.txt[nextTxt].txt = tostring(g_i18n:getText("fillType_roundBale")); 
				if moFillTypes.values.items.rBalesTotal > 0 then
					isLineTable.txt[nextTxt].outputColor = "txtFillTypesColor";
				else
					isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
				end;
				isLineTable.txt[nextTxt].bold = txtBold;
				isLineTable.txt[nextTxt].width = width[nextTxt];
				nextTxt = nextTxt+1;
				if moFillTypeAmountPriceConfig.values.viewAmounts then
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].txt = tostring(moFillTypes.values.items.rBalesTotal);
					if moFillTypes.values.items.rBalesTotal > 0 then
						isLineTable.txt[nextTxt].outputColor = "txtAmountColor"; 
					else
						isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
					end;
					isLineTable.txt[nextTxt].bold = txtBold;
					isLineTable.txt[nextTxt].width = width[nextTxt];
					isLineTable.txt[nextTxt].alignment = 3;						
					nextTxt = nextTxt+1;
				end;
				if moFillTypeAmountPriceConfig.values.viewPrices then
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].width = width[nextTxt];						
					isLineTable.txt[nextTxt].bold = txtBold;
					isLineTable.txt[nextTxt].outputColor = "txtNoPriceColor";
					isLineTable.txt[nextTxt].txt = "-";	
					isLineTable.txt[nextTxt].alignment = 3;
				end;
				if moFillTypes.values.items.rBalesTotal > 0 then
					local color = "gray";
					if moFillTypeAmountPriceConfig.values.viewDetailsBalesR then color = "green";end;
					isLineTable.txt[1].icon = {before={},after={}};
					isLineTable.txt[1].icon.before[1] = {name="buttonDown", color=color, settingButton=true, callback={[1]=moFillTypeAmountPriceOutput.clickViewDetailsPalBales}, ownTable={"viewDetailsBalesR"}, infoTxt="View Bales List"};	
					nextTxt = 1;
					if moFillTypeAmountPriceConfig.values.viewDetailsBalesR then
						for fillType, values in pairs (moFillTypes.values.items.rBales) do
							if moFillTypes.values.fillTypes[fillType] ~= nil then
								local isPrice = moFillTypes.values.bestPrice[fillType] ~= nil and moFillTypes.values.bestPrice[fillType][1] ~= nil and moFillTypes.values.bestPrice[fillType][1][1] > 0;
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];
								isLineTable.txt = {};
								isLineTable.txt[nextTxt] = {};
								isLineTable.txt[nextTxt].txt = "*".. tostring(moFillTypes.values.fillTypes[fillType].name);
								isLineTable.txt[nextTxt].bold = txtBold;
								isLineTable.txt[nextTxt].outputColor = "txtPriceColor";
								if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
								isLineTable.txt[nextTxt].width = width[nextTxt];
								nextTxt = nextTxt+1;
								if moFillTypeAmountPriceConfig.values.viewAmounts then
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].txt = tostring(values.amount);
									isLineTable.txt[nextTxt].outputColor = "txtPriceColor";						
									if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
									isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickViewPalBalesCapacity;
									isLineTable.txt[nextTxt].ownTable = {"capacityBalesR",fillType};
									
									isLineTable.txt[nextTxt-1].callback = moFillTypeAmountPriceOutput.clickViewPalBalesMapHotSpot;
									isLineTable.txt[nextTxt-1].ownTable = {values.objects};
									
									isLineTable.txt[nextTxt].bold = txtBold;
									isLineTable.txt[nextTxt].width = width[nextTxt];
									isLineTable.txt[nextTxt].alignment = 3;						
									nextTxt = nextTxt+1;
								end;
								if moFillTypeAmountPriceConfig.values.viewPrices then
									local priceTrend = "priceNormal";
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].width = width[nextTxt];						
									isLineTable.txt[nextTxt].bold = txtBold;
									if isPrice then
										foundViewBestPrice = true;
										isLineTable.txt[nextTxt].outputColor = "txtPriceColor";							
										isLineTable.txt[nextTxt].txt = tostring(g_i18n:formatMoney(moFillTypes.values.bestPrice[fillType][1][1], 0, true, false));
										if moFillTypes.values.bestPrice[fillType][1][3] == "up" then priceTrend = "priceUp";elseif moFillTypes.values.bestPrice[fillType][1][3] == "down" then priceTrend = "priceDown";end;
										isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickOutputPrice;
										isLineTable.txt[nextTxt].ownTable = {fillType, tostring(moFillTypes.values.fillTypes[fillType].name)};
									else
										isLineTable.txt[nextTxt].outputColor = "txtNoPriceColor";
										isLineTable.txt[nextTxt].txt = "-";
										priceTrend = nil;
									end;
									if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
									isLineTable.txt[nextTxt].width = width[nextTxt];						
									isLineTable.txt[nextTxt].alignment = 3;						
									if moFillTypeAmountPriceConfig.values.viewPriceTrend and priceTrend ~= nil then
										isLineTable.txt[nextTxt].icon = {before={},after={}};
										isLineTable.txt[nextTxt].icon.after[1] = {name=priceTrend, modName="MultiOverlayV4", groupName="intern" };
									end;									
								end;
								nextTxt = 1;
								if values.amountF ~= nil and values.amountF > 0 then
									local percentTxt = string.format("%d%%", math.ceil(values.percentF/values.amountF * 100))
									lineTable.line[#lineTable.line+1] = {};
									isLineTable = lineTable.line[#lineTable.line];
									isLineTable.txt = {};
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].txt = " -".. tostring(g_i18n:getText("info_fermenting")).. ": ".. tostring(values.amountF).. "x"; -- / ".. tostring(percentTxt); 
									isLineTable.txt[nextTxt].bold = txtBold;
									isLineTable.txt[nextTxt].outputColor = "txtPriceColor";
								end;
								nextTxt = 1;
							end;
						end;
					end;
				end;
			end;
			if moFillTypes.values.items.sBalesTotal > 0 or (not moFillTypes.values.items.sBalesTotal == 0 and moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount) then
				local width = {40,30,30};
				if (moFillTypeAmountPriceConfig.values.viewPrices and not moFillTypeAmountPriceConfig.values.viewAmounts) or (not moFillTypeAmountPriceConfig.values.viewPrices and moFillTypeAmountPriceConfig.values.viewAmounts) then
					width = {60,40};
				end;
				local nextTxt = 1;			
				if not isSeparator then
					---seperator---
					isSeparator = true;
					lineTable.line[#lineTable.line+1] = {};
					local isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
					isLineTable.txt[nextTxt].bold = true;
					isLineTable.txt[nextTxt].txt = "--";
					nextTxt = nextTxt+1;
					if #width == 2 then
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = true;
						isLineTable.txt[nextTxt].txt = "--";
						isLineTable.txt[nextTxt].alignment = 3;
					else
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = false;
						isLineTable.txt[nextTxt].txt = "";				
						nextTxt = nextTxt+1;
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = true;
						isLineTable.txt[nextTxt].txt = "--";
						isLineTable.txt[nextTxt].alignment = 3;
					end;			
					---seperator---	
				end;
				nextTxt = 1;
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[nextTxt] = {};			
				isLineTable.txt[nextTxt].txt = tostring(g_i18n:getText("fillType_squareBale")); 
				if moFillTypes.values.items.sBalesTotal > 0 then
					isLineTable.txt[nextTxt].outputColor = "txtFillTypesColor";
				else
					isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
				end;
				isLineTable.txt[nextTxt].bold = txtBold;
				isLineTable.txt[nextTxt].width = width[nextTxt];
				nextTxt = nextTxt+1;
				if moFillTypeAmountPriceConfig.values.viewAmounts then
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].txt = tostring(moFillTypes.values.items.sBalesTotal);
					if moFillTypes.values.items.sBalesTotal > 0 then
						isLineTable.txt[nextTxt].outputColor = "txtAmountColor"; 
					else
						isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
					end;
					isLineTable.txt[nextTxt].bold = txtBold;
					isLineTable.txt[nextTxt].width = width[nextTxt];
					isLineTable.txt[nextTxt].alignment = 3;						
					nextTxt = nextTxt+1;
				end;
				if moFillTypeAmountPriceConfig.values.viewPrices then
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].width = width[nextTxt];						
					isLineTable.txt[nextTxt].bold = txtBold;
					isLineTable.txt[nextTxt].outputColor = "txtNoPriceColor";
					isLineTable.txt[nextTxt].txt = "-";	
					isLineTable.txt[nextTxt].alignment = 3;
				end;
				if moFillTypes.values.items.sBalesTotal > 0 then
					local color = "gray";
					if moFillTypeAmountPriceConfig.values.viewDetailsBalesS then color = "green";end;
					isLineTable.txt[1].icon = {before={},after={}};
					isLineTable.txt[1].icon.before[1] = {name="buttonDown", color=color, settingButton=true, callback={[1]=moFillTypeAmountPriceOutput.clickViewDetailsPalBales}, ownTable={"viewDetailsBalesS"}, infoTxt="View Bales List"};	
					nextTxt = 1;
					if moFillTypeAmountPriceConfig.values.viewDetailsBalesS then
						for fillType, values in pairs (moFillTypes.values.items.sBales) do
							if moFillTypes.values.fillTypes[fillType] ~= nil then
								local isPrice = moFillTypes.values.bestPrice[fillType] ~= nil and moFillTypes.values.bestPrice[fillType][1] ~= nil and moFillTypes.values.bestPrice[fillType][1][1] > 0;
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];
								isLineTable.txt = {};
								isLineTable.txt[nextTxt] = {};
								isLineTable.txt[nextTxt].txt = "*".. tostring(moFillTypes.values.fillTypes[fillType].name);
								isLineTable.txt[nextTxt].bold = txtBold;
								isLineTable.txt[nextTxt].outputColor = "txtPriceColor";
								if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
								isLineTable.txt[nextTxt].width = width[nextTxt];
								nextTxt = nextTxt+1;
								if moFillTypeAmountPriceConfig.values.viewAmounts then
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].txt = tostring(values.amount);
									isLineTable.txt[nextTxt].outputColor = "txtPriceColor";						
									if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
									isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickViewPalBalesCapacity;
									isLineTable.txt[nextTxt].ownTable = {"capacityBalesS",fillType};
									
									isLineTable.txt[nextTxt-1].callback = moFillTypeAmountPriceOutput.clickViewPalBalesMapHotSpot;
									isLineTable.txt[nextTxt-1].ownTable = {values.objects};
									
									isLineTable.txt[nextTxt].bold = txtBold;
									isLineTable.txt[nextTxt].width = width[nextTxt];
									isLineTable.txt[nextTxt].alignment = 3;						
									nextTxt = nextTxt+1;
								end;
								if moFillTypeAmountPriceConfig.values.viewPrices then
									local priceTrend = "priceNormal";
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].width = width[nextTxt];						
									isLineTable.txt[nextTxt].bold = txtBold;
									if isPrice then
										foundViewBestPrice = true;
										isLineTable.txt[nextTxt].outputColor = "txtPriceColor";							
										isLineTable.txt[nextTxt].txt = tostring(g_i18n:formatMoney(moFillTypes.values.bestPrice[fillType][1][1], 0, true, false));
										if moFillTypes.values.bestPrice[fillType][1][3] == "up" then priceTrend = "priceUp";elseif moFillTypes.values.bestPrice[fillType][1][3] == "down" then priceTrend = "priceDown";end;
										isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickOutputPrice;
										isLineTable.txt[nextTxt].ownTable = {fillType, tostring(moFillTypes.values.fillTypes[fillType].name)};
									else
										isLineTable.txt[nextTxt].outputColor = "txtNoPriceColor";
										isLineTable.txt[nextTxt].txt = "-";
										priceTrend = nil;
									end;
									if isPrice and moFillTypes.values.bestPrice[fillType][1][3] == "greatDemand" then isLineTable.txt[nextTxt].outputColor = "txtGreatDemandColor";end;
									isLineTable.txt[nextTxt].width = width[nextTxt];						
									isLineTable.txt[nextTxt].alignment = 3;						
									if moFillTypeAmountPriceConfig.values.viewPriceTrend and priceTrend ~= nil then
										isLineTable.txt[nextTxt].icon = {before={},after={}};
										isLineTable.txt[nextTxt].icon.after[1] = {name=priceTrend, modName="MultiOverlayV4", groupName="intern" };
									end;							
								end;
								nextTxt = 1;
								if values.amountF ~= nil and values.amountF > 0 then
									local percentTxt = string.format("%d%%", math.ceil(values.percentF/values.amountF * 100))
									lineTable.line[#lineTable.line+1] = {};
									isLineTable = lineTable.line[#lineTable.line];
									isLineTable.txt = {};
									isLineTable.txt[nextTxt] = {};
									isLineTable.txt[nextTxt].txt = " -".. tostring(g_i18n:getText("info_fermenting")).. ": ".. tostring(values.amountF).. "x"; -- / ".. tostring(percentTxt); 
									isLineTable.txt[nextTxt].bold = txtBold;
									isLineTable.txt[nextTxt].outputColor = "txtPriceColor";
								end;
								nextTxt = 1;
							end;
						end;
					end;
				end;
			end;
		end;
		
		if moFillTypeAmountPriceConfig.values.viewAnimals then
			if moFillTypes.values.animals ~= nil then 
				local width = {40,30,30};
				if (moFillTypeAmountPriceConfig.values.viewPrices and not moFillTypeAmountPriceConfig.values.viewAmounts) or (not moFillTypeAmountPriceConfig.values.viewPrices and moFillTypeAmountPriceConfig.values.viewAmounts) then
					width = {60,40};
				end;
				local nextTxt = 1;
				if not isSeparator then
					---seperator---
					isSeparator = true;
					lineTable.line[#lineTable.line+1] = {};
					local isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
					isLineTable.txt[nextTxt].bold = true;
					isLineTable.txt[nextTxt].txt = "--";
					nextTxt = nextTxt+1;
					if (moFillTypeAmountPriceConfig.values.viewAmounts and not moFillTypeAmountPriceConfig.values.viewPrices) or (not moFillTypeAmountPriceConfig.values.viewAmounts and moFillTypeAmountPriceConfig.values.viewPrices) then
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = true;
						isLineTable.txt[nextTxt].txt = "--";
						isLineTable.txt[nextTxt].alignment = 3;
					else
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = false;
						isLineTable.txt[nextTxt].txt = "";				
						nextTxt = nextTxt+1;
						isLineTable.txt[nextTxt] = {};
						isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
						isLineTable.txt[nextTxt].bold = true;
						isLineTable.txt[nextTxt].txt = "--";
						isLineTable.txt[nextTxt].alignment = 3;
					end;			
					---seperator---	
				end;					
				nextTxt = 1;
				for animal, value in pairs (moFillTypes.values.animals) do
					local animalName = g_i18n:getText("ui_statisticView_".. animal:lower());
					if string.find(animalName, "Missing") then animalName = animal:upper();end;
					local isAmount = value.amount > 0;
					if isAmount or (not isAmount and moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount) then
						lineTable.line[#lineTable.line+1] = {};
						local isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[nextTxt] = {};
						
						isLineTable.txt[nextTxt].icon = {before={},after={}};
						isLineTable.txt[nextTxt].icon.before[1] = {name="buttonNoView", color="gray", settingButton=true, callback={[1]=moFillTypeAmountPriceOutput.clickViewAmountStorages}};	
												
						isLineTable.txt[nextTxt].sortByName = tostring(animalName);
						isLineTable.txt[nextTxt].sortByPrice = 0;
						isLineTable.txt[nextTxt].sortByAmount = value.amount;
						isLineTable.txt[nextTxt].txt = tostring(animalName);
						isLineTable.txt[nextTxt].callback = moFillTypeAmountPriceOutput.clickAnimalName;
						if isAmount then
							isLineTable.txt[nextTxt].outputColor = "txtFillTypesColor";
						else
							isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
						end;
						isLineTable.txt[nextTxt].bold = txtBold;
						isLineTable.txt[nextTxt].width = width[nextTxt];
						nextTxt = nextTxt+1;
						if moFillTypeAmountPriceConfig.values.viewAmounts then
							isLineTable.txt[nextTxt] = {};
							isLineTable.txt[nextTxt].txt = tostring(value.amount);
							if isAmount then
								isLineTable.txt[nextTxt].outputColor = "txtAmountColor";
							else
								isLineTable.txt[nextTxt].outputColor = "txtNoAmountColor";
							end;
							isLineTable.txt[nextTxt].bold = txtBold;
							isLineTable.txt[nextTxt].width = width[nextTxt];
							isLineTable.txt[nextTxt].alignment = 3;						
							nextTxt = nextTxt+1;
						end;
						if moFillTypeAmountPriceConfig.values.viewPrices then
							isLineTable.txt[nextTxt] = {};
							isLineTable.txt[nextTxt].width = width[nextTxt];						
							isLineTable.txt[nextTxt].bold = txtBold;
							isLineTable.txt[nextTxt].outputColor = "txtNoPriceColor";
							isLineTable.txt[nextTxt].txt = "-";	
							isLineTable.txt[nextTxt].alignment = 3;
						end;
						nextTxt = 1;
					end;
				end;
			end;
		end;
		--new update 4.11--		
	end;
	table.insert(lineTable.line, 1, {});
	isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = "FillType/Amount/Price";	
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moFillTypeAmountPriceOutput.clickTitleHelpTxt}};
	end;
	if g_currentMission.hl.isMouseCursor then
		local color = "gray"
		if moFillTypeAmountPriceConfig.values.viewSettingLines then color = "green";end;
		if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
		isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="outputSetting", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewSettingLines}, infoTxt="Settings"};
	end;
	--setting lines---
	if moFillTypeAmountPriceConfig.values.viewSettingLines then
		local moreTxt = "Name";
		if moFillTypeAmountPriceConfig.values.sortBy == 2 then moreTxt = "Price";elseif moFillTypeAmountPriceConfig.values.sortBy == 3 then moreTxt = "Amount";elseif moFillTypeAmountPriceConfig.values.sortBy == 4 then moreTxt = "NoSort";end;
		table.insert(lineTable.line, 2, {});
		isLineTable = lineTable.line[2];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].callback = moFillTypeAmountPriceOutput.clickButtonSortBy;
		isLineTable.txt[1].bold = true;		
		isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *".. moreTxt.. "*";
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonFlip", color="green", modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickButtonSortBy}};
		
		table.insert(lineTable.line, 3, {});
		isLineTable = lineTable.line[3];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};		
		local color = "green"
		if not moFillTypeAmountPriceConfig.values.viewPrices then color="gray";end;
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="pricesOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewPrices"}, infoTxt="View Prices List"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewPriceTrend then color="gray";end;
		isLineTable.txt[1].icon.before[2] = {name="priceTrendOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewPriceTrend"}, infoTxt="View PriceTrend"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewAmounts then color="gray";end;
		isLineTable.txt[1].icon.before[3] = {name="amountsOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewAmounts"}, infoTxt="View Amounts List"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount then color="gray";end;
		isLineTable.txt[1].icon.before[4] = {name="fillTypeNoAmountOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewFillTypeNoAmount"}, infoTxt="View No Amount FillTypes"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewAllFillTypes then color="gray";end;
		isLineTable.txt[1].icon.before[5] = {name="viewAllFillTypesOnOff", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewAllFillTypes"}, infoTxt="Ignore View On/Off FillTypes"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewAnimals then color="gray";end;
		isLineTable.txt[1].icon.before[6] = {name="viewAnimals", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewAnimals"}, infoTxt="View Animals Amounts"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewPal then color="gray";end;
		isLineTable.txt[1].icon.before[7] = {name="viewPal", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewPal"}, infoTxt="View Pallets Amounts"};
		color = "green";
		if not moFillTypeAmountPriceConfig.values.viewBales then color="gray";end;
		isLineTable.txt[1].icon.before[8] = {name="viewBales", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypeAmountPriceOutput.clickViewOnOff},ownTable={"viewBales"}, infoTxt="View Bales Amount"};
		---seperator---
		table.insert(lineTable.line, 4, {});
		isLineTable = lineTable.line[4];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "--";
		isLineTable.txt[2] = {};
		isLineTable.txt[2].slotColor = "txtOutputTitle";
		isLineTable.txt[2].bold = true;
		isLineTable.txt[2].txt = "--";
		isLineTable.txt[2].alignment = 3;
		---seperator---	
	end;
	--setting lines---
	---objectLineDistance---
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};		
	isLineTable.txt[1].txt = " ";
	---objectLineDistance---
	if foundViewBestPrice then moFillTypeAmountPriceOutput.isViewBestPrice = true;else moFillTypeAmountPriceOutput.isViewBestPrice = false;end; --for running modul bestPrices
	moFillTypeAmountPriceOutput[cmdRegName] = {output=lineTable};
end;

function moFillTypeAmountPriceOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="amounts" } );	
	if moFillTypeAmountPriceOutput.isViewBestPrice then moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="bestPrices" } );end;	--new
	moFillTypeAmountPriceOutput:load(args.cmdTable, args.slotTable);	
	return moFillTypeAmountPriceOutput[args.cmdTable.regName].output;
end;

function moFillTypeAmountPriceOutput.clickTitleHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "FillType/Amount/Price Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Setting Icon/FillType Name/Amount/Price for more Info or ...";
	end;
end;

function moFillTypeAmountPriceOutput.clickViewSettingLines(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moFillTypeAmountPriceConfig.values.viewSettingLines = not moFillTypeAmountPriceConfig.values.viewSettingLines;
	end;
end;

function moFillTypeAmountPriceOutput.clickButtonSortBy(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if moFillTypeAmountPriceConfig.values.sortBy+1 > moFillTypeAmountPriceConfig.values.maxSortBy then moFillTypeAmountPriceConfig.values.sortBy = 1;else moFillTypeAmountPriceConfig.values.sortBy = moFillTypeAmountPriceConfig.values.sortBy+1;end;		
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then
		if moFillTypeAmountPriceConfig.values.sortBy-1 < 1 then moFillTypeAmountPriceConfig.values.sortBy = moFillTypeAmountPriceConfig.values.maxSortBy;else moFillTypeAmountPriceConfig.values.sortBy = moFillTypeAmountPriceConfig.values.sortBy-1;end;
	end;
end;

function moFillTypeAmountPriceOutput.clickViewAmountStorages(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and moFillTypes.values.fillTypes[args.ownTable[1]] ~= nil then
			moFillTypes.values.fillTypes[args.ownTable[1]].viewAmountStorages = not moFillTypes.values.fillTypes[args.ownTable[1]].viewAmountStorages;
		end;
	end;
end;

function moFillTypeAmountPriceOutput.clickAnimalName(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if g_currentMission.inGameMenu.pageAnimals == nil then return;end;
		MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moAnimalsOutput.clickNumAnimals title"); --force mouseOff
		moModule:showInGameMenuFrame("pageAnimals", 0, true, false, 1);			
	end;
end;

function moFillTypeAmountPriceOutput.clickStorageName(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local x, _, z = getWorldTranslation(args.ownTable[1]);						
			if x ~= nil and x ~= 0 then					
				moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[2] ~= nil and g_currentMission.controlledVehicle == nil then			
			local hotspot = args.ownTable[2].mapHotspots[1];
			if hotspot ~= nil and hotspot.teleportWorldX ~= nil and hotspot.teleportWorldY ~= nil and hotspot.teleportWorldZ ~= nil then
				g_currentMission.player:moveToAbsolute(hotspot.teleportWorldX, hotspot.teleportWorldY, hotspot.teleportWorldZ, false, false);
				MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moFillTypeAmountPriceOutput.clickStorageName"); --force mouseOff
			end;			
		end;	
	end;
end;

function moFillTypeAmountPriceOutput.clickViewDetailsPalBales(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] == "viewDetailsBalesS" then
			moFillTypeAmountPriceConfig.values.viewDetailsBalesS = not moFillTypeAmountPriceConfig.values.viewDetailsBalesS;
		elseif args.ownTable[1] == "viewDetailsBalesR" then
			moFillTypeAmountPriceConfig.values.viewDetailsBalesR = not moFillTypeAmountPriceConfig.values.viewDetailsBalesR;
		elseif args.ownTable[1] == "viewDetailsPal" then
			moFillTypeAmountPriceConfig.values.viewDetailsPal = not moFillTypeAmountPriceConfig.values.viewDetailsPal;		
		end;
	end;
end;

function moFillTypeAmountPriceOutput.clickViewPalBalesMapHotSpot(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and #args.ownTable[1] > 0 then
			moSetGetOverlays:generateObjectsMapHotSpot(args.ownTable[1]);			
		end;
	end;
end;

function moFillTypeAmountPriceOutput.clickViewPalBalesCapacity(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] == "capacityBalesR" and args.ownTable[2] ~= nil and moFillTypes.values.items.rBales[args.ownTable[2]] ~= nil then
			local fillLevel = moFillTypes.values.items.rBales[args.ownTable[2]].fillLevel;
			local name = moFillTypes.values.fillTypes[args.ownTable[2]].name;
			moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.info.titel = tostring(g_i18n:getText("fillType_roundBale")).. " ".. tostring(name);
			moSetGetOverlays.infoHelpBox.info.txt = tostring(g_i18n:getText("ui_silos_totalCapacity")).. ": ".. tostring(fillLevel);		
		elseif args.ownTable[1] == "capacityBalesS" and args.ownTable[2] ~= nil and moFillTypes.values.items.sBales[args.ownTable[2]] ~= nil then
			local fillLevel = moFillTypes.values.items.sBales[args.ownTable[2]].fillLevel;
			local name = moFillTypes.values.fillTypes[args.ownTable[2]].name;
			moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.info.titel = tostring(g_i18n:getText("fillType_squareBale")).. " ".. tostring(name);
			moSetGetOverlays.infoHelpBox.info.txt = tostring(g_i18n:getText("ui_silos_totalCapacity")).. ": ".. tostring(fillLevel);
		elseif args.ownTable[1] == "capacityPal" and args.ownTable[2] ~= nil and moFillTypes.values.pal.fillTypes[args.ownTable[2]] ~= nil then
			local fillLevel = moFillTypes.values.items.pal[args.ownTable[2]].fillLevel;
			local palCapacity = g_i18n:formatNumber(moFillTypes.values.pal.fillTypes[args.ownTable[2]].capacity, 0);
			local name = moFillTypes.values.fillTypes[args.ownTable[2]].name;
			moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.info.titel = tostring(g_i18n:getText("category_pallets")).. " ".. tostring(name);
			moSetGetOverlays.infoHelpBox.info.txt = "1x ".. tostring(g_i18n:getText("infohud_pallet")).. " ".. tostring(g_i18n:getText("shop_capacity")).. " ".. tostring(palCapacity).. " (Reg.)\n"..	tostring(g_i18n:getText("ui_silos_totalCapacity")).. ": ".. tostring(fillLevel);
		end;
	end;
end;

function moFillTypeAmountPriceOutput.clickViewOnOff(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] == "viewPrices"	then
			moFillTypeAmountPriceConfig.values.viewPrices = not moFillTypeAmountPriceConfig.values.viewPrices;
			if not moFillTypeAmountPriceConfig.values.viewPrices then moFillTypeAmountPriceConfig.values.viewPriceTrend = false;end;
		elseif args.ownTable[1] == "viewAmounts" then
			moFillTypeAmountPriceConfig.values.viewAmounts = not moFillTypeAmountPriceConfig.values.viewAmounts;
		elseif args.ownTable[1] == "viewPriceTrend"	and moFillTypeAmountPriceConfig.values.viewPrices then
			moFillTypeAmountPriceConfig.values.viewPriceTrend = not moFillTypeAmountPriceConfig.values.viewPriceTrend;
		elseif args.ownTable[1] == "viewFillTypeNoAmount" then
			moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount = not moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount;
		elseif args.ownTable[1] == "viewAllFillTypes" then
			moFillTypeAmountPriceConfig.values.viewAllFillTypes = not moFillTypeAmountPriceConfig.values.viewAllFillTypes;
		elseif args.ownTable[1] == "viewBales" then
			moFillTypeAmountPriceConfig.values.viewBales = not moFillTypeAmountPriceConfig.values.viewBales;
		elseif args.ownTable[1] == "viewPal" then
			moFillTypeAmountPriceConfig.values.viewPal = not moFillTypeAmountPriceConfig.values.viewPal;
		elseif args.ownTable[1] == "viewAnimals" then
			moFillTypeAmountPriceConfig.values.viewAnimals = not moFillTypeAmountPriceConfig.values.viewAnimals;
		end;
	end;
end;

function moFillTypeAmountPriceOutput.clickOutputPrice(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and moFillTypes.values.bestPrice[args.ownTable[1]] ~= nil then
			local fillTypes = moFillTypes.values.bestPrice[args.ownTable[1]];
			local bestPriceStation1 = "";
			local bestPriceStation2 = "";
			local bestPriceStation3 = "";
			local bestPriceStation4 = "";
			local bestPriceTxt = "";
			local bestPriceTxt1 = "";
			local bestPrice = 0;
			local down = KeyboardHelper.getDisplayKeyName(274.0);			
			local up = KeyboardHelper.getDisplayKeyName(273.0);
			local normal = KeyboardHelper.getDisplayKeyName(276.0);
			if fillTypes[1] ~= nil then				
				bestPrice = Utils.getNoNil(fillTypes[1][1], 0);
				bestPriceStation1 = Utils.getNoNil(fillTypes[1][2], "Unknown").. ": ".. Utils.getNoNil(g_i18n:formatMoney(fillTypes[1][1], 0, true, false), "Unknown");				
				if Utils.getNoNil(fillTypes[1][3], "Unknown") == "up" then 				
					bestPriceStation1 = tostring(up).. " ".. bestPriceStation1;
				elseif Utils.getNoNil(fillTypes[1][3], "Unknown") == "down" then 
					bestPriceStation1 = tostring(down).. " ".. bestPriceStation1;
				else
					bestPriceStation1 = tostring(normal).. " ".. bestPriceStation1;
				end;
				bestPriceStation1 = "\n".. bestPriceStation1;
				--if string.find(bestPriceStation1, "Unknown") then bestPriceStation1 = "";end;
			end;
			if fillTypes[2] ~= nil then 
				if bestPrice == 0 then bestPrice = Utils.getNoNil(fillTypes[2][1], 0);end;
				bestPriceStation2 = Utils.getNoNil(fillTypes[2][2], "Unknown").. ": ".. Utils.getNoNil(g_i18n:formatMoney(fillTypes[2][1], 0, true, false), "Unknown");	
				if Utils.getNoNil(fillTypes[2][3], "Unknown") == "up" then 				
					bestPriceStation2 = tostring(up).. " ".. bestPriceStation2;
				elseif Utils.getNoNil(fillTypes[2][3], "Unknown") == "down" then 
					bestPriceStation2 = tostring(down).. " ".. bestPriceStation2;
				else
					bestPriceStation2 = tostring(normal).. " ".. bestPriceStation2;
				end;
				bestPriceStation2 = "\n".. bestPriceStation2;
				--if string.find(bestPriceStation2, "Unknown") then bestPriceStation2 = "";end;
			end;
			if fillTypes[3] ~= nil then
				if bestPrice == 0 then bestPrice = Utils.getNoNil(fillTypes[3][1], 0);end;
				bestPriceStation3 = Utils.getNoNil(fillTypes[3][2], "Unknown").. ": ".. Utils.getNoNil(g_i18n:formatMoney(fillTypes[3][1], 0, true, false), "Unknown");	
				if Utils.getNoNil(fillTypes[3][3], "Unknown") == "up" then 				
					bestPriceStation3 = tostring(up).. " ".. bestPriceStation3;
				elseif Utils.getNoNil(fillTypes[3][3], "Unknown") == "down" then 
					bestPriceStation3 = tostring(down).. " ".. bestPriceStation3;
				else
					bestPriceStation3 = tostring(normal).. " ".. bestPriceStation3;
				end;
				bestPriceStation3 = "\n".. bestPriceStation3;
				--if string.find(bestPriceStation3, "Unknown") then bestPriceStation3 = "";end;
			end;
			if fillTypes[4] ~= nil then
				if bestPrice == 0 then bestPrice = Utils.getNoNil(fillTypes[4][1], 0);end;
				bestPriceStation4 = Utils.getNoNil(fillTypes[4][2], "Unknown").. ": ".. Utils.getNoNil(g_i18n:formatMoney(fillTypes[4][1], 0, true, false), "Unknown");	
				if Utils.getNoNil(fillTypes[4][3], "Unknown") == "up" then 				
					bestPriceStation4 = tostring(up).. " ".. bestPriceStation4;
				elseif Utils.getNoNil(fillTypes[4][3], "Unknown") == "down" then 
					bestPriceStation4 = tostring(down).. " ".. bestPriceStation4;
				else
					bestPriceStation4 = tostring(normal).. " ".. bestPriceStation4;
				end;
				bestPriceStation4 = "\n".. bestPriceStation4;
				--if string.find(bestPriceStation4, "Unknown") then bestPriceStation4 = "";end;
			end;
			local totalAmount = Utils.getNoNil(moFillTypes.values.amount[args.ownTable[1]], 0);
			if totalAmount > 0 and bestPrice > 0 then
				local totalPrice = totalAmount*(bestPrice/1000);				
				bestPriceTxt = "\n------\n*".. tostring(g_i18n:getText("ui_sellPrices")).. "/".. tostring(g_i18n:getText("statistic_storage")).. " ".. tostring(g_i18n:getText("ui_total")).. ": ".. Utils.getNoNil(g_i18n:formatMoney(totalPrice, 0, true, false));				
			end;
			if string.len(bestPriceStation1) > 0 then
				moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.help.titel = "Best Price Stations:  *".. tostring(args.ownTable[2]).. "*";
				moSetGetOverlays.infoHelpBox.help.txt = tostring(bestPriceStation1).. tostring(bestPriceStation2).. tostring(bestPriceStation3).. tostring(bestPriceStation4).. tostring(bestPriceTxt);
			end;			
		end;
	end;
end;


