moSellingStationsOutput = {};
moSellingStationsOutput.isViewInput = false; --for running modul amounts

function moSellingStationsOutput:loadSimple(cmdTable, slotTable)
	local foundViewInput = false;
	local cmdRegName = cmdTable.regName;	
	local lineTable = {line={}};
	local foundSellingStations = 0;
	if moModule.sellingStations ~= nil and #moModule.sellingStations > 0 then
		for index=1, #moModule.sellingStations do
			if moModule.sellingStations[index] ~= nil then
				local cmdObject = moModule.sellingStations[index].object;
				if cmdObject ~= nil and moModuleObjects:isObject(cmdObject) and cmdObject.mohTable ~= nil and cmdObject.mohTable.general ~= nil and cmdObject.mohTable.general[1] ~= nil then					
					foundSellingStations = foundSellingStations+1;
					-----general-----
					---objectName---
					local sellingStationGeneral = cmdObject.mohTable.general[1];
					lineTable.line[#lineTable.line+1] = {};
					local isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};	
					if cmdObject.isGreatDemand ~= nil and cmdObject.isGreatDemand then
						isLineTable.txt[1].outputColor = "txtGreatDemandColor";
					else
						isLineTable.txt[1].slotColor = "txtOutputTitle";
					end;
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(sellingStationGeneral.objectName);		
					isLineTable.txt[1].callback = moSellingStationsOutput.clickSellingStation;
					isLineTable.txt[1].ownTable = {cmdObject.rootNode};
					isLineTable.txt[1].width = 75;
					local objectId = cmdObject.nodeId or cmdObject.rootNode;		
					local oX,oY,oZ = getWorldTranslation(objectId);
					if oX ~= nil and oY ~= nil and oZ ~= nil then
						local x,y,z = g_currentMission.hl.getPlayerPos();
						if x ~= nil and y ~= nil and z ~= nil then
							local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, 10);
							if nearObject then isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";end;
						end;
					end;
					---vot support---
					if sellingStationGeneral.vot ~= nil then						
						local color = "green";
						if not sellingStationGeneral.vot.isOpening then
							color = "yellow";
						end;
						isLineTable.txt[1].icon = {before={},after={}};
						isLineTable.txt[1].icon.after[1] = {name="buttonClock", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moSellingStationsOutput.clickVotOpeningTime}, ownTable={sellingStationGeneral.vot.openingTime, p}, infoTxt="VariableOpeningTime SellingStation WorkingHours"};
					end;					
					---vot support---
					---objectName---
					---input view---
					local sellingStationInput = cmdObject.mohTable.input;
					local viewInput = cmdObject.mohTable.viewInput;
					if #sellingStationInput > 0 then
						isLineTable.txt[2] = {};			
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = true;			
						isLineTable.txt[2].txt = "In ++ ".. "(".. tostring(#sellingStationInput).. ")";			
						isLineTable.txt[2].callback = moSellingStationsOutput.clickViewInputOnOff;
						isLineTable.txt[2].ownTable = {cmdObject.rootNode};
						local color = "red";
						local buttonName = "buttonDown";
						if viewInput then color = "green";buttonName = "buttonUp";end;
						isLineTable.txt[2].icon = {before={},after={}};
						isLineTable.txt[2].icon.before[1] = {name=buttonName, color=color, settingButton=true, callback={[1]=moSellingStationsOutput.clickViewInputOnOff}, ownTable={cmdObject.rootNode}};					
						isLineTable.txt[2].width = 25;
					end;
					---input view---							
					-----general-----
					
					-----input-----					
					if viewInput then			
						foundViewInput = true;
						---global on/off view filltypes later not view !?!
						for input=1, #sellingStationInput do
							if sellingStationInput[input] ~= nil then
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];
								isLineTable.txt = {};
								isLineTable.txt[1] = {};
								if moFillTypes.values.amount[sellingStationInput[input].fillType] ~= nil and moFillTypes.values.amount[sellingStationInput[input].fillType] > 0 then
									isLineTable.txt[1].outputColor = "txtFillTypesColor"; 
									isLineTable.txt[1].isAmount = true;
								else
									isLineTable.txt[1].outputColor = "txtPriceColor";
									isLineTable.txt[1].isAmount = false;
								end;
								isLineTable.txt[1].bold = false;
								isLineTable.txt[1].txt = tostring(sellingStationInput[input].fillTypeName);								
								isLineTable.txt[1].width = 60;
								
								local priceTrend = "priceNormal";
								isLineTable.txt[2] = {};																
								isLineTable.txt[2].outputColor = "txtPriceColor";
								if sellingStationInput[input].priceTrend == "up" then									
									priceTrend = "priceUp";
								elseif sellingStationInput[input].priceTrend == "down" then									
									priceTrend = "priceDown";
								elseif sellingStationInput[input].priceTrend == "greatDemand" then
									isLineTable.txt[2].outputColor = "txtGreatDemandColor";								
								end;
								isLineTable.txt[2].icon = {before={},after={}};
								isLineTable.txt[2].icon.after[1] = {name=priceTrend, modName="MultiOverlayV4", groupName="intern" };
								isLineTable.txt[2].bold = false;
								isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(sellingStationInput[input].price, 0, true, false));
								isLineTable.txt[2].width = 40;
								isLineTable.txt[2].alignment = 3;						
							end;
						end;						
					end;
					-----input-----				
				end;
			end;
		end;
		function comp(w1,w2)		
			if w1.txt[1].txt < w2.txt[1].txt then
				return true;
			end;				
		end;
		--table.sort(lineTable.line, comp);
		---objectLineDistance---
		lineTable.line[#lineTable.line+1] = {};
		local isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};		
		isLineTable.txt[1].txt = " ";
		---objectLineDistance---
	end;
	table.insert(lineTable.line, 1, {});
	isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = g_i18n:getText("construction_tab_sellingPoints").. " (".. tostring(foundSellingStations).. ")"; --moLanguageXml:getTxt("sellingstations", nil, "Stations:").. " (".. tostring(foundSellingStations).. ")";	
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moSellingStationsOutput.clickSellingStationsHelpTxt}};
	end;
	if foundViewInput then moSellingStationsOutput.isViewInput = true;else moSellingStationsOutput.isViewInput = false;end; --for running modul amounts
	moSellingStations[cmdRegName] = {output=lineTable};
end;

function moSellingStationsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="sellingStations" } );
	if args.cmdTable.ownTable ~= nil and args.cmdTable.ownTable[1] ~= nil and args.cmdTable.ownTable[1] == "simpleSellingStations" then
		if moSellingStationsOutput.isViewInput then moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="amounts" } );end;
		moSellingStationsOutput:loadSimple(args.cmdTable, args.slotTable);
	end;
	return moSellingStations[args.cmdTable.regName].output;
end;

function moSellingStationsOutput.clickSellingStationsHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "SellingStations Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional SellingStations or In++ for more Info or MapHotSpot or ...";
	end;
end;

function moSellingStationsOutput.clickSellingStation(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "sellingStations");			
			if object ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then
					moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
				end;
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[1] ~= nil and g_currentMission.controlledVehicle == nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "sellingStations");			
			if object ~= nil and object.spec_hotspots ~= nil and object.spec_hotspots.mapHotspots ~= nil then
				local hotspot = object.spec_hotspots.mapHotspots[1];
				if hotspot ~= nil and hotspot.teleportWorldX ~= nil and hotspot.teleportWorldY ~= nil and hotspot.teleportWorldZ ~= nil then
					g_currentMission.player:moveToAbsolute(hotspot.teleportWorldX, hotspot.teleportWorldY, hotspot.teleportWorldZ, false, false);
					MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moSellingStationsOutput.clickSellingStation"); --force mouseOff
				end;				
			end;
		end;		
	end;
end;

function moSellingStationsOutput.clickVotOpeningTime(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local votOpeningTime = args.ownTable[1];
			if votOpeningTime ~= nil and type(votOpeningTime) == "table" then
				local votModName = moModuleSetGet:getVotModName();
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.titel = "Variable-Opening-Time ".. tostring(g_i18n:getText("ui_operatingHours"));
				local txt = tostring(g_i18n:getText("vot_OpeningTime", votModName)).. "\n";
				for a=1, #votOpeningTime do
					txt = txt.. string.format(g_i18n:getText("vot_ClockTime", votModName), tostring(votOpeningTime[a].startTime), tostring(votOpeningTime[a].endTime)).. "\n";
				end;				
				moSetGetOverlays.infoHelpBox.info.txt = txt;
			end;
		end;		
	end;
end;

function moSellingStationsOutput.clickViewInputOnOff(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then					
			local object = moModuleObjects:getObject(args.ownTable[1], "sellingStations");			
			if object ~= nil then				
				object.mohTable.viewInput = not object.mohTable.viewInput;
			end;			
		end;
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="sellingStations" } );