moVehicleSalesConfig = {};

function moVehicleSalesConfig:defaultValues()
	moVehicleSalesConfig.values = {sales={}, updateTimer=10, msec=false};
end;

function moVehicleSalesConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moVehicleSalesConfig.values == nil then moVehicleSalesConfig:defaultValues();end;
	--local groupNameTag = (xmlNameTag.. ".module.vehicleSales(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		--moVehicleSalesConfig.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		--moVehicleSalesConfig.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;	
end;

function moVehicleSalesConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;
	if moVehicleSalesConfig.values == nil then moVehicleSalesConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.vehicleSales(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moVehicleSalesConfig.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moVehicleSalesConfig.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moVehicleSalesConfig:generateCmd()
	function generateCmd(ownTable)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = "output_vehicleSales_";
				groupName = "OutputByMoh";			
				displayName = tostring(g_i18n:getText("inputCategory_VEHICLE")).. " ".. tostring(g_i18n:getText("category_sales"));
				infoTxt = "View Vehicle Sales";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = ownTable;
				object = {};
				actionCallback = moVehicleSalesOutput.giveOutputTable;			
			}
		)
	end;	
	generateCmd({});	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moVehicleSalesConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moVehicleSalesConfig.saveXml } );
