moMouseKeyEventsLight = {};

function moMouseKeyEventsLight:setMouse(posX, posY, isDown, isUp, button, clickAreaTable)
	if button == Input.MOUSE_BUTTON_LEFT then
		moMouseKeyEventsLight:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_MIDDLE then
		moMouseKeyEventsLight:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_RIGHT then
		moMouseKeyEventsLight:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_UP then
		moMouseKeyEventsLight:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
		moMouseKeyEventsLight:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);
	end;		
end;

function moMouseKeyEventsLight:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "buttonLeft_" and isDown then
		g_currentMission.hl.addTextDisplay( {txt="Slave PDA not implements/wait update", txtBold=true, duration=3, warning=true} );
	elseif clickAreaTable.whereClick == "buttonSetting_" and isDown then
		if g_currentMission.hlGui.menue.isOpen and not moSetGetOverlaysLight.default.setting.on then
			g_currentMission.hlGui.setGet:setClose();
		end;
		moSetGetOverlaysLight.default.setting.on = not moSetGetOverlaysLight.default.setting.on;
		moSetGetOverlaysLight.default.setting.typ = tostring(clickAreaTable.whatClick);
		moSetGetOverlaysLight.default.setting.selectApp = 0;
		if moSetGetOverlaysLight.default.setting.on then
			g_currentMission.hl.addTextDisplay( {txt="Click AppIcons/Text Left/Right/Middle for Action (if available)", txtBold=true, duration=7} );
		end;
		return;
	elseif clickAreaTable.whereClick == "appIcon_" and isDown then
		if clickAreaTable.app ~= nil then
			local newGenerate = moSetGetLight:masterPdaOpenCloseApp(clickAreaTable.app);
			if newGenerate == nil then --cmd
			
			else
				if newGenerate then
					g_currentMission.hl.addTextDisplay( {txt=tostring(moSetGetOverlaysLight.default.masterPda.appOrder[clickAreaTable.app][3].. " NICHT vorhanden"), txtBold=true, duration=3} );
				else
					g_currentMission.hl.addTextDisplay( {txt=tostring(moSetGetOverlaysLight.default.masterPda.appOrder[clickAreaTable.app][3].. " vorhanden"), txtBold=true, duration=3} );
				end;
			end;
		end;		
	end;
end;

function moMouseKeyEventsLight:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable)
	
end;

function moMouseKeyEventsLight:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "buttonSetting_" and isDown then
		
		--g_currentMission.hl.addTextDisplay( {txt="click buttonSetting rightMouse", txtBold=true, duration=3} );
	end;
end;

function moMouseKeyEventsLight:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whatClick == "masterPdaScrollUp" and isDown then
		moSetGetLight:setMasterPdaBounds(true);
		return;		
	end;
end;

function moMouseKeyEventsLight:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whatClick == "masterPdaScrollDown" and isDown then
		moSetGetLight:setMasterPdaBounds(false);
		return;
	end;
end;