moMouseKeyEventsLightSetting = {};

function moMouseKeyEventsLightSetting:setMouse(posX, posY, isDown, isUp, button, clickAreaTable)
	if button == Input.MOUSE_BUTTON_LEFT then
		moMouseKeyEventsLightSetting:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_MIDDLE then
		moMouseKeyEventsLightSetting:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_RIGHT then
		moMouseKeyEventsLightSetting:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_UP then
		moMouseKeyEventsLightSetting:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
		moMouseKeyEventsLightSetting:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);
	end;		
end;

function moMouseKeyEventsLightSetting:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "buttonClose_" and isDown then
		moSetGetOverlaysLight.default.setting.on = false;moSetGetOverlaysLight.default.setting.typ = "";moSetGetOverlaysLight.default.setting.selectApp =0;
		return;
	elseif clickAreaTable.whereClick == "appIcon_" and isDown then	
		if moSetGetOverlaysLight.default.setting.selectApp == clickAreaTable.app then 
			moSetGetOverlaysLight.default.setting.selectApp = 0;			
		else 
			moSetGetOverlaysLight.default.setting.selectApp = clickAreaTable.app;
		end;		
	elseif clickAreaTable.whereClick == "appView_" and isDown then		
		local lightTyp = moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ];
		if lightTyp ~= nil and lightTyp.appOrder ~= nil and lightTyp.appOrder[clickAreaTable.app] ~= nil then
			lightTyp.appOrder[clickAreaTable.app][2] = not lightTyp.appOrder[clickAreaTable.app][2];
			if moSetGetOverlaysLight.default.setting.typ == "masterPda" then
				moSetGetLight:setMasterPdaBounds();
			end;
			if not lightTyp.appOrder[clickAreaTable.app][2] then
				g_currentMission.hl.addTextDisplay( {txt="View AppIcon OFF", txtColor="yellow", txtBold=true, duration=3} );			
			else				
				local typTxt = "AppIcon Typ is open a ".. tostring(lightTyp.appOrder[clickAreaTable.app][4]:upper());
				local name = tostring(lightTyp.appOrder[clickAreaTable.app][4]:upper()).. ": ".. tostring(lightTyp.appOrder[clickAreaTable.app][3]);				
				g_currentMission.hl.addTextDisplay( {txt="View AppIcon ON\n".. typTxt.. "\n".. name, maxLine=3, txtBold=true, duration=10} );
			end;
		end;
		return;
	elseif clickAreaTable.whereClick == "appInfoBar_" and isDown then
		local lightTyp = moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ];
		if lightTyp ~= nil and lightTyp.appOrder ~= nil and lightTyp.appOrder[clickAreaTable.app] ~= nil then
			if lightTyp.appOrder[clickAreaTable.app][6][1] ~= nil then
				lightTyp.appOrder[clickAreaTable.app][6][1] = not lightTyp.appOrder[clickAreaTable.app][6][1];
				if not lightTyp.appOrder[clickAreaTable.app][6][1] then
					g_currentMission.hl.addTextDisplay( {txt="View AppIcon InfoBar OFF", txtColor="yellow", txtBold=true, duration=5} );
				else
					local timerTxt = "Update all ".. tostring(lightTyp.appOrder[clickAreaTable.app][6][4]).. " sec";
					local noticeTxt = "see Notice InfoIcon, have a Problem or... (Option Testing...)";
					g_currentMission.hl.addTextDisplay( {txt="View AppIcon InfoBar ON\n".. timerTxt.. "\n".. noticeTxt, maxLine=3, txtBold=true, duration=10} );
				end;
			end;
		end;
	elseif clickAreaTable.whereClick == "appLeftRight_" and isDown then		
		local isNewPos = moSetGetLight:setNewAppOrder(moSetGetOverlaysLight.default.setting.typ, clickAreaTable.app, false);
		if isNewPos then
			local infoTxt = "Click Mouse Button Left or Right";
			g_currentMission.hl.addTextDisplay( {txt="<--- Set AppIcon new position\n".. infoTxt, maxLine=2, txtBold=true, duration=10} );
		else
			g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong !!", txtBold=true, duration=5, warning=true} );
		end;
	elseif clickAreaTable.whereClick == "appAutoClose_" and isDown then
		local lightTyp = moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ];
		if lightTyp ~= nil and lightTyp.appOrder ~= nil and lightTyp.appOrder[clickAreaTable.app] ~= nil then
			lightTyp.appOrder[clickAreaTable.app][5] = not lightTyp.appOrder[clickAreaTable.app][5];
			if not lightTyp.appOrder[clickAreaTable.app][5] then
				local infoTxt = "This ".. tostring(lightTyp.appOrder[clickAreaTable.app][4]:upper()).. " not Close if other ".. tostring(lightTyp.appOrder[clickAreaTable.app][4]:upper()).. " open Click";
				local infoTxt1 = "ONLY FOR THIS PDA";
				g_currentMission.hl.addTextDisplay( {txt="Set this AppIcon AutoClose OFF\n".. infoTxt.. "\n".. infoTxt1, maxLine=3, txtColor="yellow", txtBold=true, duration=10} );
			else
				local infoTxt = "This ".. tostring(lightTyp.appOrder[clickAreaTable.app][4]:upper()).. " close if other ".. tostring(lightTyp.appOrder[clickAreaTable.app][4]:upper()).. " open Click";
				local infoTxt1 = "ONLY FOR THIS PDA";
				g_currentMission.hl.addTextDisplay( {txt="Set this AppIcon AutoClose ON\n".. infoTxt.. "\n".. infoTxt1, maxLine=3, txtBold=true, duration=10} );
			end;
		end;
	elseif clickAreaTable.whereClick == "autoWidthOnOff_" and isDown then
		local lightTyp = moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ];
		if lightTyp ~= nil then
			if moSetGetOverlaysLight.default.setting.typ == "masterPda" then
				lightTyp.autoWidth = not lightTyp.autoWidth;
				moSetGetLight:setMasterPdaBounds();
				if lightTyp.autoWidth then
					local infoTxt = "View turned on AppIcons by LS WTM Hud Width (view min ".. tostring(lightTyp.minViewApps).. ")";
					local infoTxt1 = "Optional Scroll Up/Down with Mouse in PDA";
					g_currentMission.hl.addTextDisplay( {txt="Set Auto Width ON\n".. infoTxt.. "\n".. infoTxt1, maxLine=3, txtColor="yellow", txtBold=true, duration=10} );
				else
					local infoTxt = "View max turned on AppIcons";
					g_currentMission.hl.addTextDisplay( {txt="Set Auto Width OFF\n".. infoTxt, maxLine=2, txtColor="yellow", txtBold=true, duration=10} );
				end;
			else
				g_currentMission.hl.addTextDisplay( {txt="Only for Master PDA", txtBold=true, duration=5, warning=true} );
			end;
		end;
	elseif clickAreaTable.whereClick == "minViewApps_" and isDown then
		local lightTyp = moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ];
		if lightTyp ~= nil then
			if lightTyp.minViewApps >= lightTyp.maxViewApps then 
				lightTyp.minViewApps = moSetGetOverlaysLight.default.limitMinViewApps;
			else
				lightTyp.minViewApps = lightTyp.minViewApps+1;
			end;
			local infoTxt = "NEEDS Auto Width OFF";
			g_currentMission.hl.addTextDisplay( {txt="Set Min. View Apps ".. tostring(lightTyp.minViewApps).. "\n".. infoTxt, maxLine=2, txtColor="yellow", txtBold=true, duration=10} );
			moSetGetLight:setMasterPdaBounds();
		end;		
	end;
end;

function moMouseKeyEventsLightSetting:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable)
	
end;

function moMouseKeyEventsLightSetting:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "buttonSetting_" and isDown then		
		--g_currentMission.hl.addTextDisplay( {txt="click buttonSetting rightMouse", txtBold=true, duration=3} );
	elseif clickAreaTable.whereClick == "appLeftRight_" and isDown then
		local isNewPos = moSetGetLight:setNewAppOrder(moSetGetOverlaysLight.default.setting.typ, clickAreaTable.app, true);
		if isNewPos then
			local infoTxt = "Click Mouse Button Left or Right";
			g_currentMission.hl.addTextDisplay( {txt="---> Set AppIcon new position\n".. infoTxt, maxLine=2, txtBold=true, duration=10} );
		else
			g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong !!", txtBold=true, duration=5, warning=true} );
		end;
	elseif clickAreaTable.whereClick == "minViewApps_" and isDown then
		local lightTyp = moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ];
		if lightTyp ~= nil then
			if lightTyp.minViewApps <= moSetGetOverlaysLight.default.limitMinViewApps then 
				lightTyp.minViewApps = lightTyp.maxViewApps or 20;
			else
				lightTyp.minViewApps = lightTyp.minViewApps-1;
			end;
			local infoTxt = "NEEDS Auto Width OFF";
			g_currentMission.hl.addTextDisplay( {txt="Set Min. View Apps ".. tostring(lightTyp.minViewApps).. "\n".. infoTxt, maxLine=2, txtColor="yellow", txtBold=true, duration=10} );
			moSetGetLight:setMasterPdaBounds();
		end;
	end;
end;

function moMouseKeyEventsLightSetting:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable)
	
end;

function moMouseKeyEventsLightSetting:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable)
	
end;
