moMouseKeyEventsMenue = {};
source(MultiOverlayV4.modDir.."scripte/mouseKeyEvents/menue/moMouseKeyEventsMenueCmdSetting.lua");
source(MultiOverlayV4.modDir.."scripte/mouseKeyEvents/menue/moMouseKeyEventsMenueAppIconSetting.lua");

function moMouseKeyEventsMenue:setMouse(posX, posY, isDown, isUp, button, clickAreaTable)
	if button == Input.MOUSE_BUTTON_LEFT then
		moMouseKeyEventsMenue:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_MIDDLE then
		moMouseKeyEventsMenue:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_RIGHT then
		moMouseKeyEventsMenue:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_UP then
		moMouseKeyEventsMenue:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
		moMouseKeyEventsMenue:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif clickAreaTable.isHlGui ~= nil and clickAreaTable.isHlGui and clickAreaTable.infoTxt ~= nil and type(clickAreaTable.infoTxt) == "string" and string.len(clickAreaTable.infoTxt) > 0 then
		g_currentMission.hlGui.menue.infoBox.txt = tostring(clickAreaTable.infoTxt);
	end;	
end;

function moMouseKeyEventsMenue:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whatClick == "cmdSettingMenue" then
		moMouseKeyEventsMenueCmdSetting:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);	
	elseif clickAreaTable.whatClick == "appIconSettingMenue" then
		moMouseKeyEventsMenueAppIconSetting:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);
	end;	
end;

function moMouseKeyEventsMenue:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whatClick == "cmdSettingMenue" then
		moMouseKeyEventsMenueCmdSetting:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);	
	elseif clickAreaTable.whatClick == "appIconSettingMenue" then
		moMouseKeyEventsMenueAppIconSetting:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);
	end;
end;

function moMouseKeyEventsMenue:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whatClick == "cmdSettingMenue" then
		moMouseKeyEventsMenueCmdSetting:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);	
	elseif clickAreaTable.whatClick == "appIconSettingMenue" then
		moMouseKeyEventsMenueAppIconSetting:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);
	end;
end;

function moMouseKeyEventsMenue:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whatClick == "cmdSettingMenue" then
		moMouseKeyEventsMenueCmdSetting:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);	
	elseif clickAreaTable.whatClick == "appIconSettingMenue" then
		moMouseKeyEventsMenueAppIconSetting:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);
	end;
end;

function moMouseKeyEventsMenue:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whatClick == "cmdSettingMenue" then
		moMouseKeyEventsMenueCmdSetting:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);	
	elseif clickAreaTable.whatClick == "appIconSettingMenue" then
		moMouseKeyEventsMenueAppIconSetting:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);
	end;
end;

function moMouseKeyEventsMenue:setKey(unicode, sym, modifier, isDown)

end;

