moMouseKeyEvents = {};
source(MultiOverlayV4.modDir.."scripte/mouseKeyEvents/menue/moMouseKeyEventsMenue.lua");
source(MultiOverlayV4.modDir.."scripte/mouseKeyEvents/slot/moMouseKeyEventsSlot.lua");
source(MultiOverlayV4.modDir.."scripte/mouseKeyEvents/pda/moMouseKeyEventsPda.lua");
source(MultiOverlayV4.modDir.."scripte/mouseKeyEvents/light/moMouseKeyEventsLight.lua");
source(MultiOverlayV4.modDir.."scripte/mouseKeyEvents/menue/moMouseKeyEventsLightSetting.lua");

function moMouseKeyEvents:setKeyMouse(unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)
	if not moGeneralSettings.modOn and unicode ~= nil then moMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, true); return;end;
	if unicode ~= nil then
		if not g_currentMission.hl.dragDrop.on then
			moMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, false);			
		end;
	else
		if g_currentMission.hl.isMouseCursor then
			if not g_currentMission.hl.dragDrop.on then
				moMouseKeyEvents:setMouse(posX, posY, isDown, isUp, button);
			elseif g_currentMission.hl.dragDrop.on then
				moMouseKeyEvents:setDragDropMouse(posX, posY, isDown, isUp, button);
			end;
		end;
	end;
end;

function moMouseKeyEvents:setMouse(posX, posY, isDown, isUp, button)	
	if moGeneralSettings.cmdSettingMenue.on or moGeneralSettings.appIconSettingMenue.on then
		for key,value in pairs (moGeneralSettings.clickAreas.masterMenue) do		
			if value ~= nil and value[1] ~= nil then 
				if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then					
					MultiOverlayV4.cursorInArea = true;
					local whichArea = value.whichArea;					
					if moGeneralSettings.clickAreas.menue[tostring(whichArea)] ~= nil and moGeneralSettings[tostring(whichArea)].on then
						if (whichArea == "appIconSettingMenue" and moHlGuiAppIconSetting:isHlGuiOpen()) or (whichArea == "cmdSettingMenue" and moHlGuiCmdSetting:isHlGuiOpen()) then
							for area=1, #moGeneralSettings.clickAreas.menue[tostring(whichArea)] do
								if moGeneralSettings.clickAreas.menue[tostring(whichArea)] == nil or moGeneralSettings.clickAreas.menue[tostring(whichArea)][area] == nil or moGeneralSettings.clickAreas.menue[tostring(whichArea)][area][1] == nil then break;end;
								if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.menue[tostring(whichArea)][area]))then
									local clickAreaTable = moGeneralSettings.clickAreas.menue[tostring(whichArea)][area];									
									moMouseKeyEventsMenue:setMouse(posX, posY, isDown, isUp, button, clickAreaTable);
								end;						
							end;
						end;
					end;				
				end;
			end;
		end;
	end;
	if moGeneralSettings.miniMapAutoState.on and moGeneralSettings.clickAreas.miniMapAutoState ~= nil then
		for key,value in pairs (moGeneralSettings.clickAreas.miniMapAutoState) do
			if value ~= nil and value[1] ~= nil then
				if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then
					if button == Input.MOUSE_BUTTON_LEFT and isDown then
						moSetGet:setMiniMapAutoState(value);
						break;
					end;
				end;
			end;
		end;
	end;
	if moGeneralSettings.pdaType.light then
		if moSetGetOverlaysLight.default.setting.on and moGeneralSettings.clickAreas.lightSetting ~= nil then
			for key,value in pairs (moGeneralSettings.clickAreas.lightSetting) do
				if value ~= nil and value[1] ~= nil then
					if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then				
						MultiOverlayV4.cursorInArea = true;
						local whichArea = value.whichArea;
						if moGeneralSettings.clickAreas.lightSettingPda[tostring(whichArea)] ~= nil then
							for area=1, #moGeneralSettings.clickAreas.lightSettingPda[tostring(whichArea)] do
								if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.lightSettingPda[tostring(whichArea)][area]))then
									local clickAreaTable = moGeneralSettings.clickAreas.lightSettingPda[tostring(whichArea)][area];
									moMouseKeyEventsLightSetting:setMouse(posX, posY, isDown, isUp, button, clickAreaTable);
								end;
							end;					
						end;
					end;
				end;
			end;	
		end;
		if moGeneralSettings.clickAreas.lightMaster ~= nil then
			for key,value in pairs (moGeneralSettings.clickAreas.lightMaster) do
				if value ~= nil and value[1] ~= nil then
					if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then				
						MultiOverlayV4.cursorInArea = true;
						local whichArea = value.whichArea;
						if button == Input.MOUSE_BUTTON_WHEEL_UP then
							moMouseKeyEventsLight:buttonWheelUp(posX, posY, isDown, isUp, button, {whatClick="masterPdaScrollUp"});
						elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
							moMouseKeyEventsLight:buttonWheelDown(posX, posY, isDown, isUp, button, {whatClick="masterPdaScrollDown"});
						end;				
						if moGeneralSettings.clickAreas.lightPda[tostring(whichArea)] ~= nil then
							for area=1, #moGeneralSettings.clickAreas.lightPda[tostring(whichArea)] do
								if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.lightPda[tostring(whichArea)][area]))then
									local clickAreaTable = moGeneralSettings.clickAreas.lightPda[tostring(whichArea)][area];
									moMouseKeyEventsLight:setMouse(posX, posY, isDown, isUp, button, clickAreaTable);
								end;
							end;
						end;
					end;
				end;
			end;
		end;
	end;
	if moGeneralSettings.clickAreas.smallView ~= nil then
		for key,value in pairs (moGeneralSettings.clickAreas.smallView) do
			if value ~= nil and value[1] ~= nil then
				if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then
					if button == Input.MOUSE_BUTTON_LEFT and isDown then
						if moSetGetOverlays.pda["dummyPda_"] == nil then 
							local pdas = moSetGetPda:getPdas();
							if #pdas > 0 then
								moDraw.pda:setOpen(pdas[1]);
								return;
							else
								g_currentMission.hl.addTextDisplay( {txt="Not Found first Pda (generate new Pda)", txtBold=true, duration=3, warning=true} );								
							end;
						else
							moDraw.pda:setOpen("dummyPda_");
							return;
						end;
					end;
				end;
			end;
		end;
	end;
	for key,value in pairs (moGeneralSettings.clickAreas.masterSlot) do
		if value ~= nil and value[1] ~= nil then
			if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then				
				MultiOverlayV4.cursorInArea = true;
				local whichArea = value.whichArea;				
				if moGeneralSettings.clickAreas.slot[tostring(whichArea)] ~= nil and moSetGetOverlays.slot[tostring(whichArea)] ~= nil and moSetGetOverlays.slot[tostring(whichArea)].isOpen then
					for area=1, #moGeneralSettings.clickAreas.slot[tostring(whichArea)] do
						if moGeneralSettings.clickAreas.slot[tostring(whichArea)] == nil or moGeneralSettings.clickAreas.slot[tostring(whichArea)][area] == nil or moGeneralSettings.clickAreas.slot[tostring(whichArea)][area][1] == nil then break;end;
						if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.slot[tostring(whichArea)][area]))then
							local clickAreaTable = moGeneralSettings.clickAreas.slot[tostring(whichArea)][area];							
							if button == Input.MOUSE_BUTTON_LEFT and isDown and (tostring(clickAreaTable.whereClick) == "dragDrop_" or tostring(clickAreaTable.whereClick) == "dragDropWH_") then
								if not g_currentMission.hl.dragDrop.on then				
									if tostring(clickAreaTable.whereClick) == "dragDropWH_" then
										MultiOverlayV4:get_hl("setDragDrop", {true, "_slotWH_", clickAreaTable.whatClick, ""}, "moMouseKeyEvents:setMouse");
									else
										MultiOverlayV4:get_hl("setDragDrop", {true, "_slot_", clickAreaTable.whatClick, ""}, "moMouseKeyEvents:setMouse");
									end;
								elseif g_currentMission.hl.dragDrop.on and isDown and g_currentMission.hl.dragDrop.where == clickAreaTable.whatClick then
									MultiOverlayV4:get_hl("setDragDrop", {false}, "moMouseKeyEvents:setMouse");										
								end;
							else								
								moMouseKeyEventsSlot:setMouse(posX, posY, isDown, isUp, button, clickAreaTable);								
							end;						
						end;		
					end;
				end;			
			end;
		end;
	end;
	for key,value in pairs (moGeneralSettings.clickAreas.masterPda) do
		if value ~= nil and value[1] ~= nil then
			if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then				
				MultiOverlayV4.cursorInArea = true;
				local whichArea = value.whichArea;				
				if moGeneralSettings.clickAreas.pda[tostring(whichArea)] ~= nil and moSetGetOverlays.pda[tostring(whichArea)] ~= nil and moSetGetOverlays.pda[tostring(whichArea)].isOpen then
					for area=1, #moGeneralSettings.clickAreas.pda[tostring(whichArea)] do
						if moGeneralSettings.clickAreas.pda[tostring(whichArea)] == nil or moGeneralSettings.clickAreas.pda[tostring(whichArea)][area] == nil or moGeneralSettings.clickAreas.pda[tostring(whichArea)][area][1] == nil then break;end;
						if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.pda[tostring(whichArea)][area]))then
							local clickAreaTable = moGeneralSettings.clickAreas.pda[tostring(whichArea)][area];							
							if button == Input.MOUSE_BUTTON_LEFT and isDown and (tostring(clickAreaTable.whereClick) == "dragDrop_" or tostring(clickAreaTable.whereClick) == "dragDropWH_" or tostring(clickAreaTable.whereClick) == "dragDropArea_") then
								if not g_currentMission.hl.dragDrop.on then				
									if tostring(clickAreaTable.whereClick) == "dragDropWH_" then
										MultiOverlayV4:get_hl("setDragDrop", {true, "_pdaWH_", clickAreaTable.whatClick, ""}, "moMouseKeyEvents:setMouse");
									elseif tostring(clickAreaTable.whereClick) == "dragDropArea_" then
										MultiOverlayV4:get_hl("setDragDrop", {true, "_dragDropArea_", clickAreaTable.whatClick, "", clickAreaTable.appValue}, "moMouseKeyEvents:setMouse");
									else
										MultiOverlayV4:get_hl("setDragDrop", {true, "_pda_", clickAreaTable.whatClick, ""}, "moMouseKeyEvents:setMouse");
									end;
								elseif g_currentMission.hl.dragDrop.on and isDown and g_currentMission.hl.dragDrop.where == clickAreaTable.whatClick then
									MultiOverlayV4:get_hl("setDragDrop", {false}, "moMouseKeyEvents:setMouse");										
								end;
							else
								moMouseKeyEventsPda:setMouse(posX, posY, isDown, isUp, button, clickAreaTable);									
							end;						
						end;		
					end;
				end;			
			end;
		end;
	end;	
end;

function moMouseKeyEvents:setKey(unicode, sym, modifier, isDown, onlyMouse, cursorOnOff)
	--InputAction	
	if cursorOnOff then		
		if g_currentMission.hl.isMouseCursor then
			MultiOverlayV4:get_hl("mouseOnOff", {false,false,"MultiOverlayV4"}, "moMouseKeyEvents:setKey");			
		else
			MultiOverlayV4:get_hl("mouseOnOff", {true,g_currentMission.hlGui.menue.playerFrozen,"MultiOverlayV4"}, "moMouseKeyEvents:setKey");			
		end;			
		return;	
	end;
	if MultiOverlayV4.hlDebugMode and Input.isKeyPressed(Input.KEY_f2)then
		g_currentMission.hl.debugPrint("MultiOverlayV4Mod");		
	end;
end;	

function moMouseKeyEvents:setDragDropMouse(posX, posY, isDown, isUp, button)	
	if button == Input.MOUSE_BUTTON_LEFT and isDown then		
		if g_currentMission.hl.dragDrop.on then
			if g_currentMission.hl.dragDrop.what == "_dragDropArea_" then
				for key,value in pairs (moGeneralSettings.clickAreas.masterPda) do
					if value ~= nil and value[1] ~= nil then
						if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(value))then				
							local whichArea = value.whichArea;
							if moGeneralSettings.clickAreas.pda[tostring(whichArea)] ~= nil and moSetGetOverlays.pda[tostring(whichArea)] ~= nil and moSetGetOverlays.pda[tostring(whichArea)].isOpen then
								for area=1, #moGeneralSettings.clickAreas.pda[tostring(whichArea)] do
									if moGeneralSettings.clickAreas.pda[tostring(whichArea)] == nil or moGeneralSettings.clickAreas.pda[tostring(whichArea)][area] == nil or moGeneralSettings.clickAreas.pda[tostring(whichArea)][area][1] == nil then break;end;
									if g_currentMission.hl.mouseIsInArea(posX, posY, unpack(moGeneralSettings.clickAreas.pda[tostring(whichArea)][area]))then
										local clickAreaTable = moGeneralSettings.clickAreas.pda[tostring(whichArea)][area];	
										if clickAreaTable.whereClick == "selectDragDropApp_" and clickAreaTable.appValue ~= nil then
											moDragDrop:addAreaApp(clickAreaTable);											
										end;
									end;
								end;
							end;
						end;
					end;
				end;								  
			end;
			if g_currentMission.hl.dragDrop.what == "_slot_" or g_currentMission.hl.dragDrop.what == "_slotWH_" or g_currentMission.hl.dragDrop.what == "_pda_" or g_currentMission.hl.dragDrop.what == "_pdaWH_" or g_currentMission.hl.dragDrop.what == "_dragDropArea_" then
				MultiOverlayV4:get_hl("setDragDrop", {false}, "moMouseKeyEvents:setDragDropMouse");					
			end;
			return;						
		end;	
	end;
end;

function moMouseKeyEvents:setKeyMouseTest(unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)	
	if Input.isKeyPressed(Input.KEY_f9) and MultiOverlayV4.debugPrint ~= nil and not MultiOverlayV4.debugPrint then
		MultiOverlayV4.debugPrint = not MultiOverlayV4.debugPrint;		
	end;
end;
