moMouseKeyEventsSlot = {};

function moMouseKeyEventsSlot:setMouse(posX, posY, isDown, isUp, button, clickAreaTable)
	if button == Input.MOUSE_BUTTON_LEFT then
		moMouseKeyEventsSlot:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_MIDDLE then
		moMouseKeyEventsSlot:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_RIGHT then
		moMouseKeyEventsSlot:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_UP then
		moMouseKeyEventsSlot:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
		moMouseKeyEventsSlot:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif clickAreaTable.infoTxt ~= nil and type(clickAreaTable.infoTxt) == "string" and string.len(clickAreaTable.infoTxt) > 0 then
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = tostring(clickAreaTable.infoTxt);
		end;
		return;		
	end;
	--if clickAreaTable.helpTxt ~= nil and type(clickAreaTable.helpTxt) == "string" and string.len(clickAreaTable.helpTxt) > 0 then
	--	if clickAreaTable.whatClick ~= nil and moSetGetOverlays.slot[clickAreaTable.whatClick] ~= nil and moSetGetOverlays.slot[clickAreaTable.whatClick].help.globalOn then
			
			--moDraw.slot:helpTxt(clickAreaTable); --slot global help
	--	end;
	--end;
end;

function moMouseKeyEventsSlot:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable)	
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" and isDown then
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;
			clickAreaTable.mouseClick = "MOUSE_BUTTON_LEFT";
			local canCallback = not clickAreaTable.isMenue and clickAreaTable.slotTable.cmd[clickAreaTable.cmdPos].mouseClick ~= nil and (clickAreaTable.slotTable.cmd[clickAreaTable.cmdPos].mouseClick[1] and clickAreaTable.cmdTable.mouseClickAccepts[1])
			if not canCallback then canCallback = clickAreaTable.whereClick == "outputLineCallback_";end;
			if clickAreaTable.isMenue or canCallback then				
				clickAreaTable.callback(clickAreaTable);
				return;
			end;
		end;
	end;
	if clickAreaTable.whereClick == "buttonSeparatorVertical_" or clickAreaTable.whereClick == "buttonSeparatorHorizontal_" and isDown then		
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = "just a separation ";
		end;
		return;	
	elseif clickAreaTable.whereClick == "buttonClose_" and isDown then		
		moDraw.slot:setClose(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "save_" and isDown then		
		moSetGetSlot:setSave(clickAreaTable.whatClick);
		return;	
	elseif clickAreaTable.whereClick == "editSlotName_" and isDown then		
		guiDialog:editSlotName(clickAreaTable.whatClick);		
		return;
	elseif clickAreaTable.whereClick == "buttonSmallView_" and isDown then
		moDraw.slot:setSmallView(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "buttonViewModus_" and isDown then
		moDraw.slot:setViewModus(clickAreaTable.whatClick);
		return;	
	elseif clickAreaTable.whereClick == "settingDefaultLine_" and isDown then		
		moDraw.slot:setSettingDefaultLine(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "settingLineLeft_" and isDown then		
		moSetGetSlot:setSettingLineBounds(clickAreaTable.whatClick, true, false);
		return;
	elseif clickAreaTable.whereClick == "settingLineRight_" and isDown then		
		moSetGetSlot:setSettingLineBounds(clickAreaTable.whatClick, false, true);
		return;	
	elseif clickAreaTable.whereClick == "settingExtraLine_" and isDown then		
		moDraw.slot:setSettingExtraLine(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "settingMaxExtraLine_" and isDown then		
		moSetGetSlot:setSettingMaxExtraLine(clickAreaTable);
		return;	
	elseif clickAreaTable.whereClick == "settingExtraLineLeft_" and isDown then		
		moSetGetSlot:setSettingExtraLineBounds(clickAreaTable, true, false);
		return;
	elseif clickAreaTable.whereClick == "settingExtraLineRight_" and isDown then		
		moSetGetSlot:setSettingExtraLineBounds(clickAreaTable, false, true);
		return;		
	elseif clickAreaTable.whereClick == "settingModLine_" and isDown then		
		moDraw.slot:setSettingModLine(clickAreaTable.whatClick);
		return;	
	elseif clickAreaTable.whereClick == "settingInfoLine_" and isDown then		
		moDraw.slot:setSettingInfoLine(clickAreaTable.whatClick);
		return;	
	elseif clickAreaTable.whereClick == "setting_" and isDown then
		moDraw.slot:setSetting(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "settingCmd_" and isDown then		
		if moSetGetOverlays.slot[clickAreaTable.whatClick].setting.canCmdSettings then
			moHlGuiCmdSetting:setOpen( {typ="Slot", name=clickAreaTable.whatClick} );		
		end;
		return;	
	elseif clickAreaTable.whereClick == "settingZoomIn_" and isDown then		
		moSetGetSlot:setSettingZoomOutIn(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].settingZoomOutIn;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].settingZoomOutIn;
		end;
		return;
	elseif clickAreaTable.whereClick == "settingZoomOut_" and isDown then		
		moSetGetSlot:setSettingZoomOutIn(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].settingZoomOutIn;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].settingZoomOutIn;
		end;
		return;
	elseif clickAreaTable.whereClick == "settingSlotCopyPaste_" and isDown then
		moSetGetSlot:settingCopyPaste(clickAreaTable.whatClick);			
		return;		
	elseif clickAreaTable.whereClick == "helpGlobal_" and isDown then
		moSetGetSlot:setHelp(clickAreaTable.whatClick, true, false);
		return;
	elseif clickAreaTable.whereClick == "helpOutput_" and isDown then
		moSetGetSlot:setHelp(clickAreaTable.whatClick, false, true);
		return;	
	elseif clickAreaTable.whereClick == "outputTxtSizeUp_" and isDown then
		moSetGetSlot:setTxtSize(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = string.format("%1.5f", moSetGetOverlays.slot[clickAreaTable.whatClick].txtSize); 
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = string.format("%1.5f", moSetGetOverlays.slot[clickAreaTable.whatClick].txtSize); 
		end;
		return;
	elseif clickAreaTable.whereClick == "outputTxtSizeDown_" and isDown then
		moSetGetSlot:setTxtSize(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = string.format("%1.5f", moSetGetOverlays.slot[clickAreaTable.whatClick].txtSize);
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = string.format("%1.5f", moSetGetOverlays.slot[clickAreaTable.whatClick].txtSize); 
		end;
		return;
	elseif clickAreaTable.whereClick == "outputDistanceUpHorizontal_" and isDown then
		moSetGetSlot:setTxtLineDistance(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].txtLineDistance;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].txtLineDistance;
		end;
		return;		
	elseif clickAreaTable.whereClick == "outputDistanceDownHorizontal_" and isDown then
		moSetGetSlot:setTxtLineDistance(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].txtLineDistance;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].txtLineDistance;
		end;
		return;
	elseif clickAreaTable.whereClick == "outputTxtWidthFixUp_" and isDown then
		moSetGetSlot:setTxtWidthFix(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].txtWidthFix;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].txtWidthFix;
		end;
		return;
	elseif clickAreaTable.whereClick == "outputTxtWidthFixDown_" and isDown then
		moSetGetSlot:setTxtWidthFix(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].txtWidthFix;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.slot[clickAreaTable.whatClick].txtWidthFix;
		end;
		return;
	elseif clickAreaTable.whereClick == "slotCanCloseAll_" and isDown then
		moSetGetSlot:setCanCloseAll(clickAreaTable.whatClick);
		return;	
	elseif clickAreaTable.whereClick == "deleteSlot_" and isDown then
		moSetGetSlot:deleteSlot(clickAreaTable.whatClick);								
		return;
	elseif clickAreaTable.whereClick == "generateNewSlot_" and isDown then
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["generateNewSlot"] == nil then
			g_currentMission.hl.addTimer({name="generateNewSlot", delay=5, repeatable=false});
		elseif g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["generateNewSlot"] ~= nil then
			if g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then				
				g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = "Cooldown Timer active";
			end;
			return;
		end;
		local slotName = moSetGetSlot:generateOtherSlotName();
		if slotName ~= nil then 
			moSetGetSlot:generateSlot(slotName, slotName, true, false, true);
			moGeneralSettings.isSave = false;
		else
			print("***Error ".. tostring(MultiOverlayV4.metadata.title).. " -Generate Slot(Slot Limit or Name corrupt)- Error***")	
		end;									
		return;	
	elseif clickAreaTable.whereClick == "outputLineBoundsUp_" and isDown then
		clickAreaTable.mouseClick = "MOUSE_BUTTON_LEFT_UP";
		moSetGetSlot:setOutputLineBounds(clickAreaTable);										
		return;
	elseif clickAreaTable.whereClick == "outputLineBoundsDown_" and isDown then
		clickAreaTable.mouseClick = "MOUSE_BUTTON_LEFT_DOWN";
		moSetGetSlot:setOutputLineBounds(clickAreaTable);										
		return;	
	elseif clickAreaTable.whereClick == "settingOutputProductionWarning_" and isDown then		
		moSetGetSlot:setOutputProductionWarning(clickAreaTable.whatClick, 1);										
		return;		
	end;	
end;

function moMouseKeyEventsSlot:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" and isDown then
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;
			clickAreaTable.mouseClick = "MOUSE_BUTTON_RIGHT";
			local canCallback = not clickAreaTable.isMenue and clickAreaTable.slotTable.cmd[clickAreaTable.cmdPos].mouseClick ~= nil and (clickAreaTable.slotTable.cmd[clickAreaTable.cmdPos].mouseClick[3] and clickAreaTable.cmdTable.mouseClickAccepts[3]);
			if not canCallback then canCallback = clickAreaTable.whereClick == "outputLineCallback_";end;
			if clickAreaTable.isMenue or canCallback then
				clickAreaTable.callback(clickAreaTable);
				return;
			end;
		end;
	end;
	if clickAreaTable.whereClick == "settingOutputProductionWarning_" and isDown then		
		moSetGetSlot:setOutputProductionWarning(clickAreaTable.whatClick, 2);										
		return;
	end;	
end;

function moMouseKeyEventsSlot:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" and isDown then
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;
			clickAreaTable.mouseClick = "MOUSE_BUTTON_MIDDLE";
			local canCallback = not clickAreaTable.isMenue and clickAreaTable.slotTable.cmd[clickAreaTable.cmdPos].mouseClick ~= nil and (clickAreaTable.slotTable.cmd[clickAreaTable.cmdPos].mouseClick[2] and clickAreaTable.cmdTable.mouseClickAccepts[2]);
			if not canCallback then canCallback = clickAreaTable.whereClick == "outputLineCallback_";end;
			if clickAreaTable.isMenue or canCallback then
				clickAreaTable.callback(clickAreaTable);
				return;
			end;	
		end;
	end;		
end;

function moMouseKeyEventsSlot:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" then	
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;
			clickAreaTable.mouseClick = "MOUSE_BUTTON_WHEEL_UP";
			clickAreaTable.callback(clickAreaTable);
			return;	
		end;
	end;
	if clickAreaTable.whereClick == "outputLineBoundsScrollUp_" and isDown then
		clickAreaTable.mouseClick = "MOUSE_BUTTON_WHEEL_UP";
		moSetGetSlot:setOutputLineBounds(clickAreaTable);										
		return;	
	end;	
end;

function moMouseKeyEventsSlot:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" then
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;
			clickAreaTable.mouseClick = "MOUSE_BUTTON_WHEEL_DOWN";
			clickAreaTable.callback(clickAreaTable);
			return;	
		end;
	end;
	if clickAreaTable.whereClick == "outputLineBoundsScrollDown_" and isDown then
		clickAreaTable.mouseClick = "MOUSE_BUTTON_WHEEL_DOWN";
		moSetGetSlot:setOutputLineBounds(clickAreaTable);										
		return;	
	end;
end;

function moMouseKeyEventsSlot:setKey(unicode, sym, modifier, isDown)
		
end;
		