moSetGetPda = {};
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawPda.lua");

moSetGetPda.default = {
	design = {byName={}};
	name = "";	
	typ = 1;
	isOtherPda = {on=false, otherDraw=nil, menueCallback=nil, whichPda=nil, isMenue=false, menuePda=""};
	isOpen = true;	
	view = {isModus=1,max=2,[1]={isSmallView=false,boundsLine={0,0,0,0},boundsHeight={0,0,0,0},boundsWidth={0,0,0,0}},[2]={isSmallView=false,boundsLine={0,0,0,0},boundsHeight={0,0,0,0},boundsWidth={0,0,0,0}}};
	isWarning = false;
	isUp = false;
	help = {globalOn=false,globalTxt=""};
	autoClose = {false, 0}; --1 close, 2 close timer sec !free
	setting = {
		canCloseAll = true;
		distanceIconHeight = 3;
		distanceIconWidth = 3;
		distanceEdgeWidth = 2;
		up = false;
		on = false;				
		deletePda = false;
		editPdaName = true;		
		generateCallback = {};
		deleteCallback = {};
		openCallback = {};
		
		defaultLine = true;
		maxDefaultLine = 1;
		defaultIconLineBounds = {0,0,0,0,0};
		defaultIcon = {};
		
		settingLine = true; 
		maxSettingLine = 1; 
		modIcon = {};		
		settingIcon = {		
			[1]={name="free", txt="M", txtPdaColor="settingDefault", infoTxt="this Menue Setting"};			
			[2]={name="buttonZoomOut", areaName="settingZoomOut", onOpen=moDraw.pda.iconColor, infoTxt="Zoom Out this Menue"};
			[3]={name="buttonZoomIn", areaName="settingZoomIn", onOpen=moDraw.pda.iconColor, infoTxt="Zoom In this Menue"};			
			[4]={name="buttonSeparatorVertical", onOpen=moDraw.pda.iconColor};			
			[5]={name="free", txt="F", txtPdaColor="settingDefault", infoTxt="Pda Frame Setting"};			
			[6]={name="buttonZoomOut", areaName="pdaFrameZoomOut", onOpen=moDraw.pda.iconColor, infoTxt="Zoom Out this Pda Frame"};
			[7]={name="buttonZoomIn", areaName="pdaFrameZoomIn", onOpen=moDraw.pda.iconColor, infoTxt="Zoom In this Pda Frame"};			
			[8]={name="buttonCanCloseAll", areaName="pdaCanCloseAll", onOpen=moDraw.pda.iconColor, infoTxt="Stop Close by Cmd Close All"};			
			[9]={name="buttonSeparatorVertical", onOpen=moDraw.pda.iconColor};						
			[10]={name="buttonGenerate", areaName="generateNewPda", onOpen=moDraw.pda.iconColor, infoTxt="Generate New Pda"};
			[11]={name="buttonCopyPaste", areaName="settingPdaCopyPaste", onOpen=moDraw.pda.iconColor, infoTxt="Copy this Menue/Frame Values(not Pda/Apps)"};
			[12]={name="buttonDelete", areaName="deletePda", onOpen=moDraw.pda.iconColor, infoTxt="Delete this Pda(Click here 2x)cancel timer"};
			[13]={name="buttonSeparatorVertical", onOpen=moDraw.pda.iconColor};			
		};		
		settingIconLineBounds = {0,0,0,0,0};		
		
		infoLine = false; --for help info etc.		
		maxInfoLine = 1; 
				
		extraLine = true; 
		extraLineMultiple = true; -- false not implement
		maxExtraLine = 1; 		
		extraIconLine = {
			[1]= {
				view=false;
				bounds={0,0,0,0,0};
				modName="MultiOverlayV4";
				icon = {
					[1]={modName="MultiOverlayV4", name="free", txt="A", txtPdaColor="settingDefault", infoTxt="Pda App Setting"};
					[2]={modName="MultiOverlayV4", name="buttonZoomOut", areaName="pdaAppIconZoomOut", onOpen=moDraw.pda.iconColor, infoTxt="Zoom Out App Icons"};
					[3]={modName="MultiOverlayV4", name="buttonZoomIn", areaName="pdaAppIconZoomIn", onOpen=moDraw.pda.iconColor, infoTxt="Zoom In App Icons"};	
					[4]={modName="MultiOverlayV4", name="buttonDistanceUpVertical", areaName="pdaAppIconDistanceWidthUp", onOpen=moDraw.pda.iconColor, infoTxt="Distance Width Up"};
					[5]={modName="MultiOverlayV4", name="buttonDistanceDownVertical", areaName="pdaAppIconDistanceWidthDown", onOpen=moDraw.pda.iconColor, infoTxt="Distance Width Down"};
					[6]={modName="MultiOverlayV4", name="buttonDistanceUpHorizontal", areaName="pdaAppIconDistanceHeightUp", onOpen=moDraw.pda.iconColor, infoTxt="Distance Height Up"};
					[7]={modName="MultiOverlayV4", name="buttonDistanceDownHorizontal", areaName="pdaAppIconDistanceHeightDown", onOpen=moDraw.pda.iconColor, infoTxt="Distance Height Down"};
					[8]={modName="MultiOverlayV4", name="buttonTxtWidthFixUp", areaName="pdaAppIconTxtWidthFixUp", onOpen=moDraw.pda.iconColor, infoTxt="Fix Dif. Text Length Up"};
					[9]={modName="MultiOverlayV4", name="buttonTxtWidthFixDown", areaName="pdaAppIconTxtWidthFixDown", onOpen=moDraw.pda.iconColor, infoTxt="Fix Dif. Text Length Down"};
					[10]={modName="MultiOverlayV4", name="buttonSeparatorVertical", onOpen=moDraw.pda.iconColor};
				};
			};
		
		};
		extraIconLineBounds = {0,0,0,0,0}; --for not extraLineMultiple
	};	
	color = {settingOn="green",settingOff="red",settingReady="yellow",settingDefault="gray",settingActiveCmd="green",settingAlreadyExistsCmd="darkYellow",txtExtra="ls15", txtOutputTitle="khaki",txt="black",ground="white",txtTitle="orange",txtMarker="orange",selectMarker="darkBlue"};	
	colorProzent = g_currentMission.hl.colorProzent;
	
	minFrameZoomOutIn = 10;
	maxFrameZoomOutIn = 24;
	defaultFrameZoomOutIn = 20;
	frameZoomOutIn = 20;
	frameZoomOutInLV = 1;
	
	minAppIconZoomOutIn = 35;
	maxAppIconZoomOutIn = 60;
	defaultAppIconZoomOutIn = 45;
	appIconZoomOutIn = 45;
	appIconZoomOutInLV = 1;
	appOptiSizeTxtHeight = 0;
	appOptiSizeHalfTxtHeight = 0;
	
	minDistanceAppIconWidth = 1;
	maxDistanceAppIconWidth = 10;
	defaultDistanceAppIconWidth = 5;
	distanceAppIconWidth = 5;
	distanceAppIconWidthLV = 1;
	
	minDistanceAppIconHeight = 1;
	maxDistanceAppIconHeight = 10;
	defaultDistanceAppIconHeight = 5;
	distanceAppIconHeight = 5;
	distanceAppIconHeightLV = 1;
	
	minSettingZoomOutIn = 15;
	maxSettingZoomOutIn = 24;
	defaultSettingZoomOutIn = 20;
	settingZoomOutIn = 20;
	settingZoomOutInLV = 1;	
	
	minTxtSize = 0.008;
	maxTxtSize = 0.020;	
	defaultTxtSize = 0.010;
	txtSize = 0.010;
	txtSizeLV = 0.00025;
	
	minTxtLineDistance = 0.5;
	maxTxtLineDistance = 5;
	defaultTxtLineDistance = 2;
	txtLineDistance = 2;
	txtLineDistanceLV = 0.5;
	
	minTxtWidthFix = -3;
	maxTxtWidthFix = 3;
	defaultTxtWidthFix = 0;
	txtWidthFix = 0;	
	txtWidthFixLV = 1;
	
	minTransparent = 0.2;
	maxTransparent = 1.0;
	defaultTransparent = 0.8;
	transparent = 0.8;
	transparentLV = 0.1;
	
	posX = {default=0.44,[1]=0.44,[2]=0.44};
	posY = {default=0.6,[1]=0.6,[2]=0.6};
	width = {zoomOutIn=1.2,default=0,[1]=0,[2]=0};
	height = {zoomOutIn=1.2,default=0,[1]=0,[2]=0};
		
	selectApp = {0,0};	
	apps = {};
	output = {};	
	maxNotScrollLine = 0;
	cmdSettings = {openGroup={},viewActiveCmd=true,viewAlreadyExistsCmd=true,moveUp=true,distanceObject=10,viewDistanceObjectCmd=false,bounds={0,0,0,0},width=0,height=0};
	appIconSettings = {bounds={0,0,0,0},width=0,height=0,openMod="MultiOverlayV4",openGroup="animals",selectIcon=1};
};

function moSetGetPda:generateDummyPdas()
	moAutoGeneratePda:generatePda("firstLoadPdas_"); --first start MultiOverlayV4
end;

function moSetGetPda:generatePda(whichPda, name, whichPda_otherName, menue, copyPaste)
	local whichSubPda = whichPda or "dummyPda_";	
	if not string.find(whichSubPda, "_", string.len(whichSubPda)-1) then whichSubPda = whichSubPda.. "_";end; 
	if moSetGetOverlays.pda[whichSubPda] ~= nil and (whichPda_otherName == nil or not whichPda_otherName) then return false, "whichPda name not free";end;
	if moSetGetOverlays.pda[whichSubPda] ~= nil and whichPda_otherName then	
		whichSubPda = moSetGetPda:generateOtherPdaName();
		if whichSubPda == nil then return false, "not found other name slavePda1_ - slavePda100_";end;
		if utf8Strlen(utf8Substr(name, 0)) < 2 then name = whichSubPda;end;
	end;
	moSetGetOverlays.pda[whichSubPda] = g_currentMission.hl.getTableCopy(moSetGetPda.default);
	moSetGetOverlays:loadDefaultPdaIcons(whichSubPda);
	moSetGetOverlays.pda[whichSubPda].name = name or "Unknown";	
	if menue == nil or not menue then
		if copyPaste ~= nil and copyPaste then
			--auto copy/paste from the first Slot
			moSetGetPda:settingCopyPaste(moSetGetPda:getOnePdaName(whichSubPda)); --copy
			moSetGetPda:settingCopyPaste(whichSubPda); --paste
			--auto copy/paste from the first Slot
		end;
		moSetGetPda:setWidthHeight(whichSubPda);
		if #moSetGetPda.default.setting.generateCallback > 0 then
			for a=1, #moSetGetPda.default.setting.generateCallback do
				if type(moSetGetPda.default.setting.generateCallback[a]) == "function" then
					moSetGetPda.default.setting.generateCallback[a]( {whichPda=whichSubPda} );
				end;
			end;
		end;
		moSetGetCmd:setOpenClosePdaCmd(whichSubPda);	
	end;	
	return true, whichSubPda;
end;

function moSetGetPda:getOnePdaName(whichPda)	
	local whichSubPda = whichPda or "dummyPda_";
	local pdas = {};	
	if moSetGetOverlays.pda ~= nil then		
		for pdaName, pdaTable in pairs(moSetGetOverlays.pda) do			
			if whichSubPda ~= tostring(pdaName) then
				return pdaName;
			end;
		end;		
	end;	
	return "";
end;

function moSetGetPda:getPdas()	
	local pdas = {};	
	if moSetGetOverlays.pda ~= nil then		
		for pdaName, pdaTable in pairs(moSetGetOverlays.pda) do			
			pdas[#pdas+1] = tostring(pdaName);			
		end;		
	end;
	return pdas;
end;

function moSetGetPda:getPdaTable(whichPda)	
	if whichPda == nil or moSetGetOverlays.pda[whichPda] == nil then return nil;end;
	return moSetGetOverlays.pda[whichPda];
end;

function moSetGetPda:generateOtherPdaName()	
	for a=1, 100 do
		if moSetGetOverlays.pda["slavePda".. a.. "_"] == nil then return "slavePda".. a.. "_";end;
	end;
	return nil;
end;

function moSetGetPda:setWidthHeight(whichPda, pdaTable)
	local whichSubPda = whichPda or "dummyPda_";
	if pdaTable == nil then
		if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
		pdaTable = moSetGetOverlays.pda[whichSubPda];
		if pdaTable.width.default == 0 or pdaTable.width[1] == 0 or pdaTable.height.default == 0 or pdaTable.height[1] == 0 then
			pdaTable.width.default = (moSetGetOverlays.buttonGfxWidth1*pdaTable.appIconZoomOutIn)*pdaTable.width.zoomOutIn;
			pdaTable.height.default = (moSetGetOverlays.buttonGfxHeight1*pdaTable.appIconZoomOutIn)*pdaTable.height.zoomOutIn;
			for a=1, pdaTable.view.max do
				pdaTable.width[a] = pdaTable.width.default;				
				pdaTable.height[a] = pdaTable.height.default;				
			end;
		end;
		moSetGetPda:refreshAppOptiSize(whichSubPda);
	else
		if pdaTable.width.default == 0 then pdaTable.width.default = (moSetGetOverlays.buttonGfxWidth1*pdaTable.appIconZoomOutIn)*pdaTable.width.zoomOutIn;end;
		if pdaTable.height.default == 0 then pdaTable.height.default = (moSetGetOverlays.buttonGfxHeight1*pdaTable.appIconZoomOutIn)*pdaTable.height.zoomOutIn;end;
		for a=1, pdaTable.view.max do
			if pdaTable.width[a] < pdaTable.width.default then pdaTable.width[a] = pdaTable.width.default;end;
			if pdaTable.height[a] < pdaTable.height.default then pdaTable.height[a] = pdaTable.height.default;end;		
		end;
		moSetGetPda:refreshAppOptiSize(whichSubPda);
	end;
end;

function moSetGetPda:setSave(whichPda, state)
	if state ~= nil then moGeneralSettings.isSave = state;return;end;
	if not moGeneralSettings.isSave then 
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then
			if #moSetGetOverlays.pda[whichPda].setting.deleteCallback > 0 then
				for a=1, #moSetGetOverlays.pda[whichPda].setting.deleteCallback do
					if type(moSetGetOverlays.pda[whichPda].setting.deleteCallback[a]) == "function" then
						moSetGetOverlays.pda[whichPda].setting.deleteCallback[a]( {whichPda=whichPda} );
					end;
				end;
			end;
		end;		
		moXmlSettings:saveXml();		
	end;		
end;

function moSetGetPda:setCanCloseAll(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	moSetGetOverlays.pda[whichSubPda].setting.canCloseAll = not moSetGetOverlays.pda[whichSubPda].setting.canCloseAll;
	moGeneralSettings.isSave = false;
end;

function moSetGetPda:getHighestLine(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return 0;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	local minLine = 0;	
	function findHighestLine(table)
	    local highestLine = 0;
	    for n, _ in pairs(table) do
	        if n > minLine then
	            minLine = n;
	            highestLine = n;
	        end;
	    end;
	    return highestLine;
	end;
	if pdaTable.apps == nil then return 0;end;
	return findHighestLine(pdaTable.apps);
end;

function moSetGetPda:getHighestLineApp(whichPda, line)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return 0;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	local minApp = 0;	
	function findHighestApp(table)
	    local highestApp = 0;
	    for n, _ in pairs(table) do
	        if n > minApp then
	            minApp = n;
	            highestApp = n;
	        end;
	    end;
	    return highestApp;
	end;
	if pdaTable.apps == nil or pdaTable.apps[line] == nil then return 0;end;
	return findHighestApp(pdaTable.apps[line]);
end;

function moSetGetPda:getHighestTotal(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return 0;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	local highestLine = moSetGetPda:getHighestLine(whichSubPda);
	local highestApp = 0;
	if highestLine > 0 then
		for line=1, highestLine do
			if pdaTable.apps[line] ~= nil then
				local highestAppTemp = moSetGetPda:getHighestLineApp(whichSubPda, line)
				if highestAppTemp > highestApp then highestApp = highestAppTemp;end;
			end;
		end;
	end;
	return highestLine, highestApp;
end;

function moSetGetPda:settingCopyPaste(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];	
	if #moSetGetOverlays.pdaSettingCopyPaste > 0 then
		if moSetGetOverlays.pdaSettingCopyPaste[1].pdaName == whichSubPda then 
			moSetGetOverlays.pdaSettingCopyPaste[1] = nil;
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."SettingLine"] ~= nil then
				g_currentMission.hl.timers[whichSubPda.."SettingLine"].ownTable.infoTxt = "Cancel"; 
			end;
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."infoLine"] ~= nil then
				g_currentMission.hl.timers[whichSubPda.."infoLine"].repeatable = 2;
				g_currentMission.hl.timers[whichSubPda.."infoLine"].ownTable.infoTxt = "Cancel"; 
			end
			g_currentMission.hl.removeTimer("settingCopyPastePda");
		else
			pdaTable.color = moSetGetOverlays.pdaSettingCopyPaste[1].color;
			pdaTable.settingZoomOutIn = moSetGetOverlays.pdaSettingCopyPaste[1].settingZoomOutIn;
			pdaTable.txtSize = moSetGetOverlays.pdaSettingCopyPaste[1].txtSize;
			pdaTable.txtLineDistance = moSetGetOverlays.pdaSettingCopyPaste[1].txtLineDistance;
			pdaTable.txtWidthFix = moSetGetOverlays.pdaSettingCopyPaste[1].txtWidthFix;
			
			pdaTable.frameZoomOutIn = moSetGetOverlays.pdaSettingCopyPaste[1].frameZoomOutIn;
			pdaTable.appIconZoomOutIn = moSetGetOverlays.pdaSettingCopyPaste[1].appIconZoomOutIn;
			pdaTable.distanceAppIconWidth = moSetGetOverlays.pdaSettingCopyPaste[1].distanceAppIconWidth;
			pdaTable.distanceAppIconHeight = moSetGetOverlays.pdaSettingCopyPaste[1].distanceAppIconHeight;
			pdaTable.appOptiSizeTxtHeight = moSetGetOverlays.pdaSettingCopyPaste[1].appOptiSizeTxtHeight;
			pdaTable.appOptiSizeHalfTxtHeight = moSetGetOverlays.pdaSettingCopyPaste[1].appOptiSizeHalfTxtHeight;
			
			--pdaTable.posX[1] = moSetGetOverlays.pdaSettingCopyPaste[1].posX1;
			--pdaTable.posY[1] = moSetGetOverlays.pdaSettingCopyPaste[1].posY1;
			--pdaTable.posX[2] = moSetGetOverlays.pdaSettingCopyPaste[1].posX2;
			--pdaTable.posY[2] = moSetGetOverlays.pdaSettingCopyPaste[1].posY2;
			moSetGetOverlays.pdaSettingCopyPaste[1] = nil;
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."SettingLine"] ~= nil then
				g_currentMission.hl.timers[whichSubPda.."SettingLine"].ownTable.infoTxt = "Paste"; 
			end;
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."infoLine"] ~= nil then
				g_currentMission.hl.timers[whichSubPda.."infoLine"].repeatable = 2;
				g_currentMission.hl.timers[whichSubPda.."infoLine"].ownTable.infoTxt = "Paste"; 
			end;
			moSetGetPda:resetSettingLinesBounds(whichSubPda);
			moSetGetPda:refreshAppOptiSize(whichSubPda);			
			moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);			
			moSetGetPda:resetLineAppBounds(whichSubPda);
			moGeneralSettings.isSave = false;			
		end;
	else
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["settingCopyPastePda"] == nil then
			g_currentMission.hl.addTimer({name="settingCopyPastePda", delay=5, repeatable=false, action=moSetGetPda.deleteSettingCopyPaste, ownTable={whichPda=whichSubPda}});
		else
			g_currentMission.hl.removeTimer("settingCopyPastePda");
		end;
		moSetGetOverlays.pdaSettingCopyPaste[1] = {};
		moSetGetOverlays.pdaSettingCopyPaste[1].pdaName = tostring(whichSubPda);
		moSetGetOverlays.pdaSettingCopyPaste[1].color = pdaTable.color;
		moSetGetOverlays.pdaSettingCopyPaste[1].settingZoomOutIn = pdaTable.settingZoomOutIn;
		moSetGetOverlays.pdaSettingCopyPaste[1].txtSize = pdaTable.txtSize;
		moSetGetOverlays.pdaSettingCopyPaste[1].txtLineDistance = pdaTable.txtLineDistance;
		moSetGetOverlays.pdaSettingCopyPaste[1].txtWidthFix = pdaTable.txtWidthFix;
		
		moSetGetOverlays.pdaSettingCopyPaste[1].frameZoomOutIn = pdaTable.frameZoomOutIn;
		moSetGetOverlays.pdaSettingCopyPaste[1].appIconZoomOutIn = pdaTable.appIconZoomOutIn;
		moSetGetOverlays.pdaSettingCopyPaste[1].distanceAppIconWidth = pdaTable.distanceAppIconWidth;
		moSetGetOverlays.pdaSettingCopyPaste[1].distanceAppIconHeight = pdaTable.distanceAppIconHeight;
		moSetGetOverlays.pdaSettingCopyPaste[1].appOptiSizeTxtHeight = pdaTable.appOptiSizeTxtHeight;
		moSetGetOverlays.pdaSettingCopyPaste[1].appOptiSizeHalfTxtHeight = pdaTable.appOptiSizeHalfTxtHeight;		
		--moSetGetOverlays.pdaSettingCopyPaste[1].posX1 = pdaTable.posX[1];
		--moSetGetOverlays.pdaSettingCopyPaste[1].posY1 = pdaTable.posY[1];
		--moSetGetOverlays.pdaSettingCopyPaste[1].posX2 = pdaTable.posX[2];
		--moSetGetOverlays.pdaSettingCopyPaste[1].posY2 = pdaTable.posY[2];
		moSetGetOverlays.pdaSettingCopyPaste[1].largePosX = pdaTable.posX.largeManu;
		moSetGetOverlays.pdaSettingCopyPaste[1].largePosY = pdaTable.posY.largeManu;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."SettingLine"] ~= nil then
			g_currentMission.hl.timers[whichSubPda.."SettingLine"].ownTable.infoTxt = "Copy (Click at other Pda)"; 
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."infoLine"] ~= nil then
			g_currentMission.hl.timers[whichSubPda.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[whichSubPda.."infoLine"].ownTable.infoTxt = "Copy (Click at other Pda)"; 
		end;
	end;		
end;

function moSetGetPda.deleteSettingCopyPaste(args) --timer action callback 
	if args == nil or type(args) ~= "table" then return;end;		
	if #moSetGetOverlays.pdaSettingCopyPaste > 0 then			
		moSetGetOverlays.pdaSettingCopyPaste[1] = nil;
	end;	
end;

function moSetGetPda:deletePda(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;	
	if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."SettingLine"] ~= nil then
		if whichSubPda ~= "dummyPda_" and not moSetGetOverlays.pda[whichSubPda].setting.deletePda then
			g_currentMission.hl.timers[whichSubPda.."SettingLine"].ownTable.infoTxt = "! safely delete !";
		else
			g_currentMission.hl.timers[whichSubPda.."SettingLine"].ownTable.infoTxt = "! dummy cannot be deleted !";
		end;
	end;
	if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."infoLine"] ~= nil then
		if whichSubPda ~= "dummyPda_" and not moSetGetOverlays.pda[whichSubPda].setting.deletePda then
			g_currentMission.hl.timers[whichSubPda.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[whichSubPda.."infoLine"].ownTable.infoTxt = "! safely delete !";
		else
			g_currentMission.hl.timers[whichSubPda.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[whichSubPda.."infoLine"].ownTable.infoTxt = "! dummy cannot be deleted !";
		end;
	end;
	if whichSubPda ~= "dummyPda_" and not moSetGetOverlays.pda[whichSubPda].setting.deletePda then		
		moSetGetOverlays.pda[whichSubPda].setting.deletePda = true;
		g_currentMission.hl.removeTimer("settingCopyPasteSlot");
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."deletePda"] == nil then
			g_currentMission.hl.addTimer({name=whichSubPda.."deletePda", delay=4, repeatable=false, action=moSetGetPda.isDeletePda, ownTable={infoTxt="",whichPda=whichSubPda}});
		end;
	elseif moSetGetOverlays.pda[whichSubPda].setting.deletePda and whichSubPda ~= "dummyPda_" then
		moDraw.pda:setClose(whichSubPda);
		if #moSetGetOverlays.pda[whichSubPda].setting.deleteCallback > 0 then
			for a=1, #moSetGetOverlays.pda[whichSubPda].setting.deleteCallback do
				if type(moSetGetOverlays.pda[whichSubPda].setting.deleteCallback[a]) == "function" then
					moSetGetOverlays.pda[whichSubPda].setting.deleteCallback[a]( {whichPda=whichSubPda} );
				end;
			end;
		end;
		moSetGetOverlays:deletePdaIcons(whichSubPda);
		moDraw.pda:setCmdSettingMenue(whichSubPda, false);
		moDraw.pda:setAppIconSettingMenue(whichSubPda, "", true);		
		moSetGetOverlays.pda[whichSubPda].cmd = {};
		moSetGetOverlays.pda[whichSubPda].output = {};
		if MultiOverlayV4.cmdSetting.selectCmd[1] ~= nil then MultiOverlayV4.cmdSetting.selectCmd[1] = nil;end;
		moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="outputAction_".. whichSubPda} );
		moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_".. whichSubPda} );
		moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_open_".. whichSubPda} );
		moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_close_".. whichSubPda} );
		moSetGetOverlays.pda[whichSubPda] = nil;
		moGeneralSettings.isSave = false;
		moSetGetProfilXML:deleteXml(whichSubPda, "profilXML", "PDA");
	end;
end;

function moSetGetSlot.isDeletePda(args) --timer action callback
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.whichPda == nil then return;end;				
	local whichSubPda = args.ownTable.whichPda;
	if moSetGetOverlays.pda[whichSubPda] ~= nil then
		moSetGetOverlays.pda[whichSubPda].setting.deletePda = false;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."SettingLine"] ~= nil then
			g_currentMission.hl.timers[whichSubPda.."SettingLine"].ownTable.infoTxt = "! cancel delete !";
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubPda.."infoLine"] ~= nil then
			g_currentMission.hl.timers[whichSubPda.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[whichSubPda.."infoLine"].ownTable.infoTxt = "! cancel delete !";
		end;
	end;	
end;

function moSetGetPda:generateApp(args, copyPasteApp)
	if args == nil or type(args) ~= "table" or args.appValue == nil or args.whatClick == nil then return nil;end;
	local pdaTable = moSetGetOverlays.pda[args.whatClick];
	if pdaTable == nil then return nil;end;
	local insertApp = false;
	local appLine = args.appValue[1];
	local appPos = args.appValue[2];
	if appLine == nil or appLine <=0 or appPos == nil or appPos <= 0 then return nil;end;
	if pdaTable.apps[appLine] == nil then pdaTable.apps[appLine] = {};end;
	if pdaTable.apps[appLine][appPos] == nil then 
		pdaTable.apps[appLine][appPos] = {cmd={},icon={}};	
	else
		insertApp = true;
		table.insert(pdaTable.apps[appLine], appPos, {cmd={},icon={}});
	end;	
	moGeneralSettings.isSave = false;
	return true, insertApp;
end;

function moSetGetPda:deleteApp(args)
	if args == nil or type(args) ~= "table" or args.appValue == nil or args.whatClick == nil then return nil;end;
	local pdaTable = moSetGetOverlays.pda[args.whatClick];
	if pdaTable == nil then return nil;end;
	local appLine = args.appValue[1];
	local appPos = args.appValue[2];
	if appLine == nil or appLine <=0 or appPos == nil or appPos <= 0 then return nil;end;
	moHlGuiCmdSetting:setClose();
	if pdaTable.apps[appLine] ~= nil and pdaTable.apps[appLine][appPos] ~= nil then
		--moSetGetPda:deleteAppIcon(args);		
		moHlGuiAppIconSetting:deleteIcon(args)
		pdaTable.apps[appLine][appPos] = nil;		
	elseif pdaTable.apps[appLine] ~= nil and pdaTable.apps[appLine][appPos] == nil then
		pdaTable.apps[appLine][appPos] = {};
		table.remove(pdaTable.apps[appLine], appPos);
	end;
	local highestApp = moSetGetPda:getHighestLineApp(args.whatClick, appLine);
	if highestApp == 0 then pdaTable.apps[appLine] = nil;end;
	moGeneralSettings.isSave = false;
	return nil;
end;

function moSetGetPda:addAppIconLoadChange()
	if #moSetGetOverlays.appIconLoadChange > 0 then
		if moSetGetOverlays.previewIcons["MultiOverlayV4"] == nil then moSetGetOverlays:loadPreviewIcons();end;
		for a=1, #moSetGetOverlays.appIconLoadChange do
			local whichPda = moSetGetOverlays.appIconLoadChange[a].whichPda;
			local modName = moSetGetOverlays.appIconLoadChange[a].modName;
			local groupName = moSetGetOverlays.appIconLoadChange[a].groupName;
			local iconPlace = moSetGetOverlays.appIconLoadChange[a].iconPlace;
			local appValue = moSetGetOverlays.appIconLoadChange[a].appValue;
			if moSetGetOverlays.previewIcons[modName] ~= nil and moSetGetOverlays.previewIcons[modName][groupName] ~= nil and moSetGetOverlays.previewIcons[modName][groupName][iconPlace] ~= nil then 
				if moSetGetOverlays.pda[whichPda].apps[appValue[1]][appValue[2]].icon[1] == nil then
					local iconFile = moSetGetOverlays.previewIcons[modName][groupName][iconPlace];										
					local saveArgsNew = g_currentMission.hl.getTableCopy(iconFile.saveArgs);
					saveArgsNew.loadIcons={iconPlace};saveArgsNew.previewIcons=nil;saveArgsNew.whichPda=tostring(whichPda);saveArgsNew.appIcon={appValue[1],appValue[2]};
					local firstIcon, endIcon = moSetGetOverlays:loadIcons(saveArgsNew);
					if firstIcon ~= nil and endIcon ~= nil then moSetGetOverlays.pda[whichPda].apps[appValue[1]][appValue[2]].icon.loadChange = nil;end;
				end;
			end;
		end;
		moSetGetOverlays.appIconLoadChange = {};
		moSetGetOverlays:deletePreviewIcons();
	end;	
end;

function moSetGetPda:setSettingZoomOutIn(whichPda, up, down, reset)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	if reset then moGeneralSettings.isSave = false;pdaTable.settingZoomOutIn = pdaTable.defaultSettingZoomOutIn;moSetGetPda:resetSettingLinesBounds(whichSubPda);return;end;
	if up then
		if pdaTable.settingZoomOutIn+pdaTable.settingZoomOutInLV > pdaTable.maxSettingZoomOutIn then return;end;
		pdaTable.settingZoomOutIn = pdaTable.settingZoomOutIn+pdaTable.settingZoomOutInLV;
		moGeneralSettings.isSave = false;
		moSetGetPda:resetSettingLinesBounds(whichSubPda);
	elseif down then
		if pdaTable.settingZoomOutIn-pdaTable.settingZoomOutInLV < pdaTable.minSettingZoomOutIn then return;end;
		pdaTable.settingZoomOutIn = pdaTable.settingZoomOutIn-pdaTable.settingZoomOutInLV;
		moGeneralSettings.isSave = false;
		moSetGetPda:resetSettingLinesBounds(whichSubPda);
	end;
end;

function moSetGetPda:setFrameZoomOutIn(whichPda, up, down, reset)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	if reset then moGeneralSettings.isSave = false;pdaTable.frameZoomOutIn = pdaTable.defaultFrameZoomOutIn;moSetGetPda:resetSettingLinesBounds(whichSubPda);return;end;
	if up then
		if pdaTable.frameZoomOutIn+pdaTable.frameZoomOutInLV > pdaTable.maxFrameZoomOutIn then return;end;
		pdaTable.frameZoomOutIn = pdaTable.frameZoomOutIn+pdaTable.frameZoomOutInLV;
		moGeneralSettings.isSave = false;
		moSetGetPda:resetSettingLinesBounds(whichSubPda)
	elseif down then
		if pdaTable.frameZoomOutIn-pdaTable.frameZoomOutInLV < pdaTable.minFrameZoomOutIn then return;end;
		pdaTable.frameZoomOutIn = pdaTable.frameZoomOutIn-pdaTable.frameZoomOutInLV;
		moGeneralSettings.isSave = false;
		moSetGetPda:resetSettingLinesBounds(whichSubPda)
	end;
end;

function moSetGetPda:setAppIconZoomOutIn(whichPda, up, down, reset)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	if reset then moGeneralSettings.isSave = false;pdaTable.appIconZoomOutIn = pdaTable.defaultAppIconZoomOutIn;moSetGetPda:resetLineAppBounds(whichSubPda);moSetGetPda:refreshAppOptiSize(whichSubPda);moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);return;end;
	if up then
		if pdaTable.appIconZoomOutIn+pdaTable.appIconZoomOutInLV > pdaTable.maxAppIconZoomOutIn then return;end;
		pdaTable.appIconZoomOutIn = pdaTable.appIconZoomOutIn+pdaTable.appIconZoomOutInLV;
		moGeneralSettings.isSave = false;		
		moSetGetPda:refreshAppOptiSize(whichSubPda);
		moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);
		moSetGetPda:resetLineAppBounds(whichSubPda);
	elseif down then
		if pdaTable.appIconZoomOutIn-pdaTable.appIconZoomOutInLV < pdaTable.minAppIconZoomOutIn then return;end;
		pdaTable.appIconZoomOutIn = pdaTable.appIconZoomOutIn-pdaTable.appIconZoomOutInLV;
		moGeneralSettings.isSave = false;		
		moSetGetPda:refreshAppOptiSize(whichSubPda);
		moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);
		moSetGetPda:resetLineAppBounds(whichSubPda);
	end;	
end;

function moSetGetPda:setAppIconDistanceWidth(whichPda, up, down, reset)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	if reset then moGeneralSettings.isSave = false;pdaTable.distanceAppIconWidth = pdaTable.defaultDistanceAppIconWidth;moSetGetPda:resetLineAppBounds(whichSubPda);moSetGetPda:refreshAppOptiSize(whichSubPda);moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);return;end;
	if up then
		if pdaTable.distanceAppIconWidth+pdaTable.distanceAppIconWidthLV > pdaTable.maxDistanceAppIconWidth then return;end;
		pdaTable.distanceAppIconWidth = pdaTable.distanceAppIconWidth+pdaTable.distanceAppIconWidthLV;
		moGeneralSettings.isSave = false;
		moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);
		moSetGetPda:resetLineAppBounds(whichSubPda);
	elseif down then
		if pdaTable.distanceAppIconWidth-pdaTable.distanceAppIconWidthLV < pdaTable.minDistanceAppIconWidth then return;end;
		pdaTable.distanceAppIconWidth = pdaTable.distanceAppIconWidth-pdaTable.distanceAppIconWidthLV;
		moGeneralSettings.isSave = false;
		moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);
		moSetGetPda:resetLineAppBounds(whichSubPda);
	end;
end;

function moSetGetPda:setAppIconDistanceHeight(whichPda, up, down, reset)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	if reset then moGeneralSettings.isSave = false;pdaTable.distanceAppIconHeight = pdaTable.defaultDistanceAppIconHeight;moSetGetPda:resetLineAppBounds(whichSubPda);moSetGetPda:refreshAppOptiSize(whichSubPda);moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);return;end;
	if up then
		if pdaTable.distanceAppIconHeight+pdaTable.distanceAppIconHeightLV > pdaTable.maxDistanceAppIconHeight then return;end;
		pdaTable.distanceAppIconHeight = pdaTable.distanceAppIconHeight+pdaTable.distanceAppIconHeightLV;
		moGeneralSettings.isSave = false;
		moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);
		moSetGetPda:resetLineAppBounds(whichSubPda);
	elseif down then
		if pdaTable.distanceAppIconHeight-pdaTable.distanceAppIconHeightLV < pdaTable.minDistanceAppIconHeight then return;end;
		pdaTable.distanceAppIconHeight = pdaTable.distanceAppIconHeight-pdaTable.distanceAppIconHeightLV;
		moGeneralSettings.isSave = false;
		moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);
		moSetGetPda:resetLineAppBounds(whichSubPda);
	end;
end;

function moSetGetPda:setAppIconTxtWidthFix(whichPda, up, down, reset)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	if reset then moGeneralSettings.isSave = false;pdaTable.txtWidthFix = pdaTable.defaultTxtWidthFix;moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);return;end;
	if up then
		if pdaTable.txtWidthFix+pdaTable.txtWidthFixLV > pdaTable.maxTxtWidthFix then return;end;
		pdaTable.txtWidthFix = pdaTable.txtWidthFix+pdaTable.txtWidthFixLV;
		moGeneralSettings.isSave = false;
		moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);
	elseif down then
		if pdaTable.txtWidthFix-pdaTable.txtWidthFixLV < pdaTable.minTxtWidthFix then return;end;
		pdaTable.txtWidthFix = pdaTable.txtWidthFix-pdaTable.txtWidthFixLV;
		moGeneralSettings.isSave = false;
		moSetGetOverlays:refreshAppIconFormatTxt(whichSubPda);
	end;
end;

function moSetGetPda:refreshAppOptiSize(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];	
	local optiSize = MultiOverlayV4:get_hl("optiHeightSize", {moSetGetOverlays.buttonGfxHeight1*pdaTable.appIconZoomOutIn, "Äg", pdaTable.maxTxtSize}, "moSetGetPda:refreshAppOptiSize");
	local optiSizeHalf = MultiOverlayV4:get_hl("optiHeightSize", {moSetGetOverlays.buttonGfxHeight1*pdaTable.appIconZoomOutIn/2, "Äg", pdaTable.maxTxtSize}, "moSetGetPda:refreshAppOptiSize");
	pdaTable.appOptiSizeTxtHeight = optiSize;
	pdaTable.appOptiSizeHalfTxtHeight = optiSizeHalf;
end;

function moSetGetPda:setLineAppsBoundsClick(whichPda, left, right, up, down) --disabled, is bugi
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];	
	local boundTable = nil;
	if left or right then boundTable = pdaTable.view[pdaTable.view.isModus].boundsWidth;end;
	if up or down then boundTable = pdaTable.view[pdaTable.view.isModus].boundsHeight;end;
	
		if up then
			if boundsTable[1] == 1 then return;end;
			local tempBounds1 = boundsTable[1]-boundsTable[3];
			local tempBounds2 = boundsTable[2]-boundsTable[3];
			if tempBounds1 < 1 then
				boundsTable[1] = 1;boundsTable[2] = boundsTable[1]+boundsTable[3];
				return;
			end;
			boundsTable[1] = tempBounds1;boundsTable[2] = tempBounds2;
			return;
		elseif down then
			if boundsTable[2] == boundsTable[4] then return;end;
			local tempBounds1 = boundsTable[1]+boundsTable[3];
			local tempBounds2 = boundsTable[2]+boundsTable[3];
			if tempBounds2 > boundsTable[4] then
				boundsTable[1] = boundsTable[4]-boundsTable[3]+1;boundsTable[2] = boundsTable[1]+boundsTable[3]+1; 
				return;
			end;
			boundsTable[1] = tempBounds1;boundsTable[2] = tempBounds2;
			return;
		end;			
	



end;


function moSetGetPda:setLineAppsBoundsClick(whichPda, left, right, up, down) --disabled
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];	
	if up then
		local tempBounds = pdaTable.view[pdaTable.view.isModus].boundsHeight[1]+pdaTable.view[pdaTable.view.isModus].boundsHeight[2]-1;
		if pdaTable.view[pdaTable.view.isModus].boundsHeight[1]-pdaTable.view[pdaTable.view.isModus].boundsHeight[3] >= 1 then
			pdaTable.view[pdaTable.view.isModus].boundsHeight[1] = pdaTable.view[pdaTable.view.isModus].boundsHeight[1]-pdaTable.view[pdaTable.view.isModus].boundsHeight[3];
			pdaTable.view[pdaTable.view.isModus].boundsHeight[2] = pdaTable.view[pdaTable.view.isModus].boundsHeight[2]-pdaTable.view[pdaTable.view.isModus].boundsHeight[3];
		else
			pdaTable.view[pdaTable.view.isModus].boundsHeight[1] = 1;
			pdaTable.view[pdaTable.view.isModus].boundsHeight[2] = pdaTable.view[pdaTable.view.isModus].boundsHeight[3];
		end;
	elseif down then
		local tempBounds = pdaTable.view[pdaTable.view.isModus].boundsHeight[2]-pdaTable.view[pdaTable.view.isModus].boundsHeight[1]+1;
		if pdaTable.view[pdaTable.view.isModus].boundsHeight[2]+pdaTable.view[pdaTable.view.isModus].boundsHeight[3] <= pdaTable.view[pdaTable.view.isModus].boundsHeight[4] then
			pdaTable.view[pdaTable.view.isModus].boundsHeight[1] = pdaTable.view[pdaTable.view.isModus].boundsHeight[1]+pdaTable.view[pdaTable.view.isModus].boundsHeight[3];
			pdaTable.view[pdaTable.view.isModus].boundsHeight[2] = pdaTable.view[pdaTable.view.isModus].boundsHeight[2]+pdaTable.view[pdaTable.view.isModus].boundsHeight[3];
		else
			--pdaTable.view[pdaTable.view.isModus].boundsHeight[1] = pdaTable.view[pdaTable.view.isModus].boundsHeight[4]-pdaTable.view[pdaTable.view.isModus].boundsHeight[3]+1;
			--pdaTable.view[pdaTable.view.isModus].boundsHeight[2] = pdaTable.view[pdaTable.view.isModus].boundsHeight[1]+pdaTable.view[pdaTable.view.isModus].boundsHeight[3]+1
			
			pdaTable.view[pdaTable.view.isModus].boundsHeight[2] = pdaTable.view[pdaTable.view.isModus].boundsHeight[4];
			pdaTable.view[pdaTable.view.isModus].boundsHeight[1] = pdaTable.view[pdaTable.view.isModus].boundsHeight[4]-tempBounds;
		end;
	elseif left then
		if pdaTable.view[pdaTable.view.isModus].boundsWidth[1]-1 >= 1 then 
			pdaTable.view[pdaTable.view.isModus].boundsWidth[1] = pdaTable.view[pdaTable.view.isModus].boundsWidth[1]-1;
			pdaTable.view[pdaTable.view.isModus].boundsWidth[2] = pdaTable.view[pdaTable.view.isModus].boundsWidth[2]-1;
		end;
	elseif right then
		if pdaTable.view[pdaTable.view.isModus].boundsWidth[2]+1 <= pdaTable.view[pdaTable.view.isModus].boundsWidth[4] then 
			pdaTable.view[pdaTable.view.isModus].boundsWidth[1] = pdaTable.view[pdaTable.view.isModus].boundsWidth[1]+1;
			pdaTable.view[pdaTable.view.isModus].boundsWidth[2] = pdaTable.view[pdaTable.view.isModus].boundsWidth[2]+1;
		end;
	end;
end;

function moSetGetPda:setLineAppsBoundsScroll(whichPda, left, right, up, down)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];	
	if up then
		if pdaTable.view[pdaTable.view.isModus].boundsHeight[1]-1 >= 1 then
			pdaTable.view[pdaTable.view.isModus].boundsHeight[1] = pdaTable.view[pdaTable.view.isModus].boundsHeight[1]-1;
			pdaTable.view[pdaTable.view.isModus].boundsHeight[2] = pdaTable.view[pdaTable.view.isModus].boundsHeight[2]-1;
		end;
	elseif down then
		if pdaTable.view[pdaTable.view.isModus].boundsHeight[2]+1 <= pdaTable.view[pdaTable.view.isModus].boundsHeight[4] then
			pdaTable.view[pdaTable.view.isModus].boundsHeight[1] = pdaTable.view[pdaTable.view.isModus].boundsHeight[1]+1;
			pdaTable.view[pdaTable.view.isModus].boundsHeight[2] = pdaTable.view[pdaTable.view.isModus].boundsHeight[2]+1;
		end;
	elseif left then
		if pdaTable.view[pdaTable.view.isModus].boundsWidth[1]-1 >= 1 then 
			pdaTable.view[pdaTable.view.isModus].boundsWidth[1] = pdaTable.view[pdaTable.view.isModus].boundsWidth[1]-1;
			pdaTable.view[pdaTable.view.isModus].boundsWidth[2] = pdaTable.view[pdaTable.view.isModus].boundsWidth[2]-1;
		end;
	elseif right then
		if pdaTable.view[pdaTable.view.isModus].boundsWidth[2]+1 <= pdaTable.view[pdaTable.view.isModus].boundsWidth[4] then 
			pdaTable.view[pdaTable.view.isModus].boundsWidth[1] = pdaTable.view[pdaTable.view.isModus].boundsWidth[1]+1;
			pdaTable.view[pdaTable.view.isModus].boundsWidth[2] = pdaTable.view[pdaTable.view.isModus].boundsWidth[2]+1;
		end;
	end;
end;

function moSetGetPda:resetLineAppBounds(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];	
	for a=1, pdaTable.view.max do
		pdaTable.view[a].boundsHeight = {0,0,0,0};
		pdaTable.view[a].boundsWidth = {0,0,0,0};
	end;
end;

function moSetGetPda:setSettingLineBounds(whichPda, left, right)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	if left then
		if pdaTable.setting.settingIconLineBounds[1]-1 < 1 then return;end;		
		pdaTable.setting.settingIconLineBounds[1] = pdaTable.setting.settingIconLineBounds[1]-1;pdaTable.setting.settingIconLineBounds[2] = pdaTable.setting.settingIconLineBounds[2]-1;
	elseif right then
		if pdaTable.setting.settingIconLineBounds[2]+1 > pdaTable.setting.settingIconLineBounds[3] then return;end;
		pdaTable.setting.settingIconLineBounds[1] = pdaTable.setting.settingIconLineBounds[1]+1;pdaTable.setting.settingIconLineBounds[2] = pdaTable.setting.settingIconLineBounds[2]+1;
	end;
end;

function moSetGetPda:resetSettingLinesBounds(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	pdaTable.setting.settingIconLineBounds = {0,0,0,0};
	pdaTable.setting.defaultIconLineBounds = {0,0,0,0,0};
	moSetGetPda:resetSettingExtraLinesBounds(whichSubPda);	
end;

function moSetGetPda:setSettingExtraLineBounds(args, left, right)
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.line == nil then return;end;
	if moSetGetOverlays.pda ~= nil and moSetGetOverlays.pda[args.whatClick] ~= nil then		
		local pdaTable = moSetGetOverlays.pda[args.whatClick];
		local line = args.ownTable.line;
		local lineBounds = pdaTable.setting.extraIconLine[line].bounds;
		if not pdaTable.setting.extraLineMultiple then lineBounds = pdaTable.setting.extraIconLineBounds;end;
		if pdaTable.setting.extraIconLine[line] ~= nil then
			if left then
				if lineBounds[1]-1 < 1 then return;end;		
				lineBounds[1] = lineBounds[1]-1;lineBounds[2] = lineBounds[2]-1;
			elseif right then
				if lineBounds[2]+1 > lineBounds[3] then return;end;
				lineBounds[1] = lineBounds[1]+1;lineBounds[2] = lineBounds[2]+1;
			end;
		end;
	end;	
end;

function moSetGetPda:setSettingMaxExtraLine(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.line == nil then return;end;
	if moSetGetOverlays.pda ~= nil and moSetGetOverlays.pda[args.whatClick] ~= nil then 
		if moSetGetOverlays.pda[args.whatClick].setting.extraIconLine[args.ownTable.line] ~= nil then
			moSetGetOverlays.pda[args.whatClick].setting.extraIconLine[args.ownTable.line].view = not moSetGetOverlays.pda[args.whatClick].setting.extraIconLine[args.ownTable.line].view;
			moSetGetPda:resetSettingMaxExtraLines(args.whatClick);
		end;		
	end;	
end;

function moSetGetPda:resetSettingMaxExtraLines(whichPda)
	local whichSubPda = whichPda or "dummySlot_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	local maxExtraLine = 0;
	for a=1, #pdaTable.setting.extraIconLine do
		if pdaTable.setting.extraIconLine[a].view then
			maxExtraLine = maxExtraLine+1;
		end;
	end;	
	pdaTable.setting.maxExtraLine = maxExtraLine;
	moSetGetPda:resetSettingExtraLinesBounds(whichSubPda);
end;

function moSetGetPda:resetSettingExtraLinesBounds(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	for a=1, #pdaTable.setting.extraIconLine do
		pdaTable.setting.extraIconLine[a].bounds = {0,0,0,0,0};
	end;
	pdaTable.setting.extraIconLineBounds = {0,0,0,0,0};
end;

function moSetGetPda:refreshCmdDisplayNames(args) --args table regName = displayName
	if args == nil or type(args) ~= "table" then return false;end;
	local refreshCmdRegNames = args;
	local pdas = moSetGetPda:getPdas();
	if pdas ~= nil and #pdas > 0 then			
		for pda=1, #pdas do
			if moSetGetOverlays.pda[pdas[pda]].apps ~= nil then
				local tempPda = moSetGetOverlays.pda[pdas[pda]].apps;
				local highestLine = moSetGetPda:getHighestLine(pdas[pda]);
				if highestLine > 0 then
					for line=1, highestLine do
						if tempPda[line] ~= nil then
							local highestLineApp = moSetGetPda:getHighestLineApp(pdas[pda], line);
							if highestLineApp > 0 then
								for app=1, highestLineApp do
									if tempPda[line][app] ~= nil then
										if tempPda[line][app].cmd ~= nil and #tempPda[line][app].cmd > 0 then
											for cmd=1, #tempPda[line][app].cmd do
												if refreshCmdRegNames[tempPda[line][app].cmd[cmd].regName] ~= nil then
													moSetGetOverlays.pda[pdas[pda]].apps[line][app].cmd[cmd].displayName = tostring(refreshCmdRegNames[tempPda[line][app].cmd[cmd].regName]);
												end;												
											end;
										end;
									end;
								end;
							end;
						end;
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetPda:insertSettingModIcon(args)	
	if args ~= nil and type(args) == "table" then
		if args.whichPda == nil or args.iconName == nil or args.callback == nil or args.modName == nil then return false;end;
		if moSetGetOverlays.pda[args.whichPda] == nil or moSetGetOverlays.pda[args.whichPda].design.byName.icon[args.iconName] == nil then return false;end;
		if type(args.callback) ~= "function" then return false;end;
		local pdaTable = moSetGetOverlays.pda[args.whichPda];		
		local modPosition = 0;
		if #pdaTable.setting.modIcon > 0 then
			for a=1, #pdaTable.setting.modIcon do
				if (pdaTable.setting.modIcon[a].modName == args.modName and string.len(pdaTable.setting.modIcon[a].modName) == string.len(args.modName)) then
					if args.iconName ~= "buttonSeparatorVertical" and args.iconName ~= "buttonSeparatorHorizontal" and args.iconName ~= "free" then
						modPosition = a;
					end;
				end;
			end;			
		end;
		if modPosition == 0 then modPosition = #pdaTable.setting.modIcon+1;end;
		table.insert(pdaTable.setting.modIcon, modPosition, {});
		local modIcon = pdaTable.setting.modIcon[modPosition];
		modIcon.modName = args.modName or "Unknown";
		modIcon.name = args.iconName;
		modIcon.txt = args.txt;
		modIcon.txtColor = args.txtColor;
		modIcon.txtPdaColor = args.txtPdaColor;
		modIcon.areaName = args.areaName;
		modIcon.infoTxt = args.infoTxt;
		modIcon.callback = args.callback;
		if args.onOpen ~= nil and type(args.onOpen) == "function" then
			modIcon.onOpen = args.onOpen;
		end;
		modIcon.ownTable = args.ownTable;
		moSetGetPda:resetSettingLinesBounds(args.whichPda);
		--moSetGetCmd:generateCmd(args)
		return true;
	end;
	return false;
end;

function moSetGetPda:insertGeneratePdaCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		moSetGetPda.default.setting.generateCallback[#moSetGetPda.default.setting.generateCallback+1] = args.callback;
		return true;
	end;
	return false;
end;

function moSetGetPda:deleteGeneratePdaCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		for a=1, #moSetGetPda.default.setting.generateCallback do			
			if moSetGetPda.default.setting.generateCallback[a] == args.callback then moSetGetPda.default.setting.generateCallback[a] = nil;break;end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetPda:insertDeletePdaCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichPda ~= nil and moSetGetOverlays.pda[args.whichPda] ~= nil then
			moSetGetOverlays.pda[args.whichPda].setting.deleteCallback[#moSetGetOverlays.pda[args.whichPda].setting.deleteCallback+1] = args.callback;
		else
			moSetGetPda.default.setting.deleteCallback[#moSetGetPda.default.setting.deleteCallback+1] = args.callback;
			local pdas = moSetGetPda:getPdas();
			if #pdas > 0 then
				for a=1, #pdas do
					if moSetGetOverlays.pda[pdas[a]] ~= nil then
						moSetGetOverlays.pda[pdas[a]].setting.deleteCallback[#moSetGetOverlays.pda[pdas[a]].setting.deleteCallback+1] = args.callback;
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetPda:deleteDeletePdaCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichPda ~= nil and moSetGetOverlays.pda[args.whichPda] ~= nil then
			for a=1, moSetGetOverlays.pda[args.whichPda].setting.deleteCallback do
				if moSetGetOverlays.pda[args.whichPda].setting.deleteCallback[a] == args.callback then moSetGetOverlays.pda[args.whichPda].setting.deleteCallback[a] = nil;break;end;
			end;
		else
			local pdas = moSetGetSlot:getPdas();
			if #pdas > 0 then
				for a=1, #pdas do
					if moSetGetOverlays.pda[pdas[a]] ~= nil then
						for b=1, moSetGetOverlays.pda[pdas[a]].setting.deleteCallback do
							if moSetGetOverlays.pda[pdas[a]].setting.deleteCallback[b] == args.callback then moSetGetOverlays.pda[pdas[a]].setting.deleteCallback[b] = nil;break;end;
						end;						
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetPda:insertOpenPdaCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichPda ~= nil and moSetGetOverlays.pda[args.whichPda] ~= nil then
			moSetGetOverlays.pda[args.whichPda].setting.openCallback[#moSetGetOverlays.pda[args.whichPda].setting.openCallback+1] = args.callback;
		else
			moSetGetPda.default.setting.openCallback[#moSetGetPda.default.setting.openCallback+1] = args.callback;
			local pdas = moSetGetPda:getPdas();
			if #pdas > 0 then
				for a=1, #pdas do
					if moSetGetOverlays.pda[pdas[a]] ~= nil then
						moSetGetOverlays.pda[pdas[a]].setting.openCallback[#moSetGetOverlays.pda[pdas[a]].setting.openCallback+1] = args.callback;
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetPda:deleteOpenPdaCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichPda ~= nil and moSetGetOverlays.pda[args.whichPda] ~= nil then
			for a=1, moSetGetOverlays.pda[args.whichPda].setting.openCallback do
				if moSetGetOverlays.pda[args.whichPda].setting.openCallback[a] == args.callback then moSetGetOverlays.pda[args.whichPda].setting.openCallback[a] = nil;break;end;
			end;
		else
			local pdas = moSetGetSlot:getPdas();
			if #pdas > 0 then
				for a=1, #pdas do
					if moSetGetOverlays.pda[pdas[a]] ~= nil then
						for b=1, moSetGetOverlays.pda[pdas[a]].setting.openCallback do
							if moSetGetOverlays.pda[pdas[a]].setting.openCallback[b] == args.callback then moSetGetOverlays.pda[pdas[a]].setting.openCallback[b] = nil;break;end;
						end;						
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetPda:insertSavePdaCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichPda ~= nil and moSetGetOverlays.pda[args.whichPda] ~= nil then
			moSetGetOverlays.pda[args.whichPda].setting.saveCallback[#moSetGetOverlays.pda[args.whichPda].setting.saveCallback+1] = args.callback;
		else
			moSetGetPda.default.setting.saveCallback[#moSetGetPda.default.setting.saveCallback+1] = args.callback;
			local pdas = moSetGetPda:getPdas();
			if #pdas > 0 then
				for a=1, #pdas do
					if moSetGetOverlays.pda[pdas[a]] ~= nil then
						moSetGetOverlays.pda[pdas[a]].setting.saveCallback[#moSetGetOverlays.pda[pdas[a]].setting.saveCallback+1] = args.callback;
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetPda:deleteSavePdaCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichPda ~= nil and moSetGetOverlays.pda[args.whichPda] ~= nil then
			for a=1, moSetGetOverlays.pda[args.whichPda].setting.saveCallback do
				if moSetGetOverlays.pda[args.whichPda].setting.saveCallback[a] == args.callback then moSetGetOverlays.pda[args.whichPda].setting.saveCallback[a] = nil;break;end;
			end;
		else
			local pdas = moSetGetSlot:getPdas();
			if #pdas > 0 then
				for a=1, #pdas do
					if moSetGetOverlays.pda[pdas[a]] ~= nil then
						for b=1, moSetGetOverlays.pda[pdas[a]].setting.saveCallback do
							if moSetGetOverlays.pda[pdas[a]].setting.saveCallback[b] == args.callback then moSetGetOverlays.pda[pdas[a]].setting.saveCallback[b] = nil;break;end;
						end;						
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetPda:generateSettingExtraLine(args)	
	if args ~= nil and type(args) == "table" then
		if args.whichPda == nil or args.modName == nil or moSetGetOverlays.pda[args.whichPda] == nil then return false;end;			
		local pdaTable = moSetGetOverlays.pda[args.whichPda];		
		pdaTable.setting.extraIconLine[#pdaTable.setting.extraIconLine+1] = {view=false,bounds={0,0,0,0,0},modName=args.modName or "Unknown",icon={}};
		moSetGetPda:resetSettingMaxExtraLines(args.whichPda);	
		return true;
	end;
	return false;
end;

function moSetGetPda:deleteSettingExtraLine(args)	
	if args ~= nil and type(args) == "table" then
		if args.whichPda == nil or args.modName == nil or moSetGetOverlays.pda[args.whichPda] == nil then return false;end;			
		local pdaTable = moSetGetOverlays.pda[args.whichPda];		
		for a=1, #pdaTable.setting.extraIconLine do
			if pdaTable.setting.extraIconLine[a].modName == args.modName then
				pdaTable.setting.extraIconLine[a].view = false;
				table.remove(pdaTable.setting.extraIconLine, a);
				moSetGetPda:resetSettingMaxExtraLines(args.whichPda);				
				break;
			end;
		end;			
		return true;
	end;
	return false;
end;

function moSetGetPda:insertSettingExtraIcon(args)	
	if args ~= nil and type(args) == "table" then
		if args.whichPda == nil or args.iconName == nil or args.callback == nil or args.modName == nil then return false;end;
		if moSetGetOverlays.pda[args.whichPda] == nil or moSetGetOverlays.pda[args.whichPda].design.byName.icon[args.iconName] == nil then return false;end;
		if type(args.callback) ~= "function" then return false;end;
		local pdaTable = moSetGetOverlays.pda[args.whichPda];		
		for a=1, #pdaTable.setting.extraIconLine do
			if pdaTable.setting.extraIconLine[a].modName == args.modName then
				pdaTable.setting.extraIconLine[a].icon[#pdaTable.setting.extraIconLine[a].icon+1] = {};
				local extraIcon = pdaTable.setting.extraIconLine[a].icon[#pdaTable.setting.extraIconLine[a].icon];
				extraIcon.modName = args.modName or "Unknown";
				extraIcon.name = args.iconName;
				extraIcon.txt = args.txt;
				extraIcon.txtColor = args.txtColor;
				extraIcon.txtPdaColor = args.txtPdaColor;
				extraIcon.areaName = args.areaName;
				extraIcon.infoTxt = args.infoTxt;
				extraIcon.callback = args.callback;
				if args.onOpen ~= nil and type(args.onOpen) == "function" then
					extraIcon.onOpen = args.onOpen;
				end;
				extraIcon.ownTable = args.ownTable;	
				moSetGetPda:resetSettingExtraLinesBounds(args.whichPda);
			end;
		end;		
		return true;
	end;
	return false;
end;

-------------mod setGetPdaFunction-------------
g_currentMission.multiOverlayV4.pdaFunction={
	isPdaOpen = function(whichPda)return moDraw.pda:getOpen(whichPda);end;
	getPdas = function()return moSetGetPda:getPdas();end;
	getPdaTable = function(whichPda)return moSetGetPda:getPdaTable(whichPda);end;
	generatePda = function(whichPda, displayName, otherFreeName)return moSetGetPda:generatePda(whichPda, displayName, otherFreeName);end;
	refreshCmdDisplayNames = function(args) return moSetGetPda:refreshCmdDisplayNames(args);end;
	insertSettingIcon = function(args)return moSetGetPda:insertSettingModIcon(args);end;	
	generateSettingExtraLine = function(args)return moSetGetPda:generateSettingExtraLine(args);end;
	deleteSettingExtraLine = function(args)return moSetGetPda:deleteSettingExtraLine(args);end;
	insertSettingExtraIcon = function(args)return moSetGetPda:insertSettingExtraIcon(args);end;	
	insertGeneratePdaCallback = function(args)return moSetGetPda:insertGeneratePdaCallback(args);end;
	insertDeletePdaCallback = function(args)return moSetGetPda:insertDeletePdaCallback(args);end;
	insertOpenPdaCallback = function(args)return moSetGetPda:insertOpenPdaCallback(args);end;
	insertSavePdaCallback = function(args)return moSetGetPda:insertSavePdaCallback(args);end;
	deleteGeneratePdaCallback = function(args)return moSetGetPda:deleteGeneratePdaCallback(args);end;
	deleteDeletePdaCallback = function(args)return moSetGetPda:deleteDeletePdaCallback(args);end;
	deleteOpenPdaCallback = function(args)return moSetGetPda:deleteOpenPdaCallback(args);end;
	deleteSavePdaCallback = function(args)return moSetGetPda:deleteSavePdaCallback(args);end;
};
-------------mod setGetPdaFunction-------------



