moAutoGenerateSlot = {};

function moAutoGenerateSlot:generateSlot(whatGenerate, guiMenue)
	if whatGenerate == "firstLoadSlots_" then 
		moAutoGenerateSlot.dummySlot(false);
		moAutoGenerateSlot.mapMissionsSlot(false);
		moAutoGenerateSlot.mapFarmlandsSlot(false);
		moAutoGenerateSlot.fillTypeAmountPriceSlot(false);
		moAutoGenerateSlot.sellingStationsSlot(false);
		moAutoGenerateSlot.teleportPointsSlot(false);
	elseif guiMenue then
		moAutoGenerateSlot[whatGenerate](guiMenue);
	end;
end;

function moAutoGenerateSlot.dummySlot(guiMenue)
	if moSetGetOverlays.slot["dummySlot_"] ~= nil then if guiMenue then g_currentMission.hl.addTextDisplay( {txt="Slot already Exists in Profil", txtBold=true, duration=3, warning=true} );end;return;end;
	moSetGetSlot:generateSlot("dummySlot_", "FillTypes On/Off Global");	
	moSetGetOverlays.slot["dummySlot_"].isOpen = true;
	moSetGetOverlays.slot["dummySlot_"].cmd[1] = {regName="MultiOverlayV4_cmd_output_fillTypesOnOff_",displayName="FillTypes On/Off Global",mouseClick={true,true,true}};
end;

function moAutoGenerateSlot.mapMissionsSlot(guiMenue)
	if moSetGetOverlays.slot["mapMissionsSlot_"] ~= nil then if guiMenue then g_currentMission.hl.addTextDisplay( {txt="Slot already Exists in Profil", txtBold=true, duration=3, warning=true} );end;return;end;
	moSetGetSlot:generateSlot("mapMissionsSlot_", "Map Missions");	
	moSetGetOverlays.slot["mapMissionsSlot_"].isOpen = false;
	moSetGetOverlays.slot["mapMissionsSlot_"].cmd[1] = {regName="MultiOverlayV4_cmd_output_mapMissions_",displayName="Map Missions",mouseClick={true,true,true}};
end;

function moAutoGenerateSlot.mapFarmlandsSlot(guiMenue)
	if moSetGetOverlays.slot["mapFarmlandsSlot_"] ~= nil then if guiMenue then g_currentMission.hl.addTextDisplay( {txt="Slot already Exists in Profil", txtBold=true, duration=3, warning=true} );end;return;end;
	moSetGetSlot:generateSlot("mapFarmlandsSlot_", "Map Farmlands");	
	moSetGetOverlays.slot["mapFarmlandsSlot_"].isOpen = false;
	moSetGetOverlays.slot["mapFarmlandsSlot_"].cmd[1] = {regName="MultiOverlayV4_cmd_output_mapFarmlands_",displayName="Map Farmlands",mouseClick={true,true,true}};
end;

function moAutoGenerateSlot.fillTypeAmountPriceSlot(guiMenue)
	if moSetGetOverlays.slot["fillTypeAmountPriceSlot_"] ~= nil then if guiMenue then g_currentMission.hl.addTextDisplay( {txt="Slot already Exists in Profil", txtBold=true, duration=3, warning=true} );end;return;end;
	moSetGetSlot:generateSlot("fillTypeAmountPriceSlot_", "FillType/Amount/Price");	
	moSetGetOverlays.slot["fillTypeAmountPriceSlot_"].isOpen = false;
	moSetGetOverlays.slot["fillTypeAmountPriceSlot_"].cmd[1] = {regName="MultiOverlayV4_cmd_output_fillTypeAmountPrice_",displayName="FillType/Amount/Price",mouseClick={true,true,true}};
end;

function moAutoGenerateSlot.sellingStationsSlot(guiMenue)
	if moSetGetOverlays.slot["sellingStationsSlot_"] ~= nil then if guiMenue then g_currentMission.hl.addTextDisplay( {txt="Slot already Exists in Profil", txtBold=true, duration=3, warning=true} );end;return;end;
	moSetGetSlot:generateSlot("sellingStationsSlot_", "SellingStations");	
	moSetGetOverlays.slot["sellingStationsSlot_"].isOpen = false;
	moSetGetOverlays.slot["sellingStationsSlot_"].cmd[1] = {regName="MultiOverlayV4_cmd_output_sellingStations_",displayName="SellingStations",mouseClick={true,true,true}};
end;

function moAutoGenerateSlot.teleportPointsSlot(guiMenue)
	if moSetGetOverlays.slot["teleportPointsSlot_"] ~= nil then if guiMenue then g_currentMission.hl.addTextDisplay( {txt="Slot already Exists in Profil", txtBold=true, duration=3, warning=true} );end;return;end;
	moSetGetSlot:generateSlot("teleportPointsSlot_", "TeleportPoints");	
	moSetGetOverlays.slot["teleportPointsSlot_"].isOpen = false;
	moSetGetOverlays.slot["teleportPointsSlot_"].cmd[1] = {regName="MultiOverlayV4_cmd_output_teleportPoints_",displayName="TeleportPoints",mouseClick={true,true,true}};
end;

--function moAutoGenerateSlot:dummySlot()
--
--end;
