moSetGetSlot = {};
source(MultiOverlayV4.modDir.."scripte/draw/slot/moDrawSlot.lua");

moSetGetSlot.default = {
	design = {byName={}};
	name = "";	
	typ = 1;
	isOtherSlot = {on=false, otherDraw=nil, menueCallback=nil, whichSlot=nil, isMenue=false, menueSlot=""};
	isOpen = true;	
	view = {isModus=1,max=2,[1]={isSmallView=false,boundsLine={0,0,0,0}},[2]={isSmallView=false,boundsLine={0,0,0,0}}};	
	isWarning = true;
	isWarningBlinking = true;
	isUp = false;
	help = {globalOn=false,outputOn=false,globalTxt=""};
	autoClose = {false, 0}; --1 close, 2 close timer sec !free	
	setting = {
		canCmdSettings = true;
		canCloseAll = true;
		objectDistanceLine = 2;
		distanceIconHeight = 3;
		distanceIconWidth = 3;
		distanceEdgeWidth = 2;
		on = false; 
		up = true;		
		deleteSlot = false;
		editSlotName = true;		
		generateCallback = {};
		deleteCallback = {};
		saveCallback = {};
		openCallback = {};
		
		defaultLine = true;
		maxDefaultLine = 1;
		defaultIconLineBounds = {0,0,0,0,0};
		
		settingLine = true; 
		maxSettingLine = 1; 
		modIcon = {}; --insert setting Mod Icons		
		settingIcon = {			
			[1]={name="buttonZoomOut", areaName="settingZoomOut", onOpen=moDraw.slot.iconColor, infoTxt="Zoom Out this Menue"}; 
			[2]={name="buttonZoomIn", areaName="settingZoomIn", onOpen=moDraw.slot.iconColor, infoTxt="Zoom In this Menue"};
			[3]={name="buttonTxtSizeUp", areaName="outputTxtSizeUp", onOpen=moDraw.slot.iconColor, infoTxt="Text Scale Up(not Menue)"};
			[4]={name="buttonTxtSizeDown", areaName="outputTxtSizeDown", onOpen=moDraw.slot.iconColor, infoTxt="Text Scale Down(not Menue)"};
			[5]={name="buttonDistanceUpHorizontal", areaName="outputDistanceUpHorizontal", onOpen=moDraw.slot.iconColor, infoTxt="Text Line Distance Up(not Menue)"};
			[6]={name="buttonDistanceDownHorizontal", areaName="outputDistanceDownHorizontal", onOpen=moDraw.slot.iconColor, infoTxt="Text Line Distance Down(not Menue)"};
			[7]={name="buttonTxtWidthFixUp", areaName="outputTxtWidthFixUp", onOpen=moDraw.slot.iconColor, infoTxt="Fix Dif. Text Length Up"};
			[8]={name="buttonTxtWidthFixDown", areaName="outputTxtWidthFixDown", onOpen=moDraw.slot.iconColor, infoTxt="Fix Dif. Text Length Down"};
			[9]={name="buttonCanCloseAll", areaName="slotCanCloseAll", onOpen=moDraw.slot.iconColor, infoTxt="Stop Close by Cmd Close All"};
			--[9]={name="free"};
			[10]={name="buttonSeparatorVertical", onOpen=moDraw.slot.iconColor}; --callback=moDraw.slot.testCallback};			
			[11]={name="buttonGenerate", areaName="generateNewSlot", onOpen=moDraw.slot.iconColor, infoTxt="Generate New Slot"};
			[12]={name="buttonCopyPaste", areaName="settingSlotCopyPaste", onOpen=moDraw.slot.iconColor, infoTxt="Copy this Slot Values(not cmds)"};
			[13]={name="buttonDelete", areaName="deleteSlot", onOpen=moDraw.slot.iconColor, infoTxt="Delete this Slot(Click here 2x)cancel timer"};
			[14]={name="buttonSeparatorVertical", onOpen=moDraw.slot.iconColor};
			--[15]={name="buttonProductionWarning", areaName="outputProductionWarning" ,onOpen=moDraw.slot.iconColor, infoTxt="Set this Slot Warnings On (isSmallView)"};			
		};		
		settingIconLineBounds = {0,0,0,0,0};		
		
		infoLine = false; --for help info etc.		
		maxInfoLine = 1; 
				
		extraLine = false; 
		extraLineMultiple = true; --false not implement
		maxExtraLine = 0; 
		extraIconLine = {};
		extraIconLineBounds = {0,0,0,0,0}; --for not extraLineMultiple
				
		modLine = false; --free
		modLineMultiple = false; --free
		maxModLine = 0; --free
		modIconLine = {}; --free
		modLineBounds = {0,0,0,0,0}; --free		
	};	
	color = {settingOn="green",settingOff="red",settingReady="yellow",settingDefault="gray",settingActiveCmd="green",settingAlreadyExistsCmd="darkYellow",txtExtra="ls15", txtOutputTitle="khaki",txt="white",ground="black",txtTitle="orange",txtMarker="orange",selectMarker="ls15"};	
	colorOutput = {txtGreatDemandColor="ls22",txtFillTypesColor="yellow",txtAmountColor="yellow",txtPriceColor="white",txtNoPriceColor="gray",txtNoAmountColor="gray"};
	colorProzent = g_currentMission.hl.colorProzent;
	
	minSettingZoomOutIn = 15;
	maxSettingZoomOutIn = 25;
	defaultSettingZoomOutIn = 20;
	settingZoomOutIn = 20;
	settingZoomOutInLV = 1;	
	
	minTxtSize = 0.008;
	maxTxtSize = 0.017;	
	defaultTxtSize = 0.010;
	txtSize = 0.010;
	txtSizeLV = 0.00025;
	
	minTxtLineDistance = 0.5;
	maxTxtLineDistance = 6;
	defaultTxtLineDistance = 2;
	txtLineDistance = 2;
	txtLineDistanceLV = 0.5;
	
	minTxtWidthFix = -3;
	maxTxtWidthFix = 3;
	defaultTxtWidthFix = 0;
	txtWidthFix = 0;	
	txtWidthFixLV = 1;
	
	posX = {default=0.44,[1]=0.44,[2]=0.44};
	posY = {default=0.7,[1]=0.7,[2]=0.7};
	width = {zoomOutIn=12,default=0,[1]=0,[2]=0};
	height = {zoomOutIn=3,default=0,[1]=0,[2]=0};
		
	output = {};
	cmd = {};	
	maxNotScrollLine = 0;
	cmdSettings = {openGroup={},viewActiveCmd=true,viewAlreadyExistsCmd=true,moveUp=true,distanceObject=10,viewDistanceObjectCmd=false,bounds={0,0,0,0},width=0,height=0};
};

function moSetGetSlot:generateDummySlots()
	moAutoGenerateSlot:generateSlot("firstLoadSlots_"); --first start MultiOverlayV4	
end;

function moSetGetSlot:generateMenueSlots(menueName)
	
end;

function moSetGetSlot:generateSlot(whichSlot, name, whichSlot_otherName, menue, copyPaste)
	local whichSubSlot = whichSlot or "dummySlot_";	
	if not string.find(whichSubSlot, "_", string.len(whichSubSlot)-1) then whichSubSlot = whichSubSlot.. "_";end; 
	if moSetGetOverlays.slot[whichSubSlot] ~= nil and (whichSlot_otherName == nil or not whichSlot_otherName) then return false, "whichSlot name not free";end;
	if moSetGetOverlays.slot[whichSubSlot] ~= nil and whichSlot_otherName then	
		whichSubSlot = moSetGetSlot:generateOtherSlotName();
		if whichSubSlot == nil then return false, "not found other name slaveSlot1_ - slaveSlot100_";end;
		if utf8Strlen(utf8Substr(name, 0)) < 2 then name = whichSubSlot;end;
	end;
	moSetGetOverlays.slot[whichSubSlot] = g_currentMission.hl.getTableCopy(moSetGetSlot.default);
	moSetGetOverlays:loadDefaultSlotIcons(whichSubSlot);
	moSetGetOverlays.slot[whichSubSlot].name = name or "Unknown";	
	if menue == nil or not menue then
		if copyPaste ~= nil and copyPaste then
			--auto copy/paste from the first Slot
			moSetGetSlot:settingCopyPaste(moSetGetSlot:getOneSlotName(whichSubSlot)); --copy
			moSetGetSlot:settingCopyPaste(whichSubSlot); --paste
			--auto copy/paste from the first Slot
		end;
		moSetGetSlot:setWidthHeight(whichSubSlot);
		if #moSetGetSlot.default.setting.generateCallback > 0 then
			for a=1, #moSetGetSlot.default.setting.generateCallback do
				if type(moSetGetSlot.default.setting.generateCallback[a]) == "function" then
					moSetGetSlot.default.setting.generateCallback[a]( {whichSlot=whichSubSlot} );
				end;
			end;
		end;
		moSetGetCmd:setOpenCloseSlotCmd(whichSubSlot);	
	end;	
	return true, whichSubSlot;
end;

function moSetGetSlot:getOneSlotName(whichSlot)	
	local whichSubSlot = whichSlot or "dummySlot_";
	local slots = {};	
	if moSetGetOverlays.slot ~= nil then		
		for slotName, slotTable in pairs(moSetGetOverlays.slot) do			
			if whichSubSlot ~= tostring(slotName) then
				return slotName
			end;
		end;		
	end;
	return "";
end;

function moSetGetSlot:getSlots()	
	local slots = {};	
	if moSetGetOverlays.slot ~= nil then		
		for slotName, slotTable in pairs(moSetGetOverlays.slot) do			
			slots[#slots+1] = tostring(slotName);			
		end;		
	end;
	return slots;
end;

function moSetGetSlot:getSlotTable(whichSlot)	
	if whichSlot == nil or moSetGetOverlays.slot[whichSlot] == nil then return nil;end;
	return moSetGetOverlays.slot[whichSlot];
end;

function moSetGetSlot:generateOtherSlotName()	
	for a=1, 100 do
		if moSetGetOverlays.slot["slaveSlot".. a.. "_"] == nil then return "slaveSlot".. a.. "_";end;
	end;
	return nil;
end;

function moSetGetSlot:setWidthHeight(whichSlot, slotTable)
	local whichSubSlot = whichSlot or "dummySlot_";
	if slotTable == nil then
		if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
		slotTable = moSetGetOverlays.slot[whichSubSlot];
		if slotTable.width.default == 0 or slotTable.width[1] == 0 or slotTable.height.default == 0 or slotTable.height[1] == 0 then
			slotTable.width.default = (moSetGetOverlays.buttonGfxWidth1*slotTable.settingZoomOutIn)*slotTable.width.zoomOutIn;
			slotTable.height.default = (moSetGetOverlays.buttonGfxHeight1*slotTable.settingZoomOutIn)*slotTable.height.zoomOutIn;
			for a=1, slotTable.view.max do
				slotTable.width[a] = slotTable.width.default;
				slotTable.height[a] = slotTable.height.default;
			end;
			moSetGetSlot:resetSettingLinesBounds(whichSubSlot);
			moSetGetSlot:setOutputLineBounds( {slotTable=slotTable, reset=true} );			
		end;
	else
		if slotTable.width.default == 0 then slotTable.width.default = (moSetGetOverlays.buttonGfxWidth1*slotTable.settingZoomOutIn)*slotTable.width.zoomOutIn;end;
		if slotTable.height.default == 0 then slotTable.height.default = (moSetGetOverlays.buttonGfxHeight1*slotTable.settingZoomOutIn)*slotTable.height.zoomOutIn;end;
		for a=1, slotTable.view.max do
			if slotTable.width[a] < slotTable.width.default then slotTable.width[a] = slotTable.width.default;end;
			if slotTable.height[a] < slotTable.height.default then slotTable.height[a] = slotTable.height.default;end;		
		end;
		moSetGetSlot:resetSettingLinesBounds(whichSubSlot);
		moSetGetSlot:setOutputLineBounds( {slotTable=slotTable, reset=true} );
	end;
end;

function moSetGetSlot:setSave(whichSlot, state)	
	if state ~= nil then moGeneralSettings.isSave = state;return;end;
	if not moGeneralSettings.isSave then 
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then
			if #moSetGetOverlays.slot[whichSlot].setting.saveCallback > 0 then
				for a=1, #moSetGetOverlays.slot[whichSlot].setting.saveCallback do
					if type(moSetGetOverlays.slot[whichSlot].setting.saveCallback[a]) == "function" then
						moSetGetOverlays.slot[whichSlot].setting.saveCallback[a]( {whichSlot=whichSlot} );
					end;
				end;
			end;
		end;
		moXmlSettings:saveXml();		
	end;		
end;

function moSetGetSlot:setOutputProductionWarning(whichSlot, state)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	if state ~= nil then
		if state == 1 then moSetGetOverlays.slot[whichSubSlot].isWarning = not moSetGetOverlays.slot[whichSubSlot].isWarning;end;
		if state == 2 then moSetGetOverlays.slot[whichSubSlot].isWarningBlinking = not moSetGetOverlays.slot[whichSubSlot].isWarningBlinking;end;
		moGeneralSettings.isSave = false;
	end;
end;

function moSetGetSlot:setHelp(whichSlot, global, output)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	if global then slotTable.help.globalOn = not slotTable.help.globalOn;end;
	if output then slotTable.help.outputOn = not slotTable.help.outputOn;end;		
end;

function moSetGetSlot:setCanCloseAll(whichSlot)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	moSetGetOverlays.slot[whichSubSlot].setting.canCloseAll = not moSetGetOverlays.slot[whichSubSlot].setting.canCloseAll;
	moGeneralSettings.isSave = false;
end;

function moSetGetSlot:settingCopyPaste(whichSlot)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];	
	if #moSetGetOverlays.slotSettingCopyPaste > 0 then
		if moSetGetOverlays.slotSettingCopyPaste[1].slotName == whichSubSlot then 
			moSetGetOverlays.slotSettingCopyPaste[1] = nil;
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."SettingLine"] ~= nil then
				g_currentMission.hl.timers[whichSubSlot.."SettingLine"].ownTable.infoTxt = "Cancel"; 
			end;
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."infoLine"] ~= nil then
				g_currentMission.hl.timers[whichSubSlot.."infoLine"].repeatable = 2;
				g_currentMission.hl.timers[whichSubSlot.."infoLine"].ownTable.infoTxt = "Cancel"; 
			end
			g_currentMission.hl.removeTimer("settingCopyPasteSlot");
		else
			slotTable.color = moSetGetOverlays.slotSettingCopyPaste[1].color;
			slotTable.settingZoomOutIn = moSetGetOverlays.slotSettingCopyPaste[1].settingZoomOutIn;
			slotTable.txtSize = moSetGetOverlays.slotSettingCopyPaste[1].txtSize;
			slotTable.txtLineDistance = moSetGetOverlays.slotSettingCopyPaste[1].txtLineDistance;
			slotTable.txtWidthFix = moSetGetOverlays.slotSettingCopyPaste[1].txtWidthFix;
			--slotTable.posX[1] = moSetGetOverlays.slotSettingCopyPaste[1].posX1;
			--slotTable.posY[1] = moSetGetOverlays.slotSettingCopyPaste[1].posY1;
			--slotTable.posX[2] = moSetGetOverlays.slotSettingCopyPaste[1].posX2;
			--slotTable.posY[2] = moSetGetOverlays.slotSettingCopyPaste[1].posY2;
			moSetGetOverlays.slotSettingCopyPaste[1] = nil;
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."SettingLine"] ~= nil then
				g_currentMission.hl.timers[whichSubSlot.."SettingLine"].ownTable.infoTxt = "Paste"; 
			end;
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."infoLine"] ~= nil then
				g_currentMission.hl.timers[whichSubSlot.."infoLine"].repeatable = 2;
				g_currentMission.hl.timers[whichSubSlot.."infoLine"].ownTable.infoTxt = "Paste"; 
			end;
			moSetGetSlot:resetSettingLinesBounds(whichSubSlot);
			moSetGetSlot:setOutputLineBounds( {slotTable=slotTable, reset=true} );
		end;
	else
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["settingCopyPasteSlot"] == nil then
			g_currentMission.hl.addTimer({name="settingCopyPasteSlot", delay=5, repeatable=false, action=moSetGetSlot.deleteSettingCopyPaste, ownTable={whichSlot=whichSubSlot}});
		else
			g_currentMission.hl.removeTimer("settingCopyPasteSlot");
		end;
		moSetGetOverlays.slotSettingCopyPaste[1] = {};
		moSetGetOverlays.slotSettingCopyPaste[1].slotName = tostring(whichSubSlot);
		moSetGetOverlays.slotSettingCopyPaste[1].color = slotTable.color;
		moSetGetOverlays.slotSettingCopyPaste[1].settingZoomOutIn = slotTable.settingZoomOutIn;
		moSetGetOverlays.slotSettingCopyPaste[1].txtSize = slotTable.txtSize;
		moSetGetOverlays.slotSettingCopyPaste[1].txtLineDistance = slotTable.txtLineDistance;
		moSetGetOverlays.slotSettingCopyPaste[1].txtWidthFix = slotTable.txtWidthFix;
		
		--moSetGetOverlays.slotSettingCopyPaste[1].posX1 = slotTable.posX[1];
		--moSetGetOverlays.slotSettingCopyPaste[1].posY1 = slotTable.posY[1];
		--moSetGetOverlays.slotSettingCopyPaste[1].posX2 = slotTable.posX[2];
		--moSetGetOverlays.slotSettingCopyPaste[1].posY2 = slotTable.posY[2];
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."SettingLine"] ~= nil then
			g_currentMission.hl.timers[whichSubSlot.."SettingLine"].ownTable.infoTxt = "Copy (Click at other Slot)"; 
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."infoLine"] ~= nil then
			g_currentMission.hl.timers[whichSubSlot.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[whichSubSlot.."infoLine"].ownTable.infoTxt = "Copy (Click at other Slot)"; 
		end;
	end;		
end;

function moSetGetSlot.deleteSettingCopyPaste(args) --timer action callback 
	if args == nil or type(args) ~= "table" then return;end;	
	if #moSetGetOverlays.slotSettingCopyPaste > 0 then			
		moSetGetOverlays.slotSettingCopyPaste[1] = nil;
	end;	
end;

function moSetGetSlot:deleteSlot(whichSlot)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;	
	if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."SettingLine"] ~= nil then
		if whichSubSlot ~= "dummySlot_" and not moSetGetOverlays.slot[whichSubSlot].setting.deleteSlot then
			g_currentMission.hl.timers[whichSubSlot.."SettingLine"].ownTable.infoTxt = "! safely delete !";
		else
			g_currentMission.hl.timers[whichSubSlot.."SettingLine"].ownTable.infoTxt = "! dummy cannot be deleted !";
		end;
	end;
	if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."infoLine"] ~= nil then
		if whichSubSlot ~= "dummySlot_" and not moSetGetOverlays.slot[whichSubSlot].setting.deleteSlot then
			g_currentMission.hl.timers[whichSubSlot.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[whichSubSlot.."infoLine"].ownTable.infoTxt = "! safely delete !";
		else
			g_currentMission.hl.timers[whichSubSlot.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[whichSubSlot.."infoLine"].ownTable.infoTxt = "! dummy cannot be deleted !";
		end;
	end;
	if whichSubSlot ~= "dummySlot_" and not moSetGetOverlays.slot[whichSubSlot].setting.deleteSlot then		
		moSetGetOverlays.slot[whichSubSlot].setting.deleteSlot = true;
		g_currentMission.hl.removeTimer("settingCopyPasteSlot");
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."deleteSlot"] == nil then
			g_currentMission.hl.addTimer({name=whichSubSlot.."deleteSlot", delay=4, repeatable=false, action=moSetGetSlot.isDeleteSlot, ownTable={infoTxt="",whichSlot=whichSubSlot}});
		end;
	elseif moSetGetOverlays.slot[whichSubSlot].setting.deleteSlot and whichSubSlot ~= "dummySlot_" then
		moDraw.slot:setClose(whichSubSlot);
		if #moSetGetOverlays.slot[whichSubSlot].setting.deleteCallback > 0 then
			for a=1, #moSetGetOverlays.slot[whichSubSlot].setting.deleteCallback do
				if type(moSetGetOverlays.slot[whichSubSlot].setting.deleteCallback[a]) == "function" then
					moSetGetOverlays.slot[whichSubSlot].setting.deleteCallback[a]( {whichSlot=whichSubSlot} );
				end;
			end;
		end;
		moSetGetOverlays:deleteSlotIcons(whichSubSlot);		
		moDraw.slot:setCmdSettingMenue(whichSubSlot, false);
		--moDraw.slot:refreshEditSlotCmd(whichSubSlot, false);		
		moSetGetOverlays.slot[whichSubSlot].cmd = {};
		moSetGetOverlays.slot[whichSubSlot].output = {};
		if MultiOverlayV4.cmdSetting.selectCmd[1] ~= nil then MultiOverlayV4.cmdSetting.selectCmd[1] = nil;end;
		moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="outputAction_".. whichSubSlot} );
		moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_".. whichSubSlot} );
		moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_close_".. whichSubSlot} );
		moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_open_".. whichSubSlot} );
		moSetGetOverlays.slot[whichSubSlot] = nil;
		moGeneralSettings.isSave = false;
		moSetGetProfilXML:deleteXml(whichSubSlot, "profilXML", "SLOT");
	end;
end;

function moSetGetSlot.isDeleteSlot(args) --timer action callback
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.whichSlot == nil then return;end;				
	local whichSubSlot = args.ownTable.whichSlot;
	if moSetGetOverlays.slot[whichSubSlot] ~= nil then
		moSetGetOverlays.slot[whichSubSlot].setting.deleteSlot = false;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."SettingLine"] ~= nil then
			g_currentMission.hl.timers[whichSubSlot.."SettingLine"].ownTable.infoTxt = "! cancel delete !";
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."infoLine"] ~= nil then
			g_currentMission.hl.timers[whichSubSlot.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[whichSubSlot.."infoLine"].ownTable.infoTxt = "! cancel delete !";
		end;
	end;	
end;

function moSetGetSlot:setSettingZoomOutIn(whichSlot, up, down, reset)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	if reset then moGeneralSettings.isSave = false;slotTable.settingZoomOutIn = slotTable.defaultSettingZoomOutIn;moSetGetSlot:resetSettingLinesBounds(whichSubSlot);return;end;
	if up then
		if slotTable.settingZoomOutIn+slotTable.settingZoomOutInLV > slotTable.maxSettingZoomOutIn then return;end;
		slotTable.settingZoomOutIn = slotTable.settingZoomOutIn+slotTable.settingZoomOutInLV;
		moGeneralSettings.isSave = false;
		moSetGetSlot:resetSettingLinesBounds(whichSubSlot);
	elseif down then
		if slotTable.settingZoomOutIn-slotTable.settingZoomOutInLV < slotTable.minSettingZoomOutIn then return;end;
		slotTable.settingZoomOutIn = slotTable.settingZoomOutIn-slotTable.settingZoomOutInLV;
		moGeneralSettings.isSave = false;
		moSetGetSlot:resetSettingLinesBounds(whichSubSlot);
	end;
end;

function moSetGetSlot:setTxtSize(whichSlot, up, down, reset)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	if reset then moGeneralSettings.isSave = false;slotTable.txtSize = slotTable.defaultTxtSize;return;end;
	if up then
		if slotTable.txtSize+slotTable.txtSizeLV > slotTable.maxTxtSize then return;end;
		slotTable.txtSize = slotTable.txtSize+slotTable.txtSizeLV;
		moSetGetSlot:setOutputLineBounds( {slotTable=slotTable, reset=true} );
		moGeneralSettings.isSave = false;
	elseif down then
		if slotTable.txtSize-slotTable.txtSizeLV < slotTable.minTxtSize then return;end;
		slotTable.txtSize = slotTable.txtSize-slotTable.txtSizeLV;
		moSetGetSlot:setOutputLineBounds( {slotTable=slotTable, reset=true} );
		moGeneralSettings.isSave = false;
	end;
end;

function moSetGetSlot:setTxtLineDistance(whichSlot, up, down, reset)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	if reset then moGeneralSettings.isSave = false;slotTable.txtLineDistance = slotTable.defaultTxtLineDistance;return;end;
	if up then
		if slotTable.txtLineDistance+slotTable.txtLineDistanceLV > slotTable.maxTxtLineDistance then return;end;
		slotTable.txtLineDistance = slotTable.txtLineDistance+slotTable.txtLineDistanceLV;
		moSetGetSlot:setOutputLineBounds( {slotTable=slotTable, reset=true} );
		moGeneralSettings.isSave = false;
	elseif down then
		if slotTable.txtLineDistance-slotTable.txtLineDistanceLV < slotTable.minTxtLineDistance then return;end;
		slotTable.txtLineDistance = slotTable.txtLineDistance-slotTable.txtLineDistanceLV;
		moSetGetSlot:setOutputLineBounds( {slotTable=slotTable, reset=true} );
		moGeneralSettings.isSave = false;
	end;	
end;

function moSetGetSlot:setTxtWidthFix(whichSlot, up, down, reset)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	if reset then moGeneralSettings.isSave = false;slotTable.txtWidthFix = slotTable.defaultTxtWidthFix;return;end;
	if up then
		if slotTable.txtWidthFix+slotTable.txtWidthFixLV > slotTable.maxTxtWidthFix then return;end;
		slotTable.txtWidthFix = slotTable.txtWidthFix+slotTable.txtWidthFixLV;
		moGeneralSettings.isSave = false;
	elseif down then
		if slotTable.txtWidthFix-slotTable.txtWidthFixLV < slotTable.minTxtWidthFix then return;end;
		slotTable.txtWidthFix = slotTable.txtWidthFix-slotTable.txtWidthFixLV;
		moGeneralSettings.isSave = false;
	end;	
end;

function moSetGetSlot:setSettingLineBounds(whichSlot, left, right)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	if left then
		if slotTable.setting.settingIconLineBounds[1]-1 < 1 then return;end;		
		slotTable.setting.settingIconLineBounds[1] = slotTable.setting.settingIconLineBounds[1]-1;slotTable.setting.settingIconLineBounds[2] = slotTable.setting.settingIconLineBounds[2]-1;
	elseif right then
		if slotTable.setting.settingIconLineBounds[2]+1 > slotTable.setting.settingIconLineBounds[3] then return;end;
		slotTable.setting.settingIconLineBounds[1] = slotTable.setting.settingIconLineBounds[1]+1;slotTable.setting.settingIconLineBounds[2] = slotTable.setting.settingIconLineBounds[2]+1;
	end;
end;

function moSetGetSlot:setSettingExtraLineBounds(args, left, right)
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.line == nil then return;end;
	if moSetGetOverlays.slot ~= nil and moSetGetOverlays.slot[args.whatClick] ~= nil then		
		local slotTable = moSetGetOverlays.slot[args.whatClick];
		local line = args.ownTable.line;
		local lineBounds = slotTable.setting.extraIconLine[line].bounds;
		if not slotTable.setting.extraLineMultiple then lineBounds = slotTable.setting.extraIconLineBounds;end;
		if slotTable.setting.extraIconLine[line] ~= nil then
			if left then
				if lineBounds[1]-1 < 1 then return;end;		
				lineBounds[1] = lineBounds[1]-1;lineBounds[2] = lineBounds[2]-1;
			elseif right then
				if lineBounds[2]+1 > lineBounds[3] then return;end;
				lineBounds[1] = lineBounds[1]+1;lineBounds[2] = lineBounds[2]+1;
			end;
		end;
	end;	
end;

function moSetGetSlot:setSettingMaxExtraLine(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.line == nil then return;end;
	if moSetGetOverlays.slot ~= nil and moSetGetOverlays.slot[args.whatClick] ~= nil then
		local slotTable = moSetGetOverlays.slot[args.whatClick];		
		if slotTable.setting.extraIconLine[args.ownTable.line] ~= nil then
			slotTable.setting.extraIconLine[args.ownTable.line].view = not slotTable.setting.extraIconLine[args.ownTable.line].view;
			moSetGetSlot:resetSettingMaxExtraLines(args.whatClick);			
		end;		
	end;	
end;

function moSetGetSlot:resetSettingMaxExtraLines(whichSlot)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	local maxExtraLine = 0;
	for a=1, #slotTable.setting.extraIconLine do
		if slotTable.setting.extraIconLine[a].view then
			maxExtraLine = maxExtraLine+1;
		end;
	end;	
	slotTable.setting.maxExtraLine = maxExtraLine;
	moSetGetSlot:resetSettingExtraLinesBounds(whichSubSlot);
end;

function moSetGetSlot:resetSettingExtraLinesBounds(whichSlot)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	for a=1, #slotTable.setting.extraIconLine do
		slotTable.setting.extraIconLine[a].bounds = {0,0,0,0,0};
	end;
	slotTable.setting.extraIconLineBounds = {0,0,0,0,0};
end;

function moSetGetSlot:resetSettingLinesBounds(whichSlot)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	slotTable.setting.settingIconLineBounds = {0,0,0,0,0};
	slotTable.setting.defaultIconLineBounds = {0,0,0,0,0};
	moSetGetSlot:resetSettingExtraLinesBounds(whichSubSlot);
end;

function moSetGetSlot:setOutputLineBounds(args)
	if args == nil or type(args) ~= "table" then return;end;	
	local txtHeight = getTextHeight(args.slotTable.txtSize, utf8Substr("Äg", 0))+(moSetGetOverlays.buttonGfxHeight1*args.slotTable.txtLineDistance); --+(moSetGetOverlays.buttonGfxHeight1*args.slotTable.objectDistanceLine);
	local iconHeight = moSetGetOverlays.buttonGfxHeight1*args.slotTable.settingZoomOutIn;
	local slotMaxHeight = 0;
	local boundsTable = args.slotTable.view[args.slotTable.view.isModus].boundsLine;	
	slotMaxHeight = (args.slotTable.height[args.slotTable.view.isModus]-(iconHeight/2)-(moSetGetOverlays.buttonGfxHeight1*args.slotTable.setting.distanceIconHeight));
	if boundsTable[1] == 0 or args.reset then
		boundsTable[1] = 1;
		boundsTable[2] = math.floor((slotMaxHeight/txtHeight) -0.5)+1;
		boundsTable[3] = math.floor((slotMaxHeight/txtHeight) -0.5);
	elseif args.mouseClick ~= nil then
		if args.mouseClick == "MOUSE_BUTTON_WHEEL_UP" then
			if boundsTable[1] < 1 then 
				boundsTable[1] = 1;boundsTable[2] = boundsTable[1]+boundsTable[3];
				return;
			end;
			boundsTable[1] = boundsTable[1]-1;boundsTable[2] = boundsTable[2]-1
			return;
		elseif args.mouseClick == "MOUSE_BUTTON_WHEEL_DOWN" then	
			if boundsTable[2] > boundsTable[4] then 
				boundsTable[1] = boundsTable[4]-boundsTable[3]+1;boundsTable[2] = boundsTable[1]+boundsTable[3]+1; 
				return;
			end;
			boundsTable[1] = boundsTable[1]+1;boundsTable[2] = boundsTable[2]+1
			return;
		elseif args.mouseClick == "MOUSE_BUTTON_LEFT_UP" then
			if boundsTable[1] == 1 then return;end;
			local tempBounds1 = boundsTable[1]-boundsTable[3];
			local tempBounds2 = boundsTable[2]-boundsTable[3];
			if tempBounds1 < 1 then
				boundsTable[1] = 1;boundsTable[2] = boundsTable[1]+boundsTable[3];
				return;
			end;
			boundsTable[1] = tempBounds1;boundsTable[2] = tempBounds2;
			return;
		elseif args.mouseClick == "MOUSE_BUTTON_LEFT_DOWN" then
			if boundsTable[2] == boundsTable[4] then return;end;
			local tempBounds1 = boundsTable[1]+boundsTable[3];
			local tempBounds2 = boundsTable[2]+boundsTable[3];
			if tempBounds2 > boundsTable[4] then
				boundsTable[1] = boundsTable[4]-boundsTable[3]+1;boundsTable[2] = boundsTable[1]+boundsTable[3]+1; 
				return;
			end;
			boundsTable[1] = tempBounds1;boundsTable[2] = tempBounds2;
			return;
		end;			
	end;	
end;


--free
function moSetGetSlot:setPosX(whichSlot, posX, reset)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	moGeneralSettings.isSave = false;
	if reset then slotTable.posX.manu = slotTable.posX.default;return;end;
	moSetGetOverlays.slot[whichSubSlot].posX.manu = posX;	
end;

function moSetGetSlot:setPosY(whichSlot, posY, reset)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	moGeneralSettings.isSave = false;
	if reset then slotTable.posY.manu = slotTable.posY.default;return;end;
	moSetGetOverlays.slot[whichSubSlot].posY.manu = posY;	
end;

function moSetGetSlot:setHeight(whichSlot, height, reset)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	moGeneralSettings.isSave = false;
	if reset then slotTable.height.manu = slotTable.height.default;return;end;
	moSetGetOverlays.slot[whichSubSlot].height.manu = height;	
end;

function moSetGetSlot:setWidth(whichSlot, width, reset)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	moGeneralSettings.isSave = false;
	if reset then slotTable.width.manu = slotTable.width.default;return;end;
	moSetGetOverlays.slot[whichSubSlot].width.manu = width;	
end;

function moSetGetSlot:setBlackWhite(whichSlot) --gesperrt
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;
	--local slotTable = moSetGetOverlays.slot[whichSubSlot];
	--if slotTable.color.black ~= nil then 
	--	if slotTable.color.black then
	--		slotTable.color.black = false;
	--		slotTable.color.ground = "white";slotTable.color.txt = "black";
	--	else 
	--		slotTable.color.ground = "black";slotTable.color.txt = "white";
	--		slotTable.color.black = true;
	--	end;
	--	moGeneralSettings.isSave = false;
	--end;
end;

function moSetGetSlot:getGroundColor(whichSlot)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return nil;end;
	return moSetGetOverlays.slot[whichSubSlot].color.ground;
end;
--free

function moSetGetSlot:insertSettingModIcon(args)	
	if args ~= nil and type(args) == "table" then
		if args.whichSlot == nil or args.iconName == nil or args.callback == nil or args.modName == nil then return false;end;
		if moSetGetOverlays.slot[args.whichSlot] == nil or moSetGetOverlays.slot[args.whichSlot].design.byName.icon[args.iconName] == nil then return false;end;
		if type(args.callback) ~= "function" then return false;end;
		local slotTable = moSetGetOverlays.slot[args.whichSlot];		
		local modPosition = 0;
		if #slotTable.setting.modIcon > 0 then
			for a=1, #slotTable.setting.modIcon do
				if (slotTable.setting.modIcon[a].modName == args.modName and string.len(slotTable.setting.modIcon[a].modName) == string.len(args.modName)) then
					if args.iconName ~= "buttonSeparatorVertical" and args.iconName ~= "buttonSeparatorHorizontal" and args.iconName ~= "free" then
						modPosition = a;
					end;
				end;
			end;			
		end;
		if modPosition == 0 then modPosition = #slotTable.setting.modIcon+1;end;
		table.insert(slotTable.setting.modIcon, modPosition, {});
		local modIcon = slotTable.setting.modIcon[modPosition];
		modIcon.modName = args.modName or "Unknown";
		modIcon.name = args.iconName;
		modIcon.txt = args.txt;
		modIcon.txtColor = args.txtColor;
		modIcon.txtSlotColor = args.txtSlotColor;
		modIcon.areaName = args.areaName;
		modIcon.infoTxt = args.infoTxt;
		modIcon.callback = args.callback;
		if args.onOpen ~= nil and type(args.onOpen) == "function" then
			modIcon.onOpen = args.onOpen;
		end;
		modIcon.ownTable = args.ownTable;
		moSetGetSlot:resetSettingLinesBounds(args.whichSlot);
		--moSetGetCmd:generateCmd(args)
		return true;
	end;
	return false;
end;

function moSetGetSlot:refreshCmdDisplayNames(args) --args table regName = displayName
	if args == nil or type(args) ~= "table" then return false;end;
	local refreshCmdRegNames = args;
	local slots = moSetGetSlot:getSlots();
	if slots ~= nil and #slots > 0 then
		for slot=1, #slots do
			if moSetGetOverlays.slot[slots[slot]].cmd ~= nil and #moSetGetOverlays.slot[slots[slot]].cmd > 0 then
				for cmd=1, #moSetGetOverlays.slot[slots[slot]].cmd do
					if refreshCmdRegNames[moSetGetOverlays.slot[slots[slot]].cmd[cmd].regName] ~= nil then
						moSetGetOverlays.slot[slots[slot]].cmd[cmd].displayName = tostring(refreshCmdRegNames[moSetGetOverlays.slot[slots[slot]].cmd[cmd].regName]);							
					end;						
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetSlot:insertGenerateSlotCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		moSetGetSlot.default.setting.generateCallback[#moSetGetSlot.default.setting.generateCallback+1] = args.callback;
		return true;
	end;
	return false;
end;

function moSetGetSlot:insertDeleteSlotCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichSlot ~= nil and moSetGetOverlays.slot[args.whichSlot] ~= nil then
			moSetGetOverlays.slot[args.whichSlot].setting.deleteCallback[#moSetGetOverlays.slot[args.whichSlot].setting.deleteCallback+1] = args.callback;
		else
			moSetGetSlot.default.setting.deleteCallback[#moSetGetSlot.default.setting.deleteCallback+1] = args.callback;
			local slots = moSetGetSlot:getSlots();
			if #slots > 0 then
				for a=1, #slots do
					if moSetGetOverlays.slot[slots[a]] ~= nil then
						moSetGetOverlays.slot[slots[a]].setting.deleteCallback[#moSetGetOverlays.slot[slots[a]].setting.deleteCallback+1] = args.callback;
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetSlot:deleteDeleteSlotCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichSlot ~= nil and moSetGetOverlays.slot[args.whichSlot] ~= nil then
			for a=1, moSetGetOverlays.slot[args.whichSlot].setting.deleteCallback do
				if moSetGetOverlays.slot[args.whichSlot].setting.deleteCallback[a] == args.callback then moSetGetOverlays.slot[args.whichSlot].setting.deleteCallback[a] = nil;break;end;
			end;
		else			
			local slots = moSetGetSlot:getSlots();
			if #slots > 0 then
				for a=1, #slots do
					if moSetGetOverlays.slot[slots[a]] ~= nil then
						for b=1, moSetGetOverlays.slot[slots[a]].setting.deleteCallback do
							if moSetGetOverlays.slot[slots[a]].setting.deleteCallback[b] == args.callback then moSetGetOverlays.slot[slots[a]].setting.deleteCallback[b] = nil;break;end;
						end;						
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetSlot:insertOpenSlotCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichSlot ~= nil and moSetGetOverlays.slot[args.whichSlot] ~= nil then
			moSetGetOverlays.slot[args.whichSlot].setting.openCallback[#moSetGetOverlays.slot[args.whichSlot].setting.openCallback+1] = args.callback;
		else
			moSetGetSlot.default.setting.openCallback[#moSetGetSlot.default.setting.openCallback+1] = args.callback;
			local slots = moSetGetSlot:getSlots();
			if #slots > 0 then
				for a=1, #slots do
					if moSetGetOverlays.slot[slots[a]] ~= nil then
						moSetGetOverlays.slot[slots[a]].setting.openCallback[#moSetGetOverlays.slot[slots[a]].setting.openCallback+1] = args.callback;
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetSlot:deleteOpenSlotCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichSlot ~= nil and moSetGetOverlays.slot[args.whichSlot] ~= nil then
			for a=1, moSetGetOverlays.slot[args.whichSlot].setting.openCallback do
				if moSetGetOverlays.slot[args.whichSlot].setting.openCallback[a] == args.callback then moSetGetOverlays.slot[args.whichSlot].setting.openCallback[a] = nil;break;end;
			end;
		else			
			local slots = moSetGetSlot:getSlots();
			if #slots > 0 then
				for a=1, #slots do
					if moSetGetOverlays.slot[slots[a]] ~= nil then
						for b=1, moSetGetOverlays.slot[slots[a]].setting.openCallback do
							if moSetGetOverlays.slot[slots[a]].setting.openCallback[b] == args.callback then moSetGetOverlays.slot[slots[a]].setting.openCallback[b] = nil;break;end;
						end;						
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetSlot:insertSaveSlotCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichSlot ~= nil and moSetGetOverlays.slot[args.whichSlot] ~= nil then
			moSetGetOverlays.slot[args.whichSlot].setting.saveCallback[#moSetGetOverlays.slot[args.whichSlot].setting.saveCallback+1] = args.callback;
		else
			moSetGetSlot.default.setting.saveCallback[#moSetGetSlot.default.setting.saveCallback+1] = args.callback;
			local slots = moSetGetSlot:getSlots();
			if #slots > 0 then
				for a=1, #slots do
					if moSetGetOverlays.slot[slots[a]] ~= nil then
						moSetGetOverlays.slot[slots[a]].setting.saveCallback[#moSetGetOverlays.slot[slots[a]].setting.saveCallback+1] = args.callback;
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetSlot:deleteSaveSlotCallback(args)
	if args ~= nil and type(args) == "table" and args.callback ~= nil and type(args.callback) == "function" then
		if args.whichSlot ~= nil and moSetGetOverlays.slot[args.whichSlot] ~= nil then
			for a=1, moSetGetOverlays.slot[args.whichSlot].setting.saveCallback do
				if moSetGetOverlays.slot[args.whichSlot].setting.saveCallback[a] == args.callback then moSetGetOverlays.slot[args.whichSlot].setting.saveCallback[a] = nil;break;end;
			end;
		else
			local slots = moSetGetSlot:getSlots();
			if #slots > 0 then
				for a=1, #slots do
					if moSetGetOverlays.slot[slots[a]] ~= nil then
						for b=1, moSetGetOverlays.slot[slots[a]].setting.saveCallback do
							if moSetGetOverlays.slot[slots[a]].setting.saveCallback[b] == args.callback then moSetGetOverlays.slot[slots[a]].setting.saveCallback[b] = nil;break;end;
						end;						
					end;
				end;
			end;
		end;
		return true;
	end;
	return false;
end;

function moSetGetSlot:generateSettingExtraLine(args)	
	if args ~= nil and type(args) == "table" then
		if args.whichSlot == nil or args.modName == nil or moSetGetOverlays.slot[args.whichSlot] == nil then return false;end;			
		local slotTable = moSetGetOverlays.slot[args.whichSlot];		
		slotTable.setting.extraIconLine[#slotTable.setting.extraIconLine+1] = {view=false,bounds={0,0,0,0,0},modName=args.modName or "Unknown",icon={}};
		moSetGetSlot:resetSettingMaxExtraLines(args.whichSlot);	
		return true;
	end;
	return false;
end;

function moSetGetSlot:deleteSettingExtraLine(args)	
	if args ~= nil and type(args) == "table" then
		if args.whichSlot == nil or args.modName == nil or moSetGetOverlays.slot[args.whichSlot] == nil then return false;end;			
		local slotTable = moSetGetOverlays.slot[args.whichSlot];		
		for a=1, #slotTable.setting.extraIconLine do
			if slotTable.setting.extraIconLine[a].modName == args.modName then
				slotTable.setting.extraIconLine[a].view = false;
				table.remove(slotTable.setting.extraIconLine, a);
				moSetGetSlot:resetSettingMaxExtraLines(args.whichSlot);				
				break;
			end;
		end;			
		return true;
	end;
	return false;
end;

function moSetGetSlot:insertSettingExtraIcon(args)	
	if args ~= nil and type(args) == "table" then
		if args.whichSlot == nil or args.iconName == nil or args.callback == nil or args.modName == nil then return false;end;
		if moSetGetOverlays.slot[args.whichSlot] == nil or moSetGetOverlays.slot[args.whichSlot].design.byName.icon[args.iconName] == nil then return false;end;
		if type(args.callback) ~= "function" then return false;end;
		local slotTable = moSetGetOverlays.slot[args.whichSlot];		
		for a=1, #slotTable.setting.extraIconLine do
			if slotTable.setting.extraIconLine[a].modName == args.modName then
				slotTable.setting.extraIconLine[a].icon[#slotTable.setting.extraIconLine[a].icon+1] = {};
				local extraIcon = slotTable.setting.extraIconLine[a].icon[#slotTable.setting.extraIconLine[a].icon];
				extraIcon.modName = args.modName or "Unknown";
				extraIcon.name = args.iconName;
				extraIcon.txt = args.txt;
				extraIcon.txtColor = args.txtColor;
				extraIcon.txtSlotColor = args.txtSlotColor;
				extraIcon.areaName = args.areaName;
				extraIcon.infoTxt = args.infoTxt;
				extraIcon.callback = args.callback;
				if args.onOpen ~= nil and type(args.onOpen) == "function" then
					extraIcon.onOpen = args.onOpen;
				end;
				extraIcon.ownTable = args.ownTable;	
				moSetGetSlot:resetSettingExtraLinesBounds(args.whichSlot);
			end;
		end;		
		return true;
	end;
	return false;
end;

-------------mod setGetSlotFunction-------------
g_currentMission.multiOverlayV4.slotFunction={
	isSlotOpen = function(whichSlot)return moDraw.slot:getOpen(whichSlot);end;
	getSlots = function()return moSetGetSlot:getSlots();end;
	getSlotTable = function(whichSlot)return moSetGetSlot:getSlotTable(whichSlot);end;	
	generateSlot = function(whichSlot, displayName, otherFreeName)return moSetGetSlot:generateSlot(whichSlot, displayName, otherFreeName);end;
	refreshCmdDisplayNames = function(args)return moSetGetSlot:refreshCmdDisplayNames(args);end;
	insertSettingIcon = function(args)return moSetGetSlot:insertSettingModIcon(args);end;
	generateSettingExtraLine = function(args)return moSetGetSlot:generateSettingExtraLine(args);end;
	deleteSettingExtraLine = function(args)return moSetGetSlot:deleteSettingExtraLine(args);end;
	insertSettingExtraIcon = function(args)return moSetGetSlot:insertSettingExtraIcon(args);end;
	insertGenerateSlotCallback = function(args)return moSetGetSlot:insertGenerateSlotCallback(args);end;
	insertDeleteSlotCallback = function(args)return moSetGetSlot:insertDeleteSlotCallback(args);end;
	insertOpenSlotCallback = function(args)return moSetGetSlot:insertOpenSlotCallback(args);end;
	insertSaveSlotCallback = function(args)return moSetGetSlot:insertSaveSlotCallback(args);end;
	deleteDeleteSlotCallback = function(args)return moSetGetSlot:deleteDeleteSlotCallback(args);end;
	deleteOpenSlotCallback = function(args)return moSetGetSlot:deleteOpenSlotCallback(args);end;
	deleteSaveSlotCallback = function(args)return moSetGetSlot:deleteSaveSlotCallback(args);end;	
};
-------------mod setGetSlotFunction-------------