moDraw.infoHelpBox = {};

function moDraw.infoHelpBox:setOpenDraw()
	local helpTyp = moSetGetOverlays.infoHelpBox.help.typ;
	local infoTyp = moSetGetOverlays.infoHelpBox.info.typ;
	local up = false;
	local left = false;
	if string.len(moSetGetOverlays.infoHelpBox.help.txt) > 0 then
		if helpTyp == 0 and HUDPopupMessage.currentMessage == nil and #g_currentMission.hud.popupMessage.pendingMessages <= 0 then			
			g_currentMission.hud:showInGameMessage(tostring(moSetGetOverlays.infoHelpBox.help.titel), tostring(moSetGetOverlays.infoHelpBox.help.txt), moSetGetOverlays.infoHelpBox.help.lsTimer, nil, moDraw.infoHelpBox.resetHelp);
			HUDPopupMessage.COLOR.TEXT = g_currentMission.hl.getColor(moSetGetOverlays.infoHelpBox.help.txtColor, true);			
		end;
	end;
	if string.len(moSetGetOverlays.infoHelpBox.info.txt) > 0 then
		if infoTyp == 0 and HUDPopupMessage.currentMessage == nil and #g_currentMission.hud.popupMessage.pendingMessages <= 0 then			
			g_currentMission.hud:showInGameMessage(tostring(moSetGetOverlays.infoHelpBox.info.titel), tostring(moSetGetOverlays.infoHelpBox.info.txt), moSetGetOverlays.infoHelpBox.info.lsTimer, nil, moDraw.infoHelpBox.resetInfo);
			HUDPopupMessage.COLOR.TEXT = g_currentMission.hl.getColor(moSetGetOverlays.infoHelpBox.info.txtColor, true);	
		end;
	end;
end;

function moDraw.infoHelpBox.resetInfo()
	moSetGetOverlays.infoHelpBox.info.txt = "";
	HUDPopupMessage.COLOR.TEXT = moSetGetOverlays.infoHelpBox.info.defaultColor;	
	g_currentMission.hud.popupMessage.pendingMessages = {};
	moSetGetOverlays.infoHelpBox.info = {txt="", titel=tostring(MultiOverlayV4.metadata.title).. " Info Text", typ=0, txtColor="yellow", posX=0, posY=0, width=0, height=0, timer=1, bounds={1, 1}, lsTimer=-1, defaultColor=HUDPopupMessage.COLOR.TEXT};
end;

function moDraw.infoHelpBox.resetHelp()
	moSetGetOverlays.infoHelpBox.help.txt = "";
	HUDPopupMessage.COLOR.TEXT = moSetGetOverlays.infoHelpBox.help.defaultColor;	
	g_currentMission.hud.popupMessage.pendingMessages = {};
	moSetGetOverlays.infoHelpBox.help = {txt="", titel=tostring(MultiOverlayV4.metadata.title).. " Help Text",typ=0, txtColor="yellow", posX=0, posY=0, width=0, height=0, timer=1, bounds={1, 1}, lsTimer=-1, defaultColor=HUDPopupMessage.COLOR.TEXT};
end;

function moDraw.infoHelpBox.reset()
	moDraw.infoHelpBox.resetInfo();
	moDraw.infoHelpBox.resetHelp();
end;