moDraw.miniMapAutoState = {};

function moDraw.miniMapAutoState:setOpen()
	moGeneralSettings.clickAreas.miniMapAutoState = {};
	if not g_currentMission.hl.isMouseCursor then return;end;
	local mapState = g_currentMission.hl.getIngameMapState()
	if mapState >=4 then return;end;
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	local posX = g_currentMission.hlGui.menue.posX[2];
	local posY = g_currentMission.hlGui.menue.posY[2];
	local width = g_currentMission.hlGui.menue.width[2];
	local height = g_currentMission.hlGui.menue.height[2];
	local posX = g_currentMission.hlGui.menue.posX[2]+width;	
	local groundIcon = moSetGetOverlays.icons.byName["MultiOverlayV4"]["intern"]["miniMapStateGround"];
	local groundOverlay = moSetGetOverlays.icons["MultiOverlayV4"]["intern"][groundIcon];
	for a=1, 3 do
		local icon = moSetGetOverlays.icons.byName["MultiOverlayV4"]["intern"]["miniMapState".. tostring(a)];
		local overlay = moSetGetOverlays.icons["MultiOverlayV4"]["intern"][icon];	
		g_currentMission.hl.setOverlay(groundOverlay,posX,posY,width,height);
		g_currentMission.hl.setOverlay(overlay,posX,posY,width,height);
		local color = "green";
		if not moGeneralSettings.miniMapAutoState.state[a] then color = "red";end;
		g_currentMission.hl.setBackgroundColor(overlay, g_currentMission.hl.getColor(color, true));
		groundOverlay:render();
		overlay:render();
		if not disableClickArea then moDraw.miniMapAutoState:clickAreas( {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="miniMapAutoStateIcon", whereClick=a} );end;
		posX = posX+width
	end;
end;

function moDraw.miniMapAutoState:clickAreas(args)		
	moGeneralSettings.clickAreas.miniMapAutoState[#moGeneralSettings.clickAreas.miniMapAutoState+1] = {
		args[1]; --posX
		args[2]; --posX1
		args[3]; --posY
		args[4]; --posY1
		whatClick = args.whatClick;			
		whereClick = args.whereClick;		
	};		
end;