moDraw.digi_money = {};

function moDraw.digi_money.onOpen(args)
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	if args.overlay.isFormatTxt ~= nil then 		
		args.overlay.colorState = g_currentMission.hl.getColor("gray", true);
		args.overlay.isFormatTxt = nil;
	end;	
end;

moDraw.digi_money.setMinus = false;
function moDraw.digi_money.setOpen(args)	
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	local playerFarm = g_farmManager:getFarmById(g_currentMission.player.farmId);	
	if playerFarm ~= nil then		
		local money = g_i18n:formatMoney(playerFarm.money, 0, false, false);
		local digiMoneyIcons = moDraw.digi_money:getDigiMoney(money, args.overlay.ownValue == "getM", args.overlay.ownValue == "getT", args.overlay.ownValue == "getH");
		if digiMoneyIcons ~= nil and moSetGetOverlays.icons["MultiOverlayV4"]["digimoney"] ~= nil then
			local pdaTable = moSetGetOverlays.pda[args.whichPda];
			local digiOverlay = moSetGetOverlays.icons["MultiOverlayV4"]["digimoney"];			
			if money ~= nil and tonumber(money) ~= nil then
				if tonumber(money) < 0 and not moDraw.digi_money.setMinus then
					local color = g_currentMission.hl.getColor("darkRed", true);
					for a=1, #digiOverlay do
						g_currentMission.hl.setBackgroundColor(digiOverlay[a], color);					
					end;
					moDraw.digi_money.setMinus = true;
				end;
				if moDraw.digi_money.setMinus and tonumber(money) >= 0 then
					local color = g_currentMission.hl.getColor("darkBlue", true);
					for a=1, #digiOverlay do
						g_currentMission.hl.setBackgroundColor(digiOverlay[a], color);	
					end;
					moDraw.digi_money.setMinus = false;
				end;
			end;			
			if args.overlay.ownValue == "getM" then					
				for _, icon in pairs(digiMoneyIcons.m[1]) do
					g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[icon]:render();
					digiOverlay[icon]:render();
				end;
				for _, icon in pairs(digiMoneyIcons.m[2]) do
					g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[icon]:render();
					digiOverlay[icon]:render();
				end;
				for _, icon in pairs(digiMoneyIcons.m[3]) do
					g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[icon]:render();
					digiOverlay[icon]:render();
				end;				
			end;										
			if args.overlay.ownValue == "getT" then				
				if string.len(money) > 8 then
					g_currentMission.hl.setOverlay(digiOverlay[2], args.overlay.x-(args.overlay.width/2)-(moSetGetOverlays.buttonGfxWidth1*pdaTable.distanceAppIconWidth/2), args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[2]:render();
				end;
				for _, icon in pairs(digiMoneyIcons.t[1]) do
					g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[icon]:render();
					digiOverlay[icon]:render();
				end;
				for _, icon in pairs(digiMoneyIcons.t[2]) do
					g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[icon]:render();
					digiOverlay[icon]:render();
				end;
				for _, icon in pairs(digiMoneyIcons.t[3]) do
					g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[icon]:render();
					digiOverlay[icon]:render();
				end;				
			end;
			if args.overlay.ownValue == "getH" then				
				if string.len(money) > 4 then					
					g_currentMission.hl.setOverlay(digiOverlay[2], args.overlay.x-(args.overlay.width/2)-(moSetGetOverlays.buttonGfxWidth1*pdaTable.distanceAppIconWidth/2), args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[2]:render();
				end;
				for _, icon in pairs(digiMoneyIcons.h[1]) do					
					g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[icon]:render();
					digiOverlay[icon]:render();
				end;
				for _, icon in pairs(digiMoneyIcons.h[2]) do
					g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[icon]:render();
					digiOverlay[icon]:render();
				end;
				for _, icon in pairs(digiMoneyIcons.h[3]) do
					g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
					digiOverlay[icon]:render();
					digiOverlay[icon]:render();
				end;
			end;
		end;
	end;
end;

---MultiOverlayV3---
function moDraw.digi_money:getDigiMoney(money, getM, getT, getH)	
	local digiMoney = {m={[1]={},[2]={},[3]={}},t={[1]={},[2]={},[3]={}},h={[1]={},[2]={},[3]={}}};			
	local fInt = {};
	fInt[0]={32};fInt[1]={23};fInt[2]={24};fInt[3]={25};fInt[4]={26};fInt[5]={27};fInt[6]={28};fInt[7]={29};fInt[8]={30};fInt[9]={31};	
	local mInt = {};
	mInt[0]={22};mInt[1]={13};mInt[2]={14};mInt[3]={15};mInt[4]={16};mInt[5]={17};mInt[6]={18};mInt[7]={19};mInt[8]={20};mInt[9]={21};	
	local eInt = {};
	eInt[0]={12};eInt[1]={3};eInt[2]={4};eInt[3]={5};eInt[4]={6};eInt[5]={7};eInt[6]={8};eInt[7]={9};eInt[8]={10};eInt[9]={11};	
	local foundMoney = false;
	local formatMoney = string.gsub(tostring(money), "-", "");
	local splitMoney = g_currentMission.hl.stringSplit(tostring(formatMoney), ".", true);
	if splitMoney ~= nil and #splitMoney > 0 then
		local isNil = false;
		if getM and #splitMoney > 2 then
			local split = 1;
			isNil = tonumber(splitMoney[split]) == nil;
			if not isNil and tonumber(splitMoney[split]) > 99 then
				local number1 = string.sub(tostring(splitMoney[split]),1,1);				
				digiMoney.m[1] = fInt[tonumber(number1)];
				local number2 = string.sub(tostring(splitMoney[split]),2,2);				
				digiMoney.m[2] = mInt[tonumber(number2)];
				local number3 = string.sub(tostring(splitMoney[split]),3,3);				
				digiMoney.m[3] = eInt[tonumber(number3)];
				foundMoney = true;
			elseif not isNil and tonumber(splitMoney[split]) > 9 then
				local number1 = string.sub(tostring(splitMoney[split]),1,1);				
				digiMoney.m[2] = mInt[tonumber(number1)];
				local number2 = string.sub(tostring(splitMoney[split]),2,2);				
				digiMoney.m[3] = eInt[tonumber(number2)];
				foundMoney = true;
			elseif not isNil and tonumber(splitMoney[split]) >= 0 then
				local number1 = string.sub(tostring(splitMoney[split]),1,1);				
				digiMoney.m[3] = eInt[tonumber(number1)];
				foundMoney = true;
			end;			
		end;
		if getT and #splitMoney > 1 then
			local split = 2;
			if #splitMoney == 2 then split = 1;end;
			isNil = tonumber(splitMoney[split]) == nil;
			if not isNil and tonumber(splitMoney[split]) > 99 or #splitMoney > 2 then
				local number1 = string.sub(tostring(splitMoney[split]),1,1);				
				digiMoney.t[1] = fInt[tonumber(number1)];
				local number2 = string.sub(tostring(splitMoney[split]),2,2);				
				digiMoney.t[2] = mInt[tonumber(number2)];
				local number3 = string.sub(tostring(splitMoney[split]),3,3);				
				digiMoney.t[3] = eInt[tonumber(number3)];
				foundMoney = true;
			elseif not isNil and tonumber(splitMoney[split]) > 9 then
				local number1 = string.sub(tostring(splitMoney[split]),1,1);				
				digiMoney.t[2] = mInt[tonumber(number1)];
				local number2 = string.sub(tostring(splitMoney[split]),2,2);				
				digiMoney.t[3] = eInt[tonumber(number2)];
				foundMoney = true;
			elseif not isNil and tonumber(splitMoney[split]) >= 0 then
				local number1 = string.sub(tostring(splitMoney[split]),1,1);				
				digiMoney.t[3] = eInt[tonumber(number1)];
				foundMoney = true;
			end;			
		end;		
		if getH and #splitMoney >= 1 then
			local split = 1;
			if #splitMoney == 2 then split = 2;end;
			if #splitMoney > 2 then split = 3;end;
			isNil = tonumber(splitMoney[split]) == nil;
			if not isNil and tonumber(splitMoney[split]) > 99 or #splitMoney > 1 then				
				local number1 = string.sub(tostring(splitMoney[split]),1,1);				
				digiMoney.h[1] = fInt[tonumber(number1)];
				local number2 = string.sub(tostring(splitMoney[split]),2,2);				
				digiMoney.h[2] = mInt[tonumber(number2)];
				local number3 = string.sub(tostring(splitMoney[split]),3,3);				
				digiMoney.h[3] = eInt[tonumber(number3)];
				foundMoney = true;
			elseif not isNil and tonumber(splitMoney[split]) > 9 then				
				local number1 = string.sub(tostring(splitMoney[split]),1,1);				
				digiMoney.h[2] = mInt[tonumber(number1)];
				local number2 = string.sub(tostring(splitMoney[split]),2,2);				
				digiMoney.h[3] = eInt[tonumber(number2)];
				foundMoney = true;
			elseif not isNil and tonumber(splitMoney[split]) >= 0 then				 
				local number1 = string.sub(tostring(splitMoney[split]),1,1);				
				digiMoney.h[3] = eInt[tonumber(number1)];
				foundMoney = true;
			end;			
		end;		
	end;
	if not foundMoney then
		digiMoney.h[3] = eInt[0];
	end;
	return digiMoney;	
end;
---MultiOverlayV3---

--function moDraw.digi_moneySymbol.setOpen(args)
--	g_i18n:getCurrencySymbol(true)
--end;