moDraw.otherMods = {};

function moDraw.otherMods.onOpen(args)
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	if args.overlay.ownValue == "handToolsSwitch1" then
		if moGeneralSettings.other.handToolsSwitch then
			args.overlay.colorState = g_currentMission.hl.getColor("green", true);
		else
			args.overlay.colorState = g_currentMission.hl.getColor("red", true);
		end;
	elseif args.overlay.ownValue == "handToolsSwitch2" then
		if moGeneralSettings.other.handToolsSwitch then
			args.overlay.colorState = g_currentMission.hl.getColor("darkGreen", true);
		else
			args.overlay.colorState = g_currentMission.hl.getColor("red", true);
		end;	
	elseif args.overlay.ownValue == "strongFarmer" then
		if MultiOverlayV4.otherMods.strongFarmer == nil then return;end;
		if moGeneralSettings.other.strongFarmer.isOn then
			args.overlay.colorState = g_currentMission.hl.getColor("darkGreen", true);
		else
			args.overlay.colorState = g_currentMission.hl.getColor("red", true);
		end;
	elseif args.overlay.ownValue == "pdaViewModus1" then
		if moSetGetOverlays.pda[args.whichPda].view.isModus == 1 then
			args.overlay.colorState = g_currentMission.hl.getColor("darkGreen", true);
		else
			args.overlay.colorState = g_currentMission.hl.getColor("darkYellow", true);
		end;	
	elseif args.overlay.ownValue == "pdaViewModus2" then
		if moSetGetOverlays.pda[args.whichPda].view.isModus == 1 then
			args.overlay.colorState = g_currentMission.hl.getColor("darkGreen", true);
		else
			args.overlay.colorState = g_currentMission.hl.getColor("darkYellow", true);
		end;
	elseif args.overlay.ownValue == "mouseIcon" then
		if g_currentMission.hl.isMouseCursor then
			args.overlay.colorState = g_currentMission.hl.getColor("darkGreen", true);
		else
			args.overlay.colorState = g_currentMission.hl.getColor("darkGray", true);
		end;	
	elseif args.overlay.ownValue == "gpsOnOff" then
		if g_currentMission.controlledVehicle ~= nil and MultiOverlayV4.otherMods.gps ~= nil then
			local vehicle = g_currentMission.controlledVehicle;			
			if vehicle ~= nil then
				local spec = vehicle.spec_globalPositioningSystem;
				local hasGuidanceSystem = spec ~= nil and spec.hasGuidanceSystem;
				if hasGuidanceSystem then
					if spec.lastInputValues.guidanceIsActive then
						args.overlay.colorState = g_currentMission.hl.getColor("darkGreen", true);
					else
						args.overlay.colorState = g_currentMission.hl.getColor("darkRed", true);
					end;
				else
					args.overlay.colorState = g_currentMission.hl.getColor("darkGray", true);
				end;
			else
				args.overlay.colorState = g_currentMission.hl.getColor("darkGray", true);
			end;
		else
			args.overlay.colorState = g_currentMission.hl.getColor("darkGray", true);
		end;
	elseif args.overlay.ownValue == "contractHudOnOff" then
		if MultiOverlayV4.otherMods.gps ~= nil and FS22_ContractHUD.ContractHUD ~= nil and FS22_ContractHUD.ContractHUD.displayMode ~= nil then
			if FS22_ContractHUD.ContractHUD.displayMode == 2 then
				args.overlay.colorState = g_currentMission.hl.getColor("darkRed", true);
			else
				args.overlay.colorState = g_currentMission.hl.getColor("darkGreen", true);
			end;
		else
			args.overlay.colorState = g_currentMission.hl.getColor("darkGray", true);
		end;
	elseif args.overlay.ownValue == "parkVehicleOnOff" then
		if MultiOverlayV4.otherMods.parkVehicle ~= nil and g_currentMission.controlledVehicle ~= nil then
			local vehicle = g_currentMission.controlledVehicle;
			if vehicle ~= nil and vehicle.spec_parkvehicle ~= nil then
				local spec = vehicle.spec_parkvehicle;
				if spec.state[spec.uniqueUserId] ~= nil then
					if spec.state[spec.uniqueUserId] then
						args.overlay.colorState = g_currentMission.hl.getColor("darkRed", true);
						return;
					else
						args.overlay.colorState = g_currentMission.hl.getColor("darkGreen", true);
						return;
					end;				
				end;			
			end;			
		end;
		args.overlay.colorState = g_currentMission.hl.getColor("darkGray", true);			
	elseif args.overlay.ownValue == "radioOnOff" or args.overlay.ownValue == "radioOnOff" or args.overlay.ownValue == "radioOnOff" then
		if g_soundPlayer ~= nil and g_gameSettings:getValue(GameSettings.SETTING.RADIO_IS_ACTIVE) then --and g_soundPlayer:getIsPlaying() then
			args.overlay.colorState = g_currentMission.hl.getColor("darkGreen", true);			
		else
			args.overlay.colorState = g_currentMission.hl.getColor("darkRed", true);
		end;
	elseif args.overlay.ownValue == "cbFunkOnOff" then
	
	end;
end;