moDraw.slot_typ1 = {};

function moDraw.slot_typ1:setOpen(whichSlot, slotTable)
	local whichSubSlot = whichSlot or "dummySlot_";
	moGeneralSettings.clickAreas.slot[whichSubSlot] = {};
	moGeneralSettings.clickAreas.masterSlot[whichSubSlot] = {};	
	local slotGroundName = slotTable.design.byName.ground;
	local slotIconName = slotTable.design.byName.icon;
	local slotLineName = slotTable.design.byName.line;
	local slotIcon = slotTable.design.icon;
	local slotGround = slotTable.design.ground;
	local slotLine = slotTable.design.line;
	if slotGround == nil or slotIcon == nil or slotLine == nil or slotGroundName == nil or slotIconName == nil or slotLineName == nil then return;end;
	local groundIcon = slotGroundName["groundColorSwitchT"]; 
	local groundIconS = slotGroundName["groundColorSwitchSettingT"];
	local lineIcon = slotLineName["lineBlack"];
	local lineIconS = slotLineName["lineBlackT"];	
	local iconNumber = 0;	
	--if not moDraw.slot:setDesignColor(whichSubSlot, {slotGround[groundIcon], slotGround[groundIconS]}) then return;end;
	local overlay = slotIcon[slotIconName["close"]];
	local iconHeight = moSetGetOverlays.buttonGfxHeight1*slotTable.settingZoomOutIn;
	local iconWidth = moSetGetOverlays.buttonGfxWidth1*slotTable.settingZoomOutIn;
	local tempTxtHeight = getTextHeight(slotTable.txtSize-slotTable.txtSizeLV, utf8Substr("Äg", 0));
	local outputIconHeight = tempTxtHeight; 
	local iconWidescreenFix = 1.6+(moSetGetOverlays.iconWidescreenFix); --breitbild fix
	local outputIconWidth = tempTxtHeight/iconWidescreenFix;	
	local txtLineDistance = moSetGetOverlays.buttonGfxHeight1*slotTable.txtLineDistance;
	local objectDistanceLine = moSetGetOverlays.buttonGfxHeight1*slotTable.setting.objectDistanceLine;
	local distanceIconWidth = moSetGetOverlays.buttonGfxWidth1*slotTable.setting.distanceIconWidth;
	local distanceIconHeight = moSetGetOverlays.buttonGfxHeight1*slotTable.setting.distanceIconHeight;
	local distanceEdgeWidth = moSetGetOverlays.buttonGfxWidth1*slotTable.setting.distanceEdgeWidth;	
	local iconRightPosX = 0;
	local iconLeftPosX = 0;
	local iconPosY = 0;
	local optiSize = 0;
	local color = "";
	local txt = "";	
	local txtHeight = 0;
	local txtLength = 0;
	local txtLengthOld = 0;
	local txtLengthNew = 0;	
	local tempArea = {};
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor; 
	local thisDragDrop = g_currentMission.hl.isMouseCursor and g_currentMission.hl.dragDrop.on and (g_currentMission.hl.dragDrop.what == "_slot_" or g_currentMission.hl.dragDrop.what == "_slotWH_") and g_currentMission.hl.dragDrop.where == whichSubSlot;
		
	---slot setting Height---
	local settingHeight = iconHeight+(distanceIconHeight*2); --default	
	if slotTable.setting.defaultLine then
		settingHeight = settingHeight+((iconHeight+distanceIconHeight)*slotTable.setting.maxDefaultLine);
	end;
	if slotTable.setting.on then
		settingHeight = settingHeight+((iconHeight+distanceIconHeight)*slotTable.setting.maxSettingLine);
	end;
	if slotTable.setting.helpLine then
		settingHeight = settingHeight+((iconHeight+distanceIconHeight)*slotTable.setting.maxHelpLine);
	end;
	if slotTable.setting.infoLine then
		settingHeight = settingHeight+((iconHeight+distanceIconHeight)*slotTable.setting.maxInfoLine);
	end;
	if slotTable.setting.extraLine and not slotTable.setting.on and slotTable.setting.maxExtraLine > 0 then		
		if slotTable.setting.extraLineMultiple then
			settingHeight = settingHeight+((iconHeight+distanceIconHeight)*slotTable.setting.maxExtraLine);		
		else
			settingHeight = settingHeight+(iconHeight+distanceIconHeight);
		end;
	elseif slotTable.setting.on and slotTable.setting.extraLine then
		if slotTable.setting.extraLineMultiple then
			settingHeight = settingHeight+((iconHeight+distanceIconHeight)*#slotTable.setting.extraIconLine);
		else
			settingHeight = settingHeight+(iconHeight+distanceIconHeight);
		end;
	end;
	if slotTable.setting.modLine then --free
		settingHeight = settingHeight+((iconHeight+distanceIconHeight)*slotTable.setting.maxModLine);
	end;
	---slot setting height---
	
	---set drapDrop---
	if thisDragDrop then		
		if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][whichSubSlot] ~= nil then
			MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", whichSubSlot}, "moDraw.slot_typ1:setOpen");
		end;
		if g_currentMission.hl.dragDrop.what == "_slot_" then
			slotTable.posX[slotTable.view.isModus] = MultiOverlayV4.mouseCursor.posX-(iconWidth/2);
			slotTable.posY[slotTable.view.isModus] = MultiOverlayV4.mouseCursor.posY+(iconHeight+(distanceIconHeight*2))+(iconHeight/2);			
			moGeneralSettings.isSave = false;
		elseif g_currentMission.hl.dragDrop.what == "_slotWH_" then
			local tempWidth = MultiOverlayV4.mouseCursor.posX-slotGround[groundIcon].x;
			local tempHeight = (slotGround[groundIcon].y+slotTable.height[slotTable.view.isModus])-MultiOverlayV4.mouseCursor.posY;					
			local setRefresh = false;
			if tempWidth > slotTable.width.default then
				slotTable.width[slotTable.view.isModus] = tempWidth;
				setRefresh = true;
			end;
			if tempHeight > slotTable.height.default then
				slotTable.height[slotTable.view.isModus] = tempHeight;
				setRefresh = true;
			end;
			if setRefresh then
				moSetGetSlot:resetSettingLinesBounds(whichSubSlot);
				moSetGetSlot:setOutputLineBounds( {slotTable=slotTable, reset=true} );
				moGeneralSettings.isSave = false;				
			end;
		end;
	end;	
	---set dragDrop---		
	---ground Settings---	
	g_currentMission.hl.setOverlay(slotGround[groundIconS], 
		slotTable.posX[slotTable.view.isModus], slotTable.posY[slotTable.view.isModus]-settingHeight,
		slotTable.width[slotTable.view.isModus], settingHeight
	);	
	slotGround[groundIconS]:render();	
	---ground Settings---
	---ground---		
	if not slotTable.view[slotTable.view.isModus].isSmallView then		
		g_currentMission.hl.setOverlay(slotGround[groundIcon], 
			slotGround[groundIconS].x, slotGround[groundIconS].y-slotTable.height[slotTable.view.isModus], 
			slotTable.width[slotTable.view.isModus], slotTable.height[slotTable.view.isModus]
		);		
		slotGround[groundIcon]:render();	
		---with slot Width Height---
		moDraw.slot_typ1:clickAreas(true, {slotGround[groundIcon].x, slotGround[groundIcon].x+slotGround[groundIcon].width+(iconWidth/3), slotGround[groundIcon].y, slotGround[groundIcon].y+slotGround[groundIcon].height+slotGround[groundIconS].height+(iconHeight/3), whatClick=whichSubSlot});
		---with slot Width Height---		
	else	
		moDraw.slot_typ1:clickAreas(true, {slotGround[groundIconS].x, slotGround[groundIconS].x+slotGround[groundIconS].width, slotGround[groundIconS].y, slotGround[groundIconS].y+slotGround[groundIconS].height, whatClick=whichSubSlot});
	end;
	moSetGetDraw:setLineBorder(slotLine[lineIcon], slotGround[groundIconS], 1, 0.0005, true, true, true, true);
	---ground---
	
	--------------slot ground line 1--------------	
	iconRightPosX = slotGround[groundIconS].x+slotGround[groundIconS].width-iconWidth-distanceEdgeWidth; 
	iconLeftPosX = slotGround[groundIconS].x+distanceEdgeWidth;
	iconPosY = slotGround[groundIconS].y+slotGround[groundIconS].height-iconHeight-distanceIconHeight;
	if g_currentMission.hl.isMouseCursor then
		----close---
		overlay = slotIcon[slotIconName["buttonClose"]];
		g_currentMission.hl.setOverlay(overlay,iconRightPosX,iconPosY,iconWidth,iconHeight);		
		if overlay.iconType == 2 then
			color = g_currentMission.hl.getColor(slotTable.color.settingOff, true);					
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		iconRightPosX = iconRightPosX-iconWidth-distanceIconWidth;
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="buttonClose_", infoTxt="Close this Slot"});end;
		---close---
		---viewModus---
		overlay = slotIcon[slotIconName["buttonViewModus"]];
		g_currentMission.hl.setOverlay(overlay,iconRightPosX,iconPosY,iconWidth,iconHeight);		
		if overlay.iconType == 2 then
			if slotTable.view.isModus == 1 then
				color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
			else	
				color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;		
		overlay:render();		
		iconRightPosX = iconRightPosX-iconWidth-distanceIconWidth;
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="buttonViewModus_", infoTxt="Set other Pos/Widht/Height"});end;
		---viewModus---
		---smallView---
		overlay = slotIcon[slotIconName["buttonSmallView"]];
		g_currentMission.hl.setOverlay(overlay,iconRightPosX,iconPosY,iconWidth,iconHeight);		
		if overlay.iconType == 2 then
			if slotTable.view[slotTable.view.isModus].isSmallView then
				color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);				
			else
				if slotTable.view.isModus == 1 then
					color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
				else
					color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
				end;
			end;			
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		iconRightPosX = iconRightPosX-iconWidth-distanceIconWidth;
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="buttonSmallView_", infoTxt="Min/Max View Slot"});end;
		---smallView---
		---buttonUp setting defaultLine---
		overlay = slotIcon[slotIconName["buttonDown"]];
		g_currentMission.hl.setOverlay(overlay,iconRightPosX,iconPosY,iconWidth,iconHeight);
		if overlay.iconType == 2 then
			if slotTable.setting.defaultLine then color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);else color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		iconRightPosX = iconRightPosX-iconWidth-distanceIconWidth;
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingDefaultLine_", infoTxt="Open/Close Menue Line"});end;
		---buttonUp setting defaultLine---
		---dragDrop white/height---
		if not slotTable.view[slotTable.view.isModus].isSmallView then		
			overlay = slotIcon[slotIconName["buttonSizeWidthHeight"]];
			g_currentMission.hl.setOverlay(overlay, 
				slotGround[groundIcon].x+slotGround[groundIcon].width-(iconWidth)+(iconWidth/3),
				slotGround[groundIcon].y-(iconHeight/3),
				iconWidth,iconHeight
			);
			if overlay.iconType == 2 then
				if g_currentMission.hl.dragDrop.on and (g_currentMission.hl.dragDrop.what ~= "_slotWH_" or g_currentMission.hl.dragDrop.where ~= whichSubSlot) then 
					color = g_currentMission.hl.getColor(slotTable.color.settingOff, true);			
				elseif g_currentMission.hl.dragDrop.on and g_currentMission.hl.dragDrop.what == "_slotWH_" and g_currentMission.hl.dragDrop.where == whichSubSlot then
					color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
				else 
					color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);			
				end;			
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			if slotTable.setting.on or (thisDragDrop and g_currentMission.hl.dragDrop.what == "_slotWH_") then overlay:render();end;		
			if not disableClickArea or (thisDragDrop and g_currentMission.hl.dragDrop.what == "_slotWH_") then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="dragDropWH_"});end;
		end;
		---dragDrop white/height---
	end;
	if not slotTable.setting.editSlotName or not slotTable.setting.on or (slotTable.setting.editSlotName and slotTable.setting.on and g_currentMission.hl.runsTimer("1sec", true)) or not g_currentMission.hl.isMouseCursor then		
		---slotName---
		txt = utf8Substr(slotTable.name, 0);		
		optiSize = MultiOverlayV4:get_hl("optiHeightSize", {iconHeight, txt, slotTable.maxTxtSize}, "moDraw.slot_typ1:setOpen")-0.0005;	
		local maxTxtWidth = slotGround[groundIconS].width-(iconWidth*4)-(distanceIconWidth*4)-(distanceEdgeWidth*2);
		if not g_currentMission.hl.isMouseCursor then
			maxTxtWidth = slotGround[groundIconS].width-(distanceEdgeWidth*2);
		end;		
		txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, maxTxtWidth, "..", 0);
		color = g_currentMission.hl.getColor(slotTable.color.txtTitle, true);
		setTextBold(true);	
		setTextColor(unpack(color));		
		renderText(iconLeftPosX, iconPosY+(distanceIconHeight), optiSize, txt);
		setTextBold(false);		
		setTextColor(1, 1, 1, 1);
		---slotName---
		overlay = slotIcon[slotIconName["buttonEdit"]];
		g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if slotTable.setting.on and slotTable.setting.editSlotName then
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="editSlotName_", infoTxt="Edit this Slot Name"});end;
		end;
	elseif slotTable.setting.on and not g_currentMission.hl.runsTimer("1sec", true) and slotTable.setting.editSlotName and g_currentMission.hl.isMouseCursor then
		---slotName edit---
		overlay = slotIcon[slotIconName["buttonEdit"]];
		g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if overlay.iconType == 2 then
			color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="editSlotName_", infoTxt="Edit this Slot Name"});end;
		iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
		---slotName edit---
	end;
	--------------slot ground line 1--------------	
	
	--------------slot ground defaultLine--------------
	if slotTable.setting.defaultLine then		
		iconRightPosX = slotGround[groundIconS].x+slotGround[groundIconS].width-iconWidth-distanceEdgeWidth; 
		iconLeftPosX = slotGround[groundIconS].x+distanceEdgeWidth; 
		iconPosY = iconPosY-iconHeight-distanceIconHeight;
		---dragDrop---
		overlay = slotIcon[slotIconName["buttonDragDrop"]];
		g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if overlay.iconType == 2 then
			if g_currentMission.hl.dragDrop.on and (g_currentMission.hl.dragDrop.what ~= "_slot_" or g_currentMission.hl.dragDrop.where ~= whichSubSlot) then 
				color = g_currentMission.hl.getColor(slotTable.color.settingOff, true);			
			elseif g_currentMission.hl.dragDrop.on and g_currentMission.hl.dragDrop.what == "_slot_" and g_currentMission.hl.dragDrop.where == whichSubSlot then
				color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
			else 
				color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);			
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);		
		end;
		overlay:render();
		iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
		if not disableClickArea or (thisDragDrop and g_currentMission.hl.dragDrop.what == "_slot_") then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="dragDrop_", infoTxt="Set New Pos"});end;
		---dragDrop---	
		---setting---
		overlay = slotIcon[slotIconName["buttonSetting"]];
		g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if overlay.iconType == 2 then
			if slotTable.setting.on then
				color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
			else
				color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
			end;				
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="setting_", infoTxt="Open/Close this Slot Menue"});end;
		---setting---
		---setting extra---
		if (slotTable.setting.on and #slotTable.setting.extraIconLine > 0) or (not slotTable.setting.on and #slotTable.setting.extraIconLine > 0 and slotTable.setting.maxExtraLine > 0) then			
			overlay = slotIcon[slotIconName["buttonSettingExtra"]];
			g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
			if overlay.iconType == 2 then				
				if (slotTable.setting.extraLine and slotTable.setting.on) or (slotTable.setting.extraLine and not slotTable.setting.on) then
					color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
				elseif not slotTable.setting.extraLine and slotTable.setting.maxExtraLine > 0 then
					color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
				else
					color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
				end;						
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingExtraLine_", infoTxt="Open/Close Extra Slot Menue"});end;
		end;		
		---setting extra---			
		if not slotTable.setting.on and slotTable.setting.canCmdSettings then	
			---setting cmd---
			overlay = slotIcon[slotIconName["buttonCmd"]];
			g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
			if overlay.iconType == 2 then				
				if moHlGuiCmdSetting:isHlGuiOpen() and moHlGuiCmdSetting:isOpen("Slot", whichSubSlot) then				
					color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
				else
					color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
				end;						
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingCmd_", infoTxt="Open/Close Setting Cmd"});end;
			---setting cmd---			
		elseif slotTable.setting.on and not slotTable.setting.infoLine then
			---setting info---
			overlay = slotIcon[slotIconName["buttonCompactInfo"]];
			g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
			if overlay.iconType == 2 then
				if slotTable.setting.infoLine then
					color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
				else
					color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
				end;				
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingInfoLine_", infoTxt="View Permanent Info (if available)"});end;
			---setting info---
		end;			
		
		---setting test iconView---
		if not slotTable.setting.on then			
			--if overlay.iconType == 2 then
			--	overlay = slotIcon[slotIconName["buttonDistanceObject"]];
			--	g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
			--	if slotTable.setting.cmd then
			--		color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
			--	else
			--		color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
			--	end;						
			--	g_currentMission.hl.setBackgroundColor(overlay, color);
			--end;
			--overlay:render();
			--iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
			--if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingCmd_"});end;
		end;
		---setting test iconView---	
		
		---save---
		overlay = slotIcon[slotIconName["buttonSave"]];
		g_currentMission.hl.setOverlay(overlay,iconRightPosX,iconPosY,iconWidth,iconHeight);
		if overlay.iconType == 2 then
			if moGeneralSettings.isSave then
				color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
			else
				color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
			end;		
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		iconRightPosX = iconRightPosX-iconWidth-distanceIconWidth;
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="save_", infoTxt="Save all MultiOverlay Data"});end;
		---save---
		---global help---
		overlay = slotIcon[slotIconName["buttonHelp"]];
		g_currentMission.hl.setOverlay(overlay,iconRightPosX,iconPosY,iconWidth,iconHeight);
		if overlay.iconType == 2 then
			if slotTable.help.globalOn then
				color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
			end;			
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		iconRightPosX = iconRightPosX-iconWidth-distanceIconWidth;
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="helpGlobal_", infoTxt="View MultiOverlay help Text (if available)"});end;
		---global help---		
		---output help---
		if not slotTable.setting.on and not slotTable.isOtherSlot.isMenue then			
			overlay = slotIcon[slotIconName["buttonHelp"]];
			g_currentMission.hl.setOverlay(overlay,iconRightPosX,iconPosY,iconWidth,iconHeight);
			if overlay.iconType == 2 then
				if slotTable.help.outputOn then
					color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
				else
					color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
				end;			
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			iconRightPosX = iconRightPosX-iconWidth-distanceIconWidth;
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="helpOutput_", infoTxt="View Output/Mod help Text (if available)"});end;
		end;
		---warning output---
		overlay = slotIcon[slotIconName["buttonProductionWarning"]];
		g_currentMission.hl.setOverlay(overlay,iconRightPosX,iconPosY,iconWidth,iconHeight);
		if overlay.iconType == 2 then
			if slotTable.isWarning then
				color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		iconRightPosX = iconRightPosX-iconWidth-distanceIconWidth;
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingOutputProductionWarning_", infoTxt="Set this Slot - Warnings On (isSmallView)"});end;
		---warning output---
		---output help---		
	end;
	--------------slot ground defaultLine--------------	
	
	--------------slot ground setting line--------------
	if slotTable.setting.settingLine and slotTable.setting.on then
		iconRightPosX = slotGround[groundIconS].x+slotGround[groundIconS].width-iconWidth-distanceEdgeWidth; 
		iconLeftPosX = slotGround[groundIconS].x+distanceEdgeWidth; 
		iconPosY = iconPosY-iconHeight-distanceIconHeight;
		local maxIconLine = moSetGetDraw:getMaxWidth(iconRightPosX-iconLeftPosX, iconWidth+distanceIconWidth);
		---setting button left/right---
		if maxIconLine < #slotTable.setting.settingIcon+#slotTable.setting.modIcon then
			maxIconLine = maxIconLine-1;
			overlay = slotIcon[slotIconName["buttonLeftRight"]];
			g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);		
			if overlay.iconType == 2 then
				color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
				g_currentMission.hl.setBackgroundColor(overlay, color);
			end;
			overlay:render();
			iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+(overlay.width/2), overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingLineLeft_"});end;
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x+(overlay.width/2), overlay.x+(overlay.width), overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingLineRight_"});end;
		end;		
		---setting button left/right---
		---setting line settingIcons/modIcons---		
		if slotTable.setting.settingIconLineBounds[3] == 0 or slotTable.setting.settingIconLineBounds[1] == 0 then
			slotTable.setting.settingIconLineBounds[1]=1;slotTable.setting.settingIconLineBounds[2]=maxIconLine;slotTable.setting.settingIconLineBounds[3]=#slotTable.setting.settingIcon+#slotTable.setting.modIcon;
		end;
		local addIconTables = {};		
		table.foreach(slotTable.setting.settingIcon, function(k, v) table.insert(addIconTables, v) end);
		table.foreach(slotTable.setting.modIcon, function(k, v) table.insert(addIconTables, v) end);			
		for a=1, #addIconTables do
			if a >= slotTable.setting.settingIconLineBounds[1] and a <= slotTable.setting.settingIconLineBounds[2] then				
				local iconName = addIconTables[a].name;										
				local overlay = slotIcon[slotIconName[iconName]];
				if overlay == nil then overlay = slotGround[slotGroundName["iconFail"]];end;
				if overlay ~= nil then
					local areaName = iconName.. "_";
					if addIconTables[a].areaName ~= nil then areaName = addIconTables[a].areaName.. "_";end;
					if addIconTables[a].onOpen then
						addIconTables[a].onOpen( {whichSlot=whichSubSlot, areaName=tostring(areaName), overlay=overlay, ownTable=addIconTables[a].ownTable} );
					end;						
					g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);		
					if overlay.iconType == 2 and overlay.colorState ~= nil then g_currentMission.hl.setBackgroundColor(overlay, overlay.colorState);end;
					if overlay.isBlinking == nil or (overlay.isBlinking and g_currentMission.hl.runsTimer("1sec", true)) or not overlay.isBlinking then
						overlay:render();
						if (iconName == "free" or iconName == "buttonTxtLoad") and addIconTables[a].txt ~= nil then
							txt = utf8Substr(tostring(addIconTables[a].txt), 0);
							local difSize = 0;
							if iconName == "buttonTxtLoad" then difSize = 0.003;end;
							optiSize = MultiOverlayV4:get_hl("optiHeightSize", {iconHeight, txt, slotTable.maxTxtSize}, "moDraw.slot_typ1:setOpen")-difSize;
							optiSize = g_currentMission.hl.optiWidthSize(iconWidth, txt, optiSize);
							if addIconTables[a].txtColor ~= nil then
								color = g_currentMission.hl.getColor(addIconTables[a].txtColor, true);
							elseif addIconTables[a].txtSlotColor ~= nil then
								color = g_currentMission.hl.getColor(slotTable.color[addIconTables[a].txtSlotColor], true);
							else
								color = g_currentMission.hl.getColor(slotTable.color.txt, true);
							end;
							txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));							
							setTextBold(true);	
							setTextColor(unpack(color));
							if iconName == "free" then
								renderText(iconLeftPosX, iconPosY+(iconHeight/2)-(txtHeight/2), optiSize, txt);
							else
								txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
								renderText(iconLeftPosX+(iconWidth/2)-(txtWidth/2), iconPosY+(iconHeight/2)-(txtHeight/2), optiSize, txt);
							end;
							setTextBold(false);		
							setTextColor(1, 1, 1, 1);
						end;
					end;
					iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
					if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick=tostring(areaName), isMenue=true, slotTable=slotTable, overlay=overlay, ownTable=addIconTables[a].ownTable, callback=addIconTables[a].callback, infoTxt=addIconTables[a].infoTxt});end;
				end;							
			end;
		end;		
		---setting line settingIcons/modIcons---		
	end;
	--------------slot ground setting line--------------
	
	--------------setting extra line--------------
	if (slotTable.setting.on and #slotTable.setting.extraIconLine > 0 and slotTable.setting.extraLine) or (not slotTable.setting.on and slotTable.setting.extraLine and slotTable.setting.maxExtraLine > 0) then
		local setFirstPosY = true;		
		for extraLine=1, #slotTable.setting.extraIconLine do			
			if slotTable.setting.extraIconLine[extraLine] ~= nil and (slotTable.setting.extraIconLine[extraLine].view or slotTable.setting.on) then
				local boundsLine = extraLine;
				if slotTable.setting.extraLineMultiple or (not slotTable.setting.extraLineMultiple and setFirstPosY) then 
					iconRightPosX = slotGround[groundIconS].x+slotGround[groundIconS].width-iconWidth-distanceEdgeWidth; 
					iconLeftPosX = slotGround[groundIconS].x+distanceEdgeWidth; 
					iconPosY = iconPosY-iconHeight-distanceIconHeight;
					setFirstPosY = false;
				end;
				overlay = slotIcon[slotIconName["buttonSee"]];
				g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
				if overlay.iconType == 2 then					
					if slotTable.setting.extraIconLine[extraLine].view then
						color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
					else
						color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
					end;						
					g_currentMission.hl.setBackgroundColor(overlay, color);
				end;
				overlay:render();
				iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
				if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingMaxExtraLine_", ownTable={line=extraLine}, infoTxt="View On/Off Permanent this Line"});end;
				local maxIconLine = moSetGetDraw:getMaxWidth(iconRightPosX-iconLeftPosX, iconWidth+distanceIconWidth);
				---setting extra button left/right---
				if maxIconLine < #slotTable.setting.extraIconLine[extraLine].icon then
					maxIconLine = maxIconLine-1;
					overlay = slotIcon[slotIconName["buttonLeftRight"]];
					g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);		
					if overlay.iconType == 2 then
						color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
						g_currentMission.hl.setBackgroundColor(overlay, color);
					end;
					overlay:render();
					iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
					if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+(overlay.width/2), overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingExtraLineLeft_", ownTable={line=boundsLine}});end;
					if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x+(overlay.width/2), overlay.x+(overlay.width), overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingExtraLineRight_", ownTable={line=boundsLine}});end;
				end;		
				---setting extra button left/right---
				---setting extra icon---
				if slotTable.setting.extraIconLine[extraLine].bounds[3] == 0 or slotTable.setting.extraIconLine[extraLine].bounds[1] == 0 then
					slotTable.setting.extraIconLine[extraLine].bounds[1]=1;slotTable.setting.extraIconLine[extraLine].bounds[2]=maxIconLine;slotTable.setting.extraIconLine[extraLine].bounds[3]=#slotTable.setting.extraIconLine[extraLine].icon;
				end;				
				for a=1, #slotTable.setting.extraIconLine[extraLine].icon do
					if a >= slotTable.setting.extraIconLine[extraLine].bounds[1] and a <= slotTable.setting.extraIconLine[extraLine].bounds[2] then				
						local iconName = slotTable.setting.extraIconLine[extraLine].icon[a].name;												
						local overlay = slotIcon[slotIconName[iconName]];
						if overlay == nil then overlay = slotGround[slotGroundName["iconFail"]];end;
						if overlay ~= nil then
							local areaName = iconName.. "_";
							if slotTable.setting.extraIconLine[extraLine].icon[a].areaName ~= nil then areaName = slotTable.setting.extraIconLine[extraLine].icon[a].areaName.. "_";end;
							if slotTable.setting.extraIconLine[extraLine].icon[a].onOpen then
								slotTable.setting.extraIconLine[extraLine].icon[a].onOpen( {whichSlot=whichSubSlot, areaName=tostring(areaName), overlay=overlay, ownTable=slotTable.setting.extraIconLine[extraLine].icon[a].ownTable} );
							end;						
							g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);		
							if overlay.iconType == 2 and overlay.colorState ~= nil then g_currentMission.hl.setBackgroundColor(overlay, overlay.colorState);end;
							if overlay.isBlinking == nil or (overlay.isBlinking and g_currentMission.hl.runsTimer("1sec", true)) or not overlay.isBlinking then
								overlay:render();
								if (iconName == "free" or iconName == "buttonTxtLoad") and slotTable.setting.extraIconLine[extraLine].icon[a].txt ~= nil then
									txt = utf8Substr(tostring(slotTable.setting.extraIconLine[extraLine].icon[a].txt), 0);									
									local difSize = 0;
									if iconName == "buttonTxtLoad" then difSize = 0.003;end;
									optiSize = MultiOverlayV4:get_hl("optiHeightSize", {iconHeight, txt, slotTable.maxTxtSize}, "moDraw.slot_typ1:setOpen")-difSize;
									optiSize = g_currentMission.hl.optiWidthSize(iconWidth, txt, optiSize);
									if slotTable.setting.extraIconLine[extraLine].icon[a].txtColor ~= nil then
										color = g_currentMission.hl.getColor(slotTable.setting.extraIconLine[extraLine].icon[a].txtColor, true);
									elseif slotTable.setting.extraIconLine[extraLine].icon[a].txtSlotColor ~= nil then
										color = g_currentMission.hl.getColor(slotTable.color[slotTable.setting.extraIconLine[extraLine].icon[a].txtSlotColor], true);
									else
										color = g_currentMission.hl.getColor(slotTable.color.txt, true);
									end;
									txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));									
									setTextBold(true);	
									setTextColor(unpack(color));
									if iconName == "free" then
										renderText(iconLeftPosX, iconPosY+(iconHeight/2)-(txtHeight/2), optiSize, txt);
									else
										txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
										renderText(iconLeftPosX+(iconWidth/2)-(txtWidth/2), iconPosY+(iconHeight/2)-(txtHeight/2), optiSize, txt);
									end;
									setTextBold(false);		
									setTextColor(1, 1, 1, 1);
								end;
							end;
							iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
							if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick=tostring(areaName), isMenue=true, slotTable=slotTable, overlay=overlay, ownTable=slotTable.setting.extraIconLine[extraLine].icon[a].ownTable, callback=slotTable.setting.extraIconLine[extraLine].icon[a].callback, infoTxt=slotTable.setting.extraIconLine[extraLine].icon[a].infoTxt});end;
						end;												
					end;
				end;	
				---setting extra icon---
			end;
		end;		
	end;	
	--------------setting extra line--------------
	
	--------------setting info line Txt and timer--------------
	if slotTable.setting.infoLine then
		iconRightPosX = slotGround[groundIconS].x+slotGround[groundIconS].width-iconWidth-distanceEdgeWidth; 
		iconLeftPosX = slotGround[groundIconS].x+distanceEdgeWidth; 
		iconPosY = iconPosY-iconHeight-distanceIconHeight;
		overlay = slotIcon[slotIconName["buttonCompactInfo"]];
		g_currentMission.hl.setOverlay(overlay,iconLeftPosX,iconPosY,iconWidth,iconHeight);
		if overlay.iconType == 2 then
			if slotTable.setting.infoLine then
				color = g_currentMission.hl.getColor(slotTable.color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(slotTable.color.settingDefault, true);
			end;				
			g_currentMission.hl.setBackgroundColor(overlay, color);
		end;
		overlay:render();
		iconLeftPosX = iconLeftPosX+iconWidth+distanceIconWidth;
		if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="settingInfoLine_", infoTxt="View Permanent Info Line"} );end;
		
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."infoLine"] == nil then
			g_currentMission.hl.addTimer({name=whichSubSlot.."infoLine", delay=3, repeatable=2, ownTable={infoTxt="",whichSlot=whichSubSlot}});
		else
			txt = utf8Substr(tostring(g_currentMission.hl.timers[whichSubSlot.."infoLine"].ownTable.infoTxt), 0);
			if utf8Strlen(txt) > 0 then
				optiSize = MultiOverlayV4:get_hl("optiHeightSize", {iconHeight, txt, slotTable.maxTxtSize}, "moDraw.slot_typ1:setOpen")-0.0005;
				optiSize = g_currentMission.hl.optiWidthSize(iconRightPosX-iconLeftPosX, txt, optiSize);
				color = g_currentMission.hl.getColor(slotTable.color.txtTitle, true);
				setTextBold(true);	
				setTextColor(unpack(color));
				renderText(iconLeftPosX, iconPosY+distanceIconHeight, optiSize, txt);
				setTextBold(false);		
				setTextColor(1, 1, 1, 1);
			end;
		end;
	end;
	--------------setting info line Txt and timer--------------
		
		
	--------------output cmd and lines with more txt--------------
	if not slotTable.view[slotTable.view.isModus].isSmallView and #slotTable.cmd > 0 then	
		local outputTable = moDraw.slot_typ1:getFormatOutputLines(slotTable);
		txtHeight = getTextHeight(slotTable.txtSize, utf8Substr("Äg", 0));
		local firstTxtPosY = slotGround[groundIconS].y-distanceIconHeight;
		local nextTxtPosY = txtHeight+txtLineDistance;
		local endTxtPosY = slotGround[groundIcon].y+(distanceIconHeight)+(iconHeight/2);		
		local isLineView = 0;
		local stopFor = false;		
		for outputLine=1, #outputTable do			
			if stopFor then break;end;
			if outputLine > 1 and isLineView > 0 then moSetGetDraw:setLineBorder(slotLine[slotLineName["lineBlackBorderUp"]], {x=slotGround[groundIcon].x,y=firstTxtPosY-nextTxtPosY+(txtHeight+(txtLineDistance)),width=slotGround[groundIcon].width,height=0}, 1, 0.0008, false, true, false, false, slotTable.color.txt);end;
			local outputL = outputTable[outputLine].line;
			if outputL ~= nil then
				for line=1, #outputL do
					if stopFor then break;end;
					if outputL[line].view then
						if outputL[line].txt ~= nil and #outputL[line].txt > 0 then
							local txtWidth = moDraw.slot_typ1:getLineWidth(slotGround[groundIcon].width-(distanceEdgeWidth*2)-(distanceEdgeWidth*#outputL[line].txt), outputL[line]);
							if #txtWidth > 0 then
								local txtPosX = slotGround[groundIcon].x+(distanceEdgeWidth);
								for lineTxt=1, #outputL[line].txt do								
									if txtWidth[lineTxt] ~= nil then
										--output Icons
										local txtDifPosXBefore = 0;
										local txtDifPosXAfter = 0;
										local outputIconB = 0;
										local outputIconA = 0;										
										if outputL[line].txt[lineTxt].icon ~= nil then
											if outputL[line].txt[lineTxt].icon.before ~= nil and #outputL[line].txt[lineTxt].icon.before > 0 then outputIconB = (outputIconWidth+distanceEdgeWidth)*#outputL[line].txt[lineTxt].icon.before;end;
											if outputL[line].txt[lineTxt].icon.after ~= nil and #outputL[line].txt[lineTxt].icon.after > 0 then outputIconA = (outputIconWidth+distanceEdgeWidth)*#outputL[line].txt[lineTxt].icon.after;end;
										end;
										--outputIcons--
										local txtWidthWithIcons = txtWidth[lineTxt]-(distanceEdgeWidth*3)-(outputIconB)-(outputIconA);
										iconRightPosX = txtPosX+txtWidth[lineTxt]-outputIconWidth;
										iconLeftPosX = txtPosX;	
										--outputIconBefore--
										if outputIconB > 0 then
											local iconTable = outputL[line].txt[lineTxt].icon.before;
											for icon=1, #iconTable do												
												local setIcon = false;												
												if iconTable[icon] ~= nil and (iconTable[icon].settingButton == nil or not iconTable[icon].settingButton) and iconTable[icon].name ~= nil and iconTable[icon].modName ~= nil and iconTable[icon].groupName ~= nil then
													if moSetGetOverlays.icons.byName[iconTable[icon].modName] ~= nil and moSetGetOverlays.icons.byName[iconTable[icon].modName][iconTable[icon].groupName] ~= nil and moSetGetOverlays.icons.byName[iconTable[icon].modName][iconTable[icon].groupName][iconTable[icon].name] ~= nil then
														setIcon = true;
														local iconNumber = moSetGetOverlays.icons.byName[iconTable[icon].modName][iconTable[icon].groupName][iconTable[icon].name];
														overlay = moSetGetOverlays.icons[iconTable[icon].modName][iconTable[icon].groupName][iconNumber];
													end;
												elseif iconTable[icon] ~= nil and iconTable[icon].settingButton ~= nil and iconTable[icon].settingButton and iconTable[icon].name ~= nil and slotIcon[slotIconName[iconTable[icon].name]] ~= nil then
													setIcon = true;													
													overlay = slotIcon[slotIconName[iconTable[icon].name]]
												end;
												if setIcon and overlay ~= nil then
													if overlay.iconType == 2 then
														if iconTable[icon].color ~= nil then 
															color = g_currentMission.hl.getColor(iconTable[icon].color, true);
															g_currentMission.hl.setBackgroundColor(overlay, color);
														elseif iconTable[icon].slotColor ~= nil then
															color = g_currentMission.hl.getColor(slotTable.color[iconTable[icon].slotColor], true);
															g_currentMission.hl.setBackgroundColor(overlay, color);
														end;
													end;
													g_currentMission.hl.setOverlay(overlay,iconLeftPosX,firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
													if iconTable[icon].callback ~= nil and #iconTable[icon].callback > 0 then
														if #iconTable[icon].callback > 1 then
															if iconTable[icon].halfButton == nil or iconTable[icon].halfButton == "upDown" then
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y+overlay.height/2, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[1], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height/2, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[2], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
															elseif iconTable[icon].halfButton ~= nil and iconTable[icon].halfButton == "leftRight" then
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width/2, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[1], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x+overlay.width/2, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[2], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
															end;
														else
															if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[1], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
														end;
													end;
													if iconLeftPosX+outputIconWidth+distanceEdgeWidth < iconLeftPosX+txtWidth[lineTxt] then
														overlay:render();
														txtDifPosXBefore = txtDifPosXBefore+outputIconWidth+distanceEdgeWidth
														iconLeftPosX = iconLeftPosX+outputIconWidth+distanceEdgeWidth;
													else
														break;
													end;
												end;
											end;
										end;
										--outputIconBefore--
										--outputIconAfter--
										if outputIconA > 0 then
											local iconTable = outputL[line].txt[lineTxt].icon.after;
											for icon=1, #iconTable do												
												local setIcon = false;
												if iconTable[icon] ~= nil and (iconTable[icon].settingButton == nil or not iconTable[icon].settingButton) and iconTable[icon].name ~= nil and iconTable[icon].modName ~= nil and iconTable[icon].groupName ~= nil then
													if moSetGetOverlays.icons.byName[iconTable[icon].modName] ~= nil and moSetGetOverlays.icons.byName[iconTable[icon].modName][iconTable[icon].groupName] ~= nil and moSetGetOverlays.icons.byName[iconTable[icon].modName][iconTable[icon].groupName][iconTable[icon].name] ~= nil then
														setIcon = true;
														local iconNumber = moSetGetOverlays.icons.byName[iconTable[icon].modName][iconTable[icon].groupName][iconTable[icon].name];
														overlay = moSetGetOverlays.icons[iconTable[icon].modName][iconTable[icon].groupName][iconNumber];
													end;
												elseif iconTable[icon] ~= nil and iconTable[icon].settingButton ~= nil and iconTable[icon].settingButton and iconTable[icon].name ~= nil and slotIcon[slotIconName[iconTable[icon].name]] ~= nil then
													setIcon = true;
													overlay = slotIcon[slotIconName[iconTable[icon].name]]
												end;
												if setIcon and overlay ~= nil then													
													if overlay.iconType == 2 then
														if iconTable[icon].color ~= nil then 
															color = g_currentMission.hl.getColor(iconTable[icon].color, true);
															g_currentMission.hl.setBackgroundColor(overlay, color);
														elseif iconTable[icon].slotColor ~= nil then
															color = g_currentMission.hl.getColor(slotTable.color[iconTable[icon].slotColor], true);
															g_currentMission.hl.setBackgroundColor(overlay, color);
														end;
													end;
													g_currentMission.hl.setOverlay(overlay,iconRightPosX,firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
													if iconTable[icon].callback ~= nil and #iconTable[icon].callback > 0 then
														if #iconTable[icon].callback > 1 then
															if iconTable[icon].halfButton == nil or iconTable[icon].halfButton == "upDown" then
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y+overlay.height/2, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[1], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height/2, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[2], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
															elseif iconTable[icon].halfButton ~= nil and iconTable[icon].halfButton == "leftRight" then
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width/2, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[1], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x+overlay.width/2, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[2], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
															end;
														else
															if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[1], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
														end;
													end;
													if iconRightPosX-outputIconWidth-distanceEdgeWidth > iconLeftPosX then
														overlay:render();														
														txtDifPosXAfter = txtDifPosXAfter+outputIconWidth+distanceEdgeWidth
														iconRightPosX = iconRightPosX-outputIconWidth-distanceEdgeWidth;
													else
														break;
													end;
												end;
											end;
										end;
										--outputIconAfter--
										--output Txt--
										local lastTxtPosX = 0;
										if outputL[line].txt[lineTxt].txt ~= nil and utf8Strlen(outputL[line].txt[lineTxt].txt) > 0 then
											setTextBold(false);		
											setTextColor(1, 1, 1, 1);
											local txtSize = slotTable.txtSize;
											function setTxtColor(txtColorTable)
												if txtColorTable == nil then color = g_currentMission.hl.getColor(slotTable.color.txt, true);return;end;
												if txtColorTable.slotColor ~= nil and slotTable.color[txtColorTable.slotColor] ~= nil then
													color = g_currentMission.hl.getColor(slotTable.color[txtColorTable.slotColor], true);
												elseif txtColorTable.prozentColor ~= nil and slotTable.colorProzent[txtColorTable.prozentColor] ~= nil then
													color = g_currentMission.hl.getColor(slotTable.colorProzent[txtColorTable.prozentColor], true);
												elseif txtColorTable.outputColor ~= nil and slotTable.colorOutput[txtColorTable.outputColor] ~= nil then
													color = g_currentMission.hl.getColor(slotTable.colorOutput[txtColorTable.outputColor], true);
												elseif txtColorTable.color ~= nil then
													color = g_currentMission.hl.getColor(txtColorTable.color, true);
												elseif txtColorTable.otherColor ~= nil then
													color = txtColorTable.otherColor;
												else
													color = g_currentMission.hl.getColor(slotTable.color.txt, true);
												end;
											end;											
											if outputL[line].txt[lineTxt].txtSplitColum ~= nil and outputL[line].txt[lineTxt].txtSplitColum.splitTyp ~= nil and outputL[line].txt[lineTxt].txtSplitColum.txt ~= nil then
												local orginalTxtClone = outputL[line].txt[lineTxt].txt;
												local formatTxt, foundSplitTyp = string.gsub(orginalTxtClone, outputL[line].txt[lineTxt].txtSplitColum.splitTyp, "");
												txt = g_currentMission.hl.getTxtToWidthFix(outputL[line].txt[lineTxt].txt, txtSize, txtWidthWithIcons, "..", foundSplitTyp);
												local txtSplit = g_currentMission.hl.stringSplit(txt, outputL[line].txt[lineTxt].txtSplitColum.splitTyp, true);
												if txtSplit ~= nil and #txtSplit > 0 then													
													local txtSplitPosX = txtPosX+txtDifPosXBefore;
													for split=1, #txtSplit do
														if outputL[line].txt[lineTxt].txtSplitColum.txt[split] ~= nil then
															setTxtColor(outputL[line].txt[lineTxt].txtSplitColum.txt[split]);													
															if outputL[line].txt[lineTxt].txtSplitColum.txt[split].txtBold ~= nil then setTextBold(outputL[line].txt[lineTxt].txtSplitColum.txt[split].txtBold);else setTextBold(false);end;
															txt = tostring(utf8Substr(txtSplit[split], 0));														
															local renderTxtWidth = getTextWidth(txtSize, utf8Substr(txt, 0));														
															setTextColor(unpack(color));
															renderText(txtSplitPosX, firstTxtPosY-nextTxtPosY, txtSize, txt);
															setTextBold(false);		
															setTextColor(1, 1, 1, 1);																											
															if outputL[line].txt[lineTxt].txtSplitColum.txt[split].callback ~= nil then
																tempArea = {
																	[1]=txtSplitPosX; 
																	[2]=txtSplitPosX+renderTxtWidth;
																	[3]=firstTxtPosY-nextTxtPosY;
																	[4]=firstTxtPosY-nextTxtPosY+(txtHeight+txtLineDistance);
																};
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {tempArea[1], tempArea[2], tempArea[3], tempArea[4], whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=outputL[line].txt[lineTxt].txtSplitColum.txt[split].callback, slotTable=slotTable, ownTable=outputL[line].txt[lineTxt].txtSplitColum.txt[split].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=outputL[line].txt[lineTxt].txtSplitColum.txt[split].infoTxt});end;
															end;														
															if split < #txtSplit then															
																txtSplitPosX = txtSplitPosX+renderTxtWidth;
															else
																txtSplitPosX = txtSplitPosX+renderTxtWidth;
															end;
														end;
													end;
													lastTxtPosX = txtSplitPosX;
												end;
											else
												txt = g_currentMission.hl.getTxtToWidthFix(outputL[line].txt[lineTxt].txt, txtSize, txtWidthWithIcons, "..", slotTable.txtWidthFix);
												setTxtColor(outputL[line].txt[lineTxt]);
												if outputL[line].txt[lineTxt].bold ~= nil then setTextBold(outputL[line].txt[lineTxt].bold);else setTextBold(false);end;
												local renderTxtWidth = getTextWidth(txtSize, utf8Substr(txt, 0));
												setTextColor(unpack(color));		
												if outputL[line].txt[lineTxt].alignment == nil or outputL[line].txt[lineTxt].alignment == 1 then
													lastTxtPosX = txtPosX+txtDifPosXBefore+renderTxtWidth;
													renderText(txtPosX+txtDifPosXBefore, firstTxtPosY-nextTxtPosY, txtSize, txt);
												elseif outputL[line].txt[lineTxt].alignment ~= nil and outputL[line].txt[lineTxt].alignment == 2 then									
													lastTxtPosX = txtPosX+(txtWidth[lineTxt]/2)+(renderTxtWidth/2);
													renderText(txtPosX+(txtWidth[lineTxt]/2)-(renderTxtWidth/2), firstTxtPosY-nextTxtPosY, txtSize, txt);
												elseif outputL[line].txt[lineTxt].alignment ~= nil and outputL[line].txt[lineTxt].alignment == 3 then
													lastTxtPosX = nil;
													renderText(txtPosX+txtWidth[lineTxt]-renderTxtWidth-distanceEdgeWidth-txtDifPosXAfter, firstTxtPosY-nextTxtPosY, txtSize, txt);
												end;
											end;
											setTextBold(false);		
											setTextColor(1, 1, 1, 1);											
										end;
										--output Txt--
										--outputIconAfterBehindTxt--
										local lastBehindTxtIcon = false;
										if lastTxtPosX ~= nil and lastTxtPosX > 0 and outputL[line].txt[lineTxt].icon ~= nil and outputL[line].txt[lineTxt].icon.behindTxt ~= nil and #outputL[line].txt[lineTxt].icon.behindTxt > 0 then
											iconLeftPosX = lastTxtPosX+(distanceEdgeWidth*2);
											local iconTable = outputL[line].txt[lineTxt].icon.behindTxt;
											for icon=1, #iconTable do												
												local setIcon = false;
												if iconTable[icon] ~= nil and (iconTable[icon].settingButton == nil or not iconTable[icon].settingButton) and iconTable[icon].name ~= nil and iconTable[icon].modName ~= nil and iconTable[icon].groupName ~= nil then
													if moSetGetOverlays.icons.byName[iconTable[icon].modName] ~= nil and moSetGetOverlays.icons.byName[iconTable[icon].modName][iconTable[icon].groupName] ~= nil and moSetGetOverlays.icons.byName[iconTable[icon].modName][iconTable[icon].groupName][iconTable[icon].name] ~= nil then
														setIcon = true;
														local iconNumber = moSetGetOverlays.icons.byName[iconTable[icon].modName][iconTable[icon].groupName][iconTable[icon].name];
														overlay = moSetGetOverlays.icons[iconTable[icon].modName][iconTable[icon].groupName][iconNumber];
													end;
												elseif iconTable[icon] ~= nil and iconTable[icon].settingButton ~= nil and iconTable[icon].settingButton and iconTable[icon].name ~= nil and slotIcon[slotIconName[iconTable[icon].name]] ~= nil then
													setIcon = true;
													overlay = slotIcon[slotIconName[iconTable[icon].name]]
												end;												
												if setIcon and overlay ~= nil then													
													if overlay.iconType == 2 then
														if iconTable[icon].color ~= nil then 
															color = g_currentMission.hl.getColor(iconTable[icon].color, true);
															g_currentMission.hl.setBackgroundColor(overlay, color);
														elseif iconTable[icon].slotColor ~= nil then
															color = g_currentMission.hl.getColor(slotTable.color[iconTable[icon].slotColor], true);
															g_currentMission.hl.setBackgroundColor(overlay, color);
														end;
													end;
													g_currentMission.hl.setOverlay(overlay,iconLeftPosX,firstTxtPosY-nextTxtPosY,outputIconWidth,outputIconHeight);
													if iconTable[icon].callback ~= nil and #iconTable[icon].callback > 0 then
														if #iconTable[icon].callback > 1 then
															if iconTable[icon].halfButton == nil or iconTable[icon].halfButton == "upDown" then
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y+overlay.height/2, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[1], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height/2, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[2], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
															elseif iconTable[icon].halfButton ~= nil and iconTable[icon].halfButton == "leftRight" then
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width/2, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[1], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
																if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x+overlay.width/2, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[2], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
															end;
														else
															if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=iconTable[icon].callback[1], slotTable=slotTable, ownTable=iconTable[icon].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=iconTable[icon].infoTxt});end;
														end;
													end;
													if iconLeftPosX+outputIconWidth+distanceEdgeWidth < iconRightPosX then
														lastBehindTxtIcon = true;
														overlay:render();														
														iconLeftPosX = iconLeftPosX+outputIconWidth+distanceEdgeWidth;
													else
														break;
													end;
												end;
												
											end;	
										end;
										--outputIconAfterBehindTxt--
										if outputL[line].txt[lineTxt].callback ~= nil and outputL[line].txt[lineTxt].txtSplitColum == nil then
											local int2 = txtPosX+txtDifPosXBefore+txtWidthWithIcons;
											if lastTxtPosX ~= nil and lastBehindTxtIcon then int2 = lastTxtPosX;end;
											tempArea = {
												[1]=txtPosX+txtDifPosXBefore; 
												[2]=int2;
												[3]=firstTxtPosY-nextTxtPosY;
												[4]=firstTxtPosY-nextTxtPosY+(txtHeight+txtLineDistance);
											};
											-->test for select area moSetGetDraw:setLineBorder(slotLine[slotLineName["lineColorBorder"]], {x=tempArea[1],y=tempArea[3],width=tempArea[2]-tempArea[1],height=tempArea[4]-tempArea[3]}, 1, 0.0008, true, true, true, true, slotTable.color.selectMarker);
											if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {tempArea[1], tempArea[2], tempArea[3], tempArea[4], whatClick=whichSubSlot, whereClick="outputLineCallback_", callback=outputL[line].txt[lineTxt].callback, slotTable=slotTable, ownTable=outputL[line].txt[lineTxt].ownTable, cmdPos=outputTable[outputLine].cmdPos, cmdTable=outputTable[outputLine].cmdTable, infoTxt=outputL[line].txt[lineTxt].infoTxt});end;
										end;
										txtPosX = txtPosX+txtWidth[lineTxt]+(distanceEdgeWidth*2);										
									end;
								end;
							end;
						end;
						isLineView = isLineView+1;
						if isLineView >= slotTable.view[slotTable.view.isModus].boundsLine[3] then stopFor=true;break;end;
						nextTxtPosY = nextTxtPosY+(txtHeight+txtLineDistance);
					end;
				end;
			end;					
		end;
		---output scroll---
		if isLineView < slotTable.view[slotTable.view.isModus].boundsLine[4] then
			moSetGetDraw:setLineHorizontal(slotLine[slotLineName["lineBlackBorderUp"]], slotGround[groundIcon].x, endTxtPosY, slotGround[groundIcon].width, 0.0008)
			--moSetGetDraw:setLineBorder(slotLine[slotLineName["lineBlackBorderUp"]], {x=slotGround[groundIcon].x,y=endTxtPosY,width=slotGround[groundIcon].width,height=0}, 1, 0.0008, false, true, false, false);
			---output line up---
			overlay = slotIcon[slotIconName["buttonUp"]];
			g_currentMission.hl.setOverlay(overlay,slotGround[groundIcon].x+(slotGround[groundIcon].width/4)-(iconWidth/2),slotGround[groundIcon].y-(iconHeight/2),iconWidth,iconHeight);
			if slotTable.view[slotTable.view.isModus].boundsLine[1] <= 1 then
				color = g_currentMission.hl.getColor(slotTable.color.settingOff, true);
			else
				color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			local tempOverlay = {
				[1]=slotGround[groundIcon].x+distanceEdgeWidth; 
				[2]=slotGround[groundIcon].x+(slotGround[groundIcon].width/2)-(distanceEdgeWidth*2);
				[3]=slotGround[groundIcon].y;
				[4]=slotGround[groundIcon].y+(iconHeight/2)+distanceIconHeight;
			};			
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick=whichSubSlot, slotTable=slotTable, whereClick="outputLineBoundsUp_"});end;
			---output line up---
			---output line down---
			overlay = slotIcon[slotIconName["buttonDown"]];
			g_currentMission.hl.setOverlay(overlay,slotGround[groundIcon].x+((slotGround[groundIcon].width/4)*3)-(iconWidth/2),slotGround[groundIcon].y-(iconHeight/2),iconWidth,iconHeight);
			if slotTable.view[slotTable.view.isModus].boundsLine[2] >= slotTable.view[slotTable.view.isModus].boundsLine[4] then
				color = g_currentMission.hl.getColor(slotTable.color.settingOff, true);
			else
				color = g_currentMission.hl.getColor(slotTable.color.settingOn, true);
			end;
			g_currentMission.hl.setBackgroundColor(overlay, color);
			overlay:render();
			tempOverlay = {
				[1]=slotGround[groundIcon].x+(slotGround[groundIcon].width/2)+distanceEdgeWidth; 
				[2]=slotGround[groundIcon].x+(slotGround[groundIcon].width)-(distanceEdgeWidth*2);
				[3]=slotGround[groundIcon].y;
				[4]=slotGround[groundIcon].y+(iconHeight/2)+distanceIconHeight;
			};			
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick=whichSubSlot, slotTable=slotTable, whereClick="outputLineBoundsDown_"});end;
			---output line down---
			---output scroll line up---
			tempOverlay = {
				[1]=slotGround[groundIcon].x+distanceEdgeWidth; 
				[2]=slotGround[groundIcon].x+(slotGround[groundIcon].width)-(distanceEdgeWidth*2);
				[3]=slotGround[groundIcon].y;
				[4]=slotGround[groundIcon].y+slotGround[groundIcon].height;
			};
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick=whichSubSlot, slotTable=slotTable, whereClick="outputLineBoundsScrollUp_"});end;
			---output scroll line up---
			---output scroll line down---
			tempOverlay = {
				[1]=slotGround[groundIcon].x+distanceEdgeWidth; 
				[2]=slotGround[groundIcon].x+(slotGround[groundIcon].width)-(distanceEdgeWidth*2);
				[3]=slotGround[groundIcon].y;
				[4]=slotGround[groundIcon].y+slotGround[groundIcon].height;
			};
			if not disableClickArea then moDraw.slot_typ1:clickAreas(false, {tempOverlay[1], tempOverlay[2], tempOverlay[3], tempOverlay[4], whatClick=whichSubSlot, slotTable=slotTable, whereClick="outputLineBoundsScrollDown_"});end;
			---output scroll line down---
		end;
		---output scroll---
	end;	
	--------------output cmd and lines with more txt--------------
	--------------helpTxt Box--------------
	if slotTable.help.globalOn and g_currentMission.hl.isMouseCursor then
		--local helpBoxPosX = MultiOverlayV4.mouseCursor.posX;
		--local helpBoxPosY = MultiOverlayV4.mouseCursor.posY;
		--if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[whichSubSlot.."helpBox"] == nil then
		--	g_currentMission.hl.addTimer({name=whichSubSlot.."helpBox", delay=3, repeatable=2, ownTable={helpTxt="",whichSlot=whichSubSlot}});
		--else		
			--txt = utf8Substr(tostring(g_currentMission.hl.timers["MultiOverlayHelpBox"].ownTable.helpTxt), 0);
			--if utf8Strlen(txt) > 0 then				
				--txtHeight = getTextHeight(0.010, utf8Substr("Äg", 0));
				--local outputTxtHeight = txtHeight; 
				--local outputTxtWidth = txtHeight/1.6;
				--overlay = slotGround[slotGroundName["groundHelpBox"]];
				--g_currentMission.hl.setOverlay(overlay,helpBoxPosX,helpBoxPosY,outputIconWidth*10,outputTxtHeight*3);				
				--color = g_currentMission.hl.getColor("yellow", true);
				--g_currentMission.hl.setBackgroundColor(overlay, color);
				--overlay:render();				
				--color = g_currentMission.hl.getColor("white", true);
				--setTextBold(true);	
				--setTextColor(unpack(color));
				--renderText(overlay.x+distanceEdgeWidth, overlay.y+distanceIconHeight, 0.010, "Test");
				--setTextBold(false);		
				--setTextColor(1, 1, 1, 1);
			--end;
		--end;
	end;
	--------------helpTxt Box--------------	
	--------------setting cmd is ready--------------
	if not slotTable.view[slotTable.view.isModus].isSmallView and moHlGuiCmdSetting:isHlGuiOpen() and moHlGuiCmdSetting:isOpen("Slot", whichSubSlot) then
		if g_currentMission.hl.runsTimer("1sec", true) then
			moSetGetDraw:setLineBorder(slotLine[slotLineName["lineColorBorder"]], slotGround[groundIcon], 1, 0.0008, true, true, true, true, slotTable.color.selectMarker);
		end;
	end;
	--------------setting cmd is ready--------------
end;

function moDraw.slot_typ1:getFormatOutputLines(slotTable)
	local outputLines = {};
	local totalOutputLines = 0;
	if slotTable ~= nil then
		for cmd=1, #slotTable.cmd do
			if slotTable.cmd[cmd] ~= nil then
				if MultiOverlayV4.cmd[slotTable.cmd[cmd].regName] ~= nil then
					local outputTable = MultiOverlayV4.cmd[slotTable.cmd[cmd].regName].actionCallback( {slotTable=slotTable,cmdTable=MultiOverlayV4.cmd[slotTable.cmd[cmd].regName]} );
					if outputTable ~= nil and outputTable.line ~= nil and #outputTable.line > 0 then
						totalOutputLines = totalOutputLines+#outputTable.line;
						outputLines[#outputLines+1] = outputTable;
						outputLines[#outputLines].cmdPos = cmd;
						outputLines[#outputLines].cmdTable = MultiOverlayV4.cmd[slotTable.cmd[cmd].regName];
					end;
				end;
			end;
		end;
	end;	
	if slotTable.view[slotTable.view.isModus].boundsLine[4] == 0 then
		slotTable.view[slotTable.view.isModus].boundsLine[4] = totalOutputLines;
		moSetGetSlot:setOutputLineBounds( {slotTable=slotTable, reset=true} );
	else
		slotTable.view[slotTable.view.isModus].boundsLine[4] = totalOutputLines;
	end;	
	local isLineView = 1;
	local maxNotScrollLine = slotTable.maxNotScrollLine;
	for outputLine=1, #outputLines do
		if outputLines[outputLine].line ~= nil and #outputLines[outputLine].line > 0 then
			for line=1, #outputLines[outputLine].line do					
				if outputLines[outputLine].line[line].notScroll ~= nil and outputLines[outputLine].line[line].notScroll and maxNotScrollLine > 0 then
					outputLines[outputLine].line[line].view = true;
					maxNotScrollLine = maxNotScrollLine-1;
				elseif (isLineView >= slotTable.view[slotTable.view.isModus].boundsLine[1] and isLineView <= slotTable.view[slotTable.view.isModus].boundsLine[2]) then
					outputLines[outputLine].line[line].view = true;						
				else
					outputLines[outputLine].line[line].view = false;
				end;				
				isLineView = isLineView+1;
			end;
		end;
	end;		
	return outputLines;
end;

function moDraw.slot_typ1:clickAreas(masterArea, args)	
	if masterArea ~= nil and masterArea then
		moGeneralSettings.clickAreas.masterSlot[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;
		};
	else	
		moGeneralSettings.clickAreas.slot[args.whatClick][#moGeneralSettings.clickAreas.slot[args.whatClick]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			isMenue = args.isMenue or false;
			mouseClick = "";
			whatClick = args.whatClick;			
			whereClick = args.whereClick;
			infoTxt = args.infoTxt;
			helpTxt = args.helpTxt;
			overlay = args.overlay;
			callback = args.callback;
			cmdTable = args.cmdTable;			
			cmdPos = args.cmdPos;
			ownTable = args.ownTable;
			slotTable = args.slotTable;
		};
	end;	
end;

function moDraw.slot_typ1:getLineWidth(width, lineTable)
	if width <= 0 then return {width};end;
	local lineTyp = #lineTable.txt;	
	local percentWidth = width/100;	
	local isPercentWidth = 0;
	local newWidth = {};	
	if lineTyp == 1 then return {width};end; --set default 1
	local isWidth = 0;
	for a=1, lineTyp do		
		if lineTable.txt[a] ~= nil and lineTable.txt[a].width ~= nil and percentWidth*lineTable.txt[a].width <= width and isPercentWidth < 100 then
			isPercentWidth = isPercentWidth+lineTable.txt[a].width;
			newWidth[a] = percentWidth*lineTable.txt[a].width;
			isWidth = isWidth+1;				
		end;
	end;	
	if isWidth == 0 and lineTyp == 1 then return {width};end; --set default 1
	if isWidth < #lineTable.txt then --error fix width
		local restPercentWidth = 100-isPercentWidth;
		local missingWidth = restPercentWidth/(#lineTable.txt-isWidth);
		for a=1, #lineTable.txt do
			if isWidth < lineTyp then
				if newWidth[a] == nil then
					isPercentWidth = isPercentWidth+missingWidth;
					newWidth[a] = percentWidth*missingWidth;
					isWidth = isWidth+1;					
				end;
			else
				break;
			end;
		end;		
	end;	
	return newWidth;
end;

--MultiOverlayV3 function--
function moDraw.slot_typ1:getLineWidthOld(width, lineTable)
	if width <= 0 then return {width};end;
	local lineTyp = #lineTable.txt;	
	local percentWidth = width/100;	
	local isPercentWidth = 0;
	local newWidth = {};	
	if lineTyp == 1 then return {width};end; --set default 1
	for a=1, lineTyp do		
		if lineTable.txt[a] ~= nil and lineTable.txt[a].width ~= nil and percentWidth*lineTable.txt[a].width <= width and isPercentWidth < 100 then
			isPercentWidth = isPercentWidth+lineTable.txt[a].width;
			table.insert(newWidth, percentWidth*lineTable.txt[a].width);			
		else
			break;
		end;
	end;	
	if #newWidth == 0 and lineTyp == 1 then return {width};end; --set default 1
	if #newWidth < #lineTable.txt then --error fix width
		local restPercentWidth = 100-isPercentWidth;
		local missingWidth = restPercentWidth/(#lineTable.txt-#newWidth);
		local tempNewWidth = #newWidth;
		if tempNewWidth == 0 then tempNewWidth = 1;end;
		for a=tempNewWidth, #lineTable.txt do
			isPercentWidth = isPercentWidth+missingWidth;
			table.insert(newWidth, percentWidth*missingWidth);			
		end;
	end;	
	return newWidth;
end;
--MultiOverlayV3 function--
