moHlGuiCmdSetting = {};

function moHlGuiCmdSetting:load(editTable, editCmdTable)		
	local totalCmdTable, totalGroupCmds = moHlGuiCmdSetting:getCmds();
	local staidCmdTable = moHlGuiCmdSetting:getAllStaidCmds(editCmdTable);
	local slotColor = "";
	local txtBold = false;
	local isStaidCmd = false;
	local color = "";
	local groupName = "ActiveCmds"
	local viewLine = true;
	local activeCmd = {};
	local moreTxt = "";
	local orgCmd = nil;
	
	local lineTable = {line={}};	
	lineTable.line[#lineTable.line+1] = {};
	local isLineTable = lineTable.line[#lineTable.line];
	--isLineTable.notScroll = true;
	isLineTable.txt = {};
	isLineTable.txt[1] = {};
	isLineTable.txt[1].button = {};
	isLineTable.txt[1].bold = true;	
	isLineTable.txt[1].txt = "";
	isLineTable.txt[1].slotColor = "txtExtra";	
	
	local viewDistanceObjectCmdName = {};	
	local tempLineTable = {line={}};
	
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};
	isLineTable.txt[1].button = {};
	if editTable.cmdSettings.openGroup[groupName] ~= nil then txtBold=true;else txtBold=false;end;	
	isLineTable.txt[1].groupName = true;
	isLineTable.txt[1].txt = groupName.. "(".. tostring(#editCmdTable).. ")";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].callback = moHlGuiCmdSetting.returnClickOpenCloseGroup;
	isLineTable.txt[1].ownTable = {groupName=groupName};	
	if editTable.cmdSettings.openGroup[groupName] ~= nil then
		if #editCmdTable > 0 then
			for cmd=1, #editCmdTable do				
				if editCmdTable[cmd] ~= nil then
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};				
					isLineTable.txt[1] = {};				
					isLineTable.txt[1].groupName = false;
					isLineTable.txt[1].bold = true;
					if MultiOverlayV4.cmd[editCmdTable[cmd].regName] == nil then
						isLineTable.txt[1].notFoundCmd = true;
						moreTxt = "(old cmd not found)";
						slotColor = "settingOff"
					else
						orgCmd = MultiOverlayV4.cmd[editCmdTable[cmd].regName];
						moreTxt = "";
						slotColor = "settingActiveCmd"
					end;
					isLineTable.txt[1].activeCmd = true;
					isLineTable.txt[1].slotColor = slotColor;
					isLineTable.txt[1].callback = moHlGuiCmdSetting.returnClickSelectCmd;
					isLineTable.txt[1].ownTable = {groupName=groupName, cmdRegName=editCmdTable[cmd].regName, cmd=cmd};
					if activeCmd[editCmdTable[cmd].regName] == nil then activeCmd[editCmdTable[cmd].regName] = {};end;
					if editTable.cmdSettings.viewDistanceObjectCmd and orgCmd ~= nil and (orgCmd.typ[1] == "output_" or orgCmd.typ[1] == "actionOutput_") and orgCmd.object ~= nil then
						if #orgCmd.object > 1 then moreTxt = moreTxt.. "(".. tostring(#orgCmd.object).. ")";end;
						local x,y,z = g_currentMission.hl.getPlayerPos();
						if x ~= nil and y ~= nil and z ~= nil then
							for o=1, #orgCmd.object do
								if orgCmd.object[o] ~= nil then
									local objectId = orgCmd.object[o].nodeId or orgCmd.object[o].rootNode;		
									local oX,oY,oZ = getWorldTranslation(objectId);
									if oX ~= nil and oY ~= nil and oZ ~= nil then								
										local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, editTable.cmdSettings.distanceObject);
										if nearObject and viewDistanceObjectCmdName[editCmdTable[cmd].regName] == nil then
											if groupName == "ActiveCmds" and orgCmd.groupName == "Open/Close" then 
												viewDistanceObjectCmdName[editCmdTable[cmd].regName] = "Open/Close ".. tostring(editCmdTable[cmd].displayName);
											elseif groupName == "ActiveCmds" and orgCmd.groupName == "Only-Open-Slot/Pda" then 
												viewDistanceObjectCmdName[editCmdTable[cmd].regName] = "Open ".. tostring(editCmdTable[cmd].displayName);
											elseif groupName == "ActiveCmds" and orgCmd.groupName == "Only-Close-Slot/Pda" then 
												viewDistanceObjectCmdName[editCmdTable[cmd].regName] = "Close ".. tostring(editCmdTable[cmd].displayName);
											elseif groupName == "ActiveCmds" and orgCmd.groupName == "Pda-SwitchModus" then
												viewDistanceObjectCmdName[cmd.regName] = "Switch ".. tostring(cmd.displayName);
											else
												viewDistanceObjectCmdName[editCmdTable[cmd].regName] = tostring(editCmdTable[cmd].displayName);
											end;
										end;								
									end;
								end;
							end;
						end;
					elseif orgCmd ~= nil and orgCmd.object ~= nil and #orgCmd.object > 1 then
						moreTxt = moreTxt.. "(".. tostring(#orgCmd.object).. ")";
					end;
					if groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Open/Close" then 
						isLineTable.txt[1].txt = "Open/Close ".. tostring(editCmdTable[cmd].displayName).. moreTxt;
					elseif groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Only-Open-Slot/Pda" then 
						isLineTable.txt[1].txt = "Open ".. tostring(editCmdTable[cmd].displayName).. moreTxt;
					elseif groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Only-Close-Slot/Pda" then 
						isLineTable.txt[1].txt = "Close ".. tostring(editCmdTable[cmd].displayName).. moreTxt;
					elseif groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Pda-SwitchModus" then 
						isLineTable.txt[1].txt = "Switch ".. cmd.displayName.. moreTxt;	
					else
						isLineTable.txt[1].txt = tostring(editCmdTable[cmd].displayName).. moreTxt;
					end;
				end;
			end;
			--function comp(w1,w2)			
			--	if w1.txt[1].txt < w2.txt[1].txt then
			--		return true;
			--	end;			
			--end;	
			--table.sort(lineTable.line, comp);
		end;
	end;
	--for new sort cmds---
	local setGroup = {};
	--for new sort cmds---
	for a=1, #totalCmdTable do		
		moreTxt = "";
		if totalCmdTable[a].groupName ~= groupName then 
			groupName = totalCmdTable[a].groupName;
			if editTable.cmdSettings.openGroup[groupName] ~= nil then txtBold=true;else txtBold=false;end;
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};			
			isLineTable.txt[1] = {};				
			isLineTable.txt[1].groupName = true;
			isLineTable.txt[1].txt = groupName.. "(".. tostring(totalGroupCmds[groupName].groupCmds).. ")";
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].slotColor = "txtOutputTitle";
			isLineTable.txt[1].callback = moHlGuiCmdSetting.returnClickOpenCloseGroup;
			isLineTable.txt[1].ownTable = {groupName=groupName};
		end;
		isStaidCmd = staidCmdTable[totalCmdTable[a].regName] ~= nil;
		local fixTxtColor = false; --pda txt is black
		if isStaidCmd then 
			if activeCmd[totalCmdTable[a].regName] ~= nil and editTable.cmdSettings.viewActiveCmd then 
				txtBold=false;
				viewLine = true;
				slotColor = "settingActiveCmd";
			elseif editTable.cmdSettings.viewAlreadyExistsCmd then 
				txtBold=false;
				viewLine = true;
				slotColor = "settingAlreadyExistsCmd";
			else
				viewLine = false;
			end;			
		else 
			txtBold=true;
			viewLine = true;
			--slotColor = "txt";
			fixTxtColor = true;
		end;
		--new sort cmds---
		if viewLine and editTable.cmdSettings.openGroup[groupName] ~= nil and setGroup[groupName] == nil then
			setGroup[groupName] = {};
			for cmds=1, #totalGroupCmds[groupName].cmds do
				if totalGroupCmds[groupName].cmds[cmds] ~= nil then
					local cmd = totalGroupCmds[groupName].cmds[cmds]
					orgCmd = MultiOverlayV4.cmd[cmd.regName];
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};				
					isLineTable.txt[1] = {};				
					isLineTable.txt[1].groupName = false;			
					isLineTable.txt[1].bold = txtBold;			 
					if fixTxtColor then
						isLineTable.txt[1].color = "white";
					else
						isLineTable.txt[1].slotColor = slotColor;
					end;
					isLineTable.txt[1].callback = moHlGuiCmdSetting.returnClickSelectCmd;
					isLineTable.txt[1].ownTable = {groupName=groupName, cmdRegName=cmd.regName};
					if editTable.cmdSettings.viewDistanceObjectCmd and orgCmd ~= nil and (orgCmd.typ[1] == "output_" or orgCmd.typ[1] == "actionOutput_") and orgCmd.object ~= nil then
						if #orgCmd.object > 1 then moreTxt = moreTxt.. "(".. tostring(#orgCmd.object).. ")";end;
						local x,y,z = g_currentMission.hl.getPlayerPos();
						if x ~= nil and y ~= nil and z ~= nil then
							for o=1, #orgCmd.object do
								if orgCmd.object[o] ~= nil then
									local objectId = orgCmd.object[o].nodeId or orgCmd.object[o].rootNode;		
									local oX,oY,oZ = getWorldTranslation(objectId);
									if oX ~= nil and oY ~= nil and oZ ~= nil then								
										local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, editTable.cmdSettings.distanceObject);
										if nearObject and viewDistanceObjectCmdName[cmd.regName] == nil then
											if groupName == "ActiveCmds" and orgCmd.groupName == "Open/Close" then
												viewDistanceObjectCmdName[cmd.regName] = "Open/Close ".. tostring(cmd.displayName);
											elseif groupName == "ActiveCmds" and orgCmd.groupName == "Only-Open-Slot/Pda" then
												viewDistanceObjectCmdName[cmd.regName] = "Open ".. tostring(cmd.displayName);
											elseif groupName == "ActiveCmds" and orgCmd.groupName == "Only-Close-Slot/Pda" then
												viewDistanceObjectCmdName[cmd.regName] = "Close ".. tostring(cmd.displayName);
											elseif groupName == "ActiveCmds" and orgCmd.groupName == "Pda-SwitchModus" then
												viewDistanceObjectCmdName[cmd.regName] = "Switch ".. tostring(cmd.displayName);
											else
												viewDistanceObjectCmdName[cmd.regName] = tostring(cmd.displayName);
											end;
										end;								
									end;
								end;
							end;
						end;
					elseif orgCmd ~= nil and orgCmd.object ~= nil and #orgCmd.object > 1 then
						moreTxt = moreTxt.. "(".. tostring(#orgCmd.object).. ")";
					end;
					if groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Open/Close" then 
						isLineTable.txt[1].txt = "Open/Close ".. cmd.displayName.. moreTxt;
					elseif groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Only-Open-Slot/Pda" then 
						isLineTable.txt[1].txt = "Open ".. cmd.displayName.. moreTxt;
					elseif groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Only-Close-Slot/Pda" then 
						isLineTable.txt[1].txt = "Close ".. cmd.displayName.. moreTxt;
					elseif groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Pda-SwitchModus" then 
						isLineTable.txt[1].txt = "Switch ".. cmd.displayName.. moreTxt;	
					else			
						isLineTable.txt[1].txt = cmd.displayName.. moreTxt;
					end;
				end;
			end;		
		end;
		--new sort cmds---
		--old--
		if viewLinedisabled and editTable.cmdSettings.openGroup[groupName] ~= nil then
			orgCmd = MultiOverlayV4.cmd[totalCmdTable[a].regName];
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};				
			isLineTable.txt[1] = {};				
			isLineTable.txt[1].groupName = false;			
			isLineTable.txt[1].bold = txtBold;			 
			if fixTxtColor then
				isLineTable.txt[1].color = "white";
			else
				isLineTable.txt[1].slotColor = slotColor;
			end;
			isLineTable.txt[1].callback = moHlGuiCmdSetting.returnClickSelectCmd;
			isLineTable.txt[1].ownTable = {groupName=groupName, cmdRegName=totalCmdTable[a].regName};
			if editTable.cmdSettings.viewDistanceObjectCmd and orgCmd ~= nil and (orgCmd.typ[1] == "output_" or orgCmd.typ[1] == "actionOutput_") and orgCmd.object ~= nil then
				if #orgCmd.object > 1 then moreTxt = moreTxt.. "(".. tostring(#orgCmd.object).. ")";end;
				local x,y,z = g_currentMission.hl.getPlayerPos();
				if x ~= nil and y ~= nil and z ~= nil then
					for o=1, #orgCmd.object do
						if orgCmd.object[o] ~= nil then
							local objectId = orgCmd.object[o].nodeId or orgCmd.object[o].rootNode;		
							local oX,oY,oZ = getWorldTranslation(objectId);
							if oX ~= nil and oY ~= nil and oZ ~= nil then								
								local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, editTable.cmdSettings.distanceObject);
								if nearObject and viewDistanceObjectCmdName[totalCmdTable[a].regName] == nil then
									if groupName == "ActiveCmds" and orgCmd.groupName == "Open/Close" then
										viewDistanceObjectCmdName[cmd.regName] = "Open/Close ".. tostring(cmd.displayName);
									elseif groupName == "ActiveCmds" and orgCmd.groupName == "Only-Open-Slot/Pda" then
										viewDistanceObjectCmdName[cmd.regName] = "Open ".. tostring(cmd.displayName);
									elseif groupName == "ActiveCmds" and orgCmd.groupName == "Only-Close-Slot/Pda" then
										viewDistanceObjectCmdName[cmd.regName] = "Close ".. tostring(cmd.displayName);
									elseif groupName == "ActiveCmds" and orgCmd.groupName == "Pda-SwitchModus" then
										viewDistanceObjectCmdName[cmd.regName] = "Switch ".. tostring(cmd.displayName);
									else
										viewDistanceObjectCmdName[cmd.regName] = tostring(cmd.displayName);
									end;
								end;								
							end;
						end;
					end;
				end;
			elseif orgCmd ~= nil and orgCmd.object ~= nil and #orgCmd.object > 1 then
				moreTxt = moreTxt.. "(".. tostring(#orgCmd.object).. ")";
			end;			
			if groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Open/Close" then 
				isLineTable.txt[1].txt = "Open/Close ".. cmd.displayName.. moreTxt;
			elseif groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Only-Open-Slot/Pda" then 
				isLineTable.txt[1].txt = "Open ".. cmd.displayName.. moreTxt;
			elseif groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Only-Close-Slot/Pda" then 
				isLineTable.txt[1].txt = "Close ".. cmd.displayName.. moreTxt;
			elseif groupName == "ActiveCmds" and orgCmd ~= nil and orgCmd.groupName == "Pda-SwitchModus" then 
				isLineTable.txt[1].txt = "Switch ".. cmd.displayName.. moreTxt;	
			else			
				isLineTable.txt[1].txt = cmd.displayName.. moreTxt;
			end;
		end;
		---old---
	end;
	if editTable.cmdSettings.viewDistanceObjectCmd then		
		table.insert(lineTable.line, 1, {});				
		isLineTable = lineTable.line[1];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].button = {};			
		isLineTable.txt[1].groupName = true;
		isLineTable.txt[1].txt = "NearCmdObject";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].callback = moHlGuiCmdSetting.returnClickOpenCloseGroup;
		isLineTable.txt[1].ownTable = {groupName="NearCmdObject"};		
		local foundObject = 0;
		for cmdRegName, displayName in pairs (viewDistanceObjectCmdName) do
			if viewDistanceObjectCmdName[cmdRegName] ~= nil then
				foundObject = foundObject+1;
				if editTable.cmdSettings.openGroup["NearCmdObject"] ~= nil then
					table.insert(lineTable.line, 2, {});						
					isLineTable = lineTable.line[2];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].groupName = false;
					isLineTable.txt[1].txt = tostring(displayName);
					isLineTable.txt[1].bold = false;			 
					isLineTable.txt[1].slotColor = "txtExtra";
					isLineTable.txt[1].callback = moHlGuiCmdSetting.returnClickSelectCmd;
					isLineTable.txt[1].ownTable = {groupName="NearCmdObject", cmdRegName=cmdRegName};
				end;
			end;
		end;
		if foundObject > 0 then 
			lineTable.line[1].txt[1].txt = lineTable.line[1].txt[1].txt.. "(".. tostring(foundObject).. ")";
			if editTable.cmdSettings.openGroup["NearCmdObject"] == nil then lineTable.line[1].txt[1].slotColor = "txtExtra";end;
		end;
	end;	
	moHlGuiCmdSetting.cmdTable = {output=lineTable};
end;

function moHlGuiCmdSetting:giveOutputTable(args)	
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.editCmdTable == nil then return;end;	
	moHlGuiCmdSetting:load(args.editTable, args.editCmdTable);
	return moHlGuiCmdSetting.cmdTable.output;	
end;

function moHlGuiCmdSetting.returnClickSelectCmd(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moHlGuiCmdSetting:setSelectCmd(args);
	end;
end;

function moHlGuiCmdSetting.returnClickOpenCloseGroup(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.ownTable == nil then return;end;
		if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
			if args.editTable.cmdSettings.openGroup[args.ownTable.groupName] == nil then
				args.editTable.cmdSettings.openGroup[args.ownTable.groupName] = {};
			else
			args.editTable.cmdSettings.openGroup[args.ownTable.groupName] = nil;
		end;
	end;
end;

function moHlGuiCmdSetting:getAllStaidCmds(editCmdTable)
	local cmdStaidTable = {};	
	if moGeneralSettings.cmdSettingMenue.typ == "Slot" then
		local slots = moSetGetSlot:getSlots();
		if #slots > 0 then
			for slot=1, #slots do
				if moSetGetOverlays.slot[slots[slot]] ~= nil and moSetGetOverlays.slot[slots[slot]].cmd ~= nil and #moSetGetOverlays.slot[slots[slot]].cmd > 0 then
					for cmd=1, #moSetGetOverlays.slot[slots[slot]].cmd do
						if moSetGetOverlays.slot[slots[slot]].cmd[cmd] ~= nil then
							if cmdStaidTable[moSetGetOverlays.slot[slots[slot]].cmd[cmd].regName] == nil then
								cmdStaidTable[moSetGetOverlays.slot[slots[slot]].cmd[cmd].regName] = {staid=1};
							else
								cmdStaidTable[moSetGetOverlays.slot[slots[slot]].cmd[cmd].regName].staid = cmdStaidTable[moSetGetOverlays.slot[slots[slot]].cmd[cmd].regName].staid+1;
							end;
						end;
					end;
				end;
			end;
		end;
	else
		for cmd=1, #editCmdTable do
			if editCmdTable[cmd] ~= nil then
				if cmdStaidTable[editCmdTable[cmd].regName] == nil then
					cmdStaidTable[editCmdTable[cmd].regName] = {staid=1};
				else
					cmdStaidTable[editCmdTable[cmd].regName].staid = cmdStaidTable[editCmdTable[cmd].regName].staid+1;
				end;
			end;
		end;		
	end;
	return cmdStaidTable
end;

function moHlGuiCmdSetting:getCmds()
	local isSlot = moGeneralSettings.cmdSettingMenue.typ == "Slot";
	local cmdTable = moSetGetCmd:getCmdTable()
	if cmdTable == nil then return nil;end;	
	local cmdDrawTable = {};	
	local cmdDrawGroup = {};	
	for cmdName,cmdValue in pairs (cmdTable) do
		if (cmdValue.freeCmd == nil or cmdValue.freeCmd) and ( (isSlot and (cmdValue.typ[1] == "output_" or cmdValue.typ[1] == "outputAction_")) or (not isSlot and (cmdValue.typ[1] == "action_" or cmdValue.typ[1] == "actionOutput_")) ) then
			cmdDrawTable[#cmdDrawTable+1] = {};
			cmdDrawTable[#cmdDrawTable].typ = cmdValue.typ[1];
			cmdDrawTable[#cmdDrawTable].regName = cmdName;
			cmdDrawTable[#cmdDrawTable].cmdName = cmdValue.cmdName;
			cmdDrawTable[#cmdDrawTable].modName = cmdValue.modName;
			cmdDrawTable[#cmdDrawTable].groupName = cmdValue.groupName;
			cmdDrawTable[#cmdDrawTable].displayName = cmdValue.displayName;
			if cmdDrawGroup[cmdValue.groupName] == nil then cmdDrawGroup[cmdValue.groupName] = {groupCmds=0,cmds={}};end;
			cmdDrawGroup[cmdValue.groupName].groupCmds = cmdDrawGroup[cmdValue.groupName].groupCmds+1;
			--for new sort cmds---
			cmdDrawGroup[cmdValue.groupName].cmds[#cmdDrawGroup[cmdValue.groupName].cmds+1] = {regName=cmdName,displayName=cmdValue.displayName,cmdName=cmdValue.cmdName,modName=cmdValue.modName,typ=cmdValue.typ[1]};
			function comp2(w1,w2)		
				if w1.displayName < w2.displayName then
					return true;
				end;				
			end;
			table.sort(cmdDrawGroup[cmdValue.groupName].cmds, comp2)
			--for new sort cmds---
		end;
	end;			
	function comp(w1,w2)		
		if w1.groupName < w2.groupName then
			return true;
		end;				
	end;
	function comp1(w1,w2)		
		if w1 < w2 then
			return true;
		end;				
	end;	
	table.sort(cmdDrawTable, comp);	
	table.sort(cmdDrawGroup, comp1);	
	return cmdDrawTable, cmdDrawGroup;
end;

function moHlGuiCmdSetting:isHlGuiOpen()
	if not MultiOverlayV4.hlGui.isLoad then return false;end;
	local isOpen, isMod, isPage, isSide = g_currentMission.hlGui.setGet:getOpenAndWhat();
	return isOpen and isMod == "MultiOverlayV4" and isPage == MultiOverlayV4.hlGui.page["CmdSetting"] and isSide == MultiOverlayV4.hlGui.side["CmdSetting"];
end;

function moHlGuiCmdSetting:isOn()
	if not MultiOverlayV4.hlGui.isLoad then return false;end;
	return moGeneralSettings.cmdSettingMenue.on and string.len(moGeneralSettings.cmdSettingMenue.name) > 0;
end;

function moHlGuiCmdSetting:isOpen(typ, name, appValue)
	if moHlGuiCmdSetting:isOn() then
		if typ == "Slot" and moSetGetOverlays.slot[name] ~= nil then
			if moGeneralSettings.cmdSettingMenue.typ == "Slot" and moGeneralSettings.cmdSettingMenue.name == name then return true;end;
		elseif moSetGetOverlays.pda[name] ~= nil then
			if moGeneralSettings.cmdSettingMenue.typ == "Pda" and moGeneralSettings.cmdSettingMenue.name == name then
				if appValue == nil then return true;end;
				if moGeneralSettings.cmdSettingMenue.app[1] == appValue[1] and moGeneralSettings.cmdSettingMenue.app[2] == appValue[2] then return true;end;
			end;
		end;
	end;
	return false;
end;

function moHlGuiCmdSetting:setOpen(args)
	if not MultiOverlayV4.hlGui.isLoad then return false;end;
	if args ~= nil and args.name ~= nil and args.typ ~= nil then
		if moHlGuiCmdSetting:isOn() and moHlGuiCmdSetting:isOpen(args.typ, args.name, args.appValue) then moHlGuiCmdSetting:setClose();return;end;
		moGeneralSettings.cmdSettingMenue.name = tostring(args.name);
		moGeneralSettings.cmdSettingMenue.typ = tostring(args.typ);
		if args.appValue ~= nil and args.appValue[1] ~= nil and args.appValue[2] ~= nil then
			moGeneralSettings.cmdSettingMenue.app = {args.appValue[1],args.appValue[2]};
		end;
		moGeneralSettings.cmdSettingMenue.on = true;
	end;
	moHlGuiAppIconSetting:setClose();
	g_currentMission.hlGui.setGet:setOpen("MultiOverlayV4", MultiOverlayV4.hlGui.page["CmdSetting"], MultiOverlayV4.hlGui.side["CmdSetting"]);
end;

function moHlGuiCmdSetting:setClose()
	MultiOverlayV4.cmdSetting.selectCmd[1] = nil;
	moGeneralSettings.cmdSettingMenue = {on=false, cmd=0, name="", typ="", app={0,0}};
	moGeneralSettings.clickAreas.menue["cmdSettingMenue"] = {};
	moGeneralSettings.clickAreas.masterMenue["cmdSettingMenue"] = {};
end;

function moHlGuiCmdSetting:getEditTables()
	if moHlGuiCmdSetting:isOn() then
		local editTable = nil;
		local editCmdTable = nil;
		local title = "";
		local name = tostring(moGeneralSettings.cmdSettingMenue.name);
		if moGeneralSettings.cmdSettingMenue.typ == "Pda" then
			if moSetGetOverlays.pda[name] ~= nil then 
				editTable = moSetGetOverlays.pda[name];
				title = "Pda *".. moSetGetOverlays.pda[name].name.. "*";
				if moGeneralSettings.cmdSettingMenue.app[1] > 0 and moGeneralSettings.cmdSettingMenue.app[2] > 0 and g_currentMission.hl.dragDrop.what ~= "_dragDropArea_" then				
					if editTable.apps ~= nil and editTable.apps[moGeneralSettings.cmdSettingMenue.app[1]] ~= nil and editTable.apps[moGeneralSettings.cmdSettingMenue.app[1]][moGeneralSettings.cmdSettingMenue.app[2]].cmd ~= nil then
						editCmdTable = editTable.apps[moGeneralSettings.cmdSettingMenue.app[1]][moGeneralSettings.cmdSettingMenue.app[2]].cmd;
						title = title.. " (Line ".. tostring(moGeneralSettings.cmdSettingMenue.app[1]).. ",App ".. tostring(moGeneralSettings.cmdSettingMenue.app[2].. ")");
					end;
				end;
			end;
		else
			if moSetGetOverlays.slot[name] ~= nil then 
				editTable = moSetGetOverlays.slot[name];				
				title = "Slot *".. moSetGetOverlays.slot[name].name.. "*";
				editCmdTable = editTable.cmd;
			end;
		end;
		return editTable, editCmdTable, title;
	end;
	return nil, nil;
end;

function moHlGuiCmdSetting:setLineBounds(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.mouseClick == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT_UP" then
	
	elseif args.mouseClick == "MOUSE_BUTTON_LEFT_DOWN" then
	
	elseif args.mouseClick == "MOUSE_BUTTON_WHEEL_UP" then		
		if args.editTable.cmdSettings.bounds[1]-1 < 1 then return;end;		
		args.editTable.cmdSettings.bounds[1] = args.editTable.cmdSettings.bounds[1]-1;
		args.editTable.cmdSettings.bounds[2] = args.editTable.cmdSettings.bounds[2]-1;		
	elseif args.mouseClick == "MOUSE_BUTTON_WHEEL_DOWN" then		
		if args.editTable.cmdSettings.bounds[2]+1 > args.editTable.cmdSettings.bounds[3] then return;end;
		args.editTable.cmdSettings.bounds[1] = args.editTable.cmdSettings.bounds[1]+1;
		args.editTable.cmdSettings.bounds[2] = args.editTable.cmdSettings.bounds[2]+1;		
	end;
end;

function moHlGuiCmdSetting:setActiveCmdMoveUpOrDown(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil then return;end;	
	args.editTable.cmdSettings.moveUp = not args.editTable.cmdSettings.moveUp;
	moGeneralSettings.isSave = false;
end;

function moHlGuiCmdSetting:setViewActiveCmd(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil then return;end;	
	args.editTable.cmdSettings.viewActiveCmd = not args.editTable.cmdSettings.viewActiveCmd;
	moGeneralSettings.isSave = false;
end;

function moHlGuiCmdSetting:setViewAlreadyExistsCmd(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil then return;end;	
	args.editTable.cmdSettings.viewAlreadyExistsCmd = not args.editTable.cmdSettings.viewAlreadyExistsCmd;
	moGeneralSettings.isSave = false;
end;

function moHlGuiCmdSetting:setViewDistanceObjectCmd(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil then return;end;	
	args.editTable.cmdSettings.viewDistanceObjectCmd = not args.editTable.cmdSettings.viewDistanceObjectCmd;
	moGeneralSettings.isSave = false;
end;

function moHlGuiCmdSetting:setDistanceObjectCmd(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.mouseClick == nil then return;end;
	local maxDistance = 50;
	local minDistance = 1;
	if args.mouseClick == "MOUSE_BUTTON_LEFT_DOWN" then
		if args.editTable.cmdSettings.distanceObject-1 < minDistance then return;end;
		args.editTable.cmdSettings.distanceObject = args.editTable.cmdSettings.distanceObject-1;
		moGeneralSettings.isSave = false;
	elseif args.mouseClick == "MOUSE_BUTTON_LEFT_UP" then
		if args.editTable.cmdSettings.distanceObject+1 > maxDistance then return;end;
		args.editTable.cmdSettings.distanceObject = args.editTable.cmdSettings.distanceObject+1;
		moGeneralSettings.isSave = false;
	end;	
end;

function moHlGuiCmdSetting:setNewPosActiveCmd(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.editCmdTable == nil or args.ownTable == nil or args.ownTable.cmd == nil then return;end;
	local cmdPos = args.ownTable.cmd;
	local newPosCmd = args.editCmdTable[cmdPos]
	if args.editTable.cmdSettings.moveUp then
		if cmdPos == 1 then
			table.remove(args.editCmdTable, cmdPos);
			table.insert(args.editCmdTable, #args.editCmdTable+1, newPosCmd);
		else
			table.remove(args.editCmdTable, cmdPos);
			table.insert(args.editCmdTable, cmdPos-1, newPosCmd);
		end;	
	else
		if cmdPos == #args.editCmdTable then
			table.remove(args.editCmdTable, cmdPos);
			table.insert(args.editCmdTable, 1, newPosCmd);
		else
			table.remove(args.editCmdTable, cmdPos);
			table.insert(args.editCmdTable, cmdPos+1, newPosCmd);
		end;	
	end;	
	moGeneralSettings.isSave = false;
end;

function moHlGuiCmdSetting:setDeleteActiveCmd(args)	
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.editCmdTable == nil or args.ownTable == nil or args.ownTable.cmd == nil then return;end;
	local orgCmd = MultiOverlayV4.cmd[args.editCmdTable[args.ownTable.cmd].regName];	
	if orgCmd ~= nil then
		if orgCmd.delCmdCallback ~= nil and type(orgCmd.delCmdCallback) == "function" then
			orgCmd.delCmdCallback(args.editTable, orgCmd);
		end;
	end;	
	table.remove(args.editCmdTable, args.ownTable.cmd);	
	if MultiOverlayV4.cmdSetting.selectCmd[1] ~= nil then MultiOverlayV4.cmdSetting.selectCmd[1] = nil;end;	
	moGeneralSettings.isSave = false;
end;

function moHlGuiCmdSetting:setInsertActiveCmd(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.editCmdTable == nil or args.ownTable == nil or args.ownTable.cmdRegName == nil then return;end;
	local orgCmd = MultiOverlayV4.cmd[args.ownTable.cmdRegName];
	if orgCmd ~= nil then		
		args.editCmdTable[#args.editCmdTable+1] = { regName=args.ownTable.cmdRegName,displayName=orgCmd.displayName, mouseClick={orgCmd.mouseClickAccepts[1],orgCmd.mouseClickAccepts[2],orgCmd.mouseClickAccepts[3]} };
		if orgCmd.setCmdCallback ~= nil and type(orgCmd.setCmdCallback) == "function" then
			orgCmd.setCmdCallback(args.editTable, orgCmd);
		end;
	end;
	if args.editTable.cmdSettings.openGroup["ActiveCmds"] == nil then args.editTable.cmdSettings.openGroup["ActiveCmds"] = {};end;	
	moGeneralSettings.isSave = false;
end;

function moHlGuiCmdSetting:setSelectCmd(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil then return;end;	
	if args.cmdTable.regName ~= nil then
		if MultiOverlayV4.cmdSetting.selectCmd[1] ~= nil then 
			if MultiOverlayV4.cmdSetting.selectCmd[1].regName == args.cmdTable.regName then
				MultiOverlayV4.cmdSetting.selectCmd[1] = nil;				
				return;
			else
				MultiOverlayV4.cmdSetting.selectCmd[1] = {regName=args.cmdTable.regName};				
			end;
		end;
		MultiOverlayV4.cmdSetting.selectCmd[1] = {regName=args.cmdTable.regName};	
	end;	
end;

function moHlGuiCmdSetting:setMouseClickCmd(args)
	if args == nil or type(args) ~= "table" or args.editCmdTable == nil or args.ownTable == nil or args.ownTable.cmd == nil or args.ownTable.mouseClick == nil then return;end;
	local orgCmd = MultiOverlayV4.cmd[args.editCmdTable[args.ownTable.cmd].regName];		
	if orgCmd ~= nil then
		if orgCmd.mouseClickAccepts[args.ownTable.mouseClick] then
			args.editCmdTable[args.ownTable.cmd].mouseClick[args.ownTable.mouseClick] = not args.editCmdTable[args.ownTable.cmd].mouseClick[args.ownTable.mouseClick];
			if not args.editCmdTable[args.ownTable.cmd].mouseClick[1] and not args.editCmdTable[args.ownTable.cmd].mouseClick[2] and not args.editCmdTable[args.ownTable.cmd].mouseClick[3] then
				--if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[args.whatClick.."infoLine"] ~= nil then
				--	g_currentMission.hl.timers[args.whatClick.."infoLine"].repeatable = 2;
				--	g_currentMission.hl.timers[args.whatClick.."infoLine"].ownTable.infoTxt = "! cmd is not running (needs 1x mouseclick) !";
				--end;
			end;		
		end;
	end;
	moGeneralSettings.isSave = false;
end;