moAmountsConfig = {};

function moAmountsConfig:defaultValues()
	moAmountsConfig.values = {storages={},updateTimer=10, msec=true};
end;

function moAmountsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moAmountsConfig.values == nil then moAmountsConfig:defaultValues();end;
	--local groupNameTag = (xmlNameTag.. ".module.amounts(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		--moAmountsConfig.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		--moAmountsConfig.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;	
end;

function moAmountsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;
	if moAmountsConfig.values == nil then moAmountsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.amounts(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moAmountsConfig.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moAmountsConfig.values.msec);
	----------------------------------------------------------------------------------------------	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moAmountsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moAmountsConfig.saveXml } );
