moBeehivesOutput = {};

function moBeehivesOutput:load(cmdTable, slotTable, giveAll)
	local playerFarmId = g_currentMission.player.farmId;
	local cmdRegName = cmdTable.regName;
	local cmdObject = cmdTable.object;	
	local lineTable = {line={}};	
	local honeyPerHour = 0;
	local honeyPal = 0;
	local honeyState = 0;
	local fillLevel = 0;
	for o=1, #cmdObject do
		if cmdObject[o] ~= nil and moModuleObjects:isObject(cmdObject[o]) and cmdObject[o].mohTable ~= nil and cmdObject[o].mohTable.general ~= nil and cmdObject[o].mohTable.general[1] ~= nil then
			---check edit object name---
			local displayName = cmdObject[o]:getName();
			if displayName ~= nil and tostring(displayName) ~= tostring(cmdObject[o].mohTable.name) then 
				moBeehivesConfig:refreshCmdDisplayName(cmdRegName, displayName);
				cmdObject[o].mohTable.name = tostring(displayName);				
			end;
			---check edit object name---			
			-------------------------------general-------------------------------
			---objectName---
			local stopInOutput = false;
			local viewMoreInfo = cmdObject[o].mohTable.viewMoreInfo;			
			local beehiveGeneral = cmdObject[o].mohTable.general[1];			
			local isOwned = playerFarmId == beehiveGeneral.ownedFarmId and playerFarmId ~= 0; 
			local canBuy = beehiveGeneral.ownedFarmId == 0;
			honeyPerHour = beehiveGeneral.honeyPerHourUnFormat
			fillLevel = beehiveGeneral.fillLevel;
			local iconColor = "gray";
			local buttonName = "buttonDown";
			lineTable.line[#lineTable.line+1] = {};
			local isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			if giveAll == nil or not giveAll then
				isLineTable.txt[1].slotColor = "txtOutputTitle";
			else
				isLineTable.txt[1].slotColor = "txt";
			end;
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(beehiveGeneral.objectName);		
			isLineTable.txt[1].callback = moBeehivesOutput.clickBeehive;
			isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
			local objectId = cmdObject[o].nodeId or cmdObject[o].rootNode;		
			local oX,oY,oZ = getWorldTranslation(objectId);
			if oX ~= nil and oY ~= nil and oZ ~= nil then
				local x,y,z = g_currentMission.hl.getPlayerPos();
				if x ~= nil and y ~= nil and z ~= nil then
					local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, 10);
					if nearObject then isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";end;
				end;
			end;
			if giveAll == nil or not giveAll then 
				isLineTable.txt[1].alignment = 2;
			end;
			if slotTable ~= nil and slotTable.help.outputOn then
				isLineTable.txt[1].icon = {before={},after={}};
				isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moBeehivesOutput.clickBeehivesHelpTxt}};
			end;
			if g_currentMission.hl.isMouseCursor and isOwned then
				iconColor = "gray";
				if viewMoreInfo then iconColor = "green";end;
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="buttonClock", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moBeehivesOutput.clickViewMoreInfo}, ownTable={cmdObject[o].rootNode}, infoTxt="More Info"};
			end;
			---objectName---			
			if isOwned and viewMoreInfo then				
				---incomeHour---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("fillType_honey")).. ":"; --.. " ".. tostring(g_i18n:getText("shop_incomeValue"));
				isLineTable.txt[1].width = 40;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;				
				isLineTable.txt[2].txt = tostring(beehiveGeneral.honeyPerHour); --tostring(g_i18n:formatMoney(beehiveGeneral.honeyPerHour, 0, true, false));						
				isLineTable.txt[2].width = 60;
				isLineTable.txt[2].alignment = 3;
				---incomeHour---
				---incomeDay---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("fillType_honey")).. ":"; --.. " ".. tostring(g_i18n:getText("ui_month"));	
				isLineTable.txt[1].width = 40;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;				
				isLineTable.txt[2].txt = tostring(beehiveGeneral.honeyPerDay);						
				isLineTable.txt[2].width = 60;
				isLineTable.txt[2].alignment = 3;
				---incomeDay---	
				---range---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("infohud_range"));	
				isLineTable.txt[1].width = 70;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;				
				isLineTable.txt[2].txt = tostring(g_i18n:formatNumber(beehiveGeneral.radius, 0)) .. "m"					
				isLineTable.txt[2].width = 30;
				isLineTable.txt[2].alignment = 3;
				---range---	
				---age---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("modHub_object")).. " ".. tostring(g_i18n:getText("ui_age"));
				isLineTable.txt[1].width = 70;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;			
				if beehiveGeneral.age > 1 or beehiveGeneral.age == 0 then 
					isLineTable.txt[2].txt = tostring(beehiveGeneral.age).. " ".. tostring(g_i18n:getText("ui_days"));
				else
					isLineTable.txt[2].txt = tostring(beehiveGeneral.age).. " ".. tostring(g_i18n:getText("ui_day"));
				end;		
				isLineTable.txt[2].width = 30;
				isLineTable.txt[2].alignment = 3;
				---age---
				---costsPerActiveMonth---
				--lineTable.line[#lineTable.line+1] = {};
				--isLineTable = lineTable.line[#lineTable.line];
				--isLineTable.txt = {};
				--isLineTable.txt[1] = {};
				--isLineTable.txt[1].slotColor = "txt";
				--isLineTable.txt[1].bold = true;
				--isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_maintenance").. "/".. g_i18n:getText("ui_month"));--shop_maintenance	
				--isLineTable.txt[1].width = 70;
				--isLineTable.txt[2] = {};
				--isLineTable.txt[2].slotColor = "txt";
				--isLineTable.txt[2].bold = true;				
				--isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(beehiveGeneral.costsPerActiveMonth, 0, true, false));						
				--isLineTable.txt[2].width = 30;
				--isLineTable.txt[2].alignment = 3;				
				---costsPerActiveMonth---
				---vot support---
				if beehiveGeneral.vot ~= nil then
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].slotColor = "txt";
					isLineTable.txt[1].bold = true;							
					isLineTable.txt[1].width = 70;
					isLineTable.txt[2] = {};
					isLineTable.txt[2].slotColor = "txt";
					isLineTable.txt[2].bold = true;
					if beehiveGeneral.vot.isOpening then
						isLineTable.txt[2].slotColor = "settingOn";
					else
						isLineTable.txt[2].slotColor = "settingOff";
					end;
					isLineTable.txt[2].txt = tostring(beehiveGeneral.vot.openingTimeString);
					if #beehiveGeneral.vot.openingTime == 1 then
						isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_operatingHours")).. "/VOT";							
						isLineTable.txt[1].width = 60;
						isLineTable.txt[2].width = 40;
					else
						isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_operatingHours")).. "/VOT (".. tostring(#beehiveGeneral.vot.openingTime).. ")";							
						isLineTable.txt[2].width = 30;						
						if g_currentMission.hl.isMouseCursor and isOwned then
							local color = "green";
							if not beehiveGeneral.vot.isOpening then
								color = "yellow";
							end;
							isLineTable.txt[1].icon = {before={},after={}};
							isLineTable.txt[1].icon.after[1] = {name="moreInfo", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moBeehivesOutput.clickBeehiveVotOpeningTime}, ownTable={beehiveGeneral.vot.openingTime, p}, infoTxt="VariableOpeningTime Beehive WorkingHours"};
						end;
					end;					
					isLineTable.txt[2].alignment = 3;						
				end;					
				---vot support---
				---separator---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].isSeparator = true;
				isLineTable.txt[1].slotColor = "txtOutputTitle";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = "----";
				isLineTable.txt[2] = {};
				isLineTable.txt[2].isSeparator = true;
				isLineTable.txt[2].slotColor = "txtOutputTitle";
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].txt = "----";
				isLineTable.txt[2].alignment = 3;				
				---separator---
			else
				if not isOwned and canBuy then
					local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
					canBuy = playerFarm.money >= beehiveGeneral.price;
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("action_buyProductionPoint"));
					isLineTable.txt[1].slotColor = "txt";
					isLineTable.txt[1].width = 70;
					isLineTable.txt[1].callback = moBeehivesOutput.clickBuyBeehive;
					isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};					
					isLineTable.txt[2] = {};
					isLineTable.txt[2].bold = true;
					isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(beehiveGeneral.price, 0, true, false));
					if canBuy then
						isLineTable.txt[2].slotColor = "settingOn";
					else
						isLineTable.txt[2].slotColor = "settingOff";
					end;
					isLineTable.txt[2].callback = moBeehivesOutput.clickBuyBeehive;
					isLineTable.txt[2].ownTable = {cmdObject[o].rootNode};
					isLineTable.txt[2].width = 30;
					isLineTable.txt[2].alignment = 3;
					stopInOutput = true;				
				elseif not isOwned and not canBuy then
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_construction_landIsNotOwned")).. " (".. tostring(g_i18n:getText("construction_category_production")).. ")";
					isLineTable.txt[1].slotColor = "settingReady";					
				end;
			end;			
			-------------------------------general-------------------------------
			-------------------------------output--------------------------------
			--if enabled then
			if isOwned then
				if beehiveGeneral.productionActive and beehiveGeneral.pal >= 0 then
					if giveAll ~= nil and giveAll then
						honeyPal = beehiveGeneral.pal;
						honeyState = 1;
					else
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = false;
						if beehiveGeneral.pal > 1 then
							isLineTable.txt[1].txt = tostring(g_i18n:getText("fillType_honey")).. " (".. tostring(g_i18n:getText("typeDesc_pallets")).. ") ".. tostring(g_i18n:getText("fieldJob_tally_total"));
						else
							isLineTable.txt[1].txt = tostring(g_i18n:getText("fillType_honey")).. " (".. tostring(g_i18n:getText("typeDesc_pallet")).. ") ".. tostring(g_i18n:getText("fieldJob_tally_total"));
						end;
						--isLineTable.txt[1].txt = tostring(g_i18n:getText("storeItem_honeyBoxPallet")); --tostring(g_i18n:getText("fillType_honey"));typeDesc_pallet
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].width = 90;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].bold = false;
						isLineTable.txt[2].txt = tostring(g_i18n:formatNumber(beehiveGeneral.pal));
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].width = 10;
						isLineTable.txt[2].alignment = 3;
						if fillLevel > 10 then
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];
							isLineTable.txt = {};
							isLineTable.txt[1] = {};
							isLineTable.txt[1].bold = true;
							isLineTable.txt[1].slotColor = "settingReady";
							isLineTable.txt[2].txt = tostring(g_i18n:getText("ingameNotification_noPalletLocationAvailable") .. string.format(" (%s)", g_i18n:getText("category_beeHives")));
						end;
					end;
				end;
				if (not beehiveGeneral.productionActive or beehiveGeneral.isWinter) and beehiveGeneral.pal >= 0 then
					if giveAll ~= nil and giveAll then
						honeyPal = beehiveGeneral.pal;
						honeyState = 2;
					else
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = false;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_production")).. " ".. tostring(g_i18n:getText("ui_production_status_inactive")).. "/".. tostring(g_i18n:getText("ui_ingameMenuWeather"));
						isLineTable.txt[1].slotColor = "settingReady";						
					end;
				end;
				if (giveAll == nil or not giveAll) and beehiveGeneral.pal < 0 then
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("infohud_beehive_noPalletLocationA"));
					isLineTable.txt[1].slotColor = "settingReady";
				end;			
			end;
			--end;
			-------------------------------output--------------------------------
			if giveAll == nil or not giveAll then
				---objectLineDistance---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};		
				isLineTable.txt[1].txt = " ";
				---objectLineDistance---
			end;
		end;
	end;
	if giveAll == nil or not giveAll then
		moBeehivesOutput[cmdRegName] = {output=lineTable};
	else
		return lineTable, honeyPerHour, honeyPal, honeyState, fillLevel;
	end;
end;

function moBeehivesOutput:loadAll(slotTable)
	local playerFarmId = g_currentMission.player.farmId;	
	local honeyPerHourAll = 0;
	local honeyPalTotal = 0;
	local honeyState = 0;
	local fillLevel = 0;
	local lineTable = {line={}};
	if moModule.beehives ~= nil and #moModule.beehives > 0 then
		local cmdGroup = g_currentMission.multiOverlayV4.cmdFunction.getGroupCmdTable("Beehives");
		if cmdGroup ~= nil and #cmdGroup > 0 then
			for g=1, #cmdGroup do
				if cmdGroup[g] ~= nil and cmdGroup[g].cmd ~= nil and cmdGroup[g].cmd ~= "MultiOverlayV4_cmd_output_allBeehives_" then
					local cmdTable = MultiOverlayV4.cmd[cmdGroup[g].cmd];
					local lineByObject, hPH, hP, hS, fL = moBeehivesOutput:load(cmdTable, nil, true);
					honeyPerHourAll = honeyPerHourAll+hPH;
					honeyPalTotal = hP;
					honeyState = hS;
					fillLevel = fL;
					if lineByObject ~= nil and #lineByObject.line > 0 then
						table.foreach(lineByObject.line, function(k, v) table.insert(lineTable.line, v) end);
					end;
				end;
			end;
		end;
	end;
	if #lineTable.line > 0 and lineTable.line[#lineTable.line].txt ~= nil and lineTable.line[#lineTable.line].txt[1] ~= nil then
		if lineTable.line[#lineTable.line].txt[1].isSeparator ~= nil and lineTable.line[#lineTable.line].txt[1].isSeparator then table.remove(lineTable.line, #lineTable.line);end;
	end;
	table.insert(lineTable.line, 1, {});
	local isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = tostring(g_i18n:getText("category_beeHives"));	
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moBeehivesOutput.clickBeehivesHelpTxt}};
	end;
	if #lineTable.line <= 1 then
		table.insert(lineTable.line, 2, {});
		isLineTable = lineTable.line[2];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "settingReady";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_noItemsAvailable"));	
	else
		table.insert(lineTable.line, 2, {});
		isLineTable = lineTable.line[2];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txt";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = tostring(g_i18n:getText("fillType_honey")).. " ".. tostring(g_i18n:getText("fieldJob_tally_total"));
		isLineTable.txt[1].width = 60;
		isLineTable.txt[2] = {};	
		isLineTable.txt[2].slotColor = "txt";
		isLineTable.txt[2].bold = true;
		isLineTable.txt[2].txt = tostring(string.format(g_i18n:getText("shop_incomeValue"), g_i18n:formatVolume(honeyPerHourAll, 1)));
		isLineTable.txt[2].width = 40;
		isLineTable.txt[2].alignment = 3;
		
		local nextTable = 3
		if honeyState > 0 then			
			table.insert(lineTable.line, nextTable, {});
			isLineTable = lineTable.line[nextTable];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].bold = false;
			if honeyPalTotal > 1 then
				isLineTable.txt[1].txt = tostring(g_i18n:getText("fillType_honey")).. " (".. tostring(g_i18n:getText("typeDesc_pallets")).. ") ".. tostring(g_i18n:getText("fieldJob_tally_total"));
			else
				isLineTable.txt[1].txt = tostring(g_i18n:getText("fillType_honey")).. " (".. tostring(g_i18n:getText("typeDesc_pallet")).. ") ".. tostring(g_i18n:getText("fieldJob_tally_total"));
			end;
			isLineTable.txt[1].slotColor = "txt";
			isLineTable.txt[1].width = 90;
			isLineTable.txt[2] = {};
			isLineTable.txt[2].bold = false;
			isLineTable.txt[2].txt = tostring(g_i18n:formatNumber(honeyPalTotal));
			isLineTable.txt[2].slotColor = "txt";
			isLineTable.txt[2].width = 10;
			isLineTable.txt[2].alignment = 3;
			nextTable = nextTable+1;
			if fillLevel > 10 then
				table.insert(lineTable.line, nextTable, {});
				isLineTable = lineTable.line[nextTable];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].slotColor = "settingReady";
				isLineTable.txt[1].txt = tostring(g_i18n:getText("ingameNotification_noPalletLocationAvailable") .. string.format(" (%s)", g_i18n:getText("category_beeHives")));
				nextTable = nextTable+1;
			end;			
		end;
		if honeyState == 2 then
			table.insert(lineTable.line, nextTable, {});
			isLineTable = lineTable.line[nextTable];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].bold = false;
			isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_production")).. " ".. tostring(g_i18n:getText("ui_production_status_inactive")).. "/".. tostring(g_i18n:getText("ui_ingameMenuWeather"));
			isLineTable.txt[1].slotColor = "settingReady";			
		elseif honeyState == 0 then			
			table.insert(lineTable.line, nextTable, {});
			isLineTable = lineTable.line[nextTable];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(g_i18n:getText("infohud_beehive_noPalletLocationA"));
			isLineTable.txt[1].slotColor = "settingReady";
		end;		
	end;
	---objectLineDistance---
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};		
	isLineTable.txt[1].txt = " ";
	---objectLineDistance---
	moBeehivesOutput["all"] = {output=lineTable};
end;	

function moBeehivesOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.object == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="beehives" } );
	moBeehivesOutput:load(args.cmdTable, args.slotTable);
	return moBeehivesOutput[args.cmdTable.regName].output;
end;

function moBeehivesOutput.giveAllOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="beehives" } );
	moBeehivesOutput:loadAll(args.slotTable);
	return moBeehivesOutput["all"].output;
end;

function moBeehivesOutput.clickBeehivesHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Beehives Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Beehive Name for more Info or MapHotSpot or ...\nClick Mouse Right Optional Titel Beehive Name for Teleport(onFoot)";
	end;
end;

function moBeehivesOutput.clickViewMoreInfo(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "beehives");			
			if object ~= nil then
				object.mohTable.viewMoreInfo = not object.mohTable.viewMoreInfo;
			end;
		end;	
	end;
end;

function moBeehivesOutput.clickBuyBeehive(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "beehives");			
			if object ~= nil then
				--object.spec_productionPoint.productionPoint:buyRequest();				
			end;
		end;	
	end;
end;

function moBeehivesOutput.clickBeehive(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "beehives");			
			if object ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then					
					moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
				end;
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[1] ~= nil and g_currentMission.controlledVehicle == nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "beehives");			
			if object ~= nil and object.spec_hotspots ~= nil and object.spec_hotspots.mapHotspots ~= nil then
				local hotspot = object.spec_hotspots.mapHotspots[1];
				if hotspot ~= nil and hotspot.teleportWorldX ~= nil and hotspot.teleportWorldY ~= nil and hotspot.teleportWorldZ ~= nil then
					g_currentMission.player:moveToAbsolute(hotspot.teleportWorldX, hotspot.teleportWorldY, hotspot.teleportWorldZ, false, false);
					MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moBeehivesOutput.clickBeehive"); --force mouseOff
				end;				
			end;
		end;	
	end;
end;

function moBeehivesOutput.clickBeehiveVotOpeningTime(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local votOpeningTime = args.ownTable[1];
			if votOpeningTime ~= nil and type(votOpeningTime) == "table" then
				local votModName = moModuleSetGet:getVotModName();
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.titel = "Variable-Opening-Time ".. tostring(g_i18n:getText("ui_operatingHours"));
				local txt = tostring(g_i18n:getText("vot_WorkingHours", votModName)).. "\n";
				for a=1, #votOpeningTime do
					txt = txt.. string.format(g_i18n:getText("vot_ClockTime", votModName), tostring(votOpeningTime[a].startTime), tostring(votOpeningTime[a].endTime)).. "\n";
				end;				
				moSetGetOverlays.infoHelpBox.info.txt = txt;
			end;
		end;		
	end;
end;

function moBeehivesOutput.clickViewProductionInfo(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "beehives");			
			if object ~= nil then
				object.mohTable.viewProductionInfo = not object.mohTable.viewProductionInfo;
			end;
		end;	
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="beehives" } );