moBestPricesConfig = {};

function moBestPricesConfig:defaultValues()
	moBestPricesConfig.values = {sellingStations={},buyingStations={},updateTimer=5, msec=false};
end;

function moBestPricesConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moBestPricesConfig.values == nil then moBestPricesConfig:defaultValues();end;
	--local groupNameTag = (xmlNameTag.. ".module.bestPrices(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		--moBestPricesConfig.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		--moBestPricesConfig.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;	
end;

function moBestPricesConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;
	if moBestPricesConfig.values == nil then moBestPricesConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.bestPrices(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moBestPricesConfig.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moBestPricesConfig.values.msec);
	----------------------------------------------------------------------------------------------	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moBestPricesConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moBestPricesConfig.saveXml } );
