moBunkerSilosOutput = {};

function moBunkerSilosOutput:load(cmdTable, slotTable)
	local playerFarmId = g_currentMission.player.farmId;
	local cmdRegName = cmdTable.regName;
	local cmdObject = cmdTable.object;	
	local lineTable = {line={}};	
	for o=1, #cmdObject do
		if cmdObject[o] ~= nil and moModuleObjects:isObject(cmdObject[o]) and cmdObject[o].mohTable ~= nil and cmdObject[o].mohTable.general ~= nil and cmdObject[o].mohTable.general[1] ~= nil then
			---check edit object name---
			local displayName = cmdObject[o]:getName();
			if displayName ~= nil and tostring(displayName) ~= tostring(cmdObject[o].mohTable.name) then 
				moBunkerSilosConfig:refreshCmdDisplayName(cmdRegName, displayName);
				cmdObject[o].mohTable.name = tostring(displayName);				
			end;
			---check edit object name---			
			-------------------------------general-------------------------------
			---objectName---
			local stopInOutput = false;
			local viewMoreInfo = cmdObject[o].mohTable.viewMoreInfo;
			local viewProductionInfo = true; --cmdObject[o].mohTable.viewProductionInfo;
			local viewProductionInfoSmall = cmdObject[o].mohTable.viewProductionInfoSmall;
			local bunkerSiloGeneral = cmdObject[o].mohTable.general[1];
			local isOwned = playerFarmId == bunkerSiloGeneral.ownedFarmId and playerFarmId ~= 0; 
			local canBuy = bunkerSiloGeneral.ownedFarmId == 0;
			local iconColor = "gray";
			local buttonName = "buttonDown";
			lineTable.line[#lineTable.line+1] = {};
			local isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txtOutputTitle";
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(bunkerSiloGeneral.objectName);		
			isLineTable.txt[1].callback = moBunkerSilosOutput.clickBunkerSilo;
			isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
			if g_currentMission.hl.isMouseCursor then
				if slotTable ~= nil and slotTable.help.outputOn then
					if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
					isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moBunkerSilosOutput.clickBunkerSiloHelpTxt}};
				end;
				iconColor = "green";
				buttonName = "buttonUp";
				if viewProductionInfoSmall then iconColor = "gray";buttonName = "buttonDown";end;				
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moBunkerSilosOutput.clickViewProductionInfoSmall}, ownTable={cmdObject[o].rootNode}, infoTxt="BunkerSilo Info Small"};
			end;
			if not isOwned and canBuy then
				iconColor = "red";
				local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
				local tempCanBuy = playerFarm.money >= bunkerSiloGeneral.price;
				if tempCanBuy then iconColor = "green";end;
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="pricesOnOff", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moBunkerSilosOutput.clickBuyBunkerSilo}, ownTable={cmdObject[o].rootNode}, infoTxt="Buy BunkerSilo"};	
			end;
			local objectId = cmdObject[o].nodeId or cmdObject[o].rootNode;		
			local oX,oY,oZ = getWorldTranslation(objectId);
			if oX ~= nil and oY ~= nil and oZ ~= nil then
				local x,y,z = g_currentMission.hl.getPlayerPos();
				if x ~= nil and y ~= nil and z ~= nil then
					local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, 10);
					if nearObject then isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";end;
				end;
			end;		
			isLineTable.txt[1].alignment = 2;			
			if not viewProductionInfoSmall then
				if g_currentMission.hl.isMouseCursor and isOwned then
					iconColor = "gray";
					if viewMoreInfo then iconColor = "green";end;
					if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
					isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="moreInfo", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moBunkerSilosOutput.clickViewMoreInfo}, ownTable={cmdObject[o].rootNode}, infoTxt="More Info"};
				end;
			end;
			---objectName---			
			if not viewProductionInfoSmall then
				if isOwned and viewMoreInfo then				
					---age---
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].slotColor = "txt";
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("modHub_object")).. " ".. tostring(g_i18n:getText("ui_age"));
					isLineTable.txt[1].width = 70;
					isLineTable.txt[2] = {};
					isLineTable.txt[2].slotColor = "txt";
					isLineTable.txt[2].bold = true;			
					if bunkerSiloGeneral.age > 1 or bunkerSiloGeneral.age == 0 then 
						isLineTable.txt[2].txt = tostring(bunkerSiloGeneral.age).. " ".. tostring(g_i18n:getText("ui_days"));
					else
						isLineTable.txt[2].txt = tostring(bunkerSiloGeneral.age).. " ".. tostring(g_i18n:getText("ui_day"));
					end;		
					isLineTable.txt[2].width = 30;
					isLineTable.txt[2].alignment = 3;
					---age---
					---costsPerActiveMonth---
					--lineTable.line[#lineTable.line+1] = {};
					--isLineTable = lineTable.line[#lineTable.line];
					--isLineTable.txt = {};
					--isLineTable.txt[1] = {};
					--isLineTable.txt[1].slotColor = "txt";
					--isLineTable.txt[1].bold = true;
					--isLineTable.txt[1].txt = tostring(g_i18n:getText("finance_productionCosts").. "/".. g_i18n:getText("ui_month"));	
					--isLineTable.txt[1].width = 70;
					--isLineTable.txt[2] = {};
					--isLineTable.txt[2].slotColor = "txt";
					--isLineTable.txt[2].bold = true;				
					--isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(bunkerSiloGeneral.costsPerActiveMonth, 0, true, false));						
					--isLineTable.txt[2].width = 30;
					--isLineTable.txt[2].alignment = 3;				
					---costsPerActiveMonth---
					---separator---
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].slotColor = "txtOutputTitle";
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = "----";
					isLineTable.txt[2] = {};
					isLineTable.txt[2].slotColor = "txtOutputTitle";
					isLineTable.txt[2].bold = true;
					isLineTable.txt[2].txt = "----";
					isLineTable.txt[2].alignment = 3;				
					---separator---
				else
					if not isOwned and canBuy then
						local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
						canBuy = playerFarm.money >= bunkerSiloGeneral.price;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("action_buyProductionPoint"));
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].width = 70;
						isLineTable.txt[1].callback = moBunkerSilosOutput.clickBuyBunkerSilo;
						isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};					
						isLineTable.txt[2] = {};
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(bunkerSiloGeneral.price, 0, true, false));
						if canBuy then
							isLineTable.txt[2].slotColor = "settingOn";
						else
							isLineTable.txt[2].slotColor = "settingOff";
						end;
						isLineTable.txt[2].callback = moBunkerSilosOutput.clickBuyBunkerSilo;
						isLineTable.txt[2].ownTable = {cmdObject[o].rootNode};
						isLineTable.txt[2].width = 30;
						isLineTable.txt[2].alignment = 3;
						stopInOutput = true;				
					elseif not isOwned and not canBuy then
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_construction_landIsNotOwned")).. " (".. tostring(g_i18n:getText("construction_category_production")).. ")";
						isLineTable.txt[1].slotColor = "settingReady";					
					end;
				end;			
				-------------------------------general-------------------------------
				
				----------------------------fermentState-----------------------------
				if not stopInOutput then
					---state---				
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_status"));
					isLineTable.txt[1].callback = moBunkerSilosOutput.clickViewProductionInfo;
					isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
					isLineTable.txt[1].slotColor = "txt";				
					isLineTable.txt[1].width = 30;				
					isLineTable.txt[2] = {};
					isLineTable.txt[2].bold = true;
					if bunkerSiloGeneral.state == BunkerSilo.STATE_CLOSED or bunkerSiloGeneral.state == BunkerSilo.STATE_FERMENTED then
						isLineTable.txt[2].txt = tostring(g_i18n:getText("info_fermenting"));
					elseif bunkerSiloGeneral.state == BunkerSilo.STATE_FILL then
						isLineTable.txt[2].txt = tostring(g_i18n:getText("info_compacting"));
					else
						isLineTable.txt[2].txt = "--";
					end;
					isLineTable.txt[2].slotColor = "txt";							
					isLineTable.txt[2].width = 70;
					isLineTable.txt[2].alignment = 3;				
					---state---	
					---fermenting---								
					if bunkerSiloGeneral.state == BunkerSilo.STATE_FERMENTED or bunkerSiloGeneral.state == BunkerSilo.STATE_CLOSED then
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("info_fermenting"));
						isLineTable.txt[1].prozentColor = bunkerSiloGeneral.fermentingColor;				
						isLineTable.txt[1].width = 70;					
						isLineTable.txt[2] = {};
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = string.format("%d%%", math.ceil(bunkerSiloGeneral.fermentingPercent * 100));
						isLineTable.txt[2].prozentColor = bunkerSiloGeneral.fermentingColor;							
						isLineTable.txt[2].width = 30;
						isLineTable.txt[2].alignment = 3;					
					end;
					if bunkerSiloGeneral.state == BunkerSilo.STATE_FILL then
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("info_compacting"));
						isLineTable.txt[1].prozentColor = bunkerSiloGeneral.compactedColor;				
						isLineTable.txt[1].width = 70;					
						isLineTable.txt[2] = {};
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = string.format(" %d%%", bunkerSiloGeneral.compactedPercent);
						isLineTable.txt[2].prozentColor = bunkerSiloGeneral.compactedColor;							
						isLineTable.txt[2].width = 30;
						isLineTable.txt[2].alignment = 3;
						
						if bunkerSiloGeneral.compactedFillLevel > 0 then
							--lineTable.line[#lineTable.line+1] = {};
							--isLineTable = lineTable.line[#lineTable.line];
							--isLineTable.txt = {};
							--isLineTable.txt[1] = {};
							--isLineTable.txt[1].bold = true;
							--isLineTable.txt[1].txt = tostring(g_i18n:getText("info_fillLevel"));
							--isLineTable.txt[1].slotColor = "txt";				
							--isLineTable.txt[1].width = 70;					
							--isLineTable.txt[2] = {};
							--isLineTable.txt[2].bold = true;
							--isLineTable.txt[2].txt = string.format("%d", bunkerSiloGeneral.compactedFillLevel);
							--isLineTable.txt[2].slotColor = "txt";							
							--isLineTable.txt[2].width = 30;
							--isLineTable.txt[2].alignment = 3;
						end;					
					end;				
					---fermenting---						
				end;
				----------------------------fermentState-----------------------------
				
				----------------------------output input-----------------------------	
				if isOwned then					
					local bunkerSiloOutput = cmdObject[o].mohTable.output;
					local bunkerSiloInput = cmdObject[o].mohTable.input;
					local viewOutput = true; --cmdObject[o].mohTable.viewOutput;
					local viewInput = true; --cmdObject[o].mohTable.viewInput;						
					if not stopInOutput and viewProductionInfo then
						---output---
						if #bunkerSiloOutput > 0 and bunkerSiloGeneral.state == BunkerSilo.STATE_FERMENTED or bunkerSiloGeneral.state == BunkerSilo.STATE_CLOSED or bunkerSiloGeneral.state == BunkerSilo.STATE_DRAIN then
							if viewOutput then
								for output=1, #bunkerSiloOutput do
									if bunkerSiloOutput[output] ~= nil then
										lineTable.line[#lineTable.line+1] = {};
										isLineTable = lineTable.line[#lineTable.line];
										isLineTable.txt = {};
										isLineTable.txt[1] = {};
										isLineTable.txt[1].slotColor = "txt";
										isLineTable.txt[1].bold = false;
										isLineTable.txt[1].txt = tostring(bunkerSiloOutput[output].fillTypeName);
										isLineTable.txt[1].width = 60;
										isLineTable.txt[2] = {};
										isLineTable.txt[2].slotColor = "txt";
										isLineTable.txt[2].bold = false;									
										isLineTable.txt[2].txt = tostring(bunkerSiloOutput[output].fillLevel);									
										isLineTable.txt[2].width = 40;
										isLineTable.txt[2].alignment = 3;
									end;
								end;
							end;
						end;
						---output---
						---input---
						if #bunkerSiloInput > 0 and bunkerSiloGeneral.state ~= BunkerSilo.STATE_FERMENTED and bunkerSiloGeneral.state ~= BunkerSilo.STATE_CLOSED and bunkerSiloGeneral.state ~= BunkerSilo.STATE_DRAIN then
							if viewInput then
								for input=1, #bunkerSiloInput do
									if bunkerSiloInput[input] ~= nil then
										lineTable.line[#lineTable.line+1] = {};
										isLineTable = lineTable.line[#lineTable.line];
										isLineTable.txt = {};
										isLineTable.txt[1] = {};
										isLineTable.txt[1].slotColor = "txt";
										isLineTable.txt[1].bold = false;
										isLineTable.txt[1].txt = tostring(bunkerSiloInput[input].groupName);
										isLineTable.txt[1].width = 70;
										if bunkerSiloInput[input].fillTypeNames ~= nil then
											isLineTable.txt[1].callback = moBunkerSilosOutput.clickOutInGroupName;
											isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, tostring(bunkerSiloInput[input].groupName), tostring(bunkerSiloInput[input].fillTypeNames)};
										end;									
										isLineTable.txt[2] = {};
										isLineTable.txt[2].slotColor = "txt";
										isLineTable.txt[2].bold = false;
										isLineTable.txt[2].txt = tostring(bunkerSiloInput[input].fillLevel);
										isLineTable.txt[2].width = 30;
										isLineTable.txt[2].alignment = 3;						
									end;
								end;
							end;
						end;
						---input---
					end;
				end;			
				----------------------------output input-----------------------------
			end;
			---objectLineDistance---
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};		
			isLineTable.txt[1].txt = " ";
			---objectLineDistance---
		end;
	end;
	moBunkerSilos[cmdRegName] = {output=lineTable};
end;

function moBunkerSilosOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.object == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="bunkerSilos" } );
	moBunkerSilosOutput:load(args.cmdTable, args.slotTable);
	return moBunkerSilos[args.cmdTable.regName].output;
end;

function moBunkerSilosOutput.clickBunkerSiloHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "BunkerSilo Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional BunkerSilo Name/Productivity Name for more Info or MapHotSpot or ...\nClick Mouse Right Optional Titel BunkerSilo Name for Teleport(onFoot)";
	end;
end;

function moBunkerSilosOutput.clickOutInGroupName(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and args.ownTable[3] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "bunkerSilos");			
			if object ~= nil then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;				
				moSetGetOverlays.infoHelpBox.info.titel = "BunkerSilo *".. tostring(args.ownTable[2]).. "*";
				moSetGetOverlays.infoHelpBox.info.txt = tostring(args.ownTable[3]);				
			end;
		end;	
	end;
end;

function moBunkerSilosOutput.clickViewMoreInfo(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "bunkerSilos");			
			if object ~= nil then
				object.mohTable.viewMoreInfo = not object.mohTable.viewMoreInfo;
			end;
		end;	
	end;
end;

function moBunkerSilosOutput.clickViewProductionInfoSmall(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "bunkerSilos");			
			if object ~= nil then
				object.mohTable.viewProductionInfoSmall = not object.mohTable.viewProductionInfoSmall;
			end;
		end;	
	end;
end;

function moBunkerSilosOutput.clickBuyBunkerSilo(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "bunkerSilos");			
			if object ~= nil then
				--object.spec_bunkerSilo:buyRequest();				
			end;
		end;	
	end;
end;

function moBunkerSilosOutput.clickBunkerSilo(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "bunkerSilos");			
			if object ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then					
					moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
				end;
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[1] ~= nil and g_currentMission.controlledVehicle == nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "bunkerSilos");			
			if object ~= nil and object.spec_hotspots ~= nil and object.spec_hotspots.mapHotspots ~= nil then
				local hotspot = object.spec_hotspots.mapHotspots[1];
				if hotspot ~= nil and hotspot.teleportWorldX ~= nil and hotspot.teleportWorldY ~= nil and hotspot.teleportWorldZ ~= nil then
					g_currentMission.player:moveToAbsolute(hotspot.teleportWorldX, hotspot.teleportWorldY, hotspot.teleportWorldZ, false, false);
					MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moBunkerSilosOutput.clickBunkerSilo"); --force mouseOff
				end;				
			end;
		end;	
	end;
end;

function moBunkerSilosOutput.clickViewInputOutputOnOff(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil then					
			local object = moModuleObjects:getObject(args.ownTable[1], "bunkerSilos");			
			if object ~= nil then				
				if args.ownTable[2] == 1 then
					object.mohTable.viewOutput = not object.mohTable.viewOutput;
				elseif args.ownTable[2] == 2 then
					object.mohTable.viewInput = not object.mohTable.viewInput;
				end;
			end;			
		end;
	end;
end;

function moBunkerSilosOutput.clickViewProductionInfo(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "bunkerSilos");			
			if object ~= nil then
				object.mohTable.viewProductionInfo = not object.mohTable.viewProductionInfo;
			end;
		end;	
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="bunkerSilos" } );