moFieldsConfig = {};

function moFieldsConfig:defaultValues()
	moFields.values = {fields={}, sortBy=1, maxSortBy=8, updateTimer=5, msec=false};
	--sortBy 1=fields, 2=fruitname, 3=state/wachstum, 4=spray, 5=lime, 6=weed, 7=roller, 8=plow
end;

function moFieldsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moFields.values == nil then moFieldsConfig:defaultValues();end;
	--local groupNameTag = (xmlNameTag.. ".module.fields(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		--moFields.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		--moFields.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;
end;

function moFieldsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;
	if moFields.values == nil then moFieldsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	--local groupNameTag = (xmlNameTag.. ".module.fields(%d)"):format(0);
	--setXMLInt(Xml, groupNameTag.. "#updateTimer", moFields.values.updateTimer);
	--setXMLBool(Xml, groupNameTag.. "#mSecTimer", moFields.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moFieldsConfig:generateCmd()
	function generateCmd(ownTable)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = "output_mapFieldsInfo_";
				groupName = "OutputByMoh";			
				displayName = "Map Fields Infos";
				infoTxt = "View FieldInfos";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = ownTable;
				object = {};
				actionCallback = moFieldsOutput.giveOutputTable;			
			}
		)
	end;	
	generateCmd({});	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moFieldsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moFieldsConfig.saveXml } );
