moMissionsConfig = {};

function moMissionsConfig:defaultValues()
	moMissions.values = {missions={}, fieldToMission={}, sortBy=1, updateTimer=2, msec=false};
	--sortBy 1=price, 2=jobType, 3=hectar, 4=field
end;

function moMissionsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;
	if moMissions.values == nil then moMissionsConfig:defaultValues();end;	
	--local groupNameTag = (xmlNameTag.. ".module.missions(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		--moMissions.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") ~= nil then
		--moMissions.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;
end;

function moMissionsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;	
	if moMissions.values == nil then moMissionsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	--local groupNameTag = (xmlNameTag.. ".module.missions(%d)"):format(0);
	--setXMLInt(Xml, groupNameTag.. "#updateTimer", moMissions.values.updateTimer);
	--setXMLBool(Xml, groupNameTag.. "#mSecTimer", moMissions.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moMissionsConfig:generateCmd()
	function generateCmd(ownTable)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = "output_mapMissions_";
				groupName = "OutputByMoh";			
				displayName = "Map Missions";
				infoTxt = "View Missions";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = ownTable;
				object = {};
				actionCallback = moMissionsOutput.giveOutputTable;			
			}
		)
	end;	
	generateCmd({});	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moMissionsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moMissionsConfig.saveXml } );
