moMouseKeyEventsPda = {};

function moMouseKeyEventsPda:setMouse(posX, posY, isDown, isUp, button, clickAreaTable)
	if button == Input.MOUSE_BUTTON_LEFT then
		moMouseKeyEventsPda:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_MIDDLE then
		moMouseKeyEventsPda:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_RIGHT then
		moMouseKeyEventsPda:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_UP then
		moMouseKeyEventsPda:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
		moMouseKeyEventsPda:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif clickAreaTable.infoTxt ~= nil and type(clickAreaTable.infoTxt) == "string" and string.len(clickAreaTable.infoTxt) > 0 then
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = tostring(clickAreaTable.infoTxt);
		end;
		return;		
	end;
	--moDraw.pda:helpTxt(clickAreaTable); --pda global help
end;

function moMouseKeyEventsPda:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable)	
	---first check and set select line/app---
	if clickAreaTable.whereClick == "selectApp_" and clickAreaTable.appValue ~= nil then
		if moSetGetOverlays.pda[clickAreaTable.whatClick] ~= nil and moSetGetOverlays.pda[clickAreaTable.whatClick].setting.on then
			if moSetGetOverlays.pda[clickAreaTable.whatClick].selectApp[1] ~= clickAreaTable.appValue[1] or moSetGetOverlays.pda[clickAreaTable.whatClick].selectApp[2] ~= clickAreaTable.appValue[2] then
				moSetGetOverlays.pda[clickAreaTable.whatClick].selectApp[1] = clickAreaTable.appValue[1];moSetGetOverlays.pda[clickAreaTable.whatClick].selectApp[2] = clickAreaTable.appValue[2];
				return;
			end;
		end;
	end;
	---first check and set select line/app---
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" and isDown then
		clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;
		clickAreaTable.mouseClick = "MOUSE_BUTTON_LEFT";
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			local canCallback = not clickAreaTable.isMenue and clickAreaTable.pdaTable.cmd[clickAreaTable.cmdPos].mouseClick ~= nil and (clickAreaTable.pdaTable.cmd[clickAreaTable.cmdPos].mouseClick[1] and clickAreaTable.cmdTable.mouseClickAccepts[1]);
			if clickAreaTable.isMenue or canCallback then				
				clickAreaTable.callback(clickAreaTable);
				return;
			end;
		elseif clickAreaTable.whereClick == "callbackCmdApp_" and isDown then			
			moMouseKeyEventsPda:setCmdApp(clickAreaTable, 1);
			return;
		end;
	end;
	if clickAreaTable.whereClick == "buttonSeparatorVertical_" or clickAreaTable.whereClick == "buttonSeparatorHorizontal_" and isDown then		
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = "just a separation ";
		end;
		return;		
	elseif clickAreaTable.whereClick == "buttonClose_" and isDown then		
		moDraw.pda:setClose(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "buttonViewModus_" and isDown then
		moDraw.pda:setViewModus(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "save_" and isDown then		
		moSetGetPda:setSave(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "editPdaName_" and isDown then		
		guiDialog:editPdaName(clickAreaTable.whatClick);		
		return;

	elseif (clickAreaTable.whereClick == "boundsClickLeft_" or clickAreaTable.whereClick == "boundsClickRight_" or clickAreaTable.whereClick == "boundsClickUp_" or clickAreaTable.whereClick == "boundsClickDown_") and isDown then
		--moSetGetPda:setLineAppsBoundsClick(clickAreaTable.whatClick,clickAreaTable.whereClick == "boundsClickLeft_",clickAreaTable.whereClick == "boundsClickRight_",clickAreaTable.whereClick == "boundsClickUp_",clickAreaTable.whereClick == "boundsClickDown_")
		return;		
	elseif clickAreaTable.whereClick == "settingMoveUpDown_" and isDown then		
		moDraw.pda:setSettingMoveUpDown(clickAreaTable.whatClick);
		return;	
	elseif clickAreaTable.whereClick == "settingDefaultLine_" and isDown then		
		moDraw.pda:setSettingDefaultLine(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "settingLineLeft_" and isDown then		
		moSetGetPda:setSettingLineBounds(clickAreaTable.whatClick, true, false);
		return;
	elseif clickAreaTable.whereClick == "settingLineRight_" and isDown then		
		moSetGetPda:setSettingLineBounds(clickAreaTable.whatClick, false, true);
		return;	
	elseif clickAreaTable.whereClick == "settingExtraLine_" and isDown then		
		moDraw.pda:setSettingExtraLine(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "settingMaxExtraLine_" and isDown then		
		moSetGetPda:setSettingMaxExtraLine(clickAreaTable);
		return;	
	elseif clickAreaTable.whereClick == "settingExtraLineLeft_" and isDown then		
		moSetGetPda:setSettingExtraLineBounds(clickAreaTable, true, false);
		return;
	elseif clickAreaTable.whereClick == "settingExtraLineRight_" and isDown then		
		moSetGetPda:setSettingExtraLineBounds(clickAreaTable, false, true);
		return;		
	elseif clickAreaTable.whereClick == "settingInfoLine_" and isDown then		
		moDraw.pda:setSettingInfoLine(clickAreaTable.whatClick);
		return;	
	elseif clickAreaTable.whereClick == "setting_" and isDown then
		moDraw.pda:setSetting(clickAreaTable.whatClick);
		return;
	elseif clickAreaTable.whereClick == "settingCmd_" and isDown then		
		moHlGuiCmdSetting:setOpen( {typ="Pda", name=clickAreaTable.whatClick, appValue=clickAreaTable.appValue} );
		return;
	elseif clickAreaTable.whereClick == "settingGenerateApp_" and isDown then
		moSetGetPda:generateApp(clickAreaTable);
		return;
	elseif clickAreaTable.whereClick == "settingDeleteApp_" and isDown then
		moSetGetPda:deleteApp(clickAreaTable);		
		return;
	elseif clickAreaTable.whereClick == "settingAddAppIcon_" and isDown then 
		moHlGuiAppIconSetting:setOpen( {name=clickAreaTable.whatClick, appValue=clickAreaTable.appValue} );		
		return;
	elseif clickAreaTable.whereClick == "settingZoomIn_" and isDown then
		moSetGetPda:setSettingZoomOutIn(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].settingZoomOutIn;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].settingZoomOutIn;
		end;
		return;
	elseif clickAreaTable.whereClick == "settingZoomOut_" and isDown then
		moSetGetPda:setSettingZoomOutIn(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].settingZoomOutIn;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].settingZoomOutIn;
		end;
		return;
	elseif clickAreaTable.whereClick == "pdaCanCloseAll_" and isDown then
		moSetGetPda:setCanCloseAll(clickAreaTable.whatClick);
		return;	
	elseif clickAreaTable.whereClick == "pdaFrameZoomIn_" and isDown then
		moSetGetPda:setFrameZoomOutIn(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].frameZoomOutIn;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].frameZoomOutIn;
		end;
		return;
	elseif clickAreaTable.whereClick == "pdaFrameZoomOut_" and isDown then
		moSetGetPda:setFrameZoomOutIn(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].frameZoomOutIn;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].frameZoomOutIn;
		end;
		return;	
	elseif clickAreaTable.whereClick == "pdaAppIconZoomIn_" and isDown then
		moSetGetPda:setAppIconZoomOutIn(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].appIconZoomOutIn;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].appIconZoomOutIn;
		end;
		return;
	elseif clickAreaTable.whereClick == "pdaAppIconZoomOut_" and isDown then
		moSetGetPda:setAppIconZoomOutIn(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].appIconZoomOutIn;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].appIconZoomOutIn;
		end;
		return;
	elseif clickAreaTable.whereClick == "pdaAppIconDistanceWidthUp_" and isDown then
		moSetGetPda:setAppIconDistanceWidth(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].distanceAppIconWidth;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].distanceAppIconWidth;
		end;
		return;	
	elseif clickAreaTable.whereClick == "pdaAppIconDistanceWidthDown_" and isDown then
		moSetGetPda:setAppIconDistanceWidth(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].distanceAppIconWidth;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].distanceAppIconWidth;
		end;
		return;
	elseif clickAreaTable.whereClick == "pdaAppIconDistanceHeightUp_" and isDown then
		moSetGetPda:setAppIconDistanceHeight(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].distanceAppIconHeight;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].distanceAppIconHeight;
		end;
		return;		
	elseif clickAreaTable.whereClick == "pdaAppIconDistanceHeightDown_" and isDown then
		moSetGetPda:setAppIconDistanceHeight(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].distanceAppIconHeight;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].distanceAppIconHeight;
		end;
		return;	
	elseif clickAreaTable.whereClick == "pdaAppIconTxtWidthFixUp_" and isDown then
		moSetGetPda:setAppIconTxtWidthFix(clickAreaTable.whatClick, true, false);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].txtWidthFix;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].txtWidthFix;
		end;
		return;
	elseif clickAreaTable.whereClick == "pdaAppIconTxtWidthFixDown_" and isDown then
		moSetGetPda:setAppIconTxtWidthFix(clickAreaTable.whatClick, false, true);
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].txtWidthFix;
		end;
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
			g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = moSetGetOverlays.pda[clickAreaTable.whatClick].txtWidthFix;
		end;
		return;
	
	elseif clickAreaTable.whereClick == "settingPdaCopyPaste_" and isDown then
		moSetGetPda:settingCopyPaste(clickAreaTable.whatClick);			
		return;		
	elseif clickAreaTable.whereClick == "generateNewPda_" and isDown then
		if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["generateNewPda"] == nil then
			g_currentMission.hl.addTimer({name="generateNewPda", delay=5, repeatable=false});
		elseif g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["generateNewPda"] ~= nil then
			if g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then				
				g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = "Cooldown Timer active";
			end;
			return;
		end;
		local pdaName = moSetGetPda:generateOtherPdaName();	
		if pdaName ~= nil then 
			moSetGetPda:generatePda(pdaName, pdaName, true, false, true);
			moGeneralSettings.isSave = false;
		else
			print("***Error ".. tostring(MultiOverlayV4.metadata.title).. " -Generate Pda(Pda Limit or Name corrupt)- Error***")
		end;									
		return;
	elseif clickAreaTable.whereClick == "helpGlobal_" and isDown then
		--moSetGetSlot:setHelp(clickAreaTable.whatClick, true, false);
		--return;
	elseif clickAreaTable.whereClick == "helpOutput_" and isDown then
		--moSetGetSlot:setHelp(clickAreaTable.whatClick, false, true);
		--return;	
	elseif clickAreaTable.whereClick == "buttonTxtSizeUp_" and isDown then
		--moSetGetSlot:setTxtSize(clickAreaTable.whatClick, true, false);
		--if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then			
		--	g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = string.format("%1.5f", moSetGetOverlays.slot[clickAreaTable.whatClick].txtSize); 
		--end;
		--if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
		--	g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
		--	g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = string.format("%1.5f", moSetGetOverlays.slot[clickAreaTable.whatClick].txtSize); 
		--end;
		--return;
	elseif clickAreaTable.whereClick == "buttonTxtSizeDown_" and isDown then
		--moSetGetSlot:setTxtSize(clickAreaTable.whatClick, false, true);
		--if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"] ~= nil then
		--	g_currentMission.hl.timers[clickAreaTable.whatClick.."SettingLine"].ownTable.infoTxt = string.format("%1.5f", moSetGetOverlays.slot[clickAreaTable.whatClick].txtSize);
		--end;
		--if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"] ~= nil then			
		--	g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].repeatable = 2;
		--	g_currentMission.hl.timers[clickAreaTable.whatClick.."infoLine"].ownTable.infoTxt = string.format("%1.5f", moSetGetOverlays.slot[clickAreaTable.whatClick].txtSize); 
		--end;
		--return;		
	elseif clickAreaTable.whereClick == "deletePda_" and isDown then
		moSetGetPda:deletePda(clickAreaTable.whatClick);								
		return;		
	end;	
end;

function moMouseKeyEventsPda:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" and isDown then
		clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;
		clickAreaTable.mouseClick = "MOUSE_BUTTON_RIGHT";
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			local canCallback = not clickAreaTable.isMenue and clickAreaTable.pdaTable.cmd[clickAreaTable.cmdPos].mouseClick ~= nil and (clickAreaTable.pdaTable.cmd[clickAreaTable.cmdPos].mouseClick[3] and clickAreaTable.cmdTable.mouseClickAccepts[1]);
			if clickAreaTable.isMenue or canCallback then				
				clickAreaTable.callback(clickAreaTable);
				return;
			end;	
		elseif clickAreaTable.whereClick == "callbackCmdApp_" and isDown then			
			moMouseKeyEventsPda:setCmdApp(clickAreaTable, 3);
			return;
		end;
	end;
end;

function moMouseKeyEventsPda:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" and isDown then
		clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;
		clickAreaTable.mouseClick = "MOUSE_BUTTON_MIDDLE";
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			local canCallback = not clickAreaTable.isMenue and clickAreaTable.pdaTable.cmd[clickAreaTable.cmdPos].mouseClick ~= nil and (clickAreaTable.pdaTable.cmd[clickAreaTable.cmdPos].mouseClick[2] and clickAreaTable.cmdTable.mouseClickAccepts[1]);
			if clickAreaTable.isMenue or canCallback then				
				clickAreaTable.callback(clickAreaTable);
				return;
			end;
		elseif clickAreaTable.whereClick == "callbackCmdApp_" and isDown then			
			moMouseKeyEventsPda:setCmdApp(clickAreaTable, 2);
			return;
		end;
	end;
end;

function moMouseKeyEventsPda:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" then	
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;			
			clickAreaTable.callback(clickAreaTable);
			return;	
		end;
		if clickAreaTable.whereClick == "boundsScrollLeftRight_" and isDown then
			moSetGetPda:setLineAppsBoundsScroll(clickAreaTable.whatClick, false, true, false, false);
			return;
		elseif clickAreaTable.whereClick == "boundsScrollUpDown_" and isDown then
			moSetGetPda:setLineAppsBoundsScroll(clickAreaTable.whatClick, false, false, true, false);
			return;
		end;
	end;	
end;

function moMouseKeyEventsPda:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick ~= "buttonSeparatorVertical_" and clickAreaTable.whereClick ~= "buttonSeparatorHorizontal_" then
		if clickAreaTable.callback ~= nil and type(clickAreaTable.callback) == "function" then		
			clickAreaTable.isDown = isDown;clickAreaTable.isUp = isUp;clickAreaTable.button = button;
			clickAreaTable.callback(clickAreaTable);
			return;	
		end;
		if clickAreaTable.whereClick == "boundsScrollLeftRight_" and isDown then
			moSetGetPda:setLineAppsBoundsScroll(clickAreaTable.whatClick, true, false, false, false);
			return;
		elseif clickAreaTable.whereClick == "boundsScrollUpDown_" and isDown then
			moSetGetPda:setLineAppsBoundsScroll(clickAreaTable.whatClick, false, false, false, true);
			return;
		end;
	end;	
end;

function moMouseKeyEventsPda:setKey(unicode, sym, modifier, isDown)

end;

function moMouseKeyEventsPda:setCmdApp(args, mouseClick)
	if moSetGetOverlays.pda[args.whatClick] == nil or args.appValue[1] == nil or args.appValue[2] == nil then return;end;
	if moSetGetOverlays.pda[args.whatClick].apps[args.appValue[1]][args.appValue[2]].cmd == nil or #moSetGetOverlays.pda[args.whatClick].apps[args.appValue[1]][args.appValue[2]].cmd <= 0 then return;end;
	for cmd=1, #moSetGetOverlays.pda[args.whatClick].apps[args.appValue[1]][args.appValue[2]].cmd do
		local appCmd = moSetGetOverlays.pda[args.whatClick].apps[args.appValue[1]][args.appValue[2]].cmd[cmd];
		local orgCmd = MultiOverlayV4.cmd[appCmd.regName];
		if orgCmd ~= nil and orgCmd.actionCallback ~= nil and type(orgCmd.actionCallback) == "function" then
			if (orgCmd.typ[1] == "action_" or orgCmd.typ[1] == "actionOutput_") and orgCmd.mouseClickAccepts[mouseClick] and appCmd.mouseClick[mouseClick] then
				args.cmdTable = orgCmd;
				orgCmd.actionCallback(args);
			end;
		end;
	end;
end;

































		