moSetGetLight = {};

function moSetGetLight:masterPdaOpenCloseApp(app)
	local openCloseApp = moSetGetOverlaysLight.default.masterPda.appOrder[app];
	moSetGetOverlaysLight.default.masterPda.selectApp = app;
	if not openCloseApp[2] then return false;end;
	if openCloseApp[4] == "cmd" then return nil;end;
	if moSetGetOverlays[openCloseApp[4]] ~= nil and moSetGetOverlays[openCloseApp[4]][openCloseApp[3]] ~= nil then
		if moSetGetOverlays[openCloseApp[4]][openCloseApp[3]].isOpen then 
			moDraw[openCloseApp[4]]:setClose(openCloseApp[3]);			
			return false;
		end;	
		for o=1, #moSetGetOverlaysLight.default.masterPda.appOrder do
			if o ~= app then
				local appOrder = moSetGetOverlaysLight.default.masterPda.appOrder[o];
				if appOrder[2] and appOrder[5] then
					if moSetGetOverlays[appOrder[4]] ~= nil and moSetGetOverlays[appOrder[4]][appOrder[3]] ~= nil then
						if moSetGetOverlays[appOrder[4]][appOrder[3]].isOpen then
							moDraw[appOrder[4]]:setClose(appOrder[3]);						
						end;
					end;
				end;
			end;
		end;
		moDraw[openCloseApp[4]]:setOpen(openCloseApp[3]);		
		return false;
	end;	
	return true;
end;

function moSetGetLight:setMasterPdaBounds(up)
	local maxViewApps = moSetGetOverlaysLight:getMasterPdaMaxViewApps();
	local visibleApps = moSetGetLight:getMasterPdaVisibleApps();	
	moSetGetOverlaysLight.default.masterPda.bounds[4] = visibleApps;
	moSetGetOverlaysLight.default.masterPda.bounds[3] = maxViewApps;
	if up == nil or visibleApps <= maxViewApps then
		moSetGetOverlaysLight.default.masterPda.bounds[1] = 1;moSetGetOverlaysLight.default.masterPda.bounds[2] = maxViewApps;
		moSetGetOverlaysLight:setMasterPdaViewIconsByBounds();
		up = nil;
	end;	
	if up == nil then return;end;		
	if up then
		if moSetGetOverlaysLight.default.masterPda.bounds[1]-moSetGetOverlaysLight.default.masterPda.bounds[3] < 1 then
			--moSetGetOverlaysLight.default.masterPda.bounds[1] = moSetGetOverlaysLight.default.masterPda.bounds[4]-moSetGetOverlaysLight.default.masterPda.bounds[3]+1;
			--moSetGetOverlaysLight.default.masterPda.bounds[2] = moSetGetOverlaysLight.default.masterPda.bounds[4];						
		else
			--moSetGetOverlaysLight.default.masterPda.bounds[1] = moSetGetOverlaysLight.default.masterPda.bounds[1]-moSetGetOverlaysLight.default.masterPda.bounds[3];
			--moSetGetOverlaysLight.default.masterPda.bounds[2] = moSetGetOverlaysLight.default.masterPda.bounds[2]-moSetGetOverlaysLight.default.masterPda.bounds[3];
		end;
	else
		
		if moSetGetOverlaysLight.default.masterPda.bounds[2]+1 > moSetGetOverlaysLight.default.masterPda.bounds[4] then
			moSetGetOverlaysLight.default.masterPda.bounds[1] = 1;moSetGetOverlaysLight.default.masterPda.bounds[2] = moSetGetOverlaysLight.default.masterPda.bounds[3];	
		else
			moSetGetOverlaysLight.default.masterPda.bounds[1] = moSetGetOverlaysLight.default.masterPda.bounds[1]+moSetGetOverlaysLight.default.masterPda.bounds[3];
			moSetGetOverlaysLight.default.masterPda.bounds[2] = moSetGetOverlaysLight.default.masterPda.bounds[2]+moSetGetOverlaysLight.default.masterPda.bounds[3];
		end;
	end;		
	moSetGetOverlaysLight:setMasterPdaViewIconsByBounds();
end;

function moSetGetLight:getMasterPdaVisibleApps()
	local visible = 0;
	for o=1, #moSetGetOverlaysLight.default.masterPda.appOrder do
		if moSetGetOverlaysLight.default.masterPda.appOrder[o][2] then visible = visible+1;end;
	end;
	return visible;
end;

function moSetGetLight:setNewAppOrder(lightTyp, oldPos, up)
	if moSetGetOverlaysLight.default[lightTyp] == nil or moSetGetOverlaysLight.default[lightTyp].app == nil or moSetGetOverlaysLight.default[lightTyp].appOrder == nil then return false;end;
	local oldApp = moSetGetOverlaysLight.default[lightTyp].app[oldPos];
	local oldAppOrder = moSetGetOverlaysLight.default[lightTyp].appOrder[oldPos];
	local newPos = 0;
	if up then
		newPos = oldPos+1;
		if moSetGetOverlaysLight.default[lightTyp].app[newPos] == nil then
			newPos = 1;		
		end;		
	else
		newPos = oldPos-1;
		if newPos == 0 then
			newPos = #moSetGetOverlaysLight.default[lightTyp].app-1;		
		end;
		
	end;
	table.remove(moSetGetOverlaysLight.default[lightTyp].app, oldPos);
	table.remove(moSetGetOverlaysLight.default[lightTyp].appOrder, oldPos);
	table.insert(moSetGetOverlaysLight.default[lightTyp].app, newPos, oldApp);
	table.insert(moSetGetOverlaysLight.default[lightTyp].appOrder, newPos, oldAppOrder);
	moSetGetOverlaysLight.default.setting.selectApp = newPos;
	moSetGetLight:setMasterPdaBounds();
	return true;
end;